//
//  ObjectAttribute.h
//  KonySyncV2
//
//  Created by Sunil Phani Manne on 09/11/16.
//  Copyright © 2016 Kony. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "KSMetadataConstants.h"

@interface KSObjectAttribute : NSObject

@property (nonatomic, readonly, copy) NSString *name;

@property (nonatomic, readonly, assign) NSInteger length;

@property (nonatomic, readonly) id defaultValue;

@property (nonatomic, readonly, assign) KSAction action;

@property (nonatomic, readonly, assign) KSObjectAttributeDataType dataType;

@property (nonatomic, readonly, assign, getter=isNullable) BOOL nullable;

@property (nonatomic, readonly, assign, getter=isCreatable) BOOL creatable;

@property (nonatomic, readonly, assign, getter=isUpdatable) BOOL updatable;

@property (nonatomic, readonly, assign, getter=isAutogenerated) BOOL autogenerated;

@property (nonatomic, readonly, assign, getter=isAutoIncrement) BOOL autoIncrement;

@property (nonatomic, assign, getter=isSoftDeletable) BOOL softDeletable;

@property (nonatomic, readonly, assign) KSObjectAttributeDataType sourceDataType;

//init methods

- (instancetype) init __attribute__((unavailable("Must use initWithJSONDictionary: instead.")));

- (instancetype)initWithJSONDictionary:(NSDictionary *)JSONdictionary
                                 error:(OfflineObjectsError **)error;

@end
