Ext.data.JsonP.android_accounts_AccountManagerFuture({"tagname":"class","name":"android.accounts.AccountManagerFuture","autodetected":{},"files":[{"filename":"AccountManagerFuture.js","href":"AccountManagerFuture.html#android-accounts-AccountManagerFuture"}],"members":[{"name":"cancel","tagname":"method","owner":"android.accounts.AccountManagerFuture","id":"method-cancel","meta":{}},{"name":"getResult","tagname":"method","owner":"android.accounts.AccountManagerFuture","id":"method-getResult","meta":{}},{"name":"isCancelled","tagname":"method","owner":"android.accounts.AccountManagerFuture","id":"method-isCancelled","meta":{}},{"name":"isDone","tagname":"method","owner":"android.accounts.AccountManagerFuture","id":"method-isDone","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.accounts.AccountManagerFuture","short_doc":"A AccountManagerFuture represents the result of an asynchronous\n android.accounts.AccountManager call. ...","classIcon":"icon-class","superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Files</h4><div class='dependency'><a href='source/AccountManagerFuture.html#android-accounts-AccountManagerFuture' target='_blank'>AccountManagerFuture.js</a></div></pre><div class='doc-contents'><p>A <tt>AccountManagerFuture</tt> represents the result of an asynchronous\n <a href=\"#!/api/android.accounts.AccountManager\" rel=\"android.accounts.AccountManager\" class=\"docClass\">android.accounts.AccountManager</a> call.  Methods are provided to check if the computation is\n complete, to wait for its completion, and to retrieve the result of\n the computation.  The result can only be retrieved using method\n <tt>get</tt> when the computation has completed, blocking if\n necessary until it is ready.  Cancellation is performed by the\n <tt>cancel</tt> method.  Additional methods are provided to\n determine if the task completed normally or was cancelled. Once a\n computation has completed, the computation cannot be cancelled.\n If you would like to use a <tt>Future</tt> for the sake\n of cancellability but not provide a usable result, you can\n declare types of the form <tt>Future&lt;?&gt;</tt> and\n return <tt>null</tt> as a result of the underlying task.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-cancel' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.accounts.AccountManagerFuture'>android.accounts.AccountManagerFuture</span><br/><a href='source/AccountManagerFuture.html#android-accounts-AccountManagerFuture-method-cancel' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.accounts.AccountManagerFuture-method-cancel' class='name expandable'>cancel</a>( <span class='pre'>mayInterruptIfRunning</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Attempts to cancel execution of this task. ...</div><div class='long'><p>Attempts to cancel execution of this task.  This attempt will\n fail if the task has already completed, has already been cancelled,\n or could not be cancelled for some other reason. If successful,\n and this task has not started when <tt>cancel</tt> is called,\n this task should never run.  If the task has already started,\n then the <tt>mayInterruptIfRunning</tt> parameter determines\n whether the thread executing this task should be interrupted in\n an attempt to stop the task.</p>\n\n<p> <p>After this method returns, subsequent calls to <a href=\"#!/api/android.accounts.AccountManagerFuture-method-isDone\" rel=\"android.accounts.AccountManagerFuture-method-isDone\" class=\"docClass\">isDone</a> will\n always return <tt>true</tt>.  Subsequent calls to <a href=\"#!/api/android.accounts.AccountManagerFuture-method-isCancelled\" rel=\"android.accounts.AccountManagerFuture-method-isCancelled\" class=\"docClass\">isCancelled</a>\n will always return <tt>true</tt> if this method returned <tt>true</tt>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>mayInterruptIfRunning</span> : Boolean<div class='sub-desc'><p><tt>true</tt> if the thread executing this\n task should be interrupted; otherwise, in-progress tasks are allowed\n to complete</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p><tt>false</tt> if the task could not be cancelled,\n typically because it has already completed normally;\n <tt>true</tt> otherwise</p>\n</div></li></ul></div></div></div><div id='method-getResult' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.accounts.AccountManagerFuture'>android.accounts.AccountManagerFuture</span><br/><a href='source/AccountManagerFuture.html#android-accounts-AccountManagerFuture-method-getResult' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.accounts.AccountManagerFuture-method-getResult' class='name expandable'>getResult</a>( <span class='pre'>timeout, unit</span> ) : Object {java.lang.Object}<span class=\"signature\"></span></div><div class='description'><div class='short'>Accessor for the future result the android.accounts.AccountManagerFuture represents. ...</div><div class='long'><p>Accessor for the future result the <a href=\"#!/api/android.accounts.AccountManagerFuture\" rel=\"android.accounts.AccountManagerFuture\" class=\"docClass\">android.accounts.AccountManagerFuture</a> represents. This\n call will block until the result is available. In order to check if the result is\n available without blocking, one may call <a href=\"#!/api/android.accounts.AccountManagerFuture-method-isDone\" rel=\"android.accounts.AccountManagerFuture-method-isDone\" class=\"docClass\">isDone</a>() and  <a href=\"#!/api/android.accounts.AccountManagerFuture-method-isCancelled\" rel=\"android.accounts.AccountManagerFuture-method-isCancelled\" class=\"docClass\">isCancelled</a>().\n If the request that generated this result fails or is canceled then an exception\n will be thrown rather than the call returning normally. If a timeout is specified then\n the request will automatically be canceled if it does not complete in that amount of time.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>timeout</span> : Number<div class='sub-desc'><p>the maximum time to wait</p>\n</div></li><li><span class='pre'>unit</span> : Object {TimeUnit}<div class='sub-desc'><p>the time unit of the timeout argument. This must not be null.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Object}</span><div class='sub-desc'><p>the actual result</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p><a href=\"#!/api/android.accounts.OperationCanceledException\" rel=\"android.accounts.OperationCanceledException\" class=\"docClass\">android.accounts.OperationCanceledException</a> if the request was canceled for any\n reason</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p><a href=\"#!/api/android.accounts.AuthenticatorException\" rel=\"android.accounts.AuthenticatorException\" class=\"docClass\">android.accounts.AuthenticatorException</a> if there was an error communicating with\n the authenticator or if the authenticator returned an invalid response</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>java.io.IOException if the authenticator returned an error response that indicates\n that it encountered an IOException while communicating with the authentication server</p>\n</div></li></ul></div></div></div><div id='method-isCancelled' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.accounts.AccountManagerFuture'>android.accounts.AccountManagerFuture</span><br/><a href='source/AccountManagerFuture.html#android-accounts-AccountManagerFuture-method-isCancelled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.accounts.AccountManagerFuture-method-isCancelled' class='name expandable'>isCancelled</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns true if this task was cancelled before it completed\n normally. ...</div><div class='long'><p>Returns <tt>true</tt> if this task was cancelled before it completed\n normally.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p><tt>true</tt> if this task was cancelled before it completed</p>\n</div></li></ul></div></div></div><div id='method-isDone' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.accounts.AccountManagerFuture'>android.accounts.AccountManagerFuture</span><br/><a href='source/AccountManagerFuture.html#android-accounts-AccountManagerFuture-method-isDone' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.accounts.AccountManagerFuture-method-isDone' class='name expandable'>isDone</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns true if this task completed. ...</div><div class='long'><p>Returns <tt>true</tt> if this task completed.</p>\n\n<p> Completion may be due to normal termination, an exception, or\n cancellation -- in all of these cases, this method will return\n <tt>true</tt>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p><tt>true</tt> if this task completed</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});