Ext.data.JsonP.android_content_AsyncQueryHandler({"tagname":"class","name":"android.content.AsyncQueryHandler","autodetected":{},"files":[{"filename":"AsyncQueryHandler.js","href":"AsyncQueryHandler.html#android-content-AsyncQueryHandler"}],"extends":"android.os.Handler","members":[{"name":"cancelOperation","tagname":"method","owner":"android.content.AsyncQueryHandler","id":"method-cancelOperation","meta":{}},{"name":"handleMessage","tagname":"method","owner":"android.content.AsyncQueryHandler","id":"method-handleMessage","meta":{}},{"name":"startDelete","tagname":"method","owner":"android.content.AsyncQueryHandler","id":"method-startDelete","meta":{}},{"name":"startInsert","tagname":"method","owner":"android.content.AsyncQueryHandler","id":"method-startInsert","meta":{}},{"name":"startQuery","tagname":"method","owner":"android.content.AsyncQueryHandler","id":"method-startQuery","meta":{}},{"name":"startUpdate","tagname":"method","owner":"android.content.AsyncQueryHandler","id":"method-startUpdate","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.content.AsyncQueryHandler","classIcon":"icon-class","superclasses":["android.os.Handler"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>android.os.Handler<div class='subclass '><strong>android.content.AsyncQueryHandler</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/AsyncQueryHandler.html#android-content-AsyncQueryHandler' target='_blank'>AsyncQueryHandler.js</a></div></pre><div class='doc-contents'><p>A helper class to help make handling asynchronous <a href=\"#!/api/android.content.ContentResolver\" rel=\"android.content.ContentResolver\" class=\"docClass\">android.content.ContentResolver</a>\n queries easier.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-cancelOperation' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.AsyncQueryHandler'>android.content.AsyncQueryHandler</span><br/><a href='source/AsyncQueryHandler.html#android-content-AsyncQueryHandler-method-cancelOperation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.AsyncQueryHandler-method-cancelOperation' class='name expandable'>cancelOperation</a>( <span class='pre'>token</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Attempts to cancel operation that has not already started. ...</div><div class='long'><p>Attempts to cancel operation that has not already started. Note that\n there is no guarantee that the operation will be canceled. They still may\n result in a call to on[Query/Insert/Update/Delete]Complete after this\n call has completed.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>token</span> : Number<div class='sub-desc'><p>The token representing the operation to be canceled.\n  If multiple operations have the same token they will all be canceled.</p>\n</div></li></ul></div></div></div><div id='method-handleMessage' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.AsyncQueryHandler'>android.content.AsyncQueryHandler</span><br/><a href='source/AsyncQueryHandler.html#android-content-AsyncQueryHandler-method-handleMessage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.AsyncQueryHandler-method-handleMessage' class='name expandable'>handleMessage</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-startDelete' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.AsyncQueryHandler'>android.content.AsyncQueryHandler</span><br/><a href='source/AsyncQueryHandler.html#android-content-AsyncQueryHandler-method-startDelete' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.AsyncQueryHandler-method-startDelete' class='name expandable'>startDelete</a>( <span class='pre'>token, cookie, uri, selection</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>This method begins an asynchronous delete. ...</div><div class='long'><p>This method begins an asynchronous delete. When the delete operation is\n done onDeleteComplete is called.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>token</span> : Number<div class='sub-desc'><p>A token passed into onDeleteComplete to identify\n  the delete operation.</p>\n</div></li><li><span class='pre'>cookie</span> : Object {Object}<div class='sub-desc'><p>An object that gets passed into onDeleteComplete</p>\n</div></li><li><span class='pre'>uri</span> : Object {Uri}<div class='sub-desc'><p>the Uri passed to the delete operation.</p>\n</div></li><li><span class='pre'>selection</span> : String<div class='sub-desc'><p>the where clause.</p>\n</div></li></ul></div></div></div><div id='method-startInsert' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.AsyncQueryHandler'>android.content.AsyncQueryHandler</span><br/><a href='source/AsyncQueryHandler.html#android-content-AsyncQueryHandler-method-startInsert' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.AsyncQueryHandler-method-startInsert' class='name expandable'>startInsert</a>( <span class='pre'>token, cookie, uri, initialValues</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>This method begins an asynchronous insert. ...</div><div class='long'><p>This method begins an asynchronous insert. When the insert operation is\n done onInsertComplete is called.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>token</span> : Number<div class='sub-desc'><p>A token passed into onInsertComplete to identify\n  the insert operation.</p>\n</div></li><li><span class='pre'>cookie</span> : Object {Object}<div class='sub-desc'><p>An object that gets passed into onInsertComplete</p>\n</div></li><li><span class='pre'>uri</span> : Object {Uri}<div class='sub-desc'><p>the Uri passed to the insert operation.</p>\n</div></li><li><span class='pre'>initialValues</span> : Object {ContentValues}<div class='sub-desc'><p>the ContentValues parameter passed to the insert operation.</p>\n</div></li></ul></div></div></div><div id='method-startQuery' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.AsyncQueryHandler'>android.content.AsyncQueryHandler</span><br/><a href='source/AsyncQueryHandler.html#android-content-AsyncQueryHandler-method-startQuery' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.AsyncQueryHandler-method-startQuery' class='name expandable'>startQuery</a>( <span class='pre'>token, cookie, uri, projection, selection, selectionArgs, orderBy</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>This method begins an asynchronous query. ...</div><div class='long'><p>This method begins an asynchronous query. When the query is done\n onQueryComplete is called.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>token</span> : Number<div class='sub-desc'><p>A token passed into onQueryComplete to identify\n  the query.</p>\n</div></li><li><span class='pre'>cookie</span> : Object {Object}<div class='sub-desc'><p>An object that gets passed into onQueryComplete</p>\n</div></li><li><span class='pre'>uri</span> : Object {Uri}<div class='sub-desc'><p>The URI, using the content:// scheme, for the content to\n         retrieve.</p>\n</div></li><li><span class='pre'>projection</span> : Object {java.lang.String[]}<div class='sub-desc'><p>A list of which columns to return. Passing null will\n         return all columns, which is discouraged to prevent reading data\n         from storage that isn't going to be used.</p>\n</div></li><li><span class='pre'>selection</span> : String<div class='sub-desc'><p>A filter declaring which rows to return, formatted as an\n         SQL WHERE clause (excluding the WHERE itself). Passing null will\n         return all rows for the given URI.</p>\n</div></li><li><span class='pre'>selectionArgs</span> : Object {java.lang.String[]}<div class='sub-desc'><p>You may include ?s in selection, which will be\n         replaced by the values from selectionArgs, in the order that they\n         appear in the selection. The values will be bound as Strings.</p>\n</div></li><li><span class='pre'>orderBy</span> : String<div class='sub-desc'><p>How to order the rows, formatted as an SQL ORDER BY\n         clause (excluding the ORDER BY itself). Passing null will use the\n         default sort order, which may be unordered.</p>\n</div></li></ul></div></div></div><div id='method-startUpdate' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.AsyncQueryHandler'>android.content.AsyncQueryHandler</span><br/><a href='source/AsyncQueryHandler.html#android-content-AsyncQueryHandler-method-startUpdate' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.AsyncQueryHandler-method-startUpdate' class='name expandable'>startUpdate</a>( <span class='pre'>token, cookie, uri, values</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>This method begins an asynchronous update. ...</div><div class='long'><p>This method begins an asynchronous update. When the update operation is\n done onUpdateComplete is called.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>token</span> : Number<div class='sub-desc'><p>A token passed into onUpdateComplete to identify\n  the update operation.</p>\n</div></li><li><span class='pre'>cookie</span> : Object {Object}<div class='sub-desc'><p>An object that gets passed into onUpdateComplete</p>\n</div></li><li><span class='pre'>uri</span> : Object {Uri}<div class='sub-desc'><p>the Uri passed to the update operation.</p>\n</div></li><li><span class='pre'>values</span> : Object {ContentValues}<div class='sub-desc'><p>the ContentValues parameter passed to the update operation.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});