Ext.data.JsonP.android_content_BroadcastReceiver({"tagname":"class","name":"android.content.BroadcastReceiver","autodetected":{},"files":[{"filename":"BroadcastReceiver.js","href":"BroadcastReceiver.html#android-content-BroadcastReceiver"}],"extends":"java.lang.Object","members":[{"name":"abortBroadcast","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-abortBroadcast","meta":{}},{"name":"clearAbortBroadcast","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-clearAbortBroadcast","meta":{}},{"name":"getAbortBroadcast","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-getAbortBroadcast","meta":{}},{"name":"getDebugUnregister","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-getDebugUnregister","meta":{}},{"name":"getResultCode","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-getResultCode","meta":{}},{"name":"getResultData","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-getResultData","meta":{}},{"name":"getResultExtras","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-getResultExtras","meta":{}},{"name":"goAsync","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-goAsync","meta":{}},{"name":"isInitialStickyBroadcast","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-isInitialStickyBroadcast","meta":{}},{"name":"isOrderedBroadcast","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-isOrderedBroadcast","meta":{}},{"name":"onReceive","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-onReceive","meta":{}},{"name":"peekService","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-peekService","meta":{}},{"name":"setDebugUnregister","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-setDebugUnregister","meta":{}},{"name":"setOrderedHint","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-setOrderedHint","meta":{}},{"name":"setResult","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-setResult","meta":{}},{"name":"setResultCode","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-setResultCode","meta":{}},{"name":"setResultData","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-setResultData","meta":{}},{"name":"setResultExtras","tagname":"method","owner":"android.content.BroadcastReceiver","id":"method-setResultExtras","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.content.BroadcastReceiver","short_doc":"Base class for code that will receive intents sent by sendBroadcast(). ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.content.BroadcastReceiver</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver' target='_blank'>BroadcastReceiver.js</a></div></pre><div class='doc-contents'><p>Base class for code that will receive intents sent by sendBroadcast().</p>\n\n<p> <p>If you don't need to send broadcasts across applications, consider using\n this class with android.support.v4.content.LocalBroadcastManager instead\n of the more general facilities described below.  This will give you a much\n more efficient implementation (no cross-process communication needed) and allow\n you to avoid thinking about any security issues related to other applications\n being able to receive or send your broadcasts.</p>\n\n<p> <p>You can either dynamically register an instance of this class with\n <a href=\"#!/api/android.content.Context-method-registerReceiver\" rel=\"android.content.Context-method-registerReceiver\" class=\"docClass\">android.content.Context.registerReceiver()</a>\n or statically publish an implementation through the\n &lt;receiver&gt;\n tag in your <code>AndroidManifest.xml</code>.</p>\n\n<p> <p><em><strong>Note:</strong></em>\n &nbsp;&nbsp;&nbsp;If registering a receiver in your\n Activity.onResume()\n implementation, you should unregister it in\n Activity.onPause().\n (You won't receive intents when paused,\n and this will cut down on unnecessary system overhead). Do not unregister in\n Activity.onSaveInstanceState(),\n because this won't be called if the user moves back in the history\n stack.</p>\n\n<p> <p>There are two major classes of broadcasts that can be received:</p>\n <ul>\n <li> <b>Normal broadcasts</b> (sent with android.content.Context.sendBroadcast) are completely asynchronous.  All receivers of the\n broadcast are run in an undefined order, often at the same time.  This is\n more efficient, but means that receivers cannot use the result or abort\n APIs included here.\n <li> <b>Ordered broadcasts</b> (sent with String)\n android.content.Context.sendOrderedBroadcast) are delivered to one receiver at a time.\n As each receiver executes in turn, it can propagate a result to the next\n receiver, or it can completely abort the broadcast so that it won't be passed\n to other receivers.  The order receivers run in can be controlled with the\n android:priority attribute of the matching intent-filter; receivers with\n the same priority will be run in an arbitrary order.\n </li></li></ul></p>\n\n<p> <p>Even in the case of normal broadcasts, the system may in some\n situations revert to delivering the broadcast one receiver at a time.  In\n particular, for receivers that may require the creation of a process, only\n one will be run at a time to avoid overloading the system with new processes.\n In this situation, however, the non-ordered semantics hold: these receivers still\n cannot return results or abort their broadcast.</p></p>\n\n<p> <p>Note that, although the Intent class is used for sending and receiving\n these broadcasts, the Intent broadcast mechanism here is completely separate\n from Intents that are used to start Activities with\n <a href=\"#!/api/android.content.Context-method-startActivity\" rel=\"android.content.Context-method-startActivity\" class=\"docClass\">android.content.Context.startActivity()</a>.\n There is no way for a BroadcastReceiver\n to see or capture Intents used with startActivity(); likewise, when\n you broadcast an Intent, you will never find or start an Activity.\n These two operations are semantically very different: starting an\n Activity with an Intent is a foreground operation that modifies what the\n user is currently interacting with; broadcasting an Intent is a background\n operation that the user is not normally aware of.</p>\n\n<p> <p>The BroadcastReceiver class (when launched as a component through\n a manifest's &lt;receiver&gt;\n tag) is an important part of an\n <a href=\"{@docRoot}guide/topics/fundamentals.html#lcycles\">application's overall lifecycle</a>.</p></p>\n\n<p> <p>Topics covered here:\n <ol>\n <li><a href=\"#Security\">Security</a>\n <li><a href=\"#ReceiverLifecycle\">Receiver Lifecycle</a>\n <li><a href=\"#ProcessLifecycle\">Process Lifecycle</a>\n </li></li></li></ol></p>\n\n<p> <div class=\"special reference\">\n <h3>Developer Guides</h3>\n <p>For information about how to use this class to receive and resolve intents, read the\n <a href=\"{@docRoot}guide/topics/intents/intents-filters.html\">Intents and Intent Filters</a>\n developer guide.</p>\n </div></p>\n\n<p> <a name=\"Security\"></a>\n <h3>Security</h3></p>\n\n<p> <p>Receivers used with the <a href=\"#!/api/android.content.Context\" rel=\"android.content.Context\" class=\"docClass\">android.content.Context</a> APIs are by their nature a\n cross-application facility, so you must consider how other applications\n may be able to abuse your use of them.  Some things to consider are:</p>\n\n<p> <ul>\n <li><p>The Intent namespace is global.  Make sure that Intent action names and\n other strings are written in a namespace you own, or else you may inadvertently\n conflict with other applications.\n <li><p>When you use android.content.IntentFilter),\n <em>any</em> application may send broadcasts to that registered receiver.  You can\n control who can send broadcasts to it through permissions described below.\n <li><p>When you publish a receiver in your application's manifest and specify\n intent-filters for it, any other application can send broadcasts to it regardless\n of the filters you specify.  To prevent others from sending to it, make it\n unavailable to them with <code>android:exported=\"false\"</code>.\n <li><p>When you use android.content.Context.sendBroadcast(Intent) or related methods,\n normally any other application can receive these broadcasts.  You can control who\n can receive such broadcasts through permissions described below.  Alternatively,\n starting with android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH, you\n can also safely restrict the broadcast to a single application with\n android.content.Intent.setPackage\n </p></li></p></li></p></li></p></li></ul></p>\n\n<p> <p>None of these issues exist when using\n android.support.v4.content.LocalBroadcastManager, since intents\n broadcast it never go outside of the current process.</p>\n\n<p> <p>Access permissions can be enforced by either the sender or receiver\n of a broadcast.</p>\n\n<p> <p>To enforce a permission when sending, you supply a non-null\n <var>permission</var> argument to\n String) or\n String, BroadcastReceiver, android.os.Handler, int, String, Bundle).\n Only receivers who have been granted this permission\n (by requesting it with the\n &lt;uses-permission&gt;\n tag in their <code>AndroidManifest.xml</code>) will be able to receive\n the broadcast.</p>\n\n<p> <p>To enforce a permission when receiving, you supply a non-null\n <var>permission</var> when registering your receiver -- either when calling\n android.content.IntentFilter, String, android.os.Handler)\n or in the static\n &lt;receiver&gt;\n tag in your <code>AndroidManifest.xml</code>.  Only broadcasters who have\n been granted this permission (by requesting it with the\n &lt;uses-permission&gt;\n tag in their <code>AndroidManifest.xml</code>) will be able to send an\n Intent to the receiver.</p>\n\n<p> <p>See the <a href=\"{@docRoot}guide/topics/security/security.html\">Security and Permissions</a>\n document for more information on permissions and security in general.</p>\n\n<p> <a name=\"ReceiverLifecycle\"></a>\n <h3>Receiver Lifecycle</h3></p>\n\n<p> <p>A BroadcastReceiver object is only valid for the duration of the call\n to <a href=\"#!/api/android.content.BroadcastReceiver-method-onReceive\" rel=\"android.content.BroadcastReceiver-method-onReceive\" class=\"docClass\">onReceive</a>.  Once your code returns from this function,\n the system considers the object to be finished and no longer active.</p>\n\n<p> <p>This has important repercussions to what you can do in an\n <a href=\"#!/api/android.content.BroadcastReceiver-method-onReceive\" rel=\"android.content.BroadcastReceiver-method-onReceive\" class=\"docClass\">onReceive</a> implementation: anything that requires asynchronous\n operation is not available, because you will need to return from the\n function to handle the asynchronous operation, but at that point the\n BroadcastReceiver is no longer active and thus the system is free to kill\n its process before the asynchronous operation completes.</p>\n\n<p> <p>In particular, you may <i>not</i> show a dialog or bind to a service from\n within a BroadcastReceiver.  For the former, you should instead use the\n android.app.NotificationManager API.  For the latter, you can\n use <a href=\"#!/api/android.content.Context-method-startService\" rel=\"android.content.Context-method-startService\" class=\"docClass\">Context.startService()</a> to\n send a command to the service.</p>\n\n<p> <a name=\"ProcessLifecycle\"></a>\n <h3>Process Lifecycle</h3></p>\n\n<p> <p>A process that is currently executing a BroadcastReceiver (that is,\n currently running the code in its <a href=\"#!/api/android.content.BroadcastReceiver-method-onReceive\" rel=\"android.content.BroadcastReceiver-method-onReceive\" class=\"docClass\">onReceive</a> method) is\n considered to be a foreground process and will be kept running by the\n system except under cases of extreme memory pressure.</p>\n\n<p> <p>Once you return from onReceive(), the BroadcastReceiver is no longer\n active, and its hosting process is only as important as any other application\n components that are running in it.  This is especially important because if\n that process was only hosting the BroadcastReceiver (a common case for\n applications that the user has never or not recently interacted with), then\n upon returning from onReceive() the system will consider its process\n to be empty and aggressively kill it so that resources are available for other\n more important processes.</p>\n\n<p> <p>This means that for longer-running operations you will often use\n a android.app.Service in conjunction with a BroadcastReceiver to keep\n the containing process active for the entire time of your operation.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-abortBroadcast' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-abortBroadcast' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-abortBroadcast' class='name expandable'>abortBroadcast</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Sets the flag indicating that this receiver should abort the\n current broadcast; only works with broadcasts sent thro...</div><div class='long'><p>Sets the flag indicating that this receiver should abort the\n current broadcast; only works with broadcasts sent through\n String)\n android.content.Context.sendOrderedBroadcast.  This will prevent\n any other broadcast receivers from receiving the broadcast. It will still\n call <a href=\"#!/api/android.content.BroadcastReceiver-method-onReceive\" rel=\"android.content.BroadcastReceiver-method-onReceive\" class=\"docClass\">onReceive</a> of the BroadcastReceiver that the caller of\n String)\n android.content.Context.sendOrderedBroadcast passed in.</p>\n\n<p> <p><strong>This method does not work with non-ordered broadcasts such\n as those sent with android.content.Context.sendBroadcast</strong></p></p>\n</div></div></div><div id='method-clearAbortBroadcast' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-clearAbortBroadcast' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-clearAbortBroadcast' class='name expandable'>clearAbortBroadcast</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Clears the flag indicating that this receiver should abort the current\n broadcast. ...</div><div class='long'><p>Clears the flag indicating that this receiver should abort the current\n broadcast.</p>\n</div></div></div><div id='method-getAbortBroadcast' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-getAbortBroadcast' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-getAbortBroadcast' class='name expandable'>getAbortBroadcast</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the flag indicating whether or not this receiver should\n abort the current broadcast. ...</div><div class='long'><p>Returns the flag indicating whether or not this receiver should\n abort the current broadcast.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>True if the broadcast should be aborted.</p>\n</div></li></ul></div></div></div><div id='method-getDebugUnregister' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-getDebugUnregister' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-getDebugUnregister' class='name expandable'>getDebugUnregister</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Return the last value given to setDebugUnregister. ...</div><div class='long'><p>Return the last value given to <a href=\"#!/api/android.content.BroadcastReceiver-method-setDebugUnregister\" rel=\"android.content.BroadcastReceiver-method-setDebugUnregister\" class=\"docClass\">setDebugUnregister</a>.</p>\n</div></div></div><div id='method-getResultCode' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-getResultCode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-getResultCode' class='name expandable'>getResultCode</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Retrieve the current result code, as set by the previous receiver. ...</div><div class='long'><p>Retrieve the current result code, as set by the previous receiver.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>int The current result code.</p>\n</div></li></ul></div></div></div><div id='method-getResultData' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-getResultData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-getResultData' class='name expandable'>getResultData</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Retrieve the current result data, as set by the previous receiver. ...</div><div class='long'><p>Retrieve the current result data, as set by the previous receiver.\n Often this is null.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>String The current result data; may be null.</p>\n</div></li></ul></div></div></div><div id='method-getResultExtras' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-getResultExtras' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-getResultExtras' class='name expandable'>getResultExtras</a>( <span class='pre'>makeMap</span> ) : Object {android.os.Bundle}<span class=\"signature\"></span></div><div class='description'><div class='short'>Retrieve the current result extra data, as set by the previous receiver. ...</div><div class='long'><p>Retrieve the current result extra data, as set by the previous receiver.\n Any changes you make to the returned Map will be propagated to the next\n receiver.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>makeMap</span> : Boolean<div class='sub-desc'><p>If true then a new empty Map will be made for you if the\n                current Map is null; if false you should be prepared to\n                receive a null Map.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.os.Bundle}</span><div class='sub-desc'><p>Map The current extras map.</p>\n</div></li></ul></div></div></div><div id='method-goAsync' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-goAsync' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-goAsync' class='name expandable'>goAsync</a>( <span class='pre'></span> ) : Object {android.content.BroadcastReceiver.PendingResult}<span class=\"signature\"></span></div><div class='description'><div class='short'>This can be called by an application in onReceive to allow\n it to keep the broadcast active after returning from that...</div><div class='long'><p>This can be called by an application in <a href=\"#!/api/android.content.BroadcastReceiver-method-onReceive\" rel=\"android.content.BroadcastReceiver-method-onReceive\" class=\"docClass\">onReceive</a> to allow\n it to keep the broadcast active after returning from that function.\n This does <em>not</em> change the expectation of being relatively\n responsive to the broadcast (finishing it within 10s), but does allow\n the implementation to move work related to it over to another thread\n to avoid glitching the main UI thread due to disk IO.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.content.BroadcastReceiver.PendingResult}</span><div class='sub-desc'><p>Returns a PendingResult representing the result of\n the active broadcast.  The BroadcastRecord itself is no longer active;\n all data and other interaction must go through PendingResult\n APIs.  The PendingResult.finish() method\n must be called once processing of the broadcast is done.</p>\n</div></li></ul></div></div></div><div id='method-isInitialStickyBroadcast' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-isInitialStickyBroadcast' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-isInitialStickyBroadcast' class='name expandable'>isInitialStickyBroadcast</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns true if the receiver is currently processing the initial\n value of a sticky broadcast -- that is, the value t...</div><div class='long'><p>Returns true if the receiver is currently processing the initial\n value of a sticky broadcast -- that is, the value that was last\n broadcast and is currently held in the sticky cache, so this is\n not directly the result of a broadcast right now.</p>\n</div></div></div><div id='method-isOrderedBroadcast' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-isOrderedBroadcast' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-isOrderedBroadcast' class='name expandable'>isOrderedBroadcast</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns true if the receiver is currently processing an ordered\n broadcast. ...</div><div class='long'><p>Returns true if the receiver is currently processing an ordered\n broadcast.</p>\n</div></div></div><div id='method-onReceive' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-onReceive' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-onReceive' class='name expandable'>onReceive</a>( <span class='pre'>context, intent</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>This method is called when the BroadcastReceiver is receiving an Intent\n broadcast. ...</div><div class='long'><p>This method is called when the BroadcastReceiver is receiving an Intent\n broadcast.  During this time you can use the other methods on\n BroadcastReceiver to view/modify the current result values.  This method\n is always called within the main thread of its process, unless you\n explicitly asked for it to be scheduled on a different thread using\n IntentFilter, String, android.os.Handler). When it runs on the main\n thread you should\n never perform long-running operations in it (there is a timeout of\n 10 seconds that the system allows before considering the receiver to\n be blocked and a candidate to be killed). You cannot launch a popup dialog\n in your implementation of onReceive().</p>\n\n<p> <p><b>If this BroadcastReceiver was launched through a &lt;receiver&gt; tag,\n then the object is no longer alive after returning from this\n function.</b>  This means you should not perform any operations that\n return a result to you asynchronously -- in particular, for interacting\n with services, you should use\n android.content.Context.startService(Intent) instead of\n ServiceConnection, int).  If you wish\n to interact with a service that is already running, you can use\n <a href=\"#!/api/android.content.BroadcastReceiver-method-peekService\" rel=\"android.content.BroadcastReceiver-method-peekService\" class=\"docClass\">peekService</a>.</p>\n\n<p> <p>The Intent filters used in <a href=\"#!/api/android.content.Context-method-registerReceiver\" rel=\"android.content.Context-method-registerReceiver\" class=\"docClass\">android.content.Context.registerReceiver</a>\n and in application manifests are <em>not</em> guaranteed to be exclusive. They\n are hints to the operating system about how to find suitable recipients. It is\n possible for senders to force delivery to specific recipients, bypassing filter\n resolution.  For this reason, android.content.Intent) onReceive()\n implementations should respond only to known actions, ignoring any unexpected\n Intents that they may receive.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>context</span> : Object {Context}<div class='sub-desc'><p>The Context in which the receiver is running.</p>\n</div></li><li><span class='pre'>intent</span> : Object {Intent}<div class='sub-desc'><p>The Intent being received.</p>\n</div></li></ul></div></div></div><div id='method-peekService' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-peekService' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-peekService' class='name expandable'>peekService</a>( <span class='pre'>myContext, service</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Provide a binder to an already-running service. ...</div><div class='long'><p>Provide a binder to an already-running service.  This method is synchronous\n and will not start the target service if it is not present, so it is safe\n to call from <a href=\"#!/api/android.content.BroadcastReceiver-method-onReceive\" rel=\"android.content.BroadcastReceiver-method-onReceive\" class=\"docClass\">onReceive</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>myContext</span> : Object {Context}<div class='sub-desc'><p>The Context that had been passed to Intent)</p>\n</div></li><li><span class='pre'>service</span> : Object {Intent}<div class='sub-desc'><p>The Intent indicating the service you wish to use.  See Context.startService(Intent) for more information.</p>\n</div></li></ul></div></div></div><div id='method-setDebugUnregister' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-setDebugUnregister' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-setDebugUnregister' class='name expandable'>setDebugUnregister</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Control inclusion of debugging help for mismatched\n calls to android.content.IntentFilter)\n Context.registerReceiver(). ...</div><div class='long'><p>Control inclusion of debugging help for mismatched\n calls to android.content.IntentFilter)\n Context.registerReceiver().\n If called with true, before given to registerReceiver(), then the\n callstack of the following android.content.Context.unregisterReceiver() call is retained, to be printed if a later\n incorrect unregister call is made.  Note that doing this requires retaining\n information about the BroadcastReceiver for the lifetime of the app,\n resulting in a leak -- this should only be used for debugging.</p>\n</div></div></div><div id='method-setOrderedHint' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-setOrderedHint' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-setOrderedHint' class='name expandable'>setOrderedHint</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>For internal use, sets the hint about whether this BroadcastReceiver is\n running in ordered mode. ...</div><div class='long'><p>For internal use, sets the hint about whether this BroadcastReceiver is\n running in ordered mode.</p>\n</div></div></div><div id='method-setResult' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-setResult' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-setResult' class='name expandable'>setResult</a>( <span class='pre'>code, data, extras</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Change all of the result data returned from this broadcasts; only works\n with broadcasts sent through\n String)\n andro...</div><div class='long'><p>Change all of the result data returned from this broadcasts; only works\n with broadcasts sent through\n String)\n android.content.Context.sendOrderedBroadcast.  All current result data is replaced\n by the value given to this method.</p>\n\n<p> <p><strong>This method does not work with non-ordered broadcasts such\n as those sent with android.content.Context.sendBroadcast</strong></p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>code</span> : Number<div class='sub-desc'><p>The new result code.  Often uses the\n Activity android.app.Activity.RESULT_CANCELED and\n android.app.Activity.RESULT_OK constants, though the\n actual meaning of this value is ultimately up to the broadcaster.</p>\n</div></li><li><span class='pre'>data</span> : String<div class='sub-desc'><p>The new result data.  This is an arbitrary\n string whose interpretation is up to the broadcaster; may be null.</p>\n</div></li><li><span class='pre'>extras</span> : Object {Bundle}<div class='sub-desc'><p>The new extra data map.  This is a Bundle\n holding arbitrary data, whose interpretation is up to the\n broadcaster.  Can be set to null.  This completely\n replaces the current map (if any).</p>\n</div></li></ul></div></div></div><div id='method-setResultCode' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-setResultCode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-setResultCode' class='name expandable'>setResultCode</a>( <span class='pre'>code</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Change the current result code of this broadcast; only works with\n broadcasts sent through\n String)\n android.content....</div><div class='long'><p>Change the current result code of this broadcast; only works with\n broadcasts sent through\n String)\n android.content.Context.sendOrderedBroadcast.  Often uses the\n Activity android.app.Activity.RESULT_CANCELED and\n android.app.Activity.RESULT_OK constants, though the\n actual meaning of this value is ultimately up to the broadcaster.</p>\n\n<p> <p class=\"note\">This method does not work with non-ordered broadcasts such\n as those sent with android.content.Context.sendBroadcast</p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>code</span> : Number<div class='sub-desc'><p>The new result code.\n@see <a href=\"#!/api/android.content.BroadcastReceiver-method-setResult\" rel=\"android.content.BroadcastReceiver-method-setResult\" class=\"docClass\">setResult</a>(int, String, Bundle)</p>\n</div></li></ul></div></div></div><div id='method-setResultData' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-setResultData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-setResultData' class='name expandable'>setResultData</a>( <span class='pre'>data</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Change the current result data of this broadcast; only works with\n broadcasts sent through\n String)\n android.content....</div><div class='long'><p>Change the current result data of this broadcast; only works with\n broadcasts sent through\n String)\n android.content.Context.sendOrderedBroadcast.  This is an arbitrary\n string whose interpretation is up to the broadcaster.</p>\n\n<p> <p><strong>This method does not work with non-ordered broadcasts such\n as those sent with android.content.Context.sendBroadcast</strong></p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : String<div class='sub-desc'><p>The new result data; may be null.\n@see <a href=\"#!/api/android.content.BroadcastReceiver-method-setResult\" rel=\"android.content.BroadcastReceiver-method-setResult\" class=\"docClass\">setResult</a>(int, String, Bundle)</p>\n</div></li></ul></div></div></div><div id='method-setResultExtras' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.BroadcastReceiver'>android.content.BroadcastReceiver</span><br/><a href='source/BroadcastReceiver.html#android-content-BroadcastReceiver-method-setResultExtras' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.BroadcastReceiver-method-setResultExtras' class='name expandable'>setResultExtras</a>( <span class='pre'>extras</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Change the current result extras of this broadcast; only works with\n broadcasts sent through\n String)\n android.conten...</div><div class='long'><p>Change the current result extras of this broadcast; only works with\n broadcasts sent through\n String)\n android.content.Context.sendOrderedBroadcast.  This is a Bundle\n holding arbitrary data, whose interpretation is up to the\n broadcaster.  Can be set to null.  Calling this method completely\n replaces the current map (if any).</p>\n\n<p> <p><strong>This method does not work with non-ordered broadcasts such\n as those sent with android.content.Context.sendBroadcast</strong></p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>extras</span> : Object {Bundle}<div class='sub-desc'><p>The new extra data map; may be null.\n@see <a href=\"#!/api/android.content.BroadcastReceiver-method-setResult\" rel=\"android.content.BroadcastReceiver-method-setResult\" class=\"docClass\">setResult</a>(int, String, Bundle)</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});