Ext.data.JsonP.android_content_ComponentCallbacks({"tagname":"class","name":"android.content.ComponentCallbacks","autodetected":{},"files":[{"filename":"ComponentCallbacks.js","href":"ComponentCallbacks.html#android-content-ComponentCallbacks"}],"members":[{"name":"onConfigurationChanged","tagname":"method","owner":"android.content.ComponentCallbacks","id":"method-onConfigurationChanged","meta":{}},{"name":"onLowMemory","tagname":"method","owner":"android.content.ComponentCallbacks","id":"method-onLowMemory","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.content.ComponentCallbacks","short_doc":"The set of callback APIs that are common to all application components\n (android.app.Activity, android.app.Service,\n ...","classIcon":"icon-class","superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Files</h4><div class='dependency'><a href='source/ComponentCallbacks.html#android-content-ComponentCallbacks' target='_blank'>ComponentCallbacks.js</a></div></pre><div class='doc-contents'><p>The set of callback APIs that are common to all application components\n (android.app.Activity, android.app.Service,\n <a href=\"#!/api/android.content.ContentProvider\" rel=\"android.content.ContentProvider\" class=\"docClass\">android.content.ContentProvider</a>, and android.app.Application).</p>\n\n<p> <p class=\"note\"><strong>Note:</strong> You should also implement the <a href=\"#!/api/android.content.ComponentCallbacks2\" rel=\"android.content.ComponentCallbacks2\" class=\"docClass\">android.content.ComponentCallbacks2</a> interface, which provides the <a href=\"#!/api/android.content.ComponentCallbacks2-method-onTrimMemory\" rel=\"android.content.ComponentCallbacks2-method-onTrimMemory\" class=\"docClass\">android.content.ComponentCallbacks2.onTrimMemory</a> callback to help your app manage its memory usage more\n effectively.</p></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-onConfigurationChanged' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.ComponentCallbacks'>android.content.ComponentCallbacks</span><br/><a href='source/ComponentCallbacks.html#android-content-ComponentCallbacks-method-onConfigurationChanged' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.ComponentCallbacks-method-onConfigurationChanged' class='name expandable'>onConfigurationChanged</a>( <span class='pre'>newConfig</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Called by the system when the device configuration changes while your\n component is running. ...</div><div class='long'><p>Called by the system when the device configuration changes while your\n component is running.  Note that, unlike activities, other components\n are never restarted when a configuration changes: they must always deal\n with the results of the change, such as by re-retrieving resources.</p>\n\n<p> <p>At the time that this function has been called, your Resources\n object will have been updated to return resource values matching the\n new configuration.</p>\n\n<p> <p>For more information, read &lt;a href=\"{@docRoot}guide/topics/resources/runtime-changes.html\"</p>\n\n<blockquote><p>Handling Runtime Changes.</p></blockquote>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newConfig</span> : Object {Configuration}<div class='sub-desc'><p>The new device configuration.</p>\n</div></li></ul></div></div></div><div id='method-onLowMemory' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.ComponentCallbacks'>android.content.ComponentCallbacks</span><br/><a href='source/ComponentCallbacks.html#android-content-ComponentCallbacks-method-onLowMemory' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.ComponentCallbacks-method-onLowMemory' class='name expandable'>onLowMemory</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>This is called when the overall system is running low on memory, and\n actively running processes should trim their me...</div><div class='long'><p>This is called when the overall system is running low on memory, and\n actively running processes should trim their memory usage.  While\n the exact point at which this will be called is not defined, generally\n it will happen when all background process have been killed.\n That is, before reaching the point of killing processes hosting\n service and foreground UI that we would like to avoid killing.</p>\n\n<p> <p>You should implement this method to release\n any caches or other unnecessary resources you may be holding on to.\n The system will perform a garbage collection for you after returning from this method.\n <p>Preferably, you should implement <a href=\"#!/api/android.content.ComponentCallbacks2-method-onTrimMemory\" rel=\"android.content.ComponentCallbacks2-method-onTrimMemory\" class=\"docClass\">android.content.ComponentCallbacks2.onTrimMemory</a> from\n <a href=\"#!/api/android.content.ComponentCallbacks2\" rel=\"android.content.ComponentCallbacks2\" class=\"docClass\">android.content.ComponentCallbacks2</a> to incrementally unload your resources based on various\n levels of memory demands.  That API is available for API level 14 and higher, so you should\n only use this <a href=\"#!/api/android.content.ComponentCallbacks-method-onLowMemory\" rel=\"android.content.ComponentCallbacks-method-onLowMemory\" class=\"docClass\">onLowMemory</a> method as a fallback for older versions, which can be\n treated the same as <a href=\"#!/api/android.content.ComponentCallbacks2-method-onTrimMemory\" rel=\"android.content.ComponentCallbacks2-method-onTrimMemory\" class=\"docClass\">android.content.ComponentCallbacks2.onTrimMemory</a> with the <a href=\"#!/api/android.content.ComponentCallbacks2-property-TRIM_MEMORY_COMPLETE\" rel=\"android.content.ComponentCallbacks2-property-TRIM_MEMORY_COMPLETE\" class=\"docClass\">android.content.ComponentCallbacks2.TRIM_MEMORY_COMPLETE</a> level.</p></p>\n</div></div></div></div></div></div></div>","meta":{}});