Ext.data.JsonP.android_content_ContentUris({"tagname":"class","name":"android.content.ContentUris","autodetected":{},"files":[{"filename":"ContentUris.js","href":"ContentUris.html#android-content-ContentUris"}],"extends":"java.lang.Object","members":[{"name":"appendId","tagname":"method","owner":"android.content.ContentUris","id":"method-appendId","meta":{}},{"name":"parseId","tagname":"method","owner":"android.content.ContentUris","id":"method-parseId","meta":{}},{"name":"withAppendedId","tagname":"method","owner":"android.content.ContentUris","id":"method-withAppendedId","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.content.ContentUris","short_doc":"Utility methods useful for working with android.net.Uri objects\n that use the &quot;content&quot; (content://) scheme. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.content.ContentUris</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/ContentUris.html#android-content-ContentUris' target='_blank'>ContentUris.js</a></div></pre><div class='doc-contents'><p>Utility methods useful for working with android.net.Uri objects\n that use the &quot;content&quot; (content://) scheme.</p>\n\n<p>\n   Content URIs have the syntax\n</p>\n\n\n<p>\n   <code>content://<em>authority</em>/<em>path</em>/<em>id</em></code>\n</p>\n\n\n<dl>\n   <dt>\n       <code>content:</code>\n   </dt>\n   <dd>\n       The scheme portion of the URI. This is always set to <a href=\"#!/api/android.content.ContentResolver-property-SCHEME_CONTENT\" rel=\"android.content.ContentResolver-property-SCHEME_CONTENT\" class=\"docClass\">ContentResolver.SCHEME_CONTENT</a> (value\n       <code>content://</code>).\n   </dd>\n   <dt>\n       <em>authority</em>\n   </dt>\n   <dd>\n       A string that identifies the entire content provider. All the content URIs for the provider\n       start with this string. To guarantee a unique authority, providers should consider\n       using an authority that is the same as the provider class' package identifier.\n   </dd>\n   <dt>\n       <em>path</em>\n   </dt>\n   <dd>\n       Zero or more segments, separated by a forward slash (<code>/</code>), that identify\n       some subset of the provider's data. Most providers use the path part to identify\n       individual tables. Individual segments in the path are often called\n       &quot;directories&quot; although they do not refer to file directories. The right-most\n       segment in a path is often called a &quot;twig&quot;\n   </dd>\n   <dt>\n       <em>id</em>\n   </dt>\n   <dd>\n       A unique numeric identifier for a single row in the subset of data identified by the\n       preceding path part. Most providers recognize content URIs that contain an id part\n       and give them special handling. A table that contains a column named <code>_ID</code>\n       often expects the id part to be a particular value for that column.\n   </dd>\n</dl>\n\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-appendId' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.ContentUris'>android.content.ContentUris</span><br/><a href='source/ContentUris.html#android-content-ContentUris-method-appendId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.ContentUris-method-appendId' class='name expandable'>appendId</a>( <span class='pre'>builder, id</span> ) : Object {android.net.Uri.Builder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Appends the given ID to the end of the path. ...</div><div class='long'><p>Appends the given ID to the end of the path.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>builder</span> : Object {Uri.Builder}<div class='sub-desc'><p>to append the ID to</p>\n</div></li><li><span class='pre'>id</span> : Number<div class='sub-desc'><p>to append</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.Uri.Builder}</span><div class='sub-desc'><p>the given builder</p>\n</div></li></ul></div></div></div><div id='method-parseId' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.ContentUris'>android.content.ContentUris</span><br/><a href='source/ContentUris.html#android-content-ContentUris-method-parseId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.ContentUris-method-parseId' class='name expandable'>parseId</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Converts the last path segment to a long. ...</div><div class='long'><p>Converts the last path segment to a long.</p>\n\n<p> <p>This supports a common convention for content URIs where an ID is\n stored in the last segment.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>the long conversion of the last segment or -1 if the path is\n  empty</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>UnsupportedOperationException if this isn't a hierarchical URI</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>NumberFormatException if the last segment isn't a number</p>\n</div></li></ul></div></div></div><div id='method-withAppendedId' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.ContentUris'>android.content.ContentUris</span><br/><a href='source/ContentUris.html#android-content-ContentUris-method-withAppendedId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.ContentUris-method-withAppendedId' class='name expandable'>withAppendedId</a>( <span class='pre'>contentUri, id</span> ) : Object {android.net.Uri}<span class=\"signature\"></span></div><div class='description'><div class='short'>Appends the given ID to the end of the path. ...</div><div class='long'><p>Appends the given ID to the end of the path.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>contentUri</span> : Object {Uri}<div class='sub-desc'><p>to start with</p>\n</div></li><li><span class='pre'>id</span> : Number<div class='sub-desc'><p>to append</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.Uri}</span><div class='sub-desc'><p>a new URI with the given ID appended to the end of the path</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});