Ext.data.JsonP.android_content_DefaultDataHandler({"tagname":"class","name":"android.content.DefaultDataHandler","autodetected":{},"files":[{"filename":"DefaultDataHandler.js","href":"DefaultDataHandler.html#android-content-DefaultDataHandler"}],"extends":"java.lang.Object","hide":true,"members":[{"name":"characters","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-characters","meta":{}},{"name":"endDocument","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-endDocument","meta":{}},{"name":"endElement","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-endElement","meta":{}},{"name":"endPrefixMapping","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-endPrefixMapping","meta":{}},{"name":"ignorableWhitespace","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-ignorableWhitespace","meta":{}},{"name":"insert","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-insert","meta":{}},{"name":"processingInstruction","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-processingInstruction","meta":{}},{"name":"setDocumentLocator","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-setDocumentLocator","meta":{}},{"name":"skippedEntity","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-skippedEntity","meta":{}},{"name":"startDocument","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-startDocument","meta":{}},{"name":"startElement","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-startElement","meta":{}},{"name":"startPrefixMapping","tagname":"method","owner":"android.content.DefaultDataHandler","id":"method-startPrefixMapping","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.content.DefaultDataHandler","short_doc":"implements android.content.ContentInsertHandler\n\nInserts default data from InputStream, should be in XML format. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.content.DefaultDataHandler</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler' target='_blank'>DefaultDataHandler.js</a></div></pre><div class='doc-contents'><p>implements <a href=\"#!/api/android.content.ContentInsertHandler\" rel=\"android.content.ContentInsertHandler\" class=\"docClass\">android.content.ContentInsertHandler</a></p>\n\n<p>Inserts default data from InputStream, should be in XML format.\n If the provider syncs data to the server, the imported data will be synced to the server.\n <p>Samples:</p>\n <br/>\n  Insert one row:</p>\n\n<pre> &lt;row uri=\"content://contacts/people\">\n  &lt;Col column = \"name\" value = \"foo feebe \"/>\n  &lt;Col column = \"addr\" value = \"Tx\"/>\n &lt;/row></pre>\n\n\n<p> <br/>\n Delete, it must be in order of uri, select, and arg:</p>\n\n<pre> &lt;del uri=\"content://contacts/people\" select=\"name=? and addr=?\" \n  arg1 = \"foo feebe\" arg2 =\"Tx\"/></pre>\n\n\n<p> <br/>\n  Use first row's uri to insert into another table,\n  content://contacts/people/1/phones:</p>\n\n<pre> &lt;row uri=\"content://contacts/people\">\n  &lt;col column = \"name\" value = \"foo feebe\"/>\n  &lt;col column = \"addr\" value = \"Tx\"/>\n  &lt;row postfix=\"phones\">\n    &lt;col column=\"number\" value=\"512-514-6535\"/>\n  &lt;/row>\n  &lt;row postfix=\"phones\">\n    &lt;col column=\"cell\" value=\"512-514-6535\"/>\n  &lt;/row>  \n &lt;/row></pre>\n\n\n<p> <br/>\n  Insert multiple rows in to same table and same attributes:</p>\n\n<pre> &lt;row uri=\"content://contacts/people\" >\n  &lt;row>\n   &lt;col column= \"name\" value = \"foo feebe\"/>\n   &lt;col column= \"addr\" value = \"Tx\"/>\n  &lt;/row>\n  &lt;row>\n  &lt;/row>\n &lt;/row></pre>\n\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-characters' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-characters' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-characters' class='name expandable'>characters</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-endDocument' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-endDocument' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-endDocument' class='name expandable'>endDocument</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-endElement' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-endElement' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-endElement' class='name expandable'>endElement</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-endPrefixMapping' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-endPrefixMapping' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-endPrefixMapping' class='name expandable'>endPrefixMapping</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-ignorableWhitespace' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-ignorableWhitespace' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-ignorableWhitespace' class='name expandable'>ignorableWhitespace</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-insert' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-insert' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-insert' class='name expandable'>insert</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-processingInstruction' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-processingInstruction' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-processingInstruction' class='name expandable'>processingInstruction</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-setDocumentLocator' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-setDocumentLocator' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-setDocumentLocator' class='name expandable'>setDocumentLocator</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-skippedEntity' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-skippedEntity' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-skippedEntity' class='name expandable'>skippedEntity</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-startDocument' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-startDocument' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-startDocument' class='name expandable'>startDocument</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-startElement' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-startElement' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-startElement' class='name expandable'>startElement</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-startPrefixMapping' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.DefaultDataHandler'>android.content.DefaultDataHandler</span><br/><a href='source/DefaultDataHandler.html#android-content-DefaultDataHandler-method-startPrefixMapping' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.DefaultDataHandler-method-startPrefixMapping' class='name expandable'>startPrefixMapping</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div></div></div></div></div>","meta":{}});