Ext.data.JsonP.android_content_SharedPreferences_Editor({"tagname":"class","name":"android.content.SharedPreferences.Editor","autodetected":{},"files":[{"filename":"Editor.js","href":"Editor.html#android-content-SharedPreferences-Editor"}],"members":[{"name":"apply","tagname":"method","owner":"android.content.SharedPreferences.Editor","id":"method-apply","meta":{}},{"name":"clear","tagname":"method","owner":"android.content.SharedPreferences.Editor","id":"method-clear","meta":{}},{"name":"commit","tagname":"method","owner":"android.content.SharedPreferences.Editor","id":"method-commit","meta":{}},{"name":"putBoolean","tagname":"method","owner":"android.content.SharedPreferences.Editor","id":"method-putBoolean","meta":{}},{"name":"putFloat","tagname":"method","owner":"android.content.SharedPreferences.Editor","id":"method-putFloat","meta":{}},{"name":"putInt","tagname":"method","owner":"android.content.SharedPreferences.Editor","id":"method-putInt","meta":{}},{"name":"putLong","tagname":"method","owner":"android.content.SharedPreferences.Editor","id":"method-putLong","meta":{}},{"name":"putString","tagname":"method","owner":"android.content.SharedPreferences.Editor","id":"method-putString","meta":{}},{"name":"putStringSet","tagname":"method","owner":"android.content.SharedPreferences.Editor","id":"method-putStringSet","meta":{}},{"name":"remove","tagname":"method","owner":"android.content.SharedPreferences.Editor","id":"method-remove","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.content.SharedPreferences.Editor","short_doc":"Interface used for modifying values in a android.content.SharedPreferences\n object. ...","classIcon":"icon-class","superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Files</h4><div class='dependency'><a href='source/Editor.html#android-content-SharedPreferences-Editor' target='_blank'>Editor.js</a></div></pre><div class='doc-contents'><p>Interface used for modifying values in a <a href=\"#!/api/android.content.SharedPreferences\" rel=\"android.content.SharedPreferences\" class=\"docClass\">android.content.SharedPreferences</a>\n object.  All changes you make in an editor are batched, and not copied\n back to the original <a href=\"#!/api/android.content.SharedPreferences\" rel=\"android.content.SharedPreferences\" class=\"docClass\">android.content.SharedPreferences</a> until you call <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a>\n or <a href=\"#!/api/android.content.SharedPreferences.Editor-method-apply\" rel=\"android.content.SharedPreferences.Editor-method-apply\" class=\"docClass\">apply</a></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-apply' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences.Editor'>android.content.SharedPreferences.Editor</span><br/><a href='source/Editor.html#android-content-SharedPreferences-Editor-method-apply' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences.Editor-method-apply' class='name expandable'>apply</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Commit your preferences changes back from this Editor to the\n android.content.SharedPreferences object it is editing. ...</div><div class='long'><p>Commit your preferences changes back from this Editor to the\n <a href=\"#!/api/android.content.SharedPreferences\" rel=\"android.content.SharedPreferences\" class=\"docClass\">android.content.SharedPreferences</a> object it is editing.  This atomically\n performs the requested modifications, replacing whatever is currently\n in the SharedPreferences.</p>\n\n<p> <p>Note that when two editors are modifying preferences at the same\n time, the last one to call apply wins.</p>\n\n<p> <p>Unlike <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a>, which writes its preferences out\n to persistent storage synchronously, <a href=\"#!/api/android.content.SharedPreferences.Editor-method-apply\" rel=\"android.content.SharedPreferences.Editor-method-apply\" class=\"docClass\">apply</a>\n commits its changes to the in-memory\n <a href=\"#!/api/android.content.SharedPreferences\" rel=\"android.content.SharedPreferences\" class=\"docClass\">android.content.SharedPreferences</a> immediately but starts an\n asynchronous commit to disk and you won't be notified of\n any failures.  If another editor on this\n <a href=\"#!/api/android.content.SharedPreferences\" rel=\"android.content.SharedPreferences\" class=\"docClass\">android.content.SharedPreferences</a> does a regular <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a>\n while a <a href=\"#!/api/android.content.SharedPreferences.Editor-method-apply\" rel=\"android.content.SharedPreferences.Editor-method-apply\" class=\"docClass\">apply</a> is still outstanding, the\n <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a> will block until all async commits are\n completed as well as the commit itself.</p>\n\n<p> <p>As <a href=\"#!/api/android.content.SharedPreferences\" rel=\"android.content.SharedPreferences\" class=\"docClass\">android.content.SharedPreferences</a> instances are singletons within\n a process, it's safe to replace any instance of <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a> with\n <a href=\"#!/api/android.content.SharedPreferences.Editor-method-apply\" rel=\"android.content.SharedPreferences.Editor-method-apply\" class=\"docClass\">apply</a> if you were already ignoring the return value.</p>\n\n<p> <p>You don't need to worry about Android component\n lifecycles and their interaction with <code>apply()</code>\n writing to disk.  The framework makes sure in-flight disk\n writes from <code>apply()</code> complete before switching\n states.</p>\n\n<p> <p class='note'>The SharedPreferences.Editor interface\n isn't expected to be implemented directly.  However, if you\n previously did implement it and are now getting errors\n about missing <code>apply()</code>, you can simply call\n <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a> from <code>apply()</code>.</p>\n</div></div></div><div id='method-clear' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences.Editor'>android.content.SharedPreferences.Editor</span><br/><a href='source/Editor.html#android-content-SharedPreferences-Editor-method-clear' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences.Editor-method-clear' class='name expandable'>clear</a>( <span class='pre'></span> ) : Object {android.content.SharedPreferences.Editor}<span class=\"signature\"></span></div><div class='description'><div class='short'>Mark in the editor to remove all values from the\n preferences. ...</div><div class='long'><p>Mark in the editor to remove <em>all</em> values from the\n preferences.  Once commit is called, the only remaining preferences\n will be any that you have defined in this editor.</p>\n\n<p> <p>Note that when committing back to the preferences, the clear\n is done first, regardless of whether you called clear before\n or after put methods on this editor.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.content.SharedPreferences.Editor}</span><div class='sub-desc'><p>Returns a reference to the same Editor object, so you can\n chain put calls together.</p>\n</div></li></ul></div></div></div><div id='method-commit' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences.Editor'>android.content.SharedPreferences.Editor</span><br/><a href='source/Editor.html#android-content-SharedPreferences-Editor-method-commit' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences.Editor-method-commit' class='name expandable'>commit</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Commit your preferences changes back from this Editor to the\n android.content.SharedPreferences object it is editing. ...</div><div class='long'><p>Commit your preferences changes back from this Editor to the\n <a href=\"#!/api/android.content.SharedPreferences\" rel=\"android.content.SharedPreferences\" class=\"docClass\">android.content.SharedPreferences</a> object it is editing.  This atomically\n performs the requested modifications, replacing whatever is currently\n in the SharedPreferences.</p>\n\n<p> <p>Note that when two editors are modifying preferences at the same\n time, the last one to call commit wins.</p>\n\n<p> <p>If you don't care about the return value and you're\n using this from your application's main thread, consider\n using <a href=\"#!/api/android.content.SharedPreferences.Editor-method-apply\" rel=\"android.content.SharedPreferences.Editor-method-apply\" class=\"docClass\">apply</a> instead.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the new values were successfully written\n to persistent storage.</p>\n</div></li></ul></div></div></div><div id='method-putBoolean' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences.Editor'>android.content.SharedPreferences.Editor</span><br/><a href='source/Editor.html#android-content-SharedPreferences-Editor-method-putBoolean' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences.Editor-method-putBoolean' class='name expandable'>putBoolean</a>( <span class='pre'>key, value</span> ) : Object {android.content.SharedPreferences.Editor}<span class=\"signature\"></span></div><div class='description'><div class='short'>Set a boolean value in the preferences editor, to be written back\n once commit or apply are called. ...</div><div class='long'><p>Set a boolean value in the preferences editor, to be written back\n once <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a> or <a href=\"#!/api/android.content.SharedPreferences.Editor-method-apply\" rel=\"android.content.SharedPreferences.Editor-method-apply\" class=\"docClass\">apply</a> are called.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to modify.</p>\n</div></li><li><span class='pre'>value</span> : Boolean<div class='sub-desc'><p>The new value for the preference.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.content.SharedPreferences.Editor}</span><div class='sub-desc'><p>Returns a reference to the same Editor object, so you can\n chain put calls together.</p>\n</div></li></ul></div></div></div><div id='method-putFloat' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences.Editor'>android.content.SharedPreferences.Editor</span><br/><a href='source/Editor.html#android-content-SharedPreferences-Editor-method-putFloat' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences.Editor-method-putFloat' class='name expandable'>putFloat</a>( <span class='pre'>key, value</span> ) : Object {android.content.SharedPreferences.Editor}<span class=\"signature\"></span></div><div class='description'><div class='short'>Set a float value in the preferences editor, to be written back once\n commit or apply are called. ...</div><div class='long'><p>Set a float value in the preferences editor, to be written back once\n <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a> or <a href=\"#!/api/android.content.SharedPreferences.Editor-method-apply\" rel=\"android.content.SharedPreferences.Editor-method-apply\" class=\"docClass\">apply</a> are called.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to modify.</p>\n</div></li><li><span class='pre'>value</span> : Number<div class='sub-desc'><p>The new value for the preference.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.content.SharedPreferences.Editor}</span><div class='sub-desc'><p>Returns a reference to the same Editor object, so you can\n chain put calls together.</p>\n</div></li></ul></div></div></div><div id='method-putInt' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences.Editor'>android.content.SharedPreferences.Editor</span><br/><a href='source/Editor.html#android-content-SharedPreferences-Editor-method-putInt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences.Editor-method-putInt' class='name expandable'>putInt</a>( <span class='pre'>key, value</span> ) : Object {android.content.SharedPreferences.Editor}<span class=\"signature\"></span></div><div class='description'><div class='short'>Set an int value in the preferences editor, to be written back once\n commit or apply are called. ...</div><div class='long'><p>Set an int value in the preferences editor, to be written back once\n <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a> or <a href=\"#!/api/android.content.SharedPreferences.Editor-method-apply\" rel=\"android.content.SharedPreferences.Editor-method-apply\" class=\"docClass\">apply</a> are called.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to modify.</p>\n</div></li><li><span class='pre'>value</span> : Number<div class='sub-desc'><p>The new value for the preference.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.content.SharedPreferences.Editor}</span><div class='sub-desc'><p>Returns a reference to the same Editor object, so you can\n chain put calls together.</p>\n</div></li></ul></div></div></div><div id='method-putLong' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences.Editor'>android.content.SharedPreferences.Editor</span><br/><a href='source/Editor.html#android-content-SharedPreferences-Editor-method-putLong' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences.Editor-method-putLong' class='name expandable'>putLong</a>( <span class='pre'>key, value</span> ) : Object {android.content.SharedPreferences.Editor}<span class=\"signature\"></span></div><div class='description'><div class='short'>Set a long value in the preferences editor, to be written back once\n commit or apply are called. ...</div><div class='long'><p>Set a long value in the preferences editor, to be written back once\n <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a> or <a href=\"#!/api/android.content.SharedPreferences.Editor-method-apply\" rel=\"android.content.SharedPreferences.Editor-method-apply\" class=\"docClass\">apply</a> are called.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to modify.</p>\n</div></li><li><span class='pre'>value</span> : Number<div class='sub-desc'><p>The new value for the preference.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.content.SharedPreferences.Editor}</span><div class='sub-desc'><p>Returns a reference to the same Editor object, so you can\n chain put calls together.</p>\n</div></li></ul></div></div></div><div id='method-putString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences.Editor'>android.content.SharedPreferences.Editor</span><br/><a href='source/Editor.html#android-content-SharedPreferences-Editor-method-putString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences.Editor-method-putString' class='name expandable'>putString</a>( <span class='pre'>key, value</span> ) : Object {android.content.SharedPreferences.Editor}<span class=\"signature\"></span></div><div class='description'><div class='short'>Set a String value in the preferences editor, to be written back once\n commit or apply are called. ...</div><div class='long'><p>Set a String value in the preferences editor, to be written back once\n <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a> or <a href=\"#!/api/android.content.SharedPreferences.Editor-method-apply\" rel=\"android.content.SharedPreferences.Editor-method-apply\" class=\"docClass\">apply</a> are called.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to modify.</p>\n</div></li><li><span class='pre'>value</span> : String<div class='sub-desc'><p>The new value for the preference.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.content.SharedPreferences.Editor}</span><div class='sub-desc'><p>Returns a reference to the same Editor object, so you can\n chain put calls together.</p>\n</div></li></ul></div></div></div><div id='method-putStringSet' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences.Editor'>android.content.SharedPreferences.Editor</span><br/><a href='source/Editor.html#android-content-SharedPreferences-Editor-method-putStringSet' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences.Editor-method-putStringSet' class='name expandable'>putStringSet</a>( <span class='pre'>key, values</span> ) : Object {android.content.SharedPreferences.Editor}<span class=\"signature\"></span></div><div class='description'><div class='short'>Set a set of String values in the preferences editor, to be written\n back once commit or apply is called. ...</div><div class='long'><p>Set a set of String values in the preferences editor, to be written\n back once <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a> or <a href=\"#!/api/android.content.SharedPreferences.Editor-method-apply\" rel=\"android.content.SharedPreferences.Editor-method-apply\" class=\"docClass\">apply</a> is called.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to modify.</p>\n</div></li><li><span class='pre'>values</span> : Object {java.util.Set}<div class='sub-desc'><p>The set of new values for the preference.  Passing {@code null}\n    for this argument is equivalent to calling remove(String) with\n    this key.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.content.SharedPreferences.Editor}</span><div class='sub-desc'><p>Returns a reference to the same Editor object, so you can\n chain put calls together.</p>\n</div></li></ul></div></div></div><div id='method-remove' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences.Editor'>android.content.SharedPreferences.Editor</span><br/><a href='source/Editor.html#android-content-SharedPreferences-Editor-method-remove' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences.Editor-method-remove' class='name expandable'>remove</a>( <span class='pre'>key</span> ) : Object {android.content.SharedPreferences.Editor}<span class=\"signature\"></span></div><div class='description'><div class='short'>Mark in the editor that a preference value should be removed, which\n will be done in the actual preferences once comm...</div><div class='long'><p>Mark in the editor that a preference value should be removed, which\n will be done in the actual preferences once <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">commit</a> is\n called.</p>\n\n<p> <p>Note that when committing back to the preferences, all removals\n are done first, regardless of whether you called remove before\n or after put methods on this editor.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to remove.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.content.SharedPreferences.Editor}</span><div class='sub-desc'><p>Returns a reference to the same Editor object, so you can\n chain put calls together.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});