Ext.data.JsonP.android_content_SharedPreferences({"tagname":"class","name":"android.content.SharedPreferences","autodetected":{},"files":[{"filename":"SharedPreferences.js","href":"SharedPreferences.html#android-content-SharedPreferences"}],"members":[{"name":"contains","tagname":"method","owner":"android.content.SharedPreferences","id":"method-contains","meta":{}},{"name":"edit","tagname":"method","owner":"android.content.SharedPreferences","id":"method-edit","meta":{}},{"name":"getAll","tagname":"method","owner":"android.content.SharedPreferences","id":"method-getAll","meta":{}},{"name":"getBoolean","tagname":"method","owner":"android.content.SharedPreferences","id":"method-getBoolean","meta":{}},{"name":"getFloat","tagname":"method","owner":"android.content.SharedPreferences","id":"method-getFloat","meta":{}},{"name":"getInt","tagname":"method","owner":"android.content.SharedPreferences","id":"method-getInt","meta":{}},{"name":"getLong","tagname":"method","owner":"android.content.SharedPreferences","id":"method-getLong","meta":{}},{"name":"getString","tagname":"method","owner":"android.content.SharedPreferences","id":"method-getString","meta":{}},{"name":"getStringSet","tagname":"method","owner":"android.content.SharedPreferences","id":"method-getStringSet","meta":{}},{"name":"registerOnSharedPreferenceChangeListener","tagname":"method","owner":"android.content.SharedPreferences","id":"method-registerOnSharedPreferenceChangeListener","meta":{}},{"name":"unregisterOnSharedPreferenceChangeListener","tagname":"method","owner":"android.content.SharedPreferences","id":"method-unregisterOnSharedPreferenceChangeListener","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.content.SharedPreferences","short_doc":"Interface for accessing and modifying preference data returned by android.content.Context.getSharedPreferences. ...","classIcon":"icon-class","superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Files</h4><div class='dependency'><a href='source/SharedPreferences.html#android-content-SharedPreferences' target='_blank'>SharedPreferences.js</a></div></pre><div class='doc-contents'><p>Interface for accessing and modifying preference data returned by <a href=\"#!/api/android.content.Context-method-getSharedPreferences\" rel=\"android.content.Context-method-getSharedPreferences\" class=\"docClass\">android.content.Context.getSharedPreferences</a>.  For any particular set of preferences,\n there is a single instance of this class that all clients share.\n Modifications to the preferences must go through an <a href=\"#!/api/android.content.SharedPreferences.Editor\" rel=\"android.content.SharedPreferences.Editor\" class=\"docClass\">android.content.SharedPreferences.Editor</a> object\n to ensure the preference values remain in a consistent state and control\n when they are committed to storage.  Objects that are returned from the\n various <code>get</code> methods must be treated as immutable by the application.</p>\n\n<p> <p><em>Note: currently this class does not support use across multiple\n processes.  This will be added later.</em></p>\n\n<p> <div class=\"special reference\">\n <h3>Developer Guides</h3>\n <p>For more information about using SharedPreferences, read the\n <a href=\"{@docRoot}guide/topics/data/data-storage.html#pref\">Data Storage</a>\n developer guide.</p></div></p>\n\n<p> @see Context#getSharedPreferences</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-contains' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences'>android.content.SharedPreferences</span><br/><a href='source/SharedPreferences.html#android-content-SharedPreferences-method-contains' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences-method-contains' class='name expandable'>contains</a>( <span class='pre'>key</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Checks whether the preferences contains a preference. ...</div><div class='long'><p>Checks whether the preferences contains a preference.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to check.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the preference exists in the preferences,\n         otherwise false.</p>\n</div></li></ul></div></div></div><div id='method-edit' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences'>android.content.SharedPreferences</span><br/><a href='source/SharedPreferences.html#android-content-SharedPreferences-method-edit' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences-method-edit' class='name expandable'>edit</a>( <span class='pre'></span> ) : Object {android.content.SharedPreferences.Editor}<span class=\"signature\"></span></div><div class='description'><div class='short'>Create a new Editor for these preferences, through which you can make\n modifications to the data in the preferences a...</div><div class='long'><p>Create a new Editor for these preferences, through which you can make\n modifications to the data in the preferences and atomically commit those\n changes back to the SharedPreferences object.</p>\n\n<p> <p>Note that you <em>must</em> call <a href=\"#!/api/android.content.SharedPreferences.Editor-method-commit\" rel=\"android.content.SharedPreferences.Editor-method-commit\" class=\"docClass\">android.content.SharedPreferences.Editor.commit</a> to have any\n changes you perform in the Editor actually show up in the\n SharedPreferences.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.content.SharedPreferences.Editor}</span><div class='sub-desc'><p>Returns a new instance of the Editor interface, allowing\n you to modify the values in this SharedPreferences object.</p>\n</div></li></ul></div></div></div><div id='method-getAll' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences'>android.content.SharedPreferences</span><br/><a href='source/SharedPreferences.html#android-content-SharedPreferences-method-getAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences-method-getAll' class='name expandable'>getAll</a>( <span class='pre'></span> ) : Object {java.util.Map}<span class=\"signature\"></span></div><div class='description'><div class='short'>Retrieve all values from the preferences. ...</div><div class='long'><p>Retrieve all values from the preferences.</p>\n\n<p> <p>Note that you <em>must not</em> modify the collection returned\n by this method, or alter any of its contents.  The consistency of your\n stored data is not guaranteed if you do.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.util.Map}</span><div class='sub-desc'><p>Returns a map containing a list of pairs key/value representing\n the preferences.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>NullPointerException</p>\n</div></li></ul></div></div></div><div id='method-getBoolean' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences'>android.content.SharedPreferences</span><br/><a href='source/SharedPreferences.html#android-content-SharedPreferences-method-getBoolean' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences-method-getBoolean' class='name expandable'>getBoolean</a>( <span class='pre'>key, defValue</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Retrieve a boolean value from the preferences. ...</div><div class='long'><p>Retrieve a boolean value from the preferences.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to retrieve.</p>\n</div></li><li><span class='pre'>defValue</span> : Boolean<div class='sub-desc'><p>Value to return if this preference does not exist.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns the preference value if it exists, or defValue.  Throws\n ClassCastException if there is a preference with this name that is not\n a boolean.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>ClassCastException</p>\n</div></li></ul></div></div></div><div id='method-getFloat' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences'>android.content.SharedPreferences</span><br/><a href='source/SharedPreferences.html#android-content-SharedPreferences-method-getFloat' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences-method-getFloat' class='name expandable'>getFloat</a>( <span class='pre'>key, defValue</span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Retrieve a float value from the preferences. ...</div><div class='long'><p>Retrieve a float value from the preferences.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to retrieve.</p>\n</div></li><li><span class='pre'>defValue</span> : Number<div class='sub-desc'><p>Value to return if this preference does not exist.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>Returns the preference value if it exists, or defValue.  Throws\n ClassCastException if there is a preference with this name that is not\n a float.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>ClassCastException</p>\n</div></li></ul></div></div></div><div id='method-getInt' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences'>android.content.SharedPreferences</span><br/><a href='source/SharedPreferences.html#android-content-SharedPreferences-method-getInt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences-method-getInt' class='name expandable'>getInt</a>( <span class='pre'>key, defValue</span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Retrieve an int value from the preferences. ...</div><div class='long'><p>Retrieve an int value from the preferences.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to retrieve.</p>\n</div></li><li><span class='pre'>defValue</span> : Number<div class='sub-desc'><p>Value to return if this preference does not exist.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>Returns the preference value if it exists, or defValue.  Throws\n ClassCastException if there is a preference with this name that is not\n an int.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>ClassCastException</p>\n</div></li></ul></div></div></div><div id='method-getLong' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences'>android.content.SharedPreferences</span><br/><a href='source/SharedPreferences.html#android-content-SharedPreferences-method-getLong' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences-method-getLong' class='name expandable'>getLong</a>( <span class='pre'>key, defValue</span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Retrieve a long value from the preferences. ...</div><div class='long'><p>Retrieve a long value from the preferences.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to retrieve.</p>\n</div></li><li><span class='pre'>defValue</span> : Number<div class='sub-desc'><p>Value to return if this preference does not exist.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>Returns the preference value if it exists, or defValue.  Throws\n ClassCastException if there is a preference with this name that is not\n a long.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>ClassCastException</p>\n</div></li></ul></div></div></div><div id='method-getString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences'>android.content.SharedPreferences</span><br/><a href='source/SharedPreferences.html#android-content-SharedPreferences-method-getString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences-method-getString' class='name expandable'>getString</a>( <span class='pre'>key, defValue</span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Retrieve a String value from the preferences. ...</div><div class='long'><p>Retrieve a String value from the preferences.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to retrieve.</p>\n</div></li><li><span class='pre'>defValue</span> : String<div class='sub-desc'><p>Value to return if this preference does not exist.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>Returns the preference value if it exists, or defValue.  Throws\n ClassCastException if there is a preference with this name that is not\n a String.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>ClassCastException</p>\n</div></li></ul></div></div></div><div id='method-getStringSet' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences'>android.content.SharedPreferences</span><br/><a href='source/SharedPreferences.html#android-content-SharedPreferences-method-getStringSet' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences-method-getStringSet' class='name expandable'>getStringSet</a>( <span class='pre'>key, defValues</span> ) : Object {java.util.Set}<span class=\"signature\"></span></div><div class='description'><div class='short'>Retrieve a set of String values from the preferences. ...</div><div class='long'><p>Retrieve a set of String values from the preferences.</p>\n\n<p> <p>Note that you <em>must not</em> modify the set instance returned\n by this call.  The consistency of the stored data is not guaranteed\n if you do, nor is your ability to modify the instance at all.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : String<div class='sub-desc'><p>The name of the preference to retrieve.</p>\n</div></li><li><span class='pre'>defValues</span> : Object {java.util.Set}<div class='sub-desc'><p>Values to return if this preference does not exist.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.util.Set}</span><div class='sub-desc'><p>Returns the preference values if they exist, or defValues.\n Throws ClassCastException if there is a preference with this name\n that is not a Set.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>ClassCastException</p>\n</div></li></ul></div></div></div><div id='method-registerOnSharedPreferenceChangeListener' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences'>android.content.SharedPreferences</span><br/><a href='source/SharedPreferences.html#android-content-SharedPreferences-method-registerOnSharedPreferenceChangeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences-method-registerOnSharedPreferenceChangeListener' class='name expandable'>registerOnSharedPreferenceChangeListener</a>( <span class='pre'>listener</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Registers a callback to be invoked when a change happens to a preference. ...</div><div class='long'><p>Registers a callback to be invoked when a change happens to a preference.</p>\n\n<p> <p class=\"caution\"><strong>Caution:</strong> The preference manager does\n not currently store a strong reference to the listener. You must store a\n strong reference to the listener, or it will be susceptible to garbage\n collection. We recommend you keep a reference to the listener in the\n instance data of an object that will exist as long as you need the\n listener.</p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>listener</span> : Object {SharedPreferences.OnSharedPreferenceChangeListener}<div class='sub-desc'><p>The callback that will run.\n@see <a href=\"#!/api/android.content.SharedPreferences-method-unregisterOnSharedPreferenceChangeListener\" rel=\"android.content.SharedPreferences-method-unregisterOnSharedPreferenceChangeListener\" class=\"docClass\">unregisterOnSharedPreferenceChangeListener</a></p>\n</div></li></ul></div></div></div><div id='method-unregisterOnSharedPreferenceChangeListener' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.content.SharedPreferences'>android.content.SharedPreferences</span><br/><a href='source/SharedPreferences.html#android-content-SharedPreferences-method-unregisterOnSharedPreferenceChangeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.content.SharedPreferences-method-unregisterOnSharedPreferenceChangeListener' class='name expandable'>unregisterOnSharedPreferenceChangeListener</a>( <span class='pre'>listener</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Unregisters a previous callback. ...</div><div class='long'><p>Unregisters a previous callback.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>listener</span> : Object {SharedPreferences.OnSharedPreferenceChangeListener}<div class='sub-desc'><p>The callback that should be unregistered.\n@see <a href=\"#!/api/android.content.SharedPreferences-method-registerOnSharedPreferenceChangeListener\" rel=\"android.content.SharedPreferences-method-registerOnSharedPreferenceChangeListener\" class=\"docClass\">registerOnSharedPreferenceChangeListener</a></p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});