Ext.data.JsonP.android_net_IpPrefix({"tagname":"class","name":"android.net.IpPrefix","autodetected":{},"files":[{"filename":"IpPrefix.js","href":"IpPrefix.html#android-net-IpPrefix"}],"extends":"java.lang.Object","members":[{"name":"CREATOR","tagname":"property","owner":"android.net.IpPrefix","id":"property-CREATOR","meta":{}},{"name":"contains","tagname":"method","owner":"android.net.IpPrefix","id":"method-contains","meta":{}},{"name":"describeContents","tagname":"method","owner":"android.net.IpPrefix","id":"method-describeContents","meta":{}},{"name":"equals","tagname":"method","owner":"android.net.IpPrefix","id":"method-equals","meta":{}},{"name":"getAddress","tagname":"method","owner":"android.net.IpPrefix","id":"method-getAddress","meta":{}},{"name":"getPrefixLength","tagname":"method","owner":"android.net.IpPrefix","id":"method-getPrefixLength","meta":{}},{"name":"getRawAddress","tagname":"method","owner":"android.net.IpPrefix","id":"method-getRawAddress","meta":{}},{"name":"hashCode","tagname":"method","owner":"android.net.IpPrefix","id":"method-hashCode","meta":{}},{"name":"toString","tagname":"method","owner":"android.net.IpPrefix","id":"method-toString","meta":{}},{"name":"writeToParcel","tagname":"method","owner":"android.net.IpPrefix","id":"method-writeToParcel","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.net.IpPrefix","short_doc":"implements android.os.Parcelable\n\nThis class represents an IP prefix, i.e., a contiguous block of IP addresses aligne...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.net.IpPrefix</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/IpPrefix.html#android-net-IpPrefix' target='_blank'>IpPrefix.js</a></div></pre><div class='doc-contents'><p>implements android.os.Parcelable</p>\n\n<p>This class represents an IP prefix, i.e., a contiguous block of IP addresses aligned on a\n power of two boundary (also known as an \"IP subnet\"). A prefix is specified by two pieces of\n information:</p>\n\n<p> <ul>\n <li>A starting IP address (IPv4 or IPv6). This is the first IP address of the prefix.\n <li>A prefix length. This specifies the length of the prefix by specifing the number of bits\n     in the IP address, starting from the most significant bit in network byte order, that\n     are constant for all addresses in the prefix.\n </li></li></ul></p>\n\n<p> For example, the prefix <code>192.0.2.0/24</code> covers the 256 IPv4 addresses from\n <code>192.0.2.0</code> to <code>192.0.2.255</code>, inclusive, and the prefix\n <code>2001:db8:1:2</code>  covers the 2<sup>64</sup> IPv6 addresses from <code>2001:db8:1:2::</code> to\n <code>2001:db8:1:2:ffff:ffff:ffff:ffff</code>, inclusive.</p>\n\n<p> Objects of this class are immutable.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-CREATOR' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.IpPrefix'>android.net.IpPrefix</span><br/><a href='source/IpPrefix.html#android-net-IpPrefix-property-CREATOR' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.IpPrefix-property-CREATOR' class='name expandable'>CREATOR</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Implement the Parcelable interface. ...</div><div class='long'><p>Implement the Parcelable interface.</p>\n<p>Defaults to: <code>&quot;null&quot;</code></p></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-contains' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.IpPrefix'>android.net.IpPrefix</span><br/><a href='source/IpPrefix.html#android-net-IpPrefix-method-contains' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.IpPrefix-method-contains' class='name expandable'>contains</a>( <span class='pre'>address</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Determines whether the prefix contains the specified address. ...</div><div class='long'><p>Determines whether the prefix contains the specified address.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>address</span> : Object {InetAddress}<div class='sub-desc'><p>An InetAddress to test.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the prefix covers the given address.</p>\n</div></li></ul></div></div></div><div id='method-describeContents' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.IpPrefix'>android.net.IpPrefix</span><br/><a href='source/IpPrefix.html#android-net-IpPrefix-method-describeContents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.IpPrefix-method-describeContents' class='name expandable'>describeContents</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Implement the Parcelable interface. ...</div><div class='long'><p>Implement the Parcelable interface.</p>\n</div></div></div><div id='method-equals' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.IpPrefix'>android.net.IpPrefix</span><br/><a href='source/IpPrefix.html#android-net-IpPrefix-method-equals' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.IpPrefix-method-equals' class='name expandable'>equals</a>( <span class='pre'>obj</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Compares this {@code IpPrefix} object against the specified object in {@code obj}. ...</div><div class='long'><p>Compares this {@code IpPrefix} object against the specified object in {@code obj}. Two\n objects are equal if they have the same startAddress and prefixLength.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>obj</span> : Object {Object}<div class='sub-desc'><p>the object to be tested for equality.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if both objects are equal, {@code false} otherwise.</p>\n</div></li></ul></div></div></div><div id='method-getAddress' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.IpPrefix'>android.net.IpPrefix</span><br/><a href='source/IpPrefix.html#android-net-IpPrefix-method-getAddress' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.IpPrefix-method-getAddress' class='name expandable'>getAddress</a>( <span class='pre'></span> ) : Object {java.net.InetAddress}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a copy of the first IP address in the prefix. ...</div><div class='long'><p>Returns a copy of the first IP address in the prefix. Modifying the returned object does not\n change this object's contents.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.net.InetAddress}</span><div class='sub-desc'><p>the address in the form of a byte array.</p>\n</div></li></ul></div></div></div><div id='method-getPrefixLength' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.IpPrefix'>android.net.IpPrefix</span><br/><a href='source/IpPrefix.html#android-net-IpPrefix-method-getPrefixLength' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.IpPrefix-method-getPrefixLength' class='name expandable'>getPrefixLength</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the prefix length of this {@code IpPrefix}. ...</div><div class='long'><p>Returns the prefix length of this {@code IpPrefix}.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>the prefix length.</p>\n</div></li></ul></div></div></div><div id='method-getRawAddress' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.IpPrefix'>android.net.IpPrefix</span><br/><a href='source/IpPrefix.html#android-net-IpPrefix-method-getRawAddress' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.IpPrefix-method-getRawAddress' class='name expandable'>getRawAddress</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a copy of the IP address bytes in network order (the highest order byte is the zeroth\n element). ...</div><div class='long'><p>Returns a copy of the IP address bytes in network order (the highest order byte is the zeroth\n element). Modifying the returned array does not change this object's contents.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>the address in the form of a byte array.</p>\n</div></li></ul></div></div></div><div id='method-hashCode' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.IpPrefix'>android.net.IpPrefix</span><br/><a href='source/IpPrefix.html#android-net-IpPrefix-method-hashCode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.IpPrefix-method-hashCode' class='name expandable'>hashCode</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets the hashcode of the represented IP prefix. ...</div><div class='long'><p>Gets the hashcode of the represented IP prefix.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>the appropriate hashcode value.</p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.IpPrefix'>android.net.IpPrefix</span><br/><a href='source/IpPrefix.html#android-net-IpPrefix-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.IpPrefix-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a string representation of this {@code IpPrefix}. ...</div><div class='long'><p>Returns a string representation of this {@code IpPrefix}.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>a string such as {@code \"192.0.2.0/24\"} or {@code \"2001:db8:1:2::/64\"}.</p>\n</div></li></ul></div></div></div><div id='method-writeToParcel' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.IpPrefix'>android.net.IpPrefix</span><br/><a href='source/IpPrefix.html#android-net-IpPrefix-method-writeToParcel' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.IpPrefix-method-writeToParcel' class='name expandable'>writeToParcel</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Implement the Parcelable interface. ...</div><div class='long'><p>Implement the Parcelable interface.</p>\n</div></div></div></div></div></div></div>","meta":{}});