Ext.data.JsonP.android_net_NetworkFactory({"tagname":"class","name":"android.net.NetworkFactory","autodetected":{},"files":[{"filename":"NetworkFactory.js","href":"NetworkFactory.html#android-net-NetworkFactory"}],"extends":"android.os.Handler","hide":true,"members":[{"name":"CMD_CANCEL_REQUEST","tagname":"property","owner":"android.net.NetworkFactory","id":"property-CMD_CANCEL_REQUEST","meta":{}},{"name":"CMD_REQUEST_NETWORK","tagname":"property","owner":"android.net.NetworkFactory","id":"property-CMD_REQUEST_NETWORK","meta":{}},{"name":"acceptRequest","tagname":"method","owner":"android.net.NetworkFactory","id":"method-acceptRequest","meta":{}},{"name":"addNetworkRequest","tagname":"method","owner":"android.net.NetworkFactory","id":"method-addNetworkRequest","meta":{}},{"name":"dump","tagname":"method","owner":"android.net.NetworkFactory","id":"method-dump","meta":{}},{"name":"handleMessage","tagname":"method","owner":"android.net.NetworkFactory","id":"method-handleMessage","meta":{}},{"name":"register","tagname":"method","owner":"android.net.NetworkFactory","id":"method-register","meta":{}},{"name":"removeNetworkRequest","tagname":"method","owner":"android.net.NetworkFactory","id":"method-removeNetworkRequest","meta":{}},{"name":"setCapabilityFilter","tagname":"method","owner":"android.net.NetworkFactory","id":"method-setCapabilityFilter","meta":{}},{"name":"setScoreFilter","tagname":"method","owner":"android.net.NetworkFactory","id":"method-setScoreFilter","meta":{}},{"name":"toString","tagname":"method","owner":"android.net.NetworkFactory","id":"method-toString","meta":{}},{"name":"unregister","tagname":"method","owner":"android.net.NetworkFactory","id":"method-unregister","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.net.NetworkFactory","short_doc":"A NetworkFactory is an entity that creates NetworkAgent objects. ...","classIcon":"icon-class","superclasses":["android.os.Handler"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>android.os.Handler<div class='subclass '><strong>android.net.NetworkFactory</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/NetworkFactory.html#android-net-NetworkFactory' target='_blank'>NetworkFactory.js</a></div></pre><div class='doc-contents'><p>A NetworkFactory is an entity that creates NetworkAgent objects.\n The bearers register with ConnectivityService using <a href=\"#!/api/android.net.NetworkFactory-method-register\" rel=\"android.net.NetworkFactory-method-register\" class=\"docClass\">register</a> and\n their factory will start receiving scored NetworkRequests.  NetworkRequests\n can be filtered 3 ways: by NetworkCapabilities, by score and more complexly by\n overridden function.  All of these can be dynamic - changing NetworkCapabilities\n or score forces re-evaluation of all current requests.</p>\n\n<p> If any requests pass the filter some overrideable functions will be called.\n If the bearer only cares about very simple start/stopNetwork callbacks, those\n functions can be overridden.  If the bearer needs more interaction, it can\n override addNetworkRequest and removeNetworkRequest which will give it each\n request that passes their current filters.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-CMD_CANCEL_REQUEST' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-property-CMD_CANCEL_REQUEST' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-property-CMD_CANCEL_REQUEST' class='name expandable'>CMD_CANCEL_REQUEST</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Cancel a network request\nmsg.obj = NetworkRequest ...</div><div class='long'><p>Cancel a network request\nmsg.obj = NetworkRequest</p>\n<p>Defaults to: <code>&quot;536577&quot;</code></p></div></div></div><div id='property-CMD_REQUEST_NETWORK' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-property-CMD_REQUEST_NETWORK' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-property-CMD_REQUEST_NETWORK' class='name expandable'>CMD_REQUEST_NETWORK</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Pass a network request to the bearer. ...</div><div class='long'><p>Pass a network request to the bearer.  If the bearer believes it can\nsatisfy the request it should connect to the network and create a\nNetworkAgent.  Once the NetworkAgent is fully functional it will\nregister itself with ConnectivityService using registerNetworkAgent.\nIf the bearer cannot immediately satisfy the request (no network,\nuser disabled the radio, lower-scored network) it should remember\nany NetworkRequests it may be able to satisfy in the future.  It may\ndisregard any that it will never be able to service, for example\nthose requiring a different bearer.\nmsg.obj = NetworkRequest\nmsg.arg1 = score - the score of the any network currently satisfying this\n           request.  If this bearer knows in advance it cannot\n           exceed this score it should not try to connect, holding the request\n           for the future.\n           Note that subsequent events may give a different (lower\n           or higher) score for this request, transmitted to each\n           NetworkFactory through additional CMD_REQUEST_NETWORK msgs\n           with the same NetworkRequest but an updated score.\n           Also, network conditions may change for this bearer\n           allowing for a better score in the future.</p>\n<p>Defaults to: <code>&quot;536576&quot;</code></p></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-acceptRequest' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-method-acceptRequest' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-method-acceptRequest' class='name expandable'>acceptRequest</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Overridable function to provide complex filtering. ...</div><div class='long'><p>Overridable function to provide complex filtering.\n Called for every request every time a new NetworkRequest is seen\n and whenever the filterScore or filterNetworkCapabilities change.</p>\n\n<p> acceptRequest can be overriden to provide complex filter behavior\n for the incoming requests</p>\n\n<p> For output, this class will call needNetworkFor and\n releaseNetworkFor for every request that passes the filters.\n If you don't need to see every request, you can leave the base\n implementations of those two functions and instead override\n startNetwork and stopNetwork.</p>\n\n<p> If you want to see every score fluctuation on every request, set\n your score filter to a very high number and watch needNetworkFor.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} to accept the request.</p>\n</div></li></ul></div></div></div><div id='method-addNetworkRequest' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-method-addNetworkRequest' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-method-addNetworkRequest' class='name expandable'>addNetworkRequest</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-dump' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-method-dump' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-method-dump' class='name expandable'>dump</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-handleMessage' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-method-handleMessage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-method-handleMessage' class='name expandable'>handleMessage</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-register' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-method-register' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-method-register' class='name expandable'>register</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-removeNetworkRequest' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-method-removeNetworkRequest' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-method-removeNetworkRequest' class='name expandable'>removeNetworkRequest</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-setCapabilityFilter' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-method-setCapabilityFilter' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-method-setCapabilityFilter' class='name expandable'>setCapabilityFilter</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-setScoreFilter' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-method-setScoreFilter' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-method-setScoreFilter' class='name expandable'>setScoreFilter</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-toString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-unregister' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkFactory'>android.net.NetworkFactory</span><br/><a href='source/NetworkFactory.html#android-net-NetworkFactory-method-unregister' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkFactory-method-unregister' class='name expandable'>unregister</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div></div></div></div></div>","meta":{}});