Ext.data.JsonP.android_net_NetworkRequest_Builder({"tagname":"class","name":"android.net.NetworkRequest.Builder","autodetected":{},"files":[{"filename":"Builder.js","href":"Builder.html#android-net-NetworkRequest-Builder"}],"extends":"java.lang.Object","members":[{"name":"addCapability","tagname":"method","owner":"android.net.NetworkRequest.Builder","id":"method-addCapability","meta":{}},{"name":"addTransportType","tagname":"method","owner":"android.net.NetworkRequest.Builder","id":"method-addTransportType","meta":{}},{"name":"build","tagname":"method","owner":"android.net.NetworkRequest.Builder","id":"method-build","meta":{}},{"name":"removeCapability","tagname":"method","owner":"android.net.NetworkRequest.Builder","id":"method-removeCapability","meta":{}},{"name":"removeTransportType","tagname":"method","owner":"android.net.NetworkRequest.Builder","id":"method-removeTransportType","meta":{}},{"name":"setNetworkSpecifier","tagname":"method","owner":"android.net.NetworkRequest.Builder","id":"method-setNetworkSpecifier","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.net.NetworkRequest.Builder","short_doc":"Builder used to create android.net.NetworkRequest objects. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.net.NetworkRequest.Builder</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/Builder.html#android-net-NetworkRequest-Builder' target='_blank'>Builder.js</a></div></pre><div class='doc-contents'><p>Builder used to create <a href=\"#!/api/android.net.NetworkRequest\" rel=\"android.net.NetworkRequest\" class=\"docClass\">android.net.NetworkRequest</a> objects.  Specify the Network features\n needed in terms of <a href=\"#!/api/android.net.NetworkCapabilities\" rel=\"android.net.NetworkCapabilities\" class=\"docClass\">android.net.NetworkCapabilities</a> features</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addCapability' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkRequest.Builder'>android.net.NetworkRequest.Builder</span><br/><a href='source/Builder.html#android-net-NetworkRequest-Builder-method-addCapability' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkRequest.Builder-method-addCapability' class='name expandable'>addCapability</a>( <span class='pre'>capability</span> ) : Object {android.net.NetworkRequest.Builder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Add the given capability requirement to this builder. ...</div><div class='long'><p>Add the given capability requirement to this builder.  These represent\n the requested network's required capabilities.  Note that when searching\n for a network to satisfy a request, all capabilities requested must be\n satisfied.  See <a href=\"#!/api/android.net.NetworkCapabilities\" rel=\"android.net.NetworkCapabilities\" class=\"docClass\">android.net.NetworkCapabilities</a> for {@code NET_CAPABILITIY_*}\n definitions.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>capability</span> : Number<div class='sub-desc'><p>The {@code NetworkCapabilities.NET_CAPABILITY_*} to add.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.NetworkRequest.Builder}</span><div class='sub-desc'><p>The builder to facilitate chaining\n         {@code builder.addCapability(...).addCapability();}.</p>\n</div></li></ul></div></div></div><div id='method-addTransportType' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkRequest.Builder'>android.net.NetworkRequest.Builder</span><br/><a href='source/Builder.html#android-net-NetworkRequest-Builder-method-addTransportType' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkRequest.Builder-method-addTransportType' class='name expandable'>addTransportType</a>( <span class='pre'>transportType</span> ) : Object {android.net.NetworkRequest.Builder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Adds the given transport requirement to this builder. ...</div><div class='long'><p>Adds the given transport requirement to this builder.  These represent\n the set of allowed transports for the request.  Only networks using one\n of these transports will satisfy the request.  If no particular transports\n are required, none should be specified here.  See <a href=\"#!/api/android.net.NetworkCapabilities\" rel=\"android.net.NetworkCapabilities\" class=\"docClass\">android.net.NetworkCapabilities</a>\n for {@code TRANSPORT_*} definitions.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>transportType</span> : Number<div class='sub-desc'><p>The {@code NetworkCapabilities.TRANSPORT_*} to add.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.NetworkRequest.Builder}</span><div class='sub-desc'><p>The builder to facilitate chaining.</p>\n</div></li></ul></div></div></div><div id='method-build' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkRequest.Builder'>android.net.NetworkRequest.Builder</span><br/><a href='source/Builder.html#android-net-NetworkRequest-Builder-method-build' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkRequest.Builder-method-build' class='name expandable'>build</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Build android.net.NetworkRequest give the current set of capabilities. ...</div><div class='long'><p>Build <a href=\"#!/api/android.net.NetworkRequest\" rel=\"android.net.NetworkRequest\" class=\"docClass\">android.net.NetworkRequest</a> give the current set of capabilities.</p>\n</div></div></div><div id='method-removeCapability' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkRequest.Builder'>android.net.NetworkRequest.Builder</span><br/><a href='source/Builder.html#android-net-NetworkRequest-Builder-method-removeCapability' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkRequest.Builder-method-removeCapability' class='name expandable'>removeCapability</a>( <span class='pre'>capability</span> ) : Object {android.net.NetworkRequest.Builder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Removes (if found) the given capability from this builder instance. ...</div><div class='long'><p>Removes (if found) the given capability from this builder instance.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>capability</span> : Number<div class='sub-desc'><p>The {@code NetworkCapabilities.NET_CAPABILITY_*} to remove.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.NetworkRequest.Builder}</span><div class='sub-desc'><p>The builder to facilitate chaining.</p>\n</div></li></ul></div></div></div><div id='method-removeTransportType' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkRequest.Builder'>android.net.NetworkRequest.Builder</span><br/><a href='source/Builder.html#android-net-NetworkRequest-Builder-method-removeTransportType' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkRequest.Builder-method-removeTransportType' class='name expandable'>removeTransportType</a>( <span class='pre'>transportType</span> ) : Object {android.net.NetworkRequest.Builder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Removes (if found) the given transport from this builder instance. ...</div><div class='long'><p>Removes (if found) the given transport from this builder instance.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>transportType</span> : Number<div class='sub-desc'><p>The {@code NetworkCapabilities.TRANSPORT_*} to remove.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.NetworkRequest.Builder}</span><div class='sub-desc'><p>The builder to facilitate chaining.</p>\n</div></li></ul></div></div></div><div id='method-setNetworkSpecifier' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkRequest.Builder'>android.net.NetworkRequest.Builder</span><br/><a href='source/Builder.html#android-net-NetworkRequest-Builder-method-setNetworkSpecifier' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkRequest.Builder-method-setNetworkSpecifier' class='name expandable'>setNetworkSpecifier</a>( <span class='pre'>networkSpecifier</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Sets the optional bearer specific network specifier. ...</div><div class='long'><p>Sets the optional bearer specific network specifier.\n This has no meaning if a single transport is also not specified, so calling\n this without a single transport set will generate an exception, as will\n subsequently adding or removing transports after this is set.\n </p>\n The interpretation of this {@code String} is bearer specific and bearers that use\n it should document their particulars.  For example, Bluetooth may use some sort of\n device id while WiFi could used ssid and/or bssid.  Cellular may use carrier spn.\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>networkSpecifier</span> : String<div class='sub-desc'><p>An {@code String} of opaque format used to specify the bearer\n                         specific network specifier where the bearer has a choice of\n                         networks.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});