Ext.data.JsonP.android_net_NetworkScoreManager({"tagname":"class","name":"android.net.NetworkScoreManager","autodetected":{},"files":[{"filename":"NetworkScoreManager.js","href":"NetworkScoreManager.html#android-net-NetworkScoreManager"}],"extends":"java.lang.Object","hide":true,"members":[{"name":"ACTION_CHANGE_ACTIVE","tagname":"property","owner":"android.net.NetworkScoreManager","id":"property-ACTION_CHANGE_ACTIVE","meta":{}},{"name":"ACTION_CUSTOM_ENABLE","tagname":"property","owner":"android.net.NetworkScoreManager","id":"property-ACTION_CUSTOM_ENABLE","meta":{}},{"name":"ACTION_SCORER_CHANGED","tagname":"property","owner":"android.net.NetworkScoreManager","id":"property-ACTION_SCORER_CHANGED","meta":{}},{"name":"ACTION_SCORE_NETWORKS","tagname":"property","owner":"android.net.NetworkScoreManager","id":"property-ACTION_SCORE_NETWORKS","meta":{}},{"name":"EXTRA_NETWORKS_TO_SCORE","tagname":"property","owner":"android.net.NetworkScoreManager","id":"property-EXTRA_NETWORKS_TO_SCORE","meta":{}},{"name":"EXTRA_NEW_SCORER","tagname":"property","owner":"android.net.NetworkScoreManager","id":"property-EXTRA_NEW_SCORER","meta":{}},{"name":"EXTRA_PACKAGE_NAME","tagname":"property","owner":"android.net.NetworkScoreManager","id":"property-EXTRA_PACKAGE_NAME","meta":{}},{"name":"clearScores","tagname":"method","owner":"android.net.NetworkScoreManager","id":"method-clearScores","meta":{}},{"name":"disableScoring","tagname":"method","owner":"android.net.NetworkScoreManager","id":"method-disableScoring","meta":{}},{"name":"getActiveScorerPackage","tagname":"method","owner":"android.net.NetworkScoreManager","id":"method-getActiveScorerPackage","meta":{}},{"name":"updateScores","tagname":"method","owner":"android.net.NetworkScoreManager","id":"method-updateScores","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.net.NetworkScoreManager","short_doc":"Class that manages communication between network subsystems and a network scorer. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.net.NetworkScoreManager</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager' target='_blank'>NetworkScoreManager.js</a></div></pre><div class='doc-contents'><p>Class that manages communication between network subsystems and a network scorer.</p>\n\n<p> <p>You can get an instance of this class by calling\n android.content.Context.getSystemService(String):</p>\n\n<p> <pre>NetworkScoreManager manager =\n     (NetworkScoreManager) getSystemService(Context.NETWORK_SCORE_SERVICE)</pre></p>\n\n<p> <p>A network scorer is any application which:\n <ul>\n <li>Declares the android.Manifest.permission.SCORE_NETWORKS permission.\n <li>Includes a receiver for <a href=\"#!/api/android.net.NetworkScoreManager-property-ACTION_SCORE_NETWORKS\" rel=\"android.net.NetworkScoreManager-property-ACTION_SCORE_NETWORKS\" class=\"docClass\">ACTION_SCORE_NETWORKS</a> guarded by the\n     android.Manifest.permission.BROADCAST_NETWORK_PRIVILEGED permission which scores\n     networks and (eventually) calls <a href=\"#!/api/android.net.NetworkScoreManager-method-updateScores\" rel=\"android.net.NetworkScoreManager-method-updateScores\" class=\"docClass\">updateScores</a> with the results. If this receiver\n     specifies an android:label attribute, this label will be used when referring to the\n     application throughout system settings; otherwise, the application label will be used.\n </li></li></ul></p>\n\n<p> <p>The system keeps track of an active scorer application; at any time, only this application\n will receive <a href=\"#!/api/android.net.NetworkScoreManager-property-ACTION_SCORE_NETWORKS\" rel=\"android.net.NetworkScoreManager-property-ACTION_SCORE_NETWORKS\" class=\"docClass\">ACTION_SCORE_NETWORKS</a> broadcasts and will be permitted to call\n <a href=\"#!/api/android.net.NetworkScoreManager-method-updateScores\" rel=\"android.net.NetworkScoreManager-method-updateScores\" class=\"docClass\">updateScores</a>. Applications may determine the current active scorer with\n <a href=\"#!/api/android.net.NetworkScoreManager-method-getActiveScorerPackage\" rel=\"android.net.NetworkScoreManager-method-getActiveScorerPackage\" class=\"docClass\">getActiveScorerPackage</a>() and request to change the active scorer by sending an\n <a href=\"#!/api/android.net.NetworkScoreManager-property-ACTION_CHANGE_ACTIVE\" rel=\"android.net.NetworkScoreManager-property-ACTION_CHANGE_ACTIVE\" class=\"docClass\">ACTION_CHANGE_ACTIVE</a> broadcast with another scorer.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-ACTION_CHANGE_ACTIVE' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkScoreManager'>android.net.NetworkScoreManager</span><br/><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager-property-ACTION_CHANGE_ACTIVE' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkScoreManager-property-ACTION_CHANGE_ACTIVE' class='name expandable'>ACTION_CHANGE_ACTIVE</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Activity action: ask the user to change the active network scorer. ...</div><div class='long'><p>Activity action: ask the user to change the active network scorer. This will show a dialog\nthat asks the user whether they want to replace the current active scorer with the one\nspecified in <a href=\"#!/api/android.net.NetworkScoreManager-property-EXTRA_PACKAGE_NAME\" rel=\"android.net.NetworkScoreManager-property-EXTRA_PACKAGE_NAME\" class=\"docClass\">EXTRA_PACKAGE_NAME</a>. The activity will finish with RESULT_OK if the\nactive scorer was changed or RESULT_CANCELED if it failed for any reason.</p>\n<p>Defaults to: <code>&quot;android.net.scoring.CHANGE_ACTIVE&quot;</code></p></div></div></div><div id='property-ACTION_CUSTOM_ENABLE' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkScoreManager'>android.net.NetworkScoreManager</span><br/><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager-property-ACTION_CUSTOM_ENABLE' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkScoreManager-property-ACTION_CUSTOM_ENABLE' class='name expandable'>ACTION_CUSTOM_ENABLE</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Activity action: launch a custom activity for configuring a scorer before enabling it. ...</div><div class='long'><p>Activity action: launch a custom activity for configuring a scorer before enabling it.\nScorer applications may choose to specify an activity for this action, in which case the\nframework will launch that activity which should return RESULT_OK if scoring was enabled.</p>\n\n<p><p>If no activity is included in a scorer which implements this action, the system dialog for\nselecting a scorer will be shown instead.</p>\n<p>Defaults to: <code>&quot;android.net.scoring.CUSTOM_ENABLE&quot;</code></p></div></div></div><div id='property-ACTION_SCORER_CHANGED' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkScoreManager'>android.net.NetworkScoreManager</span><br/><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager-property-ACTION_SCORER_CHANGED' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkScoreManager-property-ACTION_SCORER_CHANGED' class='name expandable'>ACTION_SCORER_CHANGED</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Broadcast action: the active scorer has been changed. ...</div><div class='long'><p>Broadcast action: the active scorer has been changed. Scorer apps may listen to this to\nperform initialization once selected as the active scorer, or clean up unneeded resources\nif another scorer has been selected. Note that it is unnecessary to clear existing scores as\nthis is handled by the system.</p>\n\n<p><p>The new scorer will be specified in <a href=\"#!/api/android.net.NetworkScoreManager-property-EXTRA_NEW_SCORER\" rel=\"android.net.NetworkScoreManager-property-EXTRA_NEW_SCORER\" class=\"docClass\">EXTRA_NEW_SCORER</a>.</p>\n\n<p><p class=\"note\">This is a protected intent that can only be sent by the system.</p>\n<p>Defaults to: <code>&quot;android.net.scoring.SCORER_CHANGED&quot;</code></p></div></div></div><div id='property-ACTION_SCORE_NETWORKS' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkScoreManager'>android.net.NetworkScoreManager</span><br/><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager-property-ACTION_SCORE_NETWORKS' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkScoreManager-property-ACTION_SCORE_NETWORKS' class='name expandable'>ACTION_SCORE_NETWORKS</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Broadcast action: new network scores are being requested. ...</div><div class='long'><p>Broadcast action: new network scores are being requested. This intent will only be delivered\nto the current active scorer app. That app is responsible for scoring the networks and\ncalling <a href=\"#!/api/android.net.NetworkScoreManager-method-updateScores\" rel=\"android.net.NetworkScoreManager-method-updateScores\" class=\"docClass\">updateScores</a> when complete. The networks to score are specified in\n<a href=\"#!/api/android.net.NetworkScoreManager-property-EXTRA_NETWORKS_TO_SCORE\" rel=\"android.net.NetworkScoreManager-property-EXTRA_NETWORKS_TO_SCORE\" class=\"docClass\">EXTRA_NETWORKS_TO_SCORE</a>, and will generally consist of all networks which have been\nconfigured by the user as well as any open networks.</p>\n\n<p><p class=\"note\">This is a protected intent that can only be sent by the system.</p>\n<p>Defaults to: <code>&quot;android.net.scoring.SCORE_NETWORKS&quot;</code></p></div></div></div><div id='property-EXTRA_NETWORKS_TO_SCORE' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkScoreManager'>android.net.NetworkScoreManager</span><br/><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager-property-EXTRA_NETWORKS_TO_SCORE' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkScoreManager-property-EXTRA_NETWORKS_TO_SCORE' class='name expandable'>EXTRA_NETWORKS_TO_SCORE</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Extra used with ACTION_SCORE_NETWORKS to specify the networks to be scored, as an\narray of android.net.NetworkKeys. ...</div><div class='long'><p>Extra used with <a href=\"#!/api/android.net.NetworkScoreManager-property-ACTION_SCORE_NETWORKS\" rel=\"android.net.NetworkScoreManager-property-ACTION_SCORE_NETWORKS\" class=\"docClass\">ACTION_SCORE_NETWORKS</a> to specify the networks to be scored, as an\narray of <a href=\"#!/api/android.net.NetworkKey\" rel=\"android.net.NetworkKey\" class=\"docClass\">android.net.NetworkKey</a>s. Can be obtained with\nandroid.content.Intent.getParcelableArrayExtra(String)}.</p>\n<p>Defaults to: <code>&quot;networksToScore&quot;</code></p></div></div></div><div id='property-EXTRA_NEW_SCORER' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkScoreManager'>android.net.NetworkScoreManager</span><br/><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager-property-EXTRA_NEW_SCORER' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkScoreManager-property-EXTRA_NEW_SCORER' class='name expandable'>EXTRA_NEW_SCORER</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Extra used with ACTION_SCORER_CHANGED to specify the newly selected scorer's package\nname. ...</div><div class='long'><p>Extra used with <a href=\"#!/api/android.net.NetworkScoreManager-property-ACTION_SCORER_CHANGED\" rel=\"android.net.NetworkScoreManager-property-ACTION_SCORER_CHANGED\" class=\"docClass\">ACTION_SCORER_CHANGED</a> to specify the newly selected scorer's package\nname. Will be null if scoring was disabled. Can be obtained with\nandroid.content.Intent.getStringExtra(String).</p>\n<p>Defaults to: <code>&quot;newScorer&quot;</code></p></div></div></div><div id='property-EXTRA_PACKAGE_NAME' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkScoreManager'>android.net.NetworkScoreManager</span><br/><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager-property-EXTRA_PACKAGE_NAME' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkScoreManager-property-EXTRA_PACKAGE_NAME' class='name expandable'>EXTRA_PACKAGE_NAME</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Extra used with ACTION_CHANGE_ACTIVE to specify the new scorer package. ...</div><div class='long'><p>Extra used with <a href=\"#!/api/android.net.NetworkScoreManager-property-ACTION_CHANGE_ACTIVE\" rel=\"android.net.NetworkScoreManager-property-ACTION_CHANGE_ACTIVE\" class=\"docClass\">ACTION_CHANGE_ACTIVE</a> to specify the new scorer package. Set with\nString).</p>\n<p>Defaults to: <code>&quot;packageName&quot;</code></p></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-clearScores' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkScoreManager'>android.net.NetworkScoreManager</span><br/><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager-method-clearScores' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkScoreManager-method-clearScores' class='name expandable'>clearScores</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Clear network scores. ...</div><div class='long'><p>Clear network scores.</p>\n\n<p> <p>Should be called when all scores need to be invalidated, i.e. because the scoring\n algorithm has changed and old scores can no longer be compared to future scores.</p>\n\n<p> <p>Note that scores will be cleared automatically when the active scorer changes, as scores\n from one scorer cannot be compared to those from another scorer.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>whether the clear was successful.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>SecurityException if the caller is not the active scorer or privileged.</p>\n</div></li></ul></div></div></div><div id='method-disableScoring' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkScoreManager'>android.net.NetworkScoreManager</span><br/><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager-method-disableScoring' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkScoreManager-method-disableScoring' class='name expandable'>disableScoring</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Turn off network scoring. ...</div><div class='long'><p>Turn off network scoring.</p>\n\n<p> <p>May only be called by the current scorer app, or the system.</p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>SecurityException if the caller is neither the active scorer nor the system.</p>\n</div></li></ul></div></div></div><div id='method-getActiveScorerPackage' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkScoreManager'>android.net.NetworkScoreManager</span><br/><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager-method-getActiveScorerPackage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkScoreManager-method-getActiveScorerPackage' class='name expandable'>getActiveScorerPackage</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Obtain the package name of the current active network scorer. ...</div><div class='long'><p>Obtain the package name of the current active network scorer.</p>\n\n<p> <p>At any time, only one scorer application will receive <a href=\"#!/api/android.net.NetworkScoreManager-property-ACTION_SCORE_NETWORKS\" rel=\"android.net.NetworkScoreManager-property-ACTION_SCORE_NETWORKS\" class=\"docClass\">ACTION_SCORE_NETWORKS</a>\n broadcasts and be allowed to call <a href=\"#!/api/android.net.NetworkScoreManager-method-updateScores\" rel=\"android.net.NetworkScoreManager-method-updateScores\" class=\"docClass\">updateScores</a>. Applications may use this method to\n determine the current scorer and offer the user the ability to select a different scorer via\n the <a href=\"#!/api/android.net.NetworkScoreManager-property-ACTION_CHANGE_ACTIVE\" rel=\"android.net.NetworkScoreManager-property-ACTION_CHANGE_ACTIVE\" class=\"docClass\">ACTION_CHANGE_ACTIVE</a> intent.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the full package name of the current active scorer, or null if there is no active\n         scorer.</p>\n</div></li></ul></div></div></div><div id='method-updateScores' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.NetworkScoreManager'>android.net.NetworkScoreManager</span><br/><a href='source/NetworkScoreManager.html#android-net-NetworkScoreManager-method-updateScores' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.NetworkScoreManager-method-updateScores' class='name expandable'>updateScores</a>( <span class='pre'>networks</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Update network scores. ...</div><div class='long'><p>Update network scores.</p>\n\n<p> <p>This may be called at any time to re-score active networks. Scores will generally be\n updated quickly, but if this method is called too frequently, the scores may be held and\n applied at a later time.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>networks</span> : Object {android.net.ScoredNetwork[]}<div class='sub-desc'><p>the networks which have been scored by the scorer.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>whether the update was successful.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>SecurityException if the caller is not the active scorer.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});