Ext.data.JsonP.android_net_RssiCurve({"tagname":"class","name":"android.net.RssiCurve","autodetected":{},"files":[{"filename":"RssiCurve.js","href":"RssiCurve.html#android-net-RssiCurve"}],"extends":"java.lang.Object","hide":true,"members":[{"name":"CREATOR","tagname":"property","owner":"android.net.RssiCurve","id":"property-CREATOR","meta":{}},{"name":"activeNetworkRssiBoost","tagname":"property","owner":"android.net.RssiCurve","id":"property-activeNetworkRssiBoost","meta":{}},{"name":"bucketWidth","tagname":"property","owner":"android.net.RssiCurve","id":"property-bucketWidth","meta":{}},{"name":"rssiBuckets","tagname":"property","owner":"android.net.RssiCurve","id":"property-rssiBuckets","meta":{}},{"name":"start","tagname":"property","owner":"android.net.RssiCurve","id":"property-start","meta":{}},{"name":"describeContents","tagname":"method","owner":"android.net.RssiCurve","id":"method-describeContents","meta":{}},{"name":"equals","tagname":"method","owner":"android.net.RssiCurve","id":"method-equals","meta":{}},{"name":"hashCode","tagname":"method","owner":"android.net.RssiCurve","id":"method-hashCode","meta":{}},{"name":"lookupScore","tagname":"method","owner":"android.net.RssiCurve","id":"method-lookupScore","meta":{}},{"name":"toString","tagname":"method","owner":"android.net.RssiCurve","id":"method-toString","meta":{}},{"name":"writeToParcel","tagname":"method","owner":"android.net.RssiCurve","id":"method-writeToParcel","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.net.RssiCurve","short_doc":"implements android.os.Parcelable\n\nA curve defining the network score over a range of RSSI values. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.net.RssiCurve</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/RssiCurve.html#android-net-RssiCurve' target='_blank'>RssiCurve.js</a></div></pre><div class='doc-contents'><p>implements android.os.Parcelable</p>\n\n<p>A curve defining the network score over a range of RSSI values.</p>\n\n<p> <p>For each RSSI bucket, the score may be any byte. Scores have no absolute meaning and are only\n considered relative to other scores assigned by the same scorer. Networks with no score are\n treated equivalently to a network with score Byte.MIN_VALUE, and will not be used.</p>\n\n<p> <p>For example, consider a curve starting at -110 dBm with a bucket width of 10 and the\n following buckets: {@code [-20, -10, 0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100, 110, 120]}.\n This represents a linear curve between -110 dBm and 30 dBm. It scores progressively higher at\n stronger signal strengths.</p>\n\n<p> <p>A network can be assigned a fixed score independent of RSSI by setting\n <a href=\"#!/api/android.net.RssiCurve-property-rssiBuckets\" rel=\"android.net.RssiCurve-property-rssiBuckets\" class=\"docClass\">rssiBuckets</a> to a one-byte array whose element is the fixed score. <a href=\"#!/api/android.net.RssiCurve-property-start\" rel=\"android.net.RssiCurve-property-start\" class=\"docClass\">start</a>\n should be set to the lowest RSSI value at which this fixed score should apply, and\n <a href=\"#!/api/android.net.RssiCurve-property-bucketWidth\" rel=\"android.net.RssiCurve-property-bucketWidth\" class=\"docClass\">bucketWidth</a> should be set such that {@code start + bucketWidth} is equal to the\n highest RSSI value at which this fixed score should apply.</p>\n\n<p> <p>Note that RSSI values below -110 dBm or above 30 dBm are unlikely to cause any difference\n in connectivity behavior from those endpoints. That is, the connectivity framework will treat\n a network with a -120 dBm signal exactly as it would treat one with a -110 dBm signal.\n Therefore, graphs which specify scores outside this range may be truncated to this range by\n the system.</p>\n\n<p> @see ScoredNetwork</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-CREATOR' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.RssiCurve'>android.net.RssiCurve</span><br/><a href='source/RssiCurve.html#android-net-RssiCurve-property-CREATOR' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.RssiCurve-property-CREATOR' class='name expandable'>CREATOR</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>&quot;null&quot;</code></p></div></div></div><div id='property-activeNetworkRssiBoost' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.RssiCurve'>android.net.RssiCurve</span><br/><a href='source/RssiCurve.html#android-net-RssiCurve-property-activeNetworkRssiBoost' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.RssiCurve-property-activeNetworkRssiBoost' class='name expandable'>activeNetworkRssiBoost</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>The RSSI boost to give this network when active, in dBm. ...</div><div class='long'><p>The RSSI boost to give this network when active, in dBm.</p>\n\n<p><p>When the system is connected to this network, it will pretend that the network has this\nmuch higher of an RSSI. This is to avoid switching networks when another network has only a\nslightly higher score.</p>\n<p>Defaults to: <code>&quot;null&quot;</code></p></div></div></div><div id='property-bucketWidth' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.RssiCurve'>android.net.RssiCurve</span><br/><a href='source/RssiCurve.html#android-net-RssiCurve-property-bucketWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.RssiCurve-property-bucketWidth' class='name expandable'>bucketWidth</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>The width of each RSSI bucket, in dBm. ...</div><div class='long'><p>The width of each RSSI bucket, in dBm.</p>\n<p>Defaults to: <code>&quot;null&quot;</code></p></div></div></div><div id='property-rssiBuckets' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.RssiCurve'>android.net.RssiCurve</span><br/><a href='source/RssiCurve.html#android-net-RssiCurve-property-rssiBuckets' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.RssiCurve-property-rssiBuckets' class='name expandable'>rssiBuckets</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>The score for each RSSI bucket. ...</div><div class='long'><p>The score for each RSSI bucket.</p>\n<p>Defaults to: <code>&quot;null&quot;</code></p></div></div></div><div id='property-start' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.RssiCurve'>android.net.RssiCurve</span><br/><a href='source/RssiCurve.html#android-net-RssiCurve-property-start' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.RssiCurve-property-start' class='name expandable'>start</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>The starting dBm of the curve. ...</div><div class='long'><p>The starting dBm of the curve.</p>\n<p>Defaults to: <code>&quot;null&quot;</code></p></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-describeContents' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.RssiCurve'>android.net.RssiCurve</span><br/><a href='source/RssiCurve.html#android-net-RssiCurve-method-describeContents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.RssiCurve-method-describeContents' class='name expandable'>describeContents</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-equals' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.RssiCurve'>android.net.RssiCurve</span><br/><a href='source/RssiCurve.html#android-net-RssiCurve-method-equals' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.RssiCurve-method-equals' class='name expandable'>equals</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Determine if two RSSI curves are defined in the same way. ...</div><div class='long'><p>Determine if two RSSI curves are defined in the same way.</p>\n\n<p> <p>Note that two curves can be equivalent but defined differently, e.g. if one bucket in one\n curve is split into two buckets in another. For the purpose of this method, these curves are\n not considered equal to each other.</p>\n</div></div></div><div id='method-hashCode' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.RssiCurve'>android.net.RssiCurve</span><br/><a href='source/RssiCurve.html#android-net-RssiCurve-method-hashCode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.RssiCurve-method-hashCode' class='name expandable'>hashCode</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-lookupScore' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.RssiCurve'>android.net.RssiCurve</span><br/><a href='source/RssiCurve.html#android-net-RssiCurve-method-lookupScore' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.RssiCurve-method-lookupScore' class='name expandable'>lookupScore</a>( <span class='pre'>rssi, isActiveNetwork</span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Lookup the score for a given RSSI value. ...</div><div class='long'><p>Lookup the score for a given RSSI value.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>rssi</span> : Number<div class='sub-desc'><p>The RSSI to lookup. If the RSSI falls below the start of the curve, the score at\n         the start of the curve will be returned. If it falls after the end of the curve, the\n         score at the end of the curve will be returned.</p>\n</div></li><li><span class='pre'>isActiveNetwork</span> : Boolean<div class='sub-desc'><p>Whether this network is currently active.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>the score for the given RSSI.</p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.RssiCurve'>android.net.RssiCurve</span><br/><a href='source/RssiCurve.html#android-net-RssiCurve-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.RssiCurve-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-writeToParcel' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.RssiCurve'>android.net.RssiCurve</span><br/><a href='source/RssiCurve.html#android-net-RssiCurve-method-writeToParcel' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.RssiCurve-method-writeToParcel' class='name expandable'>writeToParcel</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div></div></div></div></div>","meta":{}});