Ext.data.JsonP.android_net_SntpClient({"tagname":"class","name":"android.net.SntpClient","autodetected":{},"files":[{"filename":"SntpClient.js","href":"SntpClient.html#android-net-SntpClient"}],"extends":"java.lang.Object","members":[{"name":"getNtpTime","tagname":"method","owner":"android.net.SntpClient","id":"method-getNtpTime","meta":{}},{"name":"getNtpTimeReference","tagname":"method","owner":"android.net.SntpClient","id":"method-getNtpTimeReference","meta":{}},{"name":"getRoundTripTime","tagname":"method","owner":"android.net.SntpClient","id":"method-getRoundTripTime","meta":{}},{"name":"requestTime","tagname":"method","owner":"android.net.SntpClient","id":"method-requestTime","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.net.SntpClient","short_doc":"{@hide}\n\n Simple SNTP client class for retrieving network time. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.net.SntpClient</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/SntpClient.html#android-net-SntpClient' target='_blank'>SntpClient.js</a></div></pre><div class='doc-contents'><p>{@hide}</p>\n\n<p> Simple SNTP client class for retrieving network time.</p>\n\n<p> Sample usage:\n <pre>SntpClient client = new SntpClient();\n if (client.requestTime(\"time.foo.com\")) {\n     long now = client.getNtpTime() + SystemClock.elapsedRealtime() - client.getNtpTimeReference();\n }\n </pre></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-getNtpTime' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.SntpClient'>android.net.SntpClient</span><br/><a href='source/SntpClient.html#android-net-SntpClient-method-getNtpTime' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.SntpClient-method-getNtpTime' class='name expandable'>getNtpTime</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the time computed from the NTP transaction. ...</div><div class='long'><p>Returns the time computed from the NTP transaction.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>time value computed from NTP server response.</p>\n</div></li></ul></div></div></div><div id='method-getNtpTimeReference' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.SntpClient'>android.net.SntpClient</span><br/><a href='source/SntpClient.html#android-net-SntpClient-method-getNtpTimeReference' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.SntpClient-method-getNtpTimeReference' class='name expandable'>getNtpTimeReference</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the reference clock value (value of SystemClock.elapsedRealtime())\n corresponding to the NTP time. ...</div><div class='long'><p>Returns the reference clock value (value of SystemClock.elapsedRealtime())\n corresponding to the NTP time.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>reference clock corresponding to the NTP time.</p>\n</div></li></ul></div></div></div><div id='method-getRoundTripTime' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.SntpClient'>android.net.SntpClient</span><br/><a href='source/SntpClient.html#android-net-SntpClient-method-getRoundTripTime' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.SntpClient-method-getRoundTripTime' class='name expandable'>getRoundTripTime</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the round trip time of the NTP transaction ...</div><div class='long'><p>Returns the round trip time of the NTP transaction</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>round trip time in milliseconds.</p>\n</div></li></ul></div></div></div><div id='method-requestTime' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.SntpClient'>android.net.SntpClient</span><br/><a href='source/SntpClient.html#android-net-SntpClient-method-requestTime' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.SntpClient-method-requestTime' class='name expandable'>requestTime</a>( <span class='pre'>host, timeout</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Sends an SNTP request to the given host and processes the response. ...</div><div class='long'><p>Sends an SNTP request to the given host and processes the response.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>host</span> : String<div class='sub-desc'><p>host name of the server.</p>\n</div></li><li><span class='pre'>timeout</span> : Number<div class='sub-desc'><p>network timeout in milliseconds.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>true if the transaction was successful.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});