Ext.data.JsonP.android_net_UrlQuerySanitizer({"tagname":"class","name":"android.net.UrlQuerySanitizer","autodetected":{},"files":[{"filename":"UrlQuerySanitizer.js","href":"UrlQuerySanitizer.html#android-net-UrlQuerySanitizer"}],"extends":"java.lang.Object","members":[{"name":"getAllButNulAndAngleBracketsLegal","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getAllButNulAndAngleBracketsLegal","meta":{}},{"name":"getAllButNulLegal","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getAllButNulLegal","meta":{}},{"name":"getAllButWhitespaceLegal","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getAllButWhitespaceLegal","meta":{}},{"name":"getAllIllegal","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getAllIllegal","meta":{}},{"name":"getAllowUnregisteredParamaters","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getAllowUnregisteredParamaters","meta":{}},{"name":"getAmpAndSpaceLegal","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getAmpAndSpaceLegal","meta":{}},{"name":"getAmpLegal","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getAmpLegal","meta":{}},{"name":"getEffectiveValueSanitizer","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getEffectiveValueSanitizer","meta":{}},{"name":"getParameterList","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getParameterList","meta":{}},{"name":"getParameterSet","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getParameterSet","meta":{}},{"name":"getPreferFirstRepeatedParameter","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getPreferFirstRepeatedParameter","meta":{}},{"name":"getSpaceLegal","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getSpaceLegal","meta":{}},{"name":"getUnregisteredParameterValueSanitizer","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getUnregisteredParameterValueSanitizer","meta":{}},{"name":"getUrlAndSpaceLegal","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getUrlAndSpaceLegal","meta":{}},{"name":"getUrlLegal","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getUrlLegal","meta":{}},{"name":"getValue","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getValue","meta":{}},{"name":"getValueSanitizer","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-getValueSanitizer","meta":{}},{"name":"hasParameter","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-hasParameter","meta":{}},{"name":"parseQuery","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-parseQuery","meta":{}},{"name":"parseUrl","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-parseUrl","meta":{}},{"name":"registerParameter","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-registerParameter","meta":{}},{"name":"registerParameters","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-registerParameters","meta":{}},{"name":"setAllowUnregisteredParamaters","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-setAllowUnregisteredParamaters","meta":{}},{"name":"setPreferFirstRepeatedParameter","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-setPreferFirstRepeatedParameter","meta":{}},{"name":"setUnregisteredParameterValueSanitizer","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-setUnregisteredParameterValueSanitizer","meta":{}},{"name":"unescape","tagname":"method","owner":"android.net.UrlQuerySanitizer","id":"method-unescape","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.net.UrlQuerySanitizer","short_doc":"Sanitizes the Query portion of a URL. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.net.UrlQuerySanitizer</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer' target='_blank'>UrlQuerySanitizer.js</a></div></pre><div class='doc-contents'><p>Sanitizes the Query portion of a URL. Simple example:\n <code>\n UrlQuerySanitizer sanitizer = new UrlQuerySanitizer();\n sanitizer.setAllowUnregisteredParamaters(true);\n sanitizer.parseUrl(\"http://example.com/?name=Joe+User\");\n String name = sanitizer.getValue(\"name\"));\n // name now contains \"Joe_User\"\n </code></p>\n\n<p> Register ValueSanitizers to customize the way individual\n parameters are sanitized:\n <code>\n UrlQuerySanitizer sanitizer = new UrlQuerySanitizer();\n sanitizer.registerParamater(\"name\", UrlQuerySanitizer.createSpaceLegal());\n sanitizer.parseUrl(\"http://example.com/?name=Joe+User\");\n String name = sanitizer.getValue(\"name\"));\n // name now contains \"Joe User\". (The string is first decoded, which\n // converts the '+' to a ' '. Then the string is sanitized, which\n // converts the ' ' to an '_'. (The ' ' is converted because the default\n unregistered parameter sanitizer does not allow any special characters,\n and ' ' is a special character.)\n </code></p>\n\n<p> There are several ways to create ValueSanitizers. In order of increasing\n sophistication:\n <ol>\n <li>Call one of the UrlQuerySanitizer.createXXX() methods.\n <li>Construct your own instance of\n UrlQuerySanitizer.IllegalCharacterValueSanitizer.\n <li>Subclass UrlQuerySanitizer.ValueSanitizer to define your own value\n sanitizer.\n </li></li></li></ol></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-getAllButNulAndAngleBracketsLegal' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getAllButNulAndAngleBracketsLegal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getAllButNulAndAngleBracketsLegal' class='name expandable'>getAllButNulAndAngleBracketsLegal</a>( <span class='pre'></span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Return a value sanitizer that allows any special characters\n except angle brackets ('&lt;' and '>') and Nul ('\\0'). ...</div><div class='long'><p>Return a value sanitizer that allows any special characters\n except angle brackets ('&lt;' and '>') and Nul ('\\0').\n Allows script URLs.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>a value sanitizer</p>\n</div></li></ul></div></div></div><div id='method-getAllButNulLegal' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getAllButNulLegal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getAllButNulLegal' class='name expandable'>getAllButNulLegal</a>( <span class='pre'></span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Return a value sanitizer that allows everything except Nul ('\\0')\n characters. ...</div><div class='long'><p>Return a value sanitizer that allows everything except Nul ('\\0')\n characters. Script URLs are allowed.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>a value sanitizer</p>\n</div></li></ul></div></div></div><div id='method-getAllButWhitespaceLegal' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getAllButWhitespaceLegal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getAllButWhitespaceLegal' class='name expandable'>getAllButWhitespaceLegal</a>( <span class='pre'></span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Return a value sanitizer that allows everything except Nul ('\\0')\n characters, space (' '), and other whitespace char...</div><div class='long'><p>Return a value sanitizer that allows everything except Nul ('\\0')\n characters, space (' '), and other whitespace characters.\n Script URLs are allowed.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>a value sanitizer</p>\n</div></li></ul></div></div></div><div id='method-getAllIllegal' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getAllIllegal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getAllIllegal' class='name expandable'>getAllIllegal</a>( <span class='pre'></span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Return a value sanitizer that does not allow any special characters,\n and also does not allow script URLs. ...</div><div class='long'><p>Return a value sanitizer that does not allow any special characters,\n and also does not allow script URLs.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>a value sanitizer</p>\n</div></li></ul></div></div></div><div id='method-getAllowUnregisteredParamaters' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getAllowUnregisteredParamaters' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getAllowUnregisteredParamaters' class='name expandable'>getAllowUnregisteredParamaters</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Get whether or not unregistered parameters are allowed. ...</div><div class='long'><p>Get whether or not unregistered parameters are allowed. If not\n allowed, they will be dropped when a query is parsed.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>true if unregistered parameters are allowed.\n@see <a href=\"#!/api/android.net.UrlQuerySanitizer-method-setAllowUnregisteredParamaters\" rel=\"android.net.UrlQuerySanitizer-method-setAllowUnregisteredParamaters\" class=\"docClass\">setAllowUnregisteredParamaters</a>(boolean)</p>\n</div></li></ul></div></div></div><div id='method-getAmpAndSpaceLegal' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getAmpAndSpaceLegal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getAmpAndSpaceLegal' class='name expandable'>getAmpAndSpaceLegal</a>( <span class='pre'></span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Return a value sanitizer that does not allow any special characters\n except ampersand ('&amp;') and space (' '). ...</div><div class='long'><p>Return a value sanitizer that does not allow any special characters\n except ampersand ('&amp;') and space (' '). Does not allow script URLs.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>a value sanitizer</p>\n</div></li></ul></div></div></div><div id='method-getAmpLegal' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getAmpLegal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getAmpLegal' class='name expandable'>getAmpLegal</a>( <span class='pre'></span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Return a value sanitizer that does not allow any special characters\n except ampersand ('&amp;'). ...</div><div class='long'><p>Return a value sanitizer that does not allow any special characters\n except ampersand ('&amp;'). Does not allow script URLs.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>a value sanitizer</p>\n</div></li></ul></div></div></div><div id='method-getEffectiveValueSanitizer' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getEffectiveValueSanitizer' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getEffectiveValueSanitizer' class='name expandable'>getEffectiveValueSanitizer</a>( <span class='pre'>parameter</span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Get the effective value sanitizer for a parameter. ...</div><div class='long'><p>Get the effective value sanitizer for a parameter. Like getValueSanitizer,\n except if there is no value sanitizer registered for a parameter, and\n unregistered paramaters are allowed, then the default value sanitizer is\n returned.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>parameter</span> : String<div class='sub-desc'><p>an unescaped parameter</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>the effective value sanitizer for a parameter.</p>\n</div></li></ul></div></div></div><div id='method-getParameterList' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getParameterList' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getParameterList' class='name expandable'>getParameterList</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>An array list of all of the parameter value pairs in the sanitized\n query, in the order they appeared in the query. ...</div><div class='long'><p>An array list of all of the parameter value pairs in the sanitized\n query, in the order they appeared in the query. May contain duplicate\n parameters.\n <p class=\"note\"><b>Note:</b> Do not modify this list. Treat it as a read-only list.</p></p>\n</div></div></div><div id='method-getParameterSet' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getParameterSet' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getParameterSet' class='name expandable'>getParameterSet</a>( <span class='pre'></span> ) : Object {java.util.Set}<span class=\"signature\"></span></div><div class='description'><div class='short'>Get a set of all of the parameters found in the sanitized query. ...</div><div class='long'><p>Get a set of all of the parameters found in the sanitized query.\n <p>\n Note: Do not modify this set. Treat it as a read-only set.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.util.Set}</span><div class='sub-desc'><p>all the parameters found in the current query.</p>\n</div></li></ul></div></div></div><div id='method-getPreferFirstRepeatedParameter' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getPreferFirstRepeatedParameter' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getPreferFirstRepeatedParameter' class='name expandable'>getPreferFirstRepeatedParameter</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Get whether or not the first occurrence of a repeated parameter is\n preferred. ...</div><div class='long'><p>Get whether or not the first occurrence of a repeated parameter is\n preferred.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>true if the first occurrence of a repeated parameter is\n preferred.\n@see <a href=\"#!/api/android.net.UrlQuerySanitizer-method-setPreferFirstRepeatedParameter\" rel=\"android.net.UrlQuerySanitizer-method-setPreferFirstRepeatedParameter\" class=\"docClass\">setPreferFirstRepeatedParameter</a>(boolean)</p>\n</div></li></ul></div></div></div><div id='method-getSpaceLegal' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getSpaceLegal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getSpaceLegal' class='name expandable'>getSpaceLegal</a>( <span class='pre'></span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Return a value sanitizer that does not allow any special characters\n except space (' '). ...</div><div class='long'><p>Return a value sanitizer that does not allow any special characters\n except space (' '). Does not allow script URLs.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>a value sanitizer</p>\n</div></li></ul></div></div></div><div id='method-getUnregisteredParameterValueSanitizer' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getUnregisteredParameterValueSanitizer' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getUnregisteredParameterValueSanitizer' class='name expandable'>getUnregisteredParameterValueSanitizer</a>( <span class='pre'></span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Get the current value sanitizer used when processing\n unregistered parameter values. ...</div><div class='long'><p>Get the current value sanitizer used when processing\n unregistered parameter values.\n <p>\n <b>Note:</b> The default unregistered parameter value sanitizer is\n one that doesn't allow any special characters, similar to what\n is returned by calling createAllIllegal.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>the current ValueSanitizer used to sanitize unregistered\n parameter values.</p>\n</div></li></ul></div></div></div><div id='method-getUrlAndSpaceLegal' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getUrlAndSpaceLegal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getUrlAndSpaceLegal' class='name expandable'>getUrlAndSpaceLegal</a>( <span class='pre'></span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Return a value sanitizer that allows all the characters used by\n encoded URLs and allows spaces, which are not techni...</div><div class='long'><p>Return a value sanitizer that allows all the characters used by\n encoded URLs and allows spaces, which are not technically legal\n in encoded URLs, but commonly appear anyway.\n Does not allow script URLs.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>a value sanitizer</p>\n</div></li></ul></div></div></div><div id='method-getUrlLegal' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getUrlLegal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getUrlLegal' class='name expandable'>getUrlLegal</a>( <span class='pre'></span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Return a value sanitizer that allows all the characters used by\n encoded URLs. ...</div><div class='long'><p>Return a value sanitizer that allows all the characters used by\n encoded URLs. Does not allow script URLs.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>a value sanitizer</p>\n</div></li></ul></div></div></div><div id='method-getValue' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getValue' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getValue' class='name expandable'>getValue</a>( <span class='pre'>parameter</span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Get the value for a parameter in the current sanitized query. ...</div><div class='long'><p>Get the value for a parameter in the current sanitized query.\n Returns null if the parameter does not\n exit.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>parameter</span> : String<div class='sub-desc'><p>the unencoded name of a parameter.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the sanitized unencoded value of the parameter,\n or null if the parameter does not exist.</p>\n</div></li></ul></div></div></div><div id='method-getValueSanitizer' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-getValueSanitizer' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-getValueSanitizer' class='name expandable'>getValueSanitizer</a>( <span class='pre'>parameter</span> ) : Object {android.net.UrlQuerySanitizer.ValueSanitizer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Get the value sanitizer for a parameter. ...</div><div class='long'><p>Get the value sanitizer for a parameter. Returns null if there\n is no value sanitizer registered for the parameter.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>parameter</span> : String<div class='sub-desc'><p>the unescaped parameter</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.UrlQuerySanitizer.ValueSanitizer}</span><div class='sub-desc'><p>the currently registered value sanitizer for this parameter.\n@see <a href=\"#!/api/android.net.UrlQuerySanitizer-method-registerParameter\" rel=\"android.net.UrlQuerySanitizer-method-registerParameter\" class=\"docClass\">registerParameter</a>(String, <a href=\"#!/api/android.net.UrlQuerySanitizer.ValueSanitizer\" rel=\"android.net.UrlQuerySanitizer.ValueSanitizer\" class=\"docClass\">android.net.UrlQuerySanitizer.ValueSanitizer</a>)</p>\n</div></li></ul></div></div></div><div id='method-hasParameter' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-hasParameter' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-hasParameter' class='name expandable'>hasParameter</a>( <span class='pre'>parameter</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Check if a parameter exists in the current sanitized query. ...</div><div class='long'><p>Check if a parameter exists in the current sanitized query.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>parameter</span> : String<div class='sub-desc'><p>the unencoded name of a parameter.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>true if the paramater exists in the current sanitized queary.</p>\n</div></li></ul></div></div></div><div id='method-parseQuery' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-parseQuery' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-parseQuery' class='name expandable'>parseQuery</a>( <span class='pre'>query</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Parse a query. ...</div><div class='long'><p>Parse a query. A query string is any number of parameter-value clauses\n separated by any non-zero number of ampersands. A parameter-value clause\n is a parameter followed by an equal sign, followed by a value. If the\n equal sign is missing, the value is assumed to be the empty string.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>query</span> : String<div class='sub-desc'><p>the query to parse.</p>\n</div></li></ul></div></div></div><div id='method-parseUrl' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-parseUrl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-parseUrl' class='name expandable'>parseUrl</a>( <span class='pre'>url</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Parse the query parameters out of an encoded URL. ...</div><div class='long'><p>Parse the query parameters out of an encoded URL.\n Works by extracting the query portion from the URL and then\n calling parseQuery(). If there is no query portion it is\n treated as if the query portion is an empty string.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>url</span> : String<div class='sub-desc'><p>the encoded URL to parse.</p>\n</div></li></ul></div></div></div><div id='method-registerParameter' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-registerParameter' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-registerParameter' class='name expandable'>registerParameter</a>( <span class='pre'>parameter, valueSanitizer</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Register a value sanitizer for a particular parameter. ...</div><div class='long'><p>Register a value sanitizer for a particular parameter. Can also be used\n to replace or remove an already-set value sanitizer.\n <p>\n Registering a non-null value sanitizer for a particular parameter\n makes that parameter a registered parameter.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>parameter</span> : String<div class='sub-desc'><p>an unencoded parameter name</p>\n</div></li><li><span class='pre'>valueSanitizer</span> : Object {UrlQuerySanitizer.ValueSanitizer}<div class='sub-desc'><p>the value sanitizer to use for a particular\n parameter. May be null in order to unregister that parameter.\n@see <a href=\"#!/api/android.net.UrlQuerySanitizer-method-getAllowUnregisteredParamaters\" rel=\"android.net.UrlQuerySanitizer-method-getAllowUnregisteredParamaters\" class=\"docClass\">getAllowUnregisteredParamaters</a>()</p>\n</div></li></ul></div></div></div><div id='method-registerParameters' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-registerParameters' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-registerParameters' class='name expandable'>registerParameters</a>( <span class='pre'>parameters, valueSanitizer</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Register a value sanitizer for an array of parameters. ...</div><div class='long'><p>Register a value sanitizer for an array of parameters.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>parameters</span> : Object {java.lang.String[]}<div class='sub-desc'><p>An array of unencoded parameter names.</p>\n</div></li><li><span class='pre'>valueSanitizer</span> : Object {UrlQuerySanitizer.ValueSanitizer}<div class='sub-desc'><p>@see <a href=\"#!/api/android.net.UrlQuerySanitizer-method-registerParameter\" rel=\"android.net.UrlQuerySanitizer-method-registerParameter\" class=\"docClass\">registerParameter</a></p>\n</div></li></ul></div></div></div><div id='method-setAllowUnregisteredParamaters' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-setAllowUnregisteredParamaters' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-setAllowUnregisteredParamaters' class='name expandable'>setAllowUnregisteredParamaters</a>( <span class='pre'>allowUnregisteredParamaters</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Set whether or not unregistered parameters are allowed. ...</div><div class='long'><p>Set whether or not unregistered parameters are allowed. If they\n are not allowed, then they will be dropped when a query is sanitized.\n <p>\n Defaults to false.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>allowUnregisteredParamaters</span> : Boolean<div class='sub-desc'><p>true to allow unregistered parameters.\n@see <a href=\"#!/api/android.net.UrlQuerySanitizer-method-getAllowUnregisteredParamaters\" rel=\"android.net.UrlQuerySanitizer-method-getAllowUnregisteredParamaters\" class=\"docClass\">getAllowUnregisteredParamaters</a>()</p>\n</div></li></ul></div></div></div><div id='method-setPreferFirstRepeatedParameter' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-setPreferFirstRepeatedParameter' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-setPreferFirstRepeatedParameter' class='name expandable'>setPreferFirstRepeatedParameter</a>( <span class='pre'>preferFirstRepeatedParameter</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Set whether or not the first occurrence of a repeated parameter is\n preferred. ...</div><div class='long'><p>Set whether or not the first occurrence of a repeated parameter is\n preferred. True means the first repeated parameter is preferred.\n False means that the last repeated parameter is preferred.\n <p>\n The preferred parameter is the one that is returned when getParameter\n is called.\n <p>\n defaults to false.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>preferFirstRepeatedParameter</span> : Boolean<div class='sub-desc'><p>True if the first repeated\n parameter is preferred.\n@see <a href=\"#!/api/android.net.UrlQuerySanitizer-method-getPreferFirstRepeatedParameter\" rel=\"android.net.UrlQuerySanitizer-method-getPreferFirstRepeatedParameter\" class=\"docClass\">getPreferFirstRepeatedParameter</a>()</p>\n</div></li></ul></div></div></div><div id='method-setUnregisteredParameterValueSanitizer' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-setUnregisteredParameterValueSanitizer' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-setUnregisteredParameterValueSanitizer' class='name expandable'>setUnregisteredParameterValueSanitizer</a>( <span class='pre'>sanitizer</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Set the value sanitizer used when processing unregistered\n parameter values. ...</div><div class='long'><p>Set the value sanitizer used when processing unregistered\n parameter values.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>sanitizer</span> : Object {UrlQuerySanitizer.ValueSanitizer}<div class='sub-desc'><p>set the ValueSanitizer used to sanitize unregistered\n parameter values.</p>\n</div></li></ul></div></div></div><div id='method-unescape' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.net.UrlQuerySanitizer'>android.net.UrlQuerySanitizer</span><br/><a href='source/UrlQuerySanitizer.html#android-net-UrlQuerySanitizer-method-unescape' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.net.UrlQuerySanitizer-method-unescape' class='name expandable'>unescape</a>( <span class='pre'>string</span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Unescape an escaped string. ...</div><div class='long'><p>Unescape an escaped string.\n <ul>\n <li>'+' characters are replaced by\n ' ' characters.\n <li>Valid \"%xx\" escape sequences are replaced by the\n corresponding unescaped character.\n <li>Invalid escape sequences such as %1z\", are passed through unchanged.\n <ol></ol></li></li></li></ul></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>string</span> : String<div class='sub-desc'><p>the escaped string</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the unescaped string.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});