Ext.data.JsonP.android_os_CancellationSignal({"tagname":"class","name":"android.os.CancellationSignal","autodetected":{},"files":[{"filename":"CancellationSignal.js","href":"CancellationSignal.html#android-os-CancellationSignal"}],"extends":"java.lang.Object","members":[{"name":"cancel","tagname":"method","owner":"android.os.CancellationSignal","id":"method-cancel","meta":{}},{"name":"isCanceled","tagname":"method","owner":"android.os.CancellationSignal","id":"method-isCanceled","meta":{}},{"name":"setOnCancelListener","tagname":"method","owner":"android.os.CancellationSignal","id":"method-setOnCancelListener","meta":{}},{"name":"throwIfCanceled","tagname":"method","owner":"android.os.CancellationSignal","id":"method-throwIfCanceled","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.CancellationSignal","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.CancellationSignal</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/CancellationSignal.html#android-os-CancellationSignal' target='_blank'>CancellationSignal.js</a></div></pre><div class='doc-contents'><p>Provides the ability to cancel an operation in progress.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-cancel' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.CancellationSignal'>android.os.CancellationSignal</span><br/><a href='source/CancellationSignal.html#android-os-CancellationSignal-method-cancel' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.CancellationSignal-method-cancel' class='name expandable'>cancel</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Cancels the operation and signals the cancellation listener. ...</div><div class='long'><p>Cancels the operation and signals the cancellation listener.\n If the operation has not yet started, then it will be canceled as soon as it does.</p>\n</div></div></div><div id='method-isCanceled' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.CancellationSignal'>android.os.CancellationSignal</span><br/><a href='source/CancellationSignal.html#android-os-CancellationSignal-method-isCanceled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.CancellationSignal-method-isCanceled' class='name expandable'>isCanceled</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns true if the operation has been canceled. ...</div><div class='long'><p>Returns true if the operation has been canceled.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>True if the operation has been canceled.</p>\n</div></li></ul></div></div></div><div id='method-setOnCancelListener' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.CancellationSignal'>android.os.CancellationSignal</span><br/><a href='source/CancellationSignal.html#android-os-CancellationSignal-method-setOnCancelListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.CancellationSignal-method-setOnCancelListener' class='name expandable'>setOnCancelListener</a>( <span class='pre'>listener</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Sets the cancellation listener to be called when canceled. ...</div><div class='long'><p>Sets the cancellation listener to be called when canceled.</p>\n\n<p> This method is intended to be used by the recipient of a cancellation signal\n such as a database or a content provider to handle cancellation requests\n while performing a long-running operation.  This method is not intended to be\n used by applications themselves.</p>\n\n<p> If <a href=\"#!/api/android.os.CancellationSignal-method-cancel\" rel=\"android.os.CancellationSignal-method-cancel\" class=\"docClass\">cancel</a> has already been called, then the provided\n listener is invoked immediately.</p>\n\n<p> This method is guaranteed that the listener will not be called after it\n has been removed.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>listener</span> : Object {CancellationSignal.OnCancelListener}<div class='sub-desc'><p>The cancellation listener, or null to remove the current listener.</p>\n</div></li></ul></div></div></div><div id='method-throwIfCanceled' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.CancellationSignal'>android.os.CancellationSignal</span><br/><a href='source/CancellationSignal.html#android-os-CancellationSignal-method-throwIfCanceled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.CancellationSignal-method-throwIfCanceled' class='name expandable'>throwIfCanceled</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Throws android.os.OperationCanceledException if the operation has been canceled. ...</div><div class='long'><p>Throws <a href=\"#!/api/android.os.OperationCanceledException\" rel=\"android.os.OperationCanceledException\" class=\"docClass\">android.os.OperationCanceledException</a> if the operation has been canceled.</p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>OperationCanceledException if the operation has been canceled.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});