Ext.data.JsonP.android_os_CountDownTimer({"tagname":"class","name":"android.os.CountDownTimer","autodetected":{},"files":[{"filename":"CountDownTimer.js","href":"CountDownTimer.html#android-os-CountDownTimer"}],"extends":"java.lang.Object","members":[{"name":"cancel","tagname":"method","owner":"android.os.CountDownTimer","id":"method-cancel","meta":{}},{"name":"onFinish","tagname":"method","owner":"android.os.CountDownTimer","id":"method-onFinish","meta":{}},{"name":"onTick","tagname":"method","owner":"android.os.CountDownTimer","id":"method-onTick","meta":{}},{"name":"start","tagname":"method","owner":"android.os.CountDownTimer","id":"method-start","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.CountDownTimer","short_doc":"Schedule a countdown until a time in the future, with\n regular notifications on intervals along the way. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.CountDownTimer</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/CountDownTimer.html#android-os-CountDownTimer' target='_blank'>CountDownTimer.js</a></div></pre><div class='doc-contents'><p>Schedule a countdown until a time in the future, with\n regular notifications on intervals along the way.</p>\n\n<p> Example of showing a 30 second countdown in a text field:</p>\n\n<p> <pre class=\"prettyprint\">\n new CountDownTimer(30000, 1000) {</pre></p>\n\n<pre><code> public void onTick(long millisUntilFinished) {\n     mTextField.setText(\"seconds remaining: \" + millisUntilFinished / 1000);\n }\n\n public void onFinish() {\n     mTextField.setText(\"done!\");\n }\n</code></pre>\n\n<p>  }.start();\n </p>\n\n<p> The calls to <a href=\"#!/api/android.os.CountDownTimer-method-onTick\" rel=\"android.os.CountDownTimer-method-onTick\" class=\"docClass\">onTick</a>(long) are synchronized to this object so that\n one call to <a href=\"#!/api/android.os.CountDownTimer-method-onTick\" rel=\"android.os.CountDownTimer-method-onTick\" class=\"docClass\">onTick</a>(long) won't ever occur before the previous\n callback is complete.  This is only relevant when the implementation of\n <a href=\"#!/api/android.os.CountDownTimer-method-onTick\" rel=\"android.os.CountDownTimer-method-onTick\" class=\"docClass\">onTick</a>(long) takes an amount of time to execute that is significant\n compared to the countdown interval.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-cancel' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.CountDownTimer'>android.os.CountDownTimer</span><br/><a href='source/CountDownTimer.html#android-os-CountDownTimer-method-cancel' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.CountDownTimer-method-cancel' class='name expandable'>cancel</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Cancel the countdown. ...</div><div class='long'><p>Cancel the countdown.</p>\n</div></div></div><div id='method-onFinish' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.CountDownTimer'>android.os.CountDownTimer</span><br/><a href='source/CountDownTimer.html#android-os-CountDownTimer-method-onFinish' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.CountDownTimer-method-onFinish' class='name expandable'>onFinish</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Callback fired when the time is up. ...</div><div class='long'><p>Callback fired when the time is up.</p>\n</div></div></div><div id='method-onTick' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.CountDownTimer'>android.os.CountDownTimer</span><br/><a href='source/CountDownTimer.html#android-os-CountDownTimer-method-onTick' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.CountDownTimer-method-onTick' class='name expandable'>onTick</a>( <span class='pre'>millisUntilFinished</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Callback fired on regular interval. ...</div><div class='long'><p>Callback fired on regular interval.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>millisUntilFinished</span> : Number<div class='sub-desc'><p>The amount of time until finished.</p>\n</div></li></ul></div></div></div><div id='method-start' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.CountDownTimer'>android.os.CountDownTimer</span><br/><a href='source/CountDownTimer.html#android-os-CountDownTimer-method-start' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.CountDownTimer-method-start' class='name expandable'>start</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Start the countdown. ...</div><div class='long'><p>Start the countdown.</p>\n</div></div></div></div></div></div></div>","meta":{}});