Ext.data.JsonP.android_os_Debug_InstructionCount({"tagname":"class","name":"android.os.Debug.InstructionCount","autodetected":{},"files":[{"filename":"InstructionCount.js","href":"InstructionCount.html#android-os-Debug-InstructionCount"}],"extends":"java.lang.Object","deprecated":{"text":"<p>Instruction counting is no longer supported.</p>\n"},"members":[{"name":"collect","tagname":"method","owner":"android.os.Debug.InstructionCount","id":"method-collect","meta":{}},{"name":"globalMethodInvocations","tagname":"method","owner":"android.os.Debug.InstructionCount","id":"method-globalMethodInvocations","meta":{}},{"name":"globalTotal","tagname":"method","owner":"android.os.Debug.InstructionCount","id":"method-globalTotal","meta":{}},{"name":"resetAndStart","tagname":"method","owner":"android.os.Debug.InstructionCount","id":"method-resetAndStart","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.Debug.InstructionCount","short_doc":"API for gathering and querying instruction counts. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.Debug.InstructionCount</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/InstructionCount.html#android-os-Debug-InstructionCount' target='_blank'>InstructionCount.js</a></div></pre><div class='doc-contents'><p>API for gathering and querying instruction counts.</p>\n\n<p> Example usage:</p>\n\n<pre>   Debug.InstructionCount icount = new Debug.InstructionCount();\n   icount.resetAndStart();\n    [... do lots of stuff ...]\n   if (icount.collect()) {\n       System.out.println(\"Total instructions executed: \"\n           + icount.globalTotal());\n       System.out.println(\"Method invocations: \"\n           + icount.globalMethodInvocations());\n   }\n </pre>\n\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This class has been <strong>deprecated</strong> </p>\n        <p>Instruction counting is no longer supported.</p>\n\n        </div>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-collect' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Debug.InstructionCount'>android.os.Debug.InstructionCount</span><br/><a href='source/InstructionCount.html#android-os-Debug-InstructionCount-method-collect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Debug.InstructionCount-method-collect' class='name expandable'>collect</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Collect instruction counts. ...</div><div class='long'><p>Collect instruction counts.  May or may not stop the\n counting process.</p>\n</div></div></div><div id='method-globalMethodInvocations' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Debug.InstructionCount'>android.os.Debug.InstructionCount</span><br/><a href='source/InstructionCount.html#android-os-Debug-InstructionCount-method-globalMethodInvocations' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Debug.InstructionCount-method-globalMethodInvocations' class='name expandable'>globalMethodInvocations</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Return the total number of method-invocation instructions\n executed globally. ...</div><div class='long'><p>Return the total number of method-invocation instructions\n executed globally.</p>\n</div></div></div><div id='method-globalTotal' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Debug.InstructionCount'>android.os.Debug.InstructionCount</span><br/><a href='source/InstructionCount.html#android-os-Debug-InstructionCount-method-globalTotal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Debug.InstructionCount-method-globalTotal' class='name expandable'>globalTotal</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Return the total number of instructions executed globally (i.e. ...</div><div class='long'><p>Return the total number of instructions executed globally (i.e. in\n all threads).</p>\n</div></div></div><div id='method-resetAndStart' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Debug.InstructionCount'>android.os.Debug.InstructionCount</span><br/><a href='source/InstructionCount.html#android-os-Debug-InstructionCount-method-resetAndStart' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Debug.InstructionCount-method-resetAndStart' class='name expandable'>resetAndStart</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Reset counters and ensure counts are running. ...</div><div class='long'><p>Reset counters and ensure counts are running.  Counts may\n have already been running.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>true if counting was started</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{"deprecated":{"text":"<p>Instruction counting is no longer supported.</p>\n"}}});