Ext.data.JsonP.android_os_DropBoxManager({"tagname":"class","name":"android.os.DropBoxManager","autodetected":{},"files":[{"filename":"DropBoxManager.js","href":"DropBoxManager.html#android-os-DropBoxManager"}],"extends":"java.lang.Object","members":[{"name":"ACTION_DROPBOX_ENTRY_ADDED","tagname":"property","owner":"android.os.DropBoxManager","id":"property-ACTION_DROPBOX_ENTRY_ADDED","meta":{}},{"name":"EXTRA_TAG","tagname":"property","owner":"android.os.DropBoxManager","id":"property-EXTRA_TAG","meta":{}},{"name":"EXTRA_TIME","tagname":"property","owner":"android.os.DropBoxManager","id":"property-EXTRA_TIME","meta":{}},{"name":"IS_EMPTY","tagname":"property","owner":"android.os.DropBoxManager","id":"property-IS_EMPTY","meta":{}},{"name":"IS_GZIPPED","tagname":"property","owner":"android.os.DropBoxManager","id":"property-IS_GZIPPED","meta":{}},{"name":"IS_TEXT","tagname":"property","owner":"android.os.DropBoxManager","id":"property-IS_TEXT","meta":{}},{"name":"addData","tagname":"method","owner":"android.os.DropBoxManager","id":"method-addData","meta":{}},{"name":"addFile","tagname":"method","owner":"android.os.DropBoxManager","id":"method-addFile","meta":{}},{"name":"addText","tagname":"method","owner":"android.os.DropBoxManager","id":"method-addText","meta":{}},{"name":"getNextEntry","tagname":"method","owner":"android.os.DropBoxManager","id":"method-getNextEntry","meta":{}},{"name":"isTagEnabled","tagname":"method","owner":"android.os.DropBoxManager","id":"method-isTagEnabled","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.DropBoxManager","short_doc":"Enqueues chunks of data (from various sources -- application crashes, kernel\n log records, etc.). ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.DropBoxManager</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/DropBoxManager.html#android-os-DropBoxManager' target='_blank'>DropBoxManager.js</a></div></pre><div class='doc-contents'><p>Enqueues chunks of data (from various sources -- application crashes, kernel\n log records, etc.).  The queue is size bounded and will drop old data if the\n enqueued data exceeds the maximum size.  You can think of this as a\n persistent, system-wide, blob-oriented \"logcat\".</p>\n\n<p> <p>You can obtain an instance of this class by calling\n android.content.Context.getSystemService\n with android.content.Context.DROPBOX_SERVICE.</p>\n\n<p> <p>DropBoxManager entries are not sent anywhere directly, but other system\n services and debugging tools may scan and upload entries for processing.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-ACTION_DROPBOX_ENTRY_ADDED' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.DropBoxManager'>android.os.DropBoxManager</span><br/><a href='source/DropBoxManager.html#android-os-DropBoxManager-property-ACTION_DROPBOX_ENTRY_ADDED' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.DropBoxManager-property-ACTION_DROPBOX_ENTRY_ADDED' class='name expandable'>ACTION_DROPBOX_ENTRY_ADDED</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Broadcast Action: This is broadcast when a new entry is added in the dropbox. ...</div><div class='long'><p>Broadcast Action: This is broadcast when a new entry is added in the dropbox.\nYou must hold the android.Manifest.permission.READ_LOGS permission\nin order to receive this broadcast.</p>\n\n<p><p class=\"note\">This is a protected intent that can only be sent\nby the system.</p>\n<p>Defaults to: <code>&quot;android.intent.action.DROPBOX_ENTRY_ADDED&quot;</code></p></div></div></div><div id='property-EXTRA_TAG' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.DropBoxManager'>android.os.DropBoxManager</span><br/><a href='source/DropBoxManager.html#android-os-DropBoxManager-property-EXTRA_TAG' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.DropBoxManager-property-EXTRA_TAG' class='name expandable'>EXTRA_TAG</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Extra for ACTION_DROPBOX_ENTRY_ADDED:\nstring containing the dropbox tag. ...</div><div class='long'><p>Extra for <a href=\"#!/api/android.os.DropBoxManager-property-ACTION_DROPBOX_ENTRY_ADDED\" rel=\"android.os.DropBoxManager-property-ACTION_DROPBOX_ENTRY_ADDED\" class=\"docClass\">ACTION_DROPBOX_ENTRY_ADDED</a>:\nstring containing the dropbox tag.</p>\n<p>Defaults to: <code>&quot;tag&quot;</code></p></div></div></div><div id='property-EXTRA_TIME' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.DropBoxManager'>android.os.DropBoxManager</span><br/><a href='source/DropBoxManager.html#android-os-DropBoxManager-property-EXTRA_TIME' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.DropBoxManager-property-EXTRA_TIME' class='name expandable'>EXTRA_TIME</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Extra for ACTION_DROPBOX_ENTRY_ADDED:\nlong integer value containing time (in milliseconds since January 1, 1970 00:00...</div><div class='long'><p>Extra for <a href=\"#!/api/android.os.DropBoxManager-property-ACTION_DROPBOX_ENTRY_ADDED\" rel=\"android.os.DropBoxManager-property-ACTION_DROPBOX_ENTRY_ADDED\" class=\"docClass\">ACTION_DROPBOX_ENTRY_ADDED</a>:\nlong integer value containing time (in milliseconds since January 1, 1970 00:00:00 UTC)\nwhen the entry was created.</p>\n<p>Defaults to: <code>&quot;time&quot;</code></p></div></div></div><div id='property-IS_EMPTY' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.DropBoxManager'>android.os.DropBoxManager</span><br/><a href='source/DropBoxManager.html#android-os-DropBoxManager-property-IS_EMPTY' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.DropBoxManager-property-IS_EMPTY' class='name expandable'>IS_EMPTY</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Flag value: Entry's content was deleted to save space. ...</div><div class='long'><p>Flag value: Entry's content was deleted to save space.</p>\n<p>Defaults to: <code>&quot;1&quot;</code></p></div></div></div><div id='property-IS_GZIPPED' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.DropBoxManager'>android.os.DropBoxManager</span><br/><a href='source/DropBoxManager.html#android-os-DropBoxManager-property-IS_GZIPPED' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.DropBoxManager-property-IS_GZIPPED' class='name expandable'>IS_GZIPPED</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Flag value: Content can be decompressed with java.util.zip.GZIPOutputStream. ...</div><div class='long'><p>Flag value: Content can be decompressed with java.util.zip.GZIPOutputStream.</p>\n<p>Defaults to: <code>&quot;4&quot;</code></p></div></div></div><div id='property-IS_TEXT' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.DropBoxManager'>android.os.DropBoxManager</span><br/><a href='source/DropBoxManager.html#android-os-DropBoxManager-property-IS_TEXT' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.DropBoxManager-property-IS_TEXT' class='name expandable'>IS_TEXT</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Flag value: Content is human-readable UTF-8 text (can be combined with IS_GZIPPED). ...</div><div class='long'><p>Flag value: Content is human-readable UTF-8 text (can be combined with IS_GZIPPED).</p>\n<p>Defaults to: <code>&quot;2&quot;</code></p></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addData' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.DropBoxManager'>android.os.DropBoxManager</span><br/><a href='source/DropBoxManager.html#android-os-DropBoxManager-method-addData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.DropBoxManager-method-addData' class='name expandable'>addData</a>( <span class='pre'>tag, data, flags</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Stores binary data, which may be ignored or discarded as with addText. ...</div><div class='long'><p>Stores binary data, which may be ignored or discarded as with <a href=\"#!/api/android.os.DropBoxManager-method-addText\" rel=\"android.os.DropBoxManager-method-addText\" class=\"docClass\">addText</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>tag</span> : String<div class='sub-desc'><p>describing the type of entry being stored</p>\n</div></li><li><span class='pre'>data</span> : Object {byte[]}<div class='sub-desc'><p>value to store</p>\n</div></li><li><span class='pre'>flags</span> : Number<div class='sub-desc'><p>describing the data</p>\n</div></li></ul></div></div></div><div id='method-addFile' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.DropBoxManager'>android.os.DropBoxManager</span><br/><a href='source/DropBoxManager.html#android-os-DropBoxManager-method-addFile' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.DropBoxManager-method-addFile' class='name expandable'>addFile</a>( <span class='pre'>tag, file, flags</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Stores the contents of a file, which may be ignored or discarded as with\n addText. ...</div><div class='long'><p>Stores the contents of a file, which may be ignored or discarded as with\n <a href=\"#!/api/android.os.DropBoxManager-method-addText\" rel=\"android.os.DropBoxManager-method-addText\" class=\"docClass\">addText</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>tag</span> : String<div class='sub-desc'><p>describing the type of entry being stored</p>\n</div></li><li><span class='pre'>file</span> : Object {File}<div class='sub-desc'><p>to read from</p>\n</div></li><li><span class='pre'>flags</span> : Number<div class='sub-desc'><p>describing the data</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IOException if the file can't be opened</p>\n</div></li></ul></div></div></div><div id='method-addText' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.DropBoxManager'>android.os.DropBoxManager</span><br/><a href='source/DropBoxManager.html#android-os-DropBoxManager-method-addText' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.DropBoxManager-method-addText' class='name expandable'>addText</a>( <span class='pre'>tag, data</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Stores human-readable text. ...</div><div class='long'><p>Stores human-readable text.  The data may be discarded eventually (or even\n immediately) if space is limited, or ignored entirely if the tag has been\n blocked (see <a href=\"#!/api/android.os.DropBoxManager-method-isTagEnabled\" rel=\"android.os.DropBoxManager-method-isTagEnabled\" class=\"docClass\">isTagEnabled</a>).</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>tag</span> : String<div class='sub-desc'><p>describing the type of entry being stored</p>\n</div></li><li><span class='pre'>data</span> : String<div class='sub-desc'><p>value to store</p>\n</div></li></ul></div></div></div><div id='method-getNextEntry' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.DropBoxManager'>android.os.DropBoxManager</span><br/><a href='source/DropBoxManager.html#android-os-DropBoxManager-method-getNextEntry' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.DropBoxManager-method-getNextEntry' class='name expandable'>getNextEntry</a>( <span class='pre'>tag, msec</span> ) : Object {android.os.DropBoxManager.Entry}<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets the next entry from the drop box after the specified time. ...</div><div class='long'><p>Gets the next entry from the drop box <em>after</em> the specified time.\n Requires <code>android.permission.READ_LOGS</code>.  You must always call\n android.os.DropBoxManager.Entry.close() on the return value!</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>tag</span> : String<div class='sub-desc'><p>of entry to look for, null for all tags</p>\n</div></li><li><span class='pre'>msec</span> : Number<div class='sub-desc'><p>time of the last entry seen</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.os.DropBoxManager.Entry}</span><div class='sub-desc'><p>the next entry, or null if there are no more entries</p>\n</div></li></ul></div></div></div><div id='method-isTagEnabled' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.DropBoxManager'>android.os.DropBoxManager</span><br/><a href='source/DropBoxManager.html#android-os-DropBoxManager-method-isTagEnabled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.DropBoxManager-method-isTagEnabled' class='name expandable'>isTagEnabled</a>( <span class='pre'>tag</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Checks any blacklists (set in system settings) to see whether a certain\n tag is allowed. ...</div><div class='long'><p>Checks any blacklists (set in system settings) to see whether a certain\n tag is allowed.  Entries with disabled tags will be dropped immediately,\n so you can save the work of actually constructing and sending the data.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>tag</span> : String<div class='sub-desc'><p>that would be used in <a href=\"#!/api/android.os.DropBoxManager-method-addText\" rel=\"android.os.DropBoxManager-method-addText\" class=\"docClass\">addText</a> or <a href=\"#!/api/android.os.DropBoxManager-method-addFile\" rel=\"android.os.DropBoxManager-method-addFile\" class=\"docClass\">addFile</a></p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>whether events with that tag would be accepted</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});