Ext.data.JsonP.android_os_FileObserver({"tagname":"class","name":"android.os.FileObserver","autodetected":{},"files":[{"filename":"FileObserver.js","href":"FileObserver.html#android-os-FileObserver"}],"extends":"java.lang.Object","members":[{"name":"ACCESS","tagname":"property","owner":"android.os.FileObserver","id":"property-ACCESS","meta":{}},{"name":"ALL_EVENTS","tagname":"property","owner":"android.os.FileObserver","id":"property-ALL_EVENTS","meta":{}},{"name":"ATTRIB","tagname":"property","owner":"android.os.FileObserver","id":"property-ATTRIB","meta":{}},{"name":"CLOSE_NOWRITE","tagname":"property","owner":"android.os.FileObserver","id":"property-CLOSE_NOWRITE","meta":{}},{"name":"CLOSE_WRITE","tagname":"property","owner":"android.os.FileObserver","id":"property-CLOSE_WRITE","meta":{}},{"name":"CREATE","tagname":"property","owner":"android.os.FileObserver","id":"property-CREATE","meta":{}},{"name":"DELETE","tagname":"property","owner":"android.os.FileObserver","id":"property-DELETE","meta":{}},{"name":"DELETE_SELF","tagname":"property","owner":"android.os.FileObserver","id":"property-DELETE_SELF","meta":{}},{"name":"MODIFY","tagname":"property","owner":"android.os.FileObserver","id":"property-MODIFY","meta":{}},{"name":"MOVED_FROM","tagname":"property","owner":"android.os.FileObserver","id":"property-MOVED_FROM","meta":{}},{"name":"MOVED_TO","tagname":"property","owner":"android.os.FileObserver","id":"property-MOVED_TO","meta":{}},{"name":"MOVE_SELF","tagname":"property","owner":"android.os.FileObserver","id":"property-MOVE_SELF","meta":{}},{"name":"OPEN","tagname":"property","owner":"android.os.FileObserver","id":"property-OPEN","meta":{}},{"name":"onEvent","tagname":"method","owner":"android.os.FileObserver","id":"method-onEvent","meta":{}},{"name":"startWatching","tagname":"method","owner":"android.os.FileObserver","id":"method-startWatching","meta":{}},{"name":"stopWatching","tagname":"method","owner":"android.os.FileObserver","id":"method-stopWatching","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.FileObserver","short_doc":"Monitors files (using inotify)\n to fire an event after files are accessed or changed by by any process on\n the device...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.FileObserver</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/FileObserver.html#android-os-FileObserver' target='_blank'>FileObserver.js</a></div></pre><div class='doc-contents'><p>Monitors files (using <a href=\"http://en.wikipedia.org/wiki/Inotify\">inotify</a>)\n to fire an event after files are accessed or changed by by any process on\n the device (including this one).  FileObserver is an abstract class;\n subclasses must implement the event handler String).</p>\n\n<p> <p>Each FileObserver instance monitors a single file or directory.\n If a directory is monitored, events will be triggered for all files and\n subdirectories inside the monitored directory.</p></p>\n\n<p> <p>An event mask is used to specify which changes or actions to report.\n Event type constants are used to describe the possible changes in the\n event mask as well as what actually happened in event callbacks.</p></p>\n\n<p> <p class=\"caution\"><b>Warning</b>: If a FileObserver is garbage collected, it\n will stop sending events.  To ensure you keep receiving events, you must\n keep a reference to the FileObserver instance from some other live object.</p></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-ACCESS' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-ACCESS' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-ACCESS' class='name expandable'>ACCESS</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: Data was read from a file ...</div><div class='long'><p>Event type: Data was read from a file</p>\n<p>Defaults to: <code>&quot;1&quot;</code></p></div></div></div><div id='property-ALL_EVENTS' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-ALL_EVENTS' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-ALL_EVENTS' class='name expandable'>ALL_EVENTS</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event mask: All valid event types, combined ...</div><div class='long'><p>Event mask: All valid event types, combined</p>\n<p>Defaults to: <code>&quot;4095&quot;</code></p></div></div></div><div id='property-ATTRIB' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-ATTRIB' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-ATTRIB' class='name expandable'>ATTRIB</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: Metadata (permissions, owner, timestamp) was changed explicitly ...</div><div class='long'><p>Event type: Metadata (permissions, owner, timestamp) was changed explicitly</p>\n<p>Defaults to: <code>&quot;4&quot;</code></p></div></div></div><div id='property-CLOSE_NOWRITE' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-CLOSE_NOWRITE' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-CLOSE_NOWRITE' class='name expandable'>CLOSE_NOWRITE</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: Someone had a file or directory open read-only, and closed it ...</div><div class='long'><p>Event type: Someone had a file or directory open read-only, and closed it</p>\n<p>Defaults to: <code>&quot;16&quot;</code></p></div></div></div><div id='property-CLOSE_WRITE' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-CLOSE_WRITE' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-CLOSE_WRITE' class='name expandable'>CLOSE_WRITE</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: Someone had a file or directory open for writing, and closed it ...</div><div class='long'><p>Event type: Someone had a file or directory open for writing, and closed it</p>\n<p>Defaults to: <code>&quot;8&quot;</code></p></div></div></div><div id='property-CREATE' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-CREATE' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-CREATE' class='name expandable'>CREATE</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: A new file or subdirectory was created under the monitored directory ...</div><div class='long'><p>Event type: A new file or subdirectory was created under the monitored directory</p>\n<p>Defaults to: <code>&quot;256&quot;</code></p></div></div></div><div id='property-DELETE' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-DELETE' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-DELETE' class='name expandable'>DELETE</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: A file was deleted from the monitored directory ...</div><div class='long'><p>Event type: A file was deleted from the monitored directory</p>\n<p>Defaults to: <code>&quot;512&quot;</code></p></div></div></div><div id='property-DELETE_SELF' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-DELETE_SELF' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-DELETE_SELF' class='name expandable'>DELETE_SELF</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: The monitored file or directory was deleted; monitoring effectively stops ...</div><div class='long'><p>Event type: The monitored file or directory was deleted; monitoring effectively stops</p>\n<p>Defaults to: <code>&quot;1024&quot;</code></p></div></div></div><div id='property-MODIFY' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-MODIFY' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-MODIFY' class='name expandable'>MODIFY</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: Data was written to a file ...</div><div class='long'><p>Event type: Data was written to a file</p>\n<p>Defaults to: <code>&quot;2&quot;</code></p></div></div></div><div id='property-MOVED_FROM' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-MOVED_FROM' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-MOVED_FROM' class='name expandable'>MOVED_FROM</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: A file or subdirectory was moved from the monitored directory ...</div><div class='long'><p>Event type: A file or subdirectory was moved from the monitored directory</p>\n<p>Defaults to: <code>&quot;64&quot;</code></p></div></div></div><div id='property-MOVED_TO' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-MOVED_TO' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-MOVED_TO' class='name expandable'>MOVED_TO</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: A file or subdirectory was moved to the monitored directory ...</div><div class='long'><p>Event type: A file or subdirectory was moved to the monitored directory</p>\n<p>Defaults to: <code>&quot;128&quot;</code></p></div></div></div><div id='property-MOVE_SELF' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-MOVE_SELF' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-MOVE_SELF' class='name expandable'>MOVE_SELF</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: The monitored file or directory was moved; monitoring continues ...</div><div class='long'><p>Event type: The monitored file or directory was moved; monitoring continues</p>\n<p>Defaults to: <code>&quot;2048&quot;</code></p></div></div></div><div id='property-OPEN' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-property-OPEN' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-property-OPEN' class='name expandable'>OPEN</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Event type: A file or directory was opened ...</div><div class='long'><p>Event type: A file or directory was opened</p>\n<p>Defaults to: <code>&quot;32&quot;</code></p></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-onEvent' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-method-onEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-method-onEvent' class='name expandable'>onEvent</a>( <span class='pre'>event, path</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>The event handler, which must be implemented by subclasses. ...</div><div class='long'><p>The event handler, which must be implemented by subclasses.</p>\n\n<p> <p class=\"note\">This method is invoked on a special FileObserver thread.\n It runs independently of any threads, so take care to use appropriate\n synchronization!  Consider using android.os.Handler.post(Runnable) to shift\n event handling work to the main thread to avoid concurrency problems.</p></p>\n\n<p> <p>Event handlers must not throw exceptions.</p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>event</span> : Number<div class='sub-desc'><p>The type of event which happened</p>\n</div></li><li><span class='pre'>path</span> : String<div class='sub-desc'><p>The path, relative to the main monitored file or directory,\n     of the file or directory which triggered the event</p>\n</div></li></ul></div></div></div><div id='method-startWatching' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-method-startWatching' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-method-startWatching' class='name expandable'>startWatching</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Start watching for events. ...</div><div class='long'><p>Start watching for events.  The monitored file or directory must exist at\n this time, or else no events will be reported (even if it appears later).\n If monitoring is already started, this call has no effect.</p>\n</div></div></div><div id='method-stopWatching' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.FileObserver'>android.os.FileObserver</span><br/><a href='source/FileObserver.html#android-os-FileObserver-method-stopWatching' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.FileObserver-method-stopWatching' class='name expandable'>stopWatching</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Stop watching for events. ...</div><div class='long'><p>Stop watching for events.  Some events may be in process, so events\n may continue to be reported even after this method completes.  If\n monitoring is already stopped, this call has no effect.</p>\n</div></div></div></div></div></div></div>","meta":{}});