Ext.data.JsonP.android_os_Handler({"tagname":"class","name":"android.os.Handler","autodetected":{},"files":[{"filename":"Handler.js","href":"Handler.html#android-os-Handler"}],"extends":"java.lang.Object","members":[{"name":"dispatchMessage","tagname":"method","owner":"android.os.Handler","id":"method-dispatchMessage","meta":{}},{"name":"dump","tagname":"method","owner":"android.os.Handler","id":"method-dump","meta":{}},{"name":"getLooper","tagname":"method","owner":"android.os.Handler","id":"method-getLooper","meta":{}},{"name":"getMessageName","tagname":"method","owner":"android.os.Handler","id":"method-getMessageName","meta":{}},{"name":"handleMessage","tagname":"method","owner":"android.os.Handler","id":"method-handleMessage","meta":{}},{"name":"hasMessages","tagname":"method","owner":"android.os.Handler","id":"method-hasMessages","meta":{}},{"name":"obtainMessage","tagname":"method","owner":"android.os.Handler","id":"method-obtainMessage","meta":{}},{"name":"post","tagname":"method","owner":"android.os.Handler","id":"method-post","meta":{}},{"name":"postAtFrontOfQueue","tagname":"method","owner":"android.os.Handler","id":"method-postAtFrontOfQueue","meta":{}},{"name":"postAtTime","tagname":"method","owner":"android.os.Handler","id":"method-postAtTime","meta":{}},{"name":"postDelayed","tagname":"method","owner":"android.os.Handler","id":"method-postDelayed","meta":{}},{"name":"removeCallbacks","tagname":"method","owner":"android.os.Handler","id":"method-removeCallbacks","meta":{}},{"name":"removeCallbacksAndMessages","tagname":"method","owner":"android.os.Handler","id":"method-removeCallbacksAndMessages","meta":{}},{"name":"removeMessages","tagname":"method","owner":"android.os.Handler","id":"method-removeMessages","meta":{}},{"name":"sendEmptyMessage","tagname":"method","owner":"android.os.Handler","id":"method-sendEmptyMessage","meta":{}},{"name":"sendEmptyMessageAtTime","tagname":"method","owner":"android.os.Handler","id":"method-sendEmptyMessageAtTime","meta":{}},{"name":"sendEmptyMessageDelayed","tagname":"method","owner":"android.os.Handler","id":"method-sendEmptyMessageDelayed","meta":{}},{"name":"sendMessage","tagname":"method","owner":"android.os.Handler","id":"method-sendMessage","meta":{}},{"name":"sendMessageAtFrontOfQueue","tagname":"method","owner":"android.os.Handler","id":"method-sendMessageAtFrontOfQueue","meta":{}},{"name":"sendMessageAtTime","tagname":"method","owner":"android.os.Handler","id":"method-sendMessageAtTime","meta":{}},{"name":"sendMessageDelayed","tagname":"method","owner":"android.os.Handler","id":"method-sendMessageDelayed","meta":{}},{"name":"toString","tagname":"method","owner":"android.os.Handler","id":"method-toString","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.Handler","short_doc":"A Handler allows you to send and process android.os.Message and Runnable\n objects associated with a thread's android....","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.Handler</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/Handler.html#android-os-Handler' target='_blank'>Handler.js</a></div></pre><div class='doc-contents'><p>A Handler allows you to send and process <a href=\"#!/api/android.os.Message\" rel=\"android.os.Message\" class=\"docClass\">android.os.Message</a> and Runnable\n objects associated with a thread's <a href=\"#!/api/android.os.MessageQueue\" rel=\"android.os.MessageQueue\" class=\"docClass\">android.os.MessageQueue</a>.  Each Handler\n instance is associated with a single thread and that thread's message\n queue.  When you create a new Handler, it is bound to the thread /\n message queue of the thread that is creating it -- from that point on,\n it will deliver messages and runnables to that message queue and execute\n them as they come out of the message queue.</p>\n\n<p> <p>There are two main uses for a Handler: (1) to schedule messages and\n runnables to be executed as some point in the future; and (2) to enqueue\n an action to be performed on a different thread than your own.</p>\n\n<p> <p>Scheduling messages is accomplished with the\n <a href=\"#!/api/android.os.Handler-method-post\" rel=\"android.os.Handler-method-post\" class=\"docClass\">post</a>, long),\n <a href=\"#!/api/android.os.Handler-method-postDelayed\" rel=\"android.os.Handler-method-postDelayed\" class=\"docClass\">postDelayed</a>, <a href=\"#!/api/android.os.Handler-method-sendEmptyMessage\" rel=\"android.os.Handler-method-sendEmptyMessage\" class=\"docClass\">sendEmptyMessage</a>,\n <a href=\"#!/api/android.os.Handler-method-sendMessage\" rel=\"android.os.Handler-method-sendMessage\" class=\"docClass\">sendMessage</a>, <a href=\"#!/api/android.os.Handler-method-sendMessageAtTime\" rel=\"android.os.Handler-method-sendMessageAtTime\" class=\"docClass\">sendMessageAtTime</a>, and\n <a href=\"#!/api/android.os.Handler-method-sendMessageDelayed\" rel=\"android.os.Handler-method-sendMessageDelayed\" class=\"docClass\">sendMessageDelayed</a> methods.  The <em>post</em> versions allow\n you to enqueue Runnable objects to be called by the message queue when\n they are received; the <em>sendMessage</em> versions allow you to enqueue\n a <a href=\"#!/api/android.os.Message\" rel=\"android.os.Message\" class=\"docClass\">android.os.Message</a> object containing a bundle of data that will be\n processed by the Handler's <a href=\"#!/api/android.os.Handler-method-handleMessage\" rel=\"android.os.Handler-method-handleMessage\" class=\"docClass\">handleMessage</a> method (requiring that\n you implement a subclass of Handler).</p>\n\n<p> <p>When posting or sending to a Handler, you can either\n allow the item to be processed as soon as the message queue is ready\n to do so, or specify a delay before it gets processed or absolute time for\n it to be processed.  The latter two allow you to implement timeouts,\n ticks, and other timing-based behavior.</p>\n\n<p> <p>When a\n process is created for your application, its main thread is dedicated to\n running a message queue that takes care of managing the top-level\n application objects (activities, broadcast receivers, etc) and any windows\n they create.  You can create your own threads, and communicate back with\n the main application thread through a Handler.  This is done by calling\n the same <em>post</em> or <em>sendMessage</em> methods as before, but from\n your new thread.  The given Runnable or Message will then be scheduled\n in the Handler's message queue and processed when appropriate.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-dispatchMessage' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-dispatchMessage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-dispatchMessage' class='name expandable'>dispatchMessage</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Handle system messages here. ...</div><div class='long'><p>Handle system messages here.</p>\n</div></div></div><div id='method-dump' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-dump' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-dump' class='name expandable'>dump</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-getLooper' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-getLooper' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-getLooper' class='name expandable'>getLooper</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-getMessageName' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-getMessageName' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-getMessageName' class='name expandable'>getMessageName</a>( <span class='pre'>message</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a string representing the name of the specified message. ...</div><div class='long'><p>Returns a string representing the name of the specified message.\n The default implementation will either return the class name of the\n message callback if any, or the hexadecimal representation of the\n message \"what\" field.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>message</span> : Object {Message}<div class='sub-desc'><p>The message whose name is being queried</p>\n</div></li></ul></div></div></div><div id='method-handleMessage' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-handleMessage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-handleMessage' class='name expandable'>handleMessage</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Subclasses must implement this to receive messages. ...</div><div class='long'><p>Subclasses must implement this to receive messages.</p>\n</div></div></div><div id='method-hasMessages' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-hasMessages' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-hasMessages' class='name expandable'>hasMessages</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Check if there are any pending posts of messages with code 'what' and\n whose obj is 'object' in the message queue. ...</div><div class='long'><p>Check if there are any pending posts of messages with code 'what' and\n whose obj is 'object' in the message queue.</p>\n</div></div></div><div id='method-obtainMessage' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-obtainMessage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-obtainMessage' class='name expandable'>obtainMessage</a>( <span class='pre'>what, arg1, arg2, obj</span> ) : Object {android.os.Message}<span class=\"signature\"></span></div><div class='description'><div class='short'>Same as obtainMessage(), except that it also sets the what, obj, arg1,and arg2 values on the\n returned Message. ...</div><div class='long'><p>Same as <a href=\"#!/api/android.os.Handler-method-obtainMessage\" rel=\"android.os.Handler-method-obtainMessage\" class=\"docClass\">obtainMessage</a>(), except that it also sets the what, obj, arg1,and arg2 values on the\n returned Message.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>what</span> : Number<div class='sub-desc'><p>Value to assign to the returned Message.what field.</p>\n</div></li><li><span class='pre'>arg1</span> : Number<div class='sub-desc'><p>Value to assign to the returned Message.arg1 field.</p>\n</div></li><li><span class='pre'>arg2</span> : Number<div class='sub-desc'><p>Value to assign to the returned Message.arg2 field.</p>\n</div></li><li><span class='pre'>obj</span> : Object {Object}<div class='sub-desc'><p>Value to assign to the returned Message.obj field.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.os.Message}</span><div class='sub-desc'><p>A Message from the global message pool.</p>\n</div></li></ul></div></div></div><div id='method-post' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-post' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-post' class='name expandable'>post</a>( <span class='pre'>r</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the Runnable r to be added to the message queue. ...</div><div class='long'><p>Causes the Runnable r to be added to the message queue.\n The runnable will be run on the thread to which this handler is\n attached.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>r</span> : Object {Runnable}<div class='sub-desc'><p>The Runnable that will be executed.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the Runnable was successfully placed in to the\n         message queue.  Returns false on failure, usually because the\n         looper processing the message queue is exiting.</p>\n</div></li></ul></div></div></div><div id='method-postAtFrontOfQueue' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-postAtFrontOfQueue' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-postAtFrontOfQueue' class='name expandable'>postAtFrontOfQueue</a>( <span class='pre'>r</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Posts a message to an object that implements Runnable. ...</div><div class='long'><p>Posts a message to an object that implements Runnable.\n Causes the Runnable r to executed on the next iteration through the\n message queue. The runnable will be run on the thread to which this\n handler is attached.\n <b>This method is only for use in very special circumstances -- it\n can easily starve the message queue, cause ordering problems, or have\n other unexpected side-effects.</b></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>r</span> : Object {Runnable}<div class='sub-desc'><p>The Runnable that will be executed.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the message was successfully placed in to the\n         message queue.  Returns false on failure, usually because the\n         looper processing the message queue is exiting.</p>\n</div></li></ul></div></div></div><div id='method-postAtTime' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-postAtTime' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-postAtTime' class='name expandable'>postAtTime</a>( <span class='pre'>r, uptimeMillis</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the Runnable r to be added to the message queue, to be run\n at a specific time given by uptimeMillis. ...</div><div class='long'><p>Causes the Runnable r to be added to the message queue, to be run\n at a specific time given by <var>uptimeMillis</var>.\n <b>The time-base is <a href=\"#!/api/android.os.SystemClock-method-uptimeMillis\" rel=\"android.os.SystemClock-method-uptimeMillis\" class=\"docClass\">android.os.SystemClock.uptimeMillis</a>.</b>\n Time spent in deep sleep will add an additional delay to execution.\n The runnable will be run on the thread to which this handler is attached.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>r</span> : Object {Runnable}<div class='sub-desc'><p>The Runnable that will be executed.</p>\n</div></li><li><span class='pre'>uptimeMillis</span> : Object {Object}<div class='sub-desc'><p>The absolute time at which the callback should run,\n         using the <a href=\"#!/api/android.os.SystemClock-method-uptimeMillis\" rel=\"android.os.SystemClock-method-uptimeMillis\" class=\"docClass\">android.os.SystemClock.uptimeMillis</a> time-base.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the Runnable was successfully placed in to the\n         message queue.  Returns false on failure, usually because the\n         looper processing the message queue is exiting.  Note that a\n         result of true does not mean the Runnable will be processed -- if\n         the looper is quit before the delivery time of the message\n         occurs then the message will be dropped.\n@see <a href=\"#!/api/android.os.SystemClock-method-uptimeMillis\" rel=\"android.os.SystemClock-method-uptimeMillis\" class=\"docClass\">android.os.SystemClock.uptimeMillis</a></p>\n</div></li></ul></div></div></div><div id='method-postDelayed' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-postDelayed' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-postDelayed' class='name expandable'>postDelayed</a>( <span class='pre'>r, delayMillis</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the Runnable r to be added to the message queue, to be run\n after the specified amount of time elapses. ...</div><div class='long'><p>Causes the Runnable r to be added to the message queue, to be run\n after the specified amount of time elapses.\n The runnable will be run on the thread to which this handler\n is attached.\n <b>The time-base is <a href=\"#!/api/android.os.SystemClock-method-uptimeMillis\" rel=\"android.os.SystemClock-method-uptimeMillis\" class=\"docClass\">android.os.SystemClock.uptimeMillis</a>.</b>\n Time spent in deep sleep will add an additional delay to execution.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>r</span> : Object {Runnable}<div class='sub-desc'><p>The Runnable that will be executed.</p>\n</div></li><li><span class='pre'>delayMillis</span> : Number<div class='sub-desc'><p>The delay (in milliseconds) until the Runnable\n        will be executed.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the Runnable was successfully placed in to the\n         message queue.  Returns false on failure, usually because the\n         looper processing the message queue is exiting.  Note that a\n         result of true does not mean the Runnable will be processed --\n         if the looper is quit before the delivery time of the message\n         occurs then the message will be dropped.</p>\n</div></li></ul></div></div></div><div id='method-removeCallbacks' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-removeCallbacks' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-removeCallbacks' class='name expandable'>removeCallbacks</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Remove any pending posts of Runnable r with Object\n token that are in the message queue. ...</div><div class='long'><p>Remove any pending posts of Runnable <var>r</var> with Object\n <var>token</var> that are in the message queue.  If <var>token</var> is null,\n all callbacks will be removed.</p>\n</div></div></div><div id='method-removeCallbacksAndMessages' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-removeCallbacksAndMessages' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-removeCallbacksAndMessages' class='name expandable'>removeCallbacksAndMessages</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Remove any pending posts of callbacks and sent messages whose\n obj is token. ...</div><div class='long'><p>Remove any pending posts of callbacks and sent messages whose\n <var>obj</var> is <var>token</var>.  If <var>token</var> is null,\n all callbacks and messages will be removed.</p>\n</div></div></div><div id='method-removeMessages' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-removeMessages' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-removeMessages' class='name expandable'>removeMessages</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Remove any pending posts of messages with code 'what' and whose obj is\n 'object' that are in the message queue. ...</div><div class='long'><p>Remove any pending posts of messages with code 'what' and whose obj is\n 'object' that are in the message queue.  If <var>object</var> is null,\n all messages will be removed.</p>\n</div></div></div><div id='method-sendEmptyMessage' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-sendEmptyMessage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-sendEmptyMessage' class='name expandable'>sendEmptyMessage</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Sends a Message containing only the what value. ...</div><div class='long'><p>Sends a Message containing only the what value.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the message was successfully placed in to the\n         message queue.  Returns false on failure, usually because the\n         looper processing the message queue is exiting.</p>\n</div></li></ul></div></div></div><div id='method-sendEmptyMessageAtTime' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-sendEmptyMessageAtTime' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-sendEmptyMessageAtTime' class='name expandable'>sendEmptyMessageAtTime</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Sends a Message containing only the what value, to be delivered\n at a specific time. ...</div><div class='long'><p>Sends a Message containing only the what value, to be delivered\n at a specific time.\n@see <a href=\"#!/api/android.os.Handler-method-sendMessageAtTime\" rel=\"android.os.Handler-method-sendMessageAtTime\" class=\"docClass\">sendMessageAtTime</a>(<a href=\"#!/api/android.os.Message\" rel=\"android.os.Message\" class=\"docClass\">android.os.Message</a>, long)</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the message was successfully placed in to the\n         message queue.  Returns false on failure, usually because the\n         looper processing the message queue is exiting.</p>\n</div></li></ul></div></div></div><div id='method-sendEmptyMessageDelayed' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-sendEmptyMessageDelayed' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-sendEmptyMessageDelayed' class='name expandable'>sendEmptyMessageDelayed</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Sends a Message containing only the what value, to be delivered\n after the specified amount of time elapses. ...</div><div class='long'><p>Sends a Message containing only the what value, to be delivered\n after the specified amount of time elapses.\n@see <a href=\"#!/api/android.os.Handler-method-sendMessageDelayed\" rel=\"android.os.Handler-method-sendMessageDelayed\" class=\"docClass\">sendMessageDelayed</a>(<a href=\"#!/api/android.os.Message\" rel=\"android.os.Message\" class=\"docClass\">android.os.Message</a>, long)</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the message was successfully placed in to the\n         message queue.  Returns false on failure, usually because the\n         looper processing the message queue is exiting.</p>\n</div></li></ul></div></div></div><div id='method-sendMessage' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-sendMessage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-sendMessage' class='name expandable'>sendMessage</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Pushes a message onto the end of the message queue after all pending messages\n before the current time. ...</div><div class='long'><p>Pushes a message onto the end of the message queue after all pending messages\n before the current time. It will be received in <a href=\"#!/api/android.os.Handler-method-handleMessage\" rel=\"android.os.Handler-method-handleMessage\" class=\"docClass\">handleMessage</a>,\n in the thread attached to this handler.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the message was successfully placed in to the\n         message queue.  Returns false on failure, usually because the\n         looper processing the message queue is exiting.</p>\n</div></li></ul></div></div></div><div id='method-sendMessageAtFrontOfQueue' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-sendMessageAtFrontOfQueue' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-sendMessageAtFrontOfQueue' class='name expandable'>sendMessageAtFrontOfQueue</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Enqueue a message at the front of the message queue, to be processed on\n the next iteration of the message loop. ...</div><div class='long'><p>Enqueue a message at the front of the message queue, to be processed on\n the next iteration of the message loop.  You will receive it in\n <a href=\"#!/api/android.os.Handler-method-handleMessage\" rel=\"android.os.Handler-method-handleMessage\" class=\"docClass\">handleMessage</a>, in the thread attached to this handler.\n <b>This method is only for use in very special circumstances -- it\n can easily starve the message queue, cause ordering problems, or have\n other unexpected side-effects.</b></p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the message was successfully placed in to the\n         message queue.  Returns false on failure, usually because the\n         looper processing the message queue is exiting.</p>\n</div></li></ul></div></div></div><div id='method-sendMessageAtTime' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-sendMessageAtTime' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-sendMessageAtTime' class='name expandable'>sendMessageAtTime</a>( <span class='pre'>uptimeMillis</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Enqueue a message into the message queue after all pending messages\n before the absolute time (in milliseconds) uptim...</div><div class='long'><p>Enqueue a message into the message queue after all pending messages\n before the absolute time (in milliseconds) <var>uptimeMillis</var>.\n <b>The time-base is <a href=\"#!/api/android.os.SystemClock-method-uptimeMillis\" rel=\"android.os.SystemClock-method-uptimeMillis\" class=\"docClass\">android.os.SystemClock.uptimeMillis</a>.</b>\n Time spent in deep sleep will add an additional delay to execution.\n You will receive it in <a href=\"#!/api/android.os.Handler-method-handleMessage\" rel=\"android.os.Handler-method-handleMessage\" class=\"docClass\">handleMessage</a>, in the thread attached\n to this handler.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>uptimeMillis</span> : Object {Message}<div class='sub-desc'><p>The absolute time at which the message should be\n         delivered, using the\n         <a href=\"#!/api/android.os.SystemClock-method-uptimeMillis\" rel=\"android.os.SystemClock-method-uptimeMillis\" class=\"docClass\">android.os.SystemClock.uptimeMillis</a> time-base.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the message was successfully placed in to the\n         message queue.  Returns false on failure, usually because the\n         looper processing the message queue is exiting.  Note that a\n         result of true does not mean the message will be processed -- if\n         the looper is quit before the delivery time of the message\n         occurs then the message will be dropped.</p>\n</div></li></ul></div></div></div><div id='method-sendMessageDelayed' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-sendMessageDelayed' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-sendMessageDelayed' class='name expandable'>sendMessageDelayed</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Enqueue a message into the message queue after all pending messages\n before (current time + delayMillis). ...</div><div class='long'><p>Enqueue a message into the message queue after all pending messages\n before (current time + delayMillis). You will receive it in\n <a href=\"#!/api/android.os.Handler-method-handleMessage\" rel=\"android.os.Handler-method-handleMessage\" class=\"docClass\">handleMessage</a>, in the thread attached to this handler.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns true if the message was successfully placed in to the\n         message queue.  Returns false on failure, usually because the\n         looper processing the message queue is exiting.  Note that a\n         result of true does not mean the message will be processed -- if\n         the looper is quit before the delivery time of the message\n         occurs then the message will be dropped.</p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Handler'>android.os.Handler</span><br/><a href='source/Handler.html#android-os-Handler-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Handler-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div></div></div></div></div>","meta":{}});