Ext.data.JsonP.android_os_Looper({"tagname":"class","name":"android.os.Looper","autodetected":{},"files":[{"filename":"Looper.js","href":"Looper.html#android-os-Looper"}],"extends":"java.lang.Object","members":[{"name":"dump","tagname":"method","owner":"android.os.Looper","id":"method-dump","meta":{}},{"name":"getMainLooper","tagname":"method","owner":"android.os.Looper","id":"method-getMainLooper","meta":{}},{"name":"getQueue","tagname":"method","owner":"android.os.Looper","id":"method-getQueue","meta":{}},{"name":"getThread","tagname":"method","owner":"android.os.Looper","id":"method-getThread","meta":{}},{"name":"isCurrentThread","tagname":"method","owner":"android.os.Looper","id":"method-isCurrentThread","meta":{}},{"name":"loop","tagname":"method","owner":"android.os.Looper","id":"method-loop","meta":{}},{"name":"myLooper","tagname":"method","owner":"android.os.Looper","id":"method-myLooper","meta":{}},{"name":"myQueue","tagname":"method","owner":"android.os.Looper","id":"method-myQueue","meta":{}},{"name":"prepare","tagname":"method","owner":"android.os.Looper","id":"method-prepare","meta":{}},{"name":"prepareMainLooper","tagname":"method","owner":"android.os.Looper","id":"method-prepareMainLooper","meta":{}},{"name":"quit","tagname":"method","owner":"android.os.Looper","id":"method-quit","meta":{}},{"name":"quitSafely","tagname":"method","owner":"android.os.Looper","id":"method-quitSafely","meta":{}},{"name":"setMessageLogging","tagname":"method","owner":"android.os.Looper","id":"method-setMessageLogging","meta":{}},{"name":"toString","tagname":"method","owner":"android.os.Looper","id":"method-toString","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.Looper","short_doc":"Class used to run a message loop for a thread. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.Looper</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/Looper.html#android-os-Looper' target='_blank'>Looper.js</a></div></pre><div class='doc-contents'><p>Class used to run a message loop for a thread.  Threads by default do\n not have a message loop associated with them; to create one, call\n <a href=\"#!/api/android.os.Looper-method-prepare\" rel=\"android.os.Looper-method-prepare\" class=\"docClass\">prepare</a> in the thread that is to run the loop, and then\n <a href=\"#!/api/android.os.Looper-method-loop\" rel=\"android.os.Looper-method-loop\" class=\"docClass\">loop</a> to have it process messages until the loop is stopped.</p>\n\n<p> <p>Most interaction with a message loop is through the\n <a href=\"#!/api/android.os.Handler\" rel=\"android.os.Handler\" class=\"docClass\">android.os.Handler</a> class.</p>\n\n<p> <p>This is a typical example of the implementation of a Looper thread,\n using the separation of <a href=\"#!/api/android.os.Looper-method-prepare\" rel=\"android.os.Looper-method-prepare\" class=\"docClass\">prepare</a> and <a href=\"#!/api/android.os.Looper-method-loop\" rel=\"android.os.Looper-method-loop\" class=\"docClass\">loop</a> to create an\n initial Handler to communicate with the Looper.</p>\n\n<pre>  class LooperThread extends Thread {\n      public Handler mHandler;\n\n      public void run() {\n          Looper.prepare();\n\n          mHandler = new Handler() {\n              public void handleMessage(Message msg) {\n                  // process incoming messages here\n              }\n          };\n\n          Looper.loop();\n      }\n  }</pre>\n\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-dump' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-dump' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-dump' class='name expandable'>dump</a>( <span class='pre'>pw, prefix</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Dumps the state of the looper for debugging purposes. ...</div><div class='long'><p>Dumps the state of the looper for debugging purposes.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>pw</span> : Object {Printer}<div class='sub-desc'><p>A printer to receive the contents of the dump.</p>\n</div></li><li><span class='pre'>prefix</span> : String<div class='sub-desc'><p>A prefix to prepend to each line which is printed.</p>\n</div></li></ul></div></div></div><div id='method-getMainLooper' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-getMainLooper' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-getMainLooper' class='name expandable'>getMainLooper</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the application's main looper, which lives in the main thread of the application. ...</div><div class='long'><p>Returns the application's main looper, which lives in the main thread of the application.</p>\n</div></div></div><div id='method-getQueue' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-getQueue' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-getQueue' class='name expandable'>getQueue</a>( <span class='pre'></span> ) : Object {android.os.MessageQueue}<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets this looper's message queue. ...</div><div class='long'><p>Gets this looper's message queue.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.os.MessageQueue}</span><div class='sub-desc'><p>The looper's message queue.</p>\n</div></li></ul></div></div></div><div id='method-getThread' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-getThread' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-getThread' class='name expandable'>getThread</a>( <span class='pre'></span> ) : Object {java.lang.Thread}<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets the Thread associated with this Looper. ...</div><div class='long'><p>Gets the Thread associated with this Looper.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Thread}</span><div class='sub-desc'><p>The looper's thread.</p>\n</div></li></ul></div></div></div><div id='method-isCurrentThread' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-isCurrentThread' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-isCurrentThread' class='name expandable'>isCurrentThread</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns true if the current thread is this looper's thread. ...</div><div class='long'><p>Returns true if the current thread is this looper's thread.</p>\n</div></div></div><div id='method-loop' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-loop' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-loop' class='name expandable'>loop</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Run the message queue in this thread. ...</div><div class='long'><p>Run the message queue in this thread. Be sure to call\n <a href=\"#!/api/android.os.Looper-method-quit\" rel=\"android.os.Looper-method-quit\" class=\"docClass\">quit</a>() to end the loop.</p>\n</div></div></div><div id='method-myLooper' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-myLooper' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-myLooper' class='name expandable'>myLooper</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Return the Looper object associated with the current thread. ...</div><div class='long'><p>Return the Looper object associated with the current thread.  Returns\n null if the calling thread is not associated with a Looper.</p>\n</div></div></div><div id='method-myQueue' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-myQueue' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-myQueue' class='name expandable'>myQueue</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Return the android.os.MessageQueue object associated with the current\n thread. ...</div><div class='long'><p>Return the <a href=\"#!/api/android.os.MessageQueue\" rel=\"android.os.MessageQueue\" class=\"docClass\">android.os.MessageQueue</a> object associated with the current\n thread.  This must be called from a thread running a Looper, or a\n NullPointerException will be thrown.</p>\n</div></div></div><div id='method-prepare' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-prepare' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-prepare' class='name expandable'>prepare</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Initialize the current thread as a looper. ...</div><div class='long'><p>Initialize the current thread as a looper.\n This gives you a chance to create handlers that then reference\n this looper, before actually starting the loop. Be sure to call\n <a href=\"#!/api/android.os.Looper-method-loop\" rel=\"android.os.Looper-method-loop\" class=\"docClass\">loop</a>() after calling this method, and end it by calling\n <a href=\"#!/api/android.os.Looper-method-quit\" rel=\"android.os.Looper-method-quit\" class=\"docClass\">quit</a>().</p>\n</div></div></div><div id='method-prepareMainLooper' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-prepareMainLooper' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-prepareMainLooper' class='name expandable'>prepareMainLooper</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Initialize the current thread as a looper, marking it as an\n application's main looper. ...</div><div class='long'><p>Initialize the current thread as a looper, marking it as an\n application's main looper. The main looper for your application\n is created by the Android environment, so you should never need\n to call this function yourself.  See also: <a href=\"#!/api/android.os.Looper-method-prepare\" rel=\"android.os.Looper-method-prepare\" class=\"docClass\">prepare</a>()</p>\n</div></div></div><div id='method-quit' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-quit' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-quit' class='name expandable'>quit</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Quits the looper. ...</div><div class='long'><p>Quits the looper.\n <p>\n Causes the <a href=\"#!/api/android.os.Looper-method-loop\" rel=\"android.os.Looper-method-loop\" class=\"docClass\">loop</a> method to terminate without processing any\n more messages in the message queue.\n </p><p>\n Any attempt to post messages to the queue after the looper is asked to quit will fail.\n For example, the android.os.Handler.sendMessage(Message) method will return false.\n </p><p class=\"note\">\n Using this method may be unsafe because some messages may not be delivered\n before the looper terminates.  Consider using <a href=\"#!/api/android.os.Looper-method-quitSafely\" rel=\"android.os.Looper-method-quitSafely\" class=\"docClass\">quitSafely</a> instead to ensure\n that all pending work is completed in an orderly manner.\n </p>\n@see <a href=\"#!/api/android.os.Looper-method-quitSafely\" rel=\"android.os.Looper-method-quitSafely\" class=\"docClass\">quitSafely</a></p>\n</div></div></div><div id='method-quitSafely' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-quitSafely' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-quitSafely' class='name expandable'>quitSafely</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Quits the looper safely. ...</div><div class='long'><p>Quits the looper safely.\n <p>\n Causes the <a href=\"#!/api/android.os.Looper-method-loop\" rel=\"android.os.Looper-method-loop\" class=\"docClass\">loop</a> method to terminate as soon as all remaining messages\n in the message queue that are already due to be delivered have been handled.\n However pending delayed messages with due times in the future will not be\n delivered before the loop terminates.\n </p><p>\n Any attempt to post messages to the queue after the looper is asked to quit will fail.\n For example, the android.os.Handler.sendMessage(Message) method will return false.\n </p></p>\n</div></div></div><div id='method-setMessageLogging' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-setMessageLogging' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-setMessageLogging' class='name expandable'>setMessageLogging</a>( <span class='pre'>printer</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Control logging of messages as they are processed by this Looper. ...</div><div class='long'><p>Control logging of messages as they are processed by this Looper.  If\n enabled, a log message will be written to <var>printer</var>\n at the beginning and ending of each message dispatch, identifying the\n target Handler and message contents.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>printer</span> : Object {Printer}<div class='sub-desc'><p>A Printer object that will receive log messages, or\n null to disable message logging.</p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Looper'>android.os.Looper</span><br/><a href='source/Looper.html#android-os-Looper-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Looper-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div></div></div></div></div>","meta":{}});