Ext.data.JsonP.android_os_MessageQueue({"tagname":"class","name":"android.os.MessageQueue","autodetected":{},"files":[{"filename":"MessageQueue.js","href":"MessageQueue.html#android-os-MessageQueue"}],"extends":"java.lang.Object","members":[{"name":"addIdleHandler","tagname":"method","owner":"android.os.MessageQueue","id":"method-addIdleHandler","meta":{}},{"name":"addOnFileDescriptorEventListener","tagname":"method","owner":"android.os.MessageQueue","id":"method-addOnFileDescriptorEventListener","meta":{}},{"name":"isIdle","tagname":"method","owner":"android.os.MessageQueue","id":"method-isIdle","meta":{}},{"name":"removeIdleHandler","tagname":"method","owner":"android.os.MessageQueue","id":"method-removeIdleHandler","meta":{}},{"name":"removeOnFileDescriptorEventListener","tagname":"method","owner":"android.os.MessageQueue","id":"method-removeOnFileDescriptorEventListener","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.MessageQueue","short_doc":"Low-level class holding the list of messages to be dispatched by a\n android.os.Looper. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.MessageQueue</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/MessageQueue.html#android-os-MessageQueue' target='_blank'>MessageQueue.js</a></div></pre><div class='doc-contents'><p>Low-level class holding the list of messages to be dispatched by a\n <a href=\"#!/api/android.os.Looper\" rel=\"android.os.Looper\" class=\"docClass\">android.os.Looper</a>.  Messages are not added directly to a MessageQueue,\n but rather through <a href=\"#!/api/android.os.Handler\" rel=\"android.os.Handler\" class=\"docClass\">android.os.Handler</a> objects associated with the Looper.</p>\n\n<p> <p>You can retrieve the MessageQueue for the current thread with\n android.os.Looper.myQueue().</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addIdleHandler' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.MessageQueue'>android.os.MessageQueue</span><br/><a href='source/MessageQueue.html#android-os-MessageQueue-method-addIdleHandler' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.MessageQueue-method-addIdleHandler' class='name expandable'>addIdleHandler</a>( <span class='pre'>handler</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Add a new android.os.MessageQueue.IdleHandler to this message queue. ...</div><div class='long'><p>Add a new <a href=\"#!/api/android.os.MessageQueue.IdleHandler\" rel=\"android.os.MessageQueue.IdleHandler\" class=\"docClass\">android.os.MessageQueue.IdleHandler</a> to this message queue.  This may be\n removed automatically for you by returning false from\n <a href=\"#!/api/android.os.MessageQueue.IdleHandler-method-queueIdle\" rel=\"android.os.MessageQueue.IdleHandler-method-queueIdle\" class=\"docClass\">android.os.MessageQueue.IdleHandler.queueIdle()</a> when it is\n invoked, or explicitly removing it with <a href=\"#!/api/android.os.MessageQueue-method-removeIdleHandler\" rel=\"android.os.MessageQueue-method-removeIdleHandler\" class=\"docClass\">removeIdleHandler</a>.</p>\n\n<p> <p>This method is safe to call from any thread.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>handler</span> : Object {MessageQueue.IdleHandler}<div class='sub-desc'><p>The IdleHandler to be added.</p>\n</div></li></ul></div></div></div><div id='method-addOnFileDescriptorEventListener' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.MessageQueue'>android.os.MessageQueue</span><br/><a href='source/MessageQueue.html#android-os-MessageQueue-method-addOnFileDescriptorEventListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.MessageQueue-method-addOnFileDescriptorEventListener' class='name expandable'>addOnFileDescriptorEventListener</a>( <span class='pre'>fd, events, listener</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Adds a file descriptor listener to receive notification when file descriptor\n related events occur. ...</div><div class='long'><p>Adds a file descriptor listener to receive notification when file descriptor\n related events occur.\n <p>\n If the file descriptor has already been registered, the specified events\n and listener will replace any that were previously associated with it.\n It is not possible to set more than one listener per file descriptor.\n </p><p>\n It is important to always unregister the listener when the file descriptor\n is no longer of use.\n </p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>fd</span> : Object {FileDescriptor}<div class='sub-desc'><p>The file descriptor for which a listener will be registered.</p>\n</div></li><li><span class='pre'>events</span> : Number<div class='sub-desc'><p>The set of events to receive: a combination of the\n OnFileDescriptorEventListener.EVENT_INPUT,\n OnFileDescriptorEventListener.EVENT_OUTPUT, and\n OnFileDescriptorEventListener.EVENT_ERROR event masks.  If the requested\n set of events is zero, then the listener is unregistered.</p>\n</div></li><li><span class='pre'>listener</span> : Object {MessageQueue.OnFileDescriptorEventListener}<div class='sub-desc'><p>The listener to invoke when file descriptor events occur.\n@see OnFileDescriptorEventListener\n@see <a href=\"#!/api/android.os.MessageQueue-method-removeOnFileDescriptorEventListener\" rel=\"android.os.MessageQueue-method-removeOnFileDescriptorEventListener\" class=\"docClass\">removeOnFileDescriptorEventListener</a></p>\n</div></li></ul></div></div></div><div id='method-isIdle' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.MessageQueue'>android.os.MessageQueue</span><br/><a href='source/MessageQueue.html#android-os-MessageQueue-method-isIdle' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.MessageQueue-method-isIdle' class='name expandable'>isIdle</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns true if the looper has no pending messages which are due to be processed. ...</div><div class='long'><p>Returns true if the looper has no pending messages which are due to be processed.</p>\n\n<p> <p>This method is safe to call from any thread.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>True if the looper is idle.</p>\n</div></li></ul></div></div></div><div id='method-removeIdleHandler' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.MessageQueue'>android.os.MessageQueue</span><br/><a href='source/MessageQueue.html#android-os-MessageQueue-method-removeIdleHandler' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.MessageQueue-method-removeIdleHandler' class='name expandable'>removeIdleHandler</a>( <span class='pre'>handler</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Remove an android.os.MessageQueue.IdleHandler from the queue that was previously added\n with addIdleHandler. ...</div><div class='long'><p>Remove an <a href=\"#!/api/android.os.MessageQueue.IdleHandler\" rel=\"android.os.MessageQueue.IdleHandler\" class=\"docClass\">android.os.MessageQueue.IdleHandler</a> from the queue that was previously added\n with <a href=\"#!/api/android.os.MessageQueue-method-addIdleHandler\" rel=\"android.os.MessageQueue-method-addIdleHandler\" class=\"docClass\">addIdleHandler</a>.  If the given object is not currently\n in the idle list, nothing is done.</p>\n\n<p> <p>This method is safe to call from any thread.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>handler</span> : Object {MessageQueue.IdleHandler}<div class='sub-desc'><p>The IdleHandler to be removed.</p>\n</div></li></ul></div></div></div><div id='method-removeOnFileDescriptorEventListener' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.MessageQueue'>android.os.MessageQueue</span><br/><a href='source/MessageQueue.html#android-os-MessageQueue-method-removeOnFileDescriptorEventListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.MessageQueue-method-removeOnFileDescriptorEventListener' class='name expandable'>removeOnFileDescriptorEventListener</a>( <span class='pre'>fd</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Removes a file descriptor listener. ...</div><div class='long'><p>Removes a file descriptor listener.\n <p>\n This method does nothing if no listener has been registered for the\n specified file descriptor.\n </p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>fd</span> : Object {FileDescriptor}<div class='sub-desc'><p>The file descriptor whose listener will be unregistered.\n@see OnFileDescriptorEventListener\n@see <a href=\"#!/api/android.os.MessageQueue-method-addOnFileDescriptorEventListener\" rel=\"android.os.MessageQueue-method-addOnFileDescriptorEventListener\" class=\"docClass\">addOnFileDescriptorEventListener</a></p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});