Ext.data.JsonP.android_os_Parcelable({"tagname":"class","name":"android.os.Parcelable","autodetected":{},"files":[{"filename":"Parcelable.js","href":"Parcelable.html#android-os-Parcelable"}],"members":[{"name":"CONTENTS_FILE_DESCRIPTOR","tagname":"property","owner":"android.os.Parcelable","id":"property-CONTENTS_FILE_DESCRIPTOR","meta":{}},{"name":"PARCELABLE_WRITE_RETURN_VALUE","tagname":"property","owner":"android.os.Parcelable","id":"property-PARCELABLE_WRITE_RETURN_VALUE","meta":{}},{"name":"describeContents","tagname":"method","owner":"android.os.Parcelable","id":"method-describeContents","meta":{}},{"name":"writeToParcel","tagname":"method","owner":"android.os.Parcelable","id":"method-writeToParcel","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.Parcelable","short_doc":"Interface for classes whose instances can be written to\n and restored from a android.os.Parcel. ...","classIcon":"icon-class","superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Files</h4><div class='dependency'><a href='source/Parcelable.html#android-os-Parcelable' target='_blank'>Parcelable.js</a></div></pre><div class='doc-contents'><p>Interface for classes whose instances can be written to\n and restored from a <a href=\"#!/api/android.os.Parcel\" rel=\"android.os.Parcel\" class=\"docClass\">android.os.Parcel</a>.  Classes implementing the Parcelable\n interface must also have a non-null static field called <code>CREATOR</code>\n of a type that implements the <a href=\"#!/api/android.os.Parcelable.Creator\" rel=\"android.os.Parcelable.Creator\" class=\"docClass\">android.os.Parcelable.Creator</a> interface.</p>\n\n<p> <p>A typical implementation of Parcelable is:</p></p>\n\n<pre> public class MyParcelable implements Parcelable {\n     private int mData;\n\n     public int describeContents() {\n         return 0;\n     }\n\n     public void writeToParcel(Parcel out, int flags) {\n         out.writeInt(mData);\n     }\n\n     public static final Parcelable.Creator&lt;MyParcelable&gt; CREATOR\n             = new Parcelable.Creator&lt;MyParcelable&gt;() {\n         public MyParcelable createFromParcel(Parcel in) {\n             return new MyParcelable(in);\n         }\n\n         public MyParcelable[] newArray(int size) {\n             return new MyParcelable[size];\n         }\n     };\n     \n     private MyParcelable(Parcel in) {\n         mData = in.readInt();\n     }\n }</pre>\n\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-CONTENTS_FILE_DESCRIPTOR' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Parcelable'>android.os.Parcelable</span><br/><a href='source/Parcelable.html#android-os-Parcelable-property-CONTENTS_FILE_DESCRIPTOR' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Parcelable-property-CONTENTS_FILE_DESCRIPTOR' class='name expandable'>CONTENTS_FILE_DESCRIPTOR</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Bit masks for use with describeContents: each bit represents a\nkind of object considered to have potential special si...</div><div class='long'><p>Bit masks for use with <a href=\"#!/api/android.os.Parcelable-method-describeContents\" rel=\"android.os.Parcelable-method-describeContents\" class=\"docClass\">describeContents</a>: each bit represents a\nkind of object considered to have potential special significance when\nmarshalled.</p>\n<p>Defaults to: <code>&quot;1&quot;</code></p></div></div></div><div id='property-PARCELABLE_WRITE_RETURN_VALUE' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Parcelable'>android.os.Parcelable</span><br/><a href='source/Parcelable.html#android-os-Parcelable-property-PARCELABLE_WRITE_RETURN_VALUE' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Parcelable-property-PARCELABLE_WRITE_RETURN_VALUE' class='name expandable'>PARCELABLE_WRITE_RETURN_VALUE</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Flag for use with writeToParcel: the object being written\nis a return value, that is the result of a function such as...</div><div class='long'><p>Flag for use with <a href=\"#!/api/android.os.Parcelable-method-writeToParcel\" rel=\"android.os.Parcelable-method-writeToParcel\" class=\"docClass\">writeToParcel</a>: the object being written\nis a return value, that is the result of a function such as\n\"<code>Parcelable someFunction()</code>\",\n\"<code>void someFunction(out Parcelable)</code>\", or\n\"<code>void someFunction(inout Parcelable)</code>\".  Some implementations\nmay want to release resources at this point.</p>\n<p>Defaults to: <code>&quot;1&quot;</code></p></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-describeContents' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Parcelable'>android.os.Parcelable</span><br/><a href='source/Parcelable.html#android-os-Parcelable-method-describeContents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Parcelable-method-describeContents' class='name expandable'>describeContents</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Describe the kinds of special objects contained in this Parcelable's\n marshalled representation. ...</div><div class='long'><p>Describe the kinds of special objects contained in this Parcelable's\n marshalled representation.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>a bitmask indicating the set of special object types marshalled\n by the Parcelable.</p>\n</div></li></ul></div></div></div><div id='method-writeToParcel' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.Parcelable'>android.os.Parcelable</span><br/><a href='source/Parcelable.html#android-os-Parcelable-method-writeToParcel' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.Parcelable-method-writeToParcel' class='name expandable'>writeToParcel</a>( <span class='pre'>dest, flags</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Flatten this object in to a Parcel. ...</div><div class='long'><p>Flatten this object in to a Parcel.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>dest</span> : Object {Parcel}<div class='sub-desc'><p>The Parcel in which the object should be written.</p>\n</div></li><li><span class='pre'>flags</span> : Number<div class='sub-desc'><p>Additional flags about how the object should be written.\n May be 0 or <a href=\"#!/api/android.os.Parcelable-property-PARCELABLE_WRITE_RETURN_VALUE\" rel=\"android.os.Parcelable-property-PARCELABLE_WRITE_RETURN_VALUE\" class=\"docClass\">PARCELABLE_WRITE_RETURN_VALUE</a>.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});