Ext.data.JsonP.android_os_RecoverySystem({"tagname":"class","name":"android.os.RecoverySystem","autodetected":{},"files":[{"filename":"RecoverySystem.js","href":"RecoverySystem.html#android-os-RecoverySystem"}],"extends":"java.lang.Object","members":[{"name":"installPackage","tagname":"method","owner":"android.os.RecoverySystem","id":"method-installPackage","meta":{}},{"name":"rebootWipeCache","tagname":"method","owner":"android.os.RecoverySystem","id":"method-rebootWipeCache","meta":{}},{"name":"verifyPackage","tagname":"method","owner":"android.os.RecoverySystem","id":"method-verifyPackage","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.RecoverySystem","short_doc":"RecoverySystem contains methods for interacting with the Android\n recovery system (the separate partition that can be...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.RecoverySystem</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/RecoverySystem.html#android-os-RecoverySystem' target='_blank'>RecoverySystem.js</a></div></pre><div class='doc-contents'><p>RecoverySystem contains methods for interacting with the Android\n recovery system (the separate partition that can be used to install\n system updates, wipe user data, etc.)</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-installPackage' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.RecoverySystem'>android.os.RecoverySystem</span><br/><a href='source/RecoverySystem.html#android-os-RecoverySystem-method-installPackage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.RecoverySystem-method-installPackage' class='name expandable'>installPackage</a>( <span class='pre'>context, packageFile</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Reboots the device in order to install the given update\n package. ...</div><div class='long'><p>Reboots the device in order to install the given update\n package.\n Requires the android.Manifest.permission.REBOOT permission.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>context</span> : Object {Context}<div class='sub-desc'><p>the Context to use</p>\n</div></li><li><span class='pre'>packageFile</span> : Object {File}<div class='sub-desc'><p>the update package to install.  Must be on\n a partition mountable by recovery.  (The set of partitions\n known to recovery may vary from device to device.  Generally,\n /cache and /data are safe.)</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IOException  if writing the recovery command file\n fails, or if the reboot itself fails.</p>\n</div></li></ul></div></div></div><div id='method-rebootWipeCache' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.RecoverySystem'>android.os.RecoverySystem</span><br/><a href='source/RecoverySystem.html#android-os-RecoverySystem-method-rebootWipeCache' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.RecoverySystem-method-rebootWipeCache' class='name expandable'>rebootWipeCache</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>{@hide} ...</div><div class='long'><p>{@hide}</p>\n</div></div></div><div id='method-verifyPackage' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.RecoverySystem'>android.os.RecoverySystem</span><br/><a href='source/RecoverySystem.html#android-os-RecoverySystem-method-verifyPackage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.RecoverySystem-method-verifyPackage' class='name expandable'>verifyPackage</a>( <span class='pre'>packageFile, listener, deviceCertsZipFile</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Verify the cryptographic signature of a system update package\n before installing it. ...</div><div class='long'><p>Verify the cryptographic signature of a system update package\n before installing it.  Note that the package is also verified\n separately by the installer once the device is rebooted into\n the recovery system.  This function will return only if the\n package was successfully verified; otherwise it will throw an\n exception.</p>\n\n<p> Verification of a package can take significant time, so this\n function should not be called from a UI thread.  Interrupting\n the thread while this function is in progress will result in a\n SecurityException being thrown (and the thread's interrupt flag\n will be cleared).</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>packageFile</span> : Object {File}<div class='sub-desc'><p>the package to be verified</p>\n</div></li><li><span class='pre'>listener</span> : Object {RecoverySystem.ProgressListener}<div class='sub-desc'><p>an object to receive periodic progress\n updates as verification proceeds.  May be null.</p>\n</div></li><li><span class='pre'>deviceCertsZipFile</span> : Object {File}<div class='sub-desc'><p>the zip file of certificates whose\n public keys we will accept.  Verification succeeds if the\n package is signed by the private key corresponding to any\n public key in this file.  May be null to use the system default\n file (currently \"/system/etc/security/otacerts.zip\").</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IOException if there were any errors reading the\n package or certs files.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>GeneralSecurityException if verification failed</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});