Ext.data.JsonP.android_os_StrictMode_VmPolicy_Builder({"tagname":"class","name":"android.os.StrictMode.VmPolicy.Builder","autodetected":{},"files":[{"filename":"Builder.js","href":"Builder.html#android-os-StrictMode-VmPolicy-Builder"}],"extends":"java.lang.Object","members":[{"name":"build","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-build","meta":{}},{"name":"detectActivityLeaks","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-detectActivityLeaks","meta":{}},{"name":"detectAll","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-detectAll","meta":{}},{"name":"detectCleartextNetwork","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-detectCleartextNetwork","meta":{}},{"name":"detectFileUriExposure","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-detectFileUriExposure","meta":{}},{"name":"detectLeakedClosableObjects","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-detectLeakedClosableObjects","meta":{}},{"name":"detectLeakedRegistrationObjects","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-detectLeakedRegistrationObjects","meta":{}},{"name":"detectLeakedSqlLiteObjects","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-detectLeakedSqlLiteObjects","meta":{}},{"name":"penaltyDeath","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-penaltyDeath","meta":{}},{"name":"penaltyDeathOnCleartextNetwork","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-penaltyDeathOnCleartextNetwork","meta":{}},{"name":"penaltyDropBox","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-penaltyDropBox","meta":{}},{"name":"penaltyLog","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-penaltyLog","meta":{}},{"name":"setClassInstanceLimit","tagname":"method","owner":"android.os.StrictMode.VmPolicy.Builder","id":"method-setClassInstanceLimit","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.StrictMode.VmPolicy.Builder","short_doc":"Creates android.os.StrictMode.VmPolicy instances. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.StrictMode.VmPolicy.Builder</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder' target='_blank'>Builder.js</a></div></pre><div class='doc-contents'><p>Creates <a href=\"#!/api/android.os.StrictMode.VmPolicy\" rel=\"android.os.StrictMode.VmPolicy\" class=\"docClass\">android.os.StrictMode.VmPolicy</a> instances.  Methods whose names start\n with {@code detect} specify what problems we should look\n for.  Methods whose names start with {@code penalty} specify what\n we should do when we detect a problem.</p>\n\n<p> <p>You can call as many {@code detect} and {@code penalty}\n methods as you like. Currently order is insignificant: all\n penalties apply to all detected problems.</p>\n\n<p> <p>For example, detect everything and log anything that's found:</p>\n\n<pre> StrictMode.VmPolicy policy = new StrictMode.VmPolicy.Builder()\n     .detectAll()\n     .penaltyLog()\n     .build();\n StrictMode.setVmPolicy(policy);\n </pre>\n\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-build' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-build' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-build' class='name expandable'>build</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Construct the VmPolicy instance. ...</div><div class='long'><p>Construct the VmPolicy instance.</p>\n\n<p> <p>Note: if no penalties are enabled before calling\n <code>build</code>, <a href=\"#!/api/android.os.StrictMode.VmPolicy.Builder-method-penaltyLog\" rel=\"android.os.StrictMode.VmPolicy.Builder-method-penaltyLog\" class=\"docClass\">penaltyLog</a> is implicitly\n set.</p>\n</div></div></div><div id='method-detectActivityLeaks' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-detectActivityLeaks' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-detectActivityLeaks' class='name expandable'>detectActivityLeaks</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Detect leaks of android.app.Activity subclasses. ...</div><div class='long'><p>Detect leaks of android.app.Activity subclasses.</p>\n</div></div></div><div id='method-detectAll' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-detectAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-detectAll' class='name expandable'>detectAll</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Detect everything that's potentially suspect. ...</div><div class='long'><p>Detect everything that's potentially suspect.</p>\n\n<p> <p>In the Honeycomb release this includes leaks of\n SQLite cursors, Activities, and other closable objects\n but will likely expand in future releases.</p>\n</div></div></div><div id='method-detectCleartextNetwork' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-detectCleartextNetwork' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-detectCleartextNetwork' class='name expandable'>detectCleartextNetwork</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Detect any network traffic from the calling app which is not\n wrapped in SSL/TLS. ...</div><div class='long'><p>Detect any network traffic from the calling app which is not\n wrapped in SSL/TLS. This can help you detect places that your app\n is inadvertently sending cleartext data across the network.\n <p>\n Using <a href=\"#!/api/android.os.StrictMode.VmPolicy.Builder-method-penaltyDeath\" rel=\"android.os.StrictMode.VmPolicy.Builder-method-penaltyDeath\" class=\"docClass\">penaltyDeath</a>() or\n <a href=\"#!/api/android.os.StrictMode.VmPolicy.Builder-method-penaltyDeathOnCleartextNetwork\" rel=\"android.os.StrictMode.VmPolicy.Builder-method-penaltyDeathOnCleartextNetwork\" class=\"docClass\">penaltyDeathOnCleartextNetwork</a>() will block further\n traffic on that socket to prevent accidental data leakage, in\n addition to crashing your process.\n <p>\n Using <a href=\"#!/api/android.os.StrictMode.VmPolicy.Builder-method-penaltyDropBox\" rel=\"android.os.StrictMode.VmPolicy.Builder-method-penaltyDropBox\" class=\"docClass\">penaltyDropBox</a>() will log the raw contents of the\n packet that triggered the violation.\n <p>\n This inspects both IPv4/IPv6 and TCP/UDP network traffic, but it\n may be subject to false positives, such as when STARTTLS\n protocols or HTTP proxies are used.</p>\n</div></div></div><div id='method-detectFileUriExposure' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-detectFileUriExposure' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-detectFileUriExposure' class='name expandable'>detectFileUriExposure</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Detect when a {@code file://} android.net.Uri is exposed beyond this\n app. ...</div><div class='long'><p>Detect when a {@code file://} android.net.Uri is exposed beyond this\n app. The receiving app may not have access to the sent path.\n Instead, when sharing files between apps, {@code content://}\n should be used with permission grants.</p>\n</div></div></div><div id='method-detectLeakedClosableObjects' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-detectLeakedClosableObjects' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-detectLeakedClosableObjects' class='name expandable'>detectLeakedClosableObjects</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Detect when an java.io.Closeable or other\n object with a explict termination method is finalized\n without having been...</div><div class='long'><p>Detect when an java.io.Closeable or other\n object with a explict termination method is finalized\n without having been closed.</p>\n\n<p> <p>You always want to explicitly close such objects to\n avoid unnecessary resources leaks.</p>\n</div></div></div><div id='method-detectLeakedRegistrationObjects' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-detectLeakedRegistrationObjects' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-detectLeakedRegistrationObjects' class='name expandable'>detectLeakedRegistrationObjects</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Detect when a BroadcastReceiver or\n android.os.Pkg.ServiceConnection is leaked during Context\n teardown. ...</div><div class='long'><p>Detect when a BroadcastReceiver or\n android.os.Pkg.ServiceConnection is leaked during Context\n teardown.</p>\n</div></div></div><div id='method-detectLeakedSqlLiteObjects' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-detectLeakedSqlLiteObjects' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-detectLeakedSqlLiteObjects' class='name expandable'>detectLeakedSqlLiteObjects</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Detect when an\n android.database.sqlite.SQLiteCursor or other\n SQLite object is finalized without having been closed. ...</div><div class='long'><p>Detect when an\n android.database.sqlite.SQLiteCursor or other\n SQLite object is finalized without having been closed.</p>\n\n<p> <p>You always want to explicitly close your SQLite\n cursors to avoid unnecessary database contention and\n temporary memory leaks.</p>\n</div></div></div><div id='method-penaltyDeath' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-penaltyDeath' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-penaltyDeath' class='name expandable'>penaltyDeath</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Crashes the whole process on violation. ...</div><div class='long'><p>Crashes the whole process on violation. This penalty runs at the\n end of all enabled penalties so you'll still get your logging or\n other violations before the process dies.</p>\n</div></div></div><div id='method-penaltyDeathOnCleartextNetwork' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-penaltyDeathOnCleartextNetwork' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-penaltyDeathOnCleartextNetwork' class='name expandable'>penaltyDeathOnCleartextNetwork</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Crashes the whole process when cleartext network traffic is\n detected. ...</div><div class='long'><p>Crashes the whole process when cleartext network traffic is\n detected.\n@see <a href=\"#!/api/android.os.StrictMode.VmPolicy.Builder-method-detectCleartextNetwork\" rel=\"android.os.StrictMode.VmPolicy.Builder-method-detectCleartextNetwork\" class=\"docClass\">detectCleartextNetwork</a>()</p>\n</div></div></div><div id='method-penaltyDropBox' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-penaltyDropBox' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-penaltyDropBox' class='name expandable'>penaltyDropBox</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Enable detected violations log a stacktrace and timing data\n to the DropBox on policy\n violation. ...</div><div class='long'><p>Enable detected violations log a stacktrace and timing data\n to the <a href=\"#!/api/android.os.DropBoxManager\" rel=\"android.os.DropBoxManager\" class=\"docClass\">DropBox</a> on policy\n violation.  Intended mostly for platform integrators doing\n beta user field data collection.</p>\n</div></div></div><div id='method-penaltyLog' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-penaltyLog' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-penaltyLog' class='name expandable'>penaltyLog</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Log detected violations to the system log. ...</div><div class='long'><p>Log detected violations to the system log.</p>\n</div></div></div><div id='method-setClassInstanceLimit' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.StrictMode.VmPolicy.Builder'>android.os.StrictMode.VmPolicy.Builder</span><br/><a href='source/Builder.html#android-os-StrictMode-VmPolicy-Builder-method-setClassInstanceLimit' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.StrictMode.VmPolicy.Builder-method-setClassInstanceLimit' class='name expandable'>setClassInstanceLimit</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Set an upper bound on how many instances of a class can be in memory\n at once. ...</div><div class='long'><p>Set an upper bound on how many instances of a class can be in memory\n at once.  Helps to prevent object leaks.</p>\n</div></div></div></div></div></div></div>","meta":{}});