Ext.data.JsonP.android_os_SystemClock({"tagname":"class","name":"android.os.SystemClock","autodetected":{},"files":[{"filename":"SystemClock.js","href":"SystemClock.html#android-os-SystemClock"}],"extends":"java.lang.Object","members":[{"name":"currentThreadTimeMillis","tagname":"method","owner":"android.os.SystemClock","id":"method-currentThreadTimeMillis","meta":{}},{"name":"elapsedRealtime","tagname":"method","owner":"android.os.SystemClock","id":"method-elapsedRealtime","meta":{}},{"name":"elapsedRealtimeNanos","tagname":"method","owner":"android.os.SystemClock","id":"method-elapsedRealtimeNanos","meta":{}},{"name":"setCurrentTimeMillis","tagname":"method","owner":"android.os.SystemClock","id":"method-setCurrentTimeMillis","meta":{}},{"name":"sleep","tagname":"method","owner":"android.os.SystemClock","id":"method-sleep","meta":{}},{"name":"uptimeMillis","tagname":"method","owner":"android.os.SystemClock","id":"method-uptimeMillis","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.SystemClock","short_doc":"Core timekeeping facilities. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.SystemClock</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/SystemClock.html#android-os-SystemClock' target='_blank'>SystemClock.js</a></div></pre><div class='doc-contents'><p>Core timekeeping facilities.</p>\n\n<p> <p> Three different clocks are available, and they should not be confused:</p>\n\n<p> <ul>\n     <li> <p> System.currentTimeMillis()\n     is the standard \"wall\" clock (time and date) expressing milliseconds\n     since the epoch.  The wall clock can be set by the user or the phone\n     network (see <a href=\"#!/api/android.os.SystemClock-method-setCurrentTimeMillis\" rel=\"android.os.SystemClock-method-setCurrentTimeMillis\" class=\"docClass\">setCurrentTimeMillis</a>), so the time may jump\n     backwards or forwards unpredictably.  This clock should only be used\n     when correspondence with real-world dates and times is important, such\n     as in a calendar or alarm clock application.  Interval or elapsed\n     time measurements should use a different clock.  If you are using\n     System.currentTimeMillis(), consider listening to the\n     ACTION_TIME_TICK,\n     ACTION_TIME_CHANGED\n     and ACTION_TIMEZONE_CHANGED Intent\n     broadcasts to find out when the time changes.</p>\n\n<pre><code> &lt;li&gt; &lt;p&gt; <a href=\"#!/api/android.os.SystemClock-method-uptimeMillis\" rel=\"android.os.SystemClock-method-uptimeMillis\" class=\"docClass\">uptimeMillis</a> is counted in milliseconds since the\n system was booted.  This clock stops when the system enters deep\n sleep (CPU off, display dark, device waiting for external input),\n but is not affected by clock scaling, idle, or other power saving\n mechanisms.  This is the basis for most interval timing\n such as Thread.sleep(millls),\n Object.wait(millis), and\n System.nanoTime().  This clock is guaranteed\n to be monotonic, and is suitable for interval timing when the\n interval does not span device sleep.  Most methods that accept a\n timestamp value currently expect the <a href=\"#!/api/android.os.SystemClock-method-uptimeMillis\" rel=\"android.os.SystemClock-method-uptimeMillis\" class=\"docClass\">uptimeMillis</a> clock.\n\n &lt;li&gt; &lt;p&gt; <a href=\"#!/api/android.os.SystemClock-method-elapsedRealtime\" rel=\"android.os.SystemClock-method-elapsedRealtime\" class=\"docClass\">elapsedRealtime</a> and <a href=\"#!/api/android.os.SystemClock-method-elapsedRealtimeNanos\" rel=\"android.os.SystemClock-method-elapsedRealtimeNanos\" class=\"docClass\">elapsedRealtimeNanos</a>\n return the time since the system was booted, and include deep sleep.\n This clock is guaranteed to be monotonic, and continues to tick even\n when the CPU is in power saving modes, so is the recommend basis\n for general purpose interval timing.\n</code></pre>\n\n<p> </p></li></ul></p>\n\n<p> There are several mechanisms for controlling the timing of events:</p>\n\n<p> <ul>\n     <li> <p> Standard functions like Thread.sleep(millis) and Object.wait(millis)\n     are always available.  These functions use the <a href=\"#!/api/android.os.SystemClock-method-uptimeMillis\" rel=\"android.os.SystemClock-method-uptimeMillis\" class=\"docClass\">uptimeMillis</a>\n     clock; if the device enters sleep, the remainder of the time will be\n     postponed until the device wakes up.  These synchronous functions may\n     be interrupted with Thread.interrupt(), and\n     you must handle InterruptedException.</p>\n\n<pre><code> &lt;li&gt; &lt;p&gt; <a href=\"#!/api/android.os.SystemClock-method-sleep\" rel=\"android.os.SystemClock-method-sleep\" class=\"docClass\">android.os.SystemClock.sleep(millis)</a> is a utility function\n very similar to Thread.sleep(millis), but it\n ignores InterruptedException.  Use this function for delays if\n you do not use Thread.interrupt(), as it will\n preserve the interrupted state of the thread.\n\n &lt;li&gt; &lt;p&gt; The <a href=\"#!/api/android.os.Handler\" rel=\"android.os.Handler\" class=\"docClass\">android.os.Handler</a> class can schedule asynchronous\n callbacks at an absolute or relative time.  Handler objects also use the\n <a href=\"#!/api/android.os.SystemClock-method-uptimeMillis\" rel=\"android.os.SystemClock-method-uptimeMillis\" class=\"docClass\">uptimeMillis</a> clock, and require an <a href=\"#!/api/android.os.Looper\" rel=\"android.os.Looper\" class=\"docClass\">event loop</a> (normally present in any GUI application).\n\n &lt;li&gt; &lt;p&gt; The android.app.AlarmManager can trigger one-time or\n recurring events which occur even when the device is in deep sleep\n or your application is not running.  Events may be scheduled with your\n choice of java.lang.System.currentTimeMillis (RTC) or\n <a href=\"#!/api/android.os.SystemClock-method-elapsedRealtime\" rel=\"android.os.SystemClock-method-elapsedRealtime\" class=\"docClass\">elapsedRealtime</a> (ELAPSED_REALTIME), and cause an\n android.content.Intent broadcast when they occur.\n</code></pre>\n\n<p> </p></li></ul></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-currentThreadTimeMillis' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.SystemClock'>android.os.SystemClock</span><br/><a href='source/SystemClock.html#android-os-SystemClock-method-currentThreadTimeMillis' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.SystemClock-method-currentThreadTimeMillis' class='name expandable'>currentThreadTimeMillis</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns milliseconds running in the current thread. ...</div><div class='long'><p>Returns milliseconds running in the current thread.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>elapsed milliseconds in the thread</p>\n</div></li></ul></div></div></div><div id='method-elapsedRealtime' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.SystemClock'>android.os.SystemClock</span><br/><a href='source/SystemClock.html#android-os-SystemClock-method-elapsedRealtime' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.SystemClock-method-elapsedRealtime' class='name expandable'>elapsedRealtime</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns milliseconds since boot, including time spent in sleep. ...</div><div class='long'><p>Returns milliseconds since boot, including time spent in sleep.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>elapsed milliseconds since boot.</p>\n</div></li></ul></div></div></div><div id='method-elapsedRealtimeNanos' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.SystemClock'>android.os.SystemClock</span><br/><a href='source/SystemClock.html#android-os-SystemClock-method-elapsedRealtimeNanos' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.SystemClock-method-elapsedRealtimeNanos' class='name expandable'>elapsedRealtimeNanos</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns nanoseconds since boot, including time spent in sleep. ...</div><div class='long'><p>Returns nanoseconds since boot, including time spent in sleep.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>elapsed nanoseconds since boot.</p>\n</div></li></ul></div></div></div><div id='method-setCurrentTimeMillis' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.SystemClock'>android.os.SystemClock</span><br/><a href='source/SystemClock.html#android-os-SystemClock-method-setCurrentTimeMillis' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.SystemClock-method-setCurrentTimeMillis' class='name expandable'>setCurrentTimeMillis</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Sets the current wall time, in milliseconds. ...</div><div class='long'><p>Sets the current wall time, in milliseconds.  Requires the calling\n process to have appropriate permissions.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>if the clock was successfully set to the specified time.</p>\n</div></li></ul></div></div></div><div id='method-sleep' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.SystemClock'>android.os.SystemClock</span><br/><a href='source/SystemClock.html#android-os-SystemClock-method-sleep' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.SystemClock-method-sleep' class='name expandable'>sleep</a>( <span class='pre'>ms</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Waits a given number of milliseconds (of uptimeMillis) before returning. ...</div><div class='long'><p>Waits a given number of milliseconds (of uptimeMillis) before returning.\n Similar to java.lang.Thread.sleep(long), but does not throw\n InterruptedException; Thread.interrupt() events are\n deferred until the next interruptible operation.  Does not return until\n at least the specified number of milliseconds has elapsed.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>ms</span> : Number<div class='sub-desc'><p>to sleep before returning, in milliseconds of uptime.</p>\n</div></li></ul></div></div></div><div id='method-uptimeMillis' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.SystemClock'>android.os.SystemClock</span><br/><a href='source/SystemClock.html#android-os-SystemClock-method-uptimeMillis' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.SystemClock-method-uptimeMillis' class='name expandable'>uptimeMillis</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns milliseconds since boot, not counting time spent in deep sleep. ...</div><div class='long'><p>Returns milliseconds since boot, not counting time spent in deep sleep.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>milliseconds of non-sleep uptime since boot.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});