Ext.data.JsonP.android_os_TransactionTooLargeException({"tagname":"class","name":"android.os.TransactionTooLargeException","autodetected":{},"files":[{"filename":"TransactionTooLargeException.js","href":"TransactionTooLargeException.html#android-os-TransactionTooLargeException"}],"extends":"android.os.RemoteException","members":[{"name":"rethrowAsRuntimeException","tagname":"method","owner":"android.os.RemoteException","id":"method-rethrowAsRuntimeException","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.TransactionTooLargeException","short_doc":"The Binder transaction failed because it was too large. ...","classIcon":"icon-class","superclasses":["android.util.AndroidException","android.os.RemoteException"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>android.util.AndroidException<div class='subclass '><a href='#!/api/android.os.RemoteException' rel='android.os.RemoteException' class='docClass'>android.os.RemoteException</a><div class='subclass '><strong>android.os.TransactionTooLargeException</strong></div></div></div><h4>Files</h4><div class='dependency'><a href='source/TransactionTooLargeException.html#android-os-TransactionTooLargeException' target='_blank'>TransactionTooLargeException.js</a></div></pre><div class='doc-contents'><p>The Binder transaction failed because it was too large.\n <p>\n During a remote procedure call, the arguments and the return value of the call\n are transferred as <a href=\"#!/api/android.os.Parcel\" rel=\"android.os.Parcel\" class=\"docClass\">android.os.Parcel</a> objects stored in the Binder transaction buffer.\n If the arguments or the return value are too large to fit in the transaction buffer,\n then the call will fail and <a href=\"#!/api/android.os.TransactionTooLargeException\" rel=\"android.os.TransactionTooLargeException\" class=\"docClass\">android.os.TransactionTooLargeException</a> will be thrown.\n </p><p>\n The Binder transaction buffer has a limited fixed size, currently 1Mb, which\n is shared by all transactions in progress for the process.  Consequently this\n exception can be thrown when there are many transactions in progress even when\n most of the individual transactions are of moderate size.\n </p><p>\n There are two possible outcomes when a remote procedure call throws\n <a href=\"#!/api/android.os.TransactionTooLargeException\" rel=\"android.os.TransactionTooLargeException\" class=\"docClass\">android.os.TransactionTooLargeException</a>.  Either the client was unable to send\n its request to the service (most likely if the arguments were too large to fit in\n the transaction buffer), or the service was unable to send its response back\n to the client (most likely if the return value was too large to fit\n in the transaction buffer).  It is not possible to tell which of these outcomes\n actually occurred.  The client should assume that a partial failure occurred.\n </p><p>\n The key to avoiding <a href=\"#!/api/android.os.TransactionTooLargeException\" rel=\"android.os.TransactionTooLargeException\" class=\"docClass\">android.os.TransactionTooLargeException</a> is to keep all\n transactions relatively small.  Try to minimize the amount of memory needed to create\n a <a href=\"#!/api/android.os.Parcel\" rel=\"android.os.Parcel\" class=\"docClass\">android.os.Parcel</a> for the arguments and the return value of the remote procedure call.\n Avoid transferring huge arrays of strings or large bitmaps.\n If possible, try to break up big requests into smaller pieces.\n </p><p>\n If you are implementing a service, it may help to impose size or complexity\n contraints on the queries that clients can perform.  For example, if the result set\n could become large, then don't allow the client to request more than a few records\n at a time.  Alternately, instead of returning all of the available data all at once,\n return the essential information first and make the client ask for additional information\n later as needed.\n </p></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-rethrowAsRuntimeException' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/android.os.RemoteException' rel='android.os.RemoteException' class='defined-in docClass'>android.os.RemoteException</a><br/><a href='source/RemoteException.html#android-os-RemoteException-method-rethrowAsRuntimeException' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.RemoteException-method-rethrowAsRuntimeException' class='name expandable'>rethrowAsRuntimeException</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>{@hide} ...</div><div class='long'><p>{@hide}</p>\n</div></div></div></div></div></div></div>","meta":{}});