Ext.data.JsonP.android_os_UEventObserver({"tagname":"class","name":"android.os.UEventObserver","autodetected":{},"files":[{"filename":"UEventObserver.js","href":"UEventObserver.html#android-os-UEventObserver"}],"extends":"java.lang.Object","hide":true,"members":[{"name":"onUEvent","tagname":"method","owner":"android.os.UEventObserver","id":"method-onUEvent","meta":{}},{"name":"startObserving","tagname":"method","owner":"android.os.UEventObserver","id":"method-startObserving","meta":{}},{"name":"stopObserving","tagname":"method","owner":"android.os.UEventObserver","id":"method-stopObserving","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.os.UEventObserver","short_doc":"UEventObserver is an abstract class that receives UEvents from the kernel. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.os.UEventObserver</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/UEventObserver.html#android-os-UEventObserver' target='_blank'>UEventObserver.js</a></div></pre><div class='doc-contents'><p>UEventObserver is an abstract class that receives UEvents from the kernel.<p></p>\n\n<p> Subclass UEventObserver, implementing onUEvent(UEvent event), then call\n startObserving() with a match string. The UEvent thread will then call your\n onUEvent() method when a UEvent occurs that contains your match string.<p></p>\n\n<p> Call stopObserving() to stop receiving UEvents.<p></p>\n\n<p> There is only one UEvent thread per process, even if that process has\n multiple UEventObserver subclass instances. The UEvent thread starts when\n the startObserving() is called for the first time in that process. Once\n started the UEvent thread will not stop (although it can stop notifying\n UEventObserver's via stopObserving()).<p></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-onUEvent' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.UEventObserver'>android.os.UEventObserver</span><br/><a href='source/UEventObserver.html#android-os-UEventObserver-method-onUEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.UEventObserver-method-onUEvent' class='name expandable'>onUEvent</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Subclasses of UEventObserver should override this method to handle\n UEvents. ...</div><div class='long'><p>Subclasses of UEventObserver should override this method to handle\n UEvents.</p>\n</div></div></div><div id='method-startObserving' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.UEventObserver'>android.os.UEventObserver</span><br/><a href='source/UEventObserver.html#android-os-UEventObserver-method-startObserving' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.UEventObserver-method-startObserving' class='name expandable'>startObserving</a>( <span class='pre'>match</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Begin observation of UEvents. ...</div><div class='long'><p>Begin observation of UEvents.<p>\n This method will cause the UEvent thread to start if this is the first\n invocation of startObserving in this process.<p>\n Once called, the UEvent thread will call onUEvent() when an incoming\n UEvent matches the specified string.<p>\n This method can be called multiple times to register multiple matches.\n Only one call to stopObserving is required even with multiple registered\n matches.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>match</span> : String<div class='sub-desc'><p>A substring of the UEvent to match.  Try to be as specific\n as possible to avoid incurring unintended additional cost from processing\n irrelevant messages.  Netlink messages can be moderately high bandwidth and\n are expensive to parse.  For example, some devices may send one netlink message\n for each vsync period.</p>\n</div></li></ul></div></div></div><div id='method-stopObserving' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.os.UEventObserver'>android.os.UEventObserver</span><br/><a href='source/UEventObserver.html#android-os-UEventObserver-method-stopObserving' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.os.UEventObserver-method-stopObserving' class='name expandable'>stopObserving</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>End observation of UEvents. ...</div><div class='long'><p>End observation of UEvents.<p>\n This process's UEvent thread will never call onUEvent() on this\n UEventObserver after this call. Repeated calls have no effect.</p>\n</div></div></div></div></div></div></div>","meta":{}});