Ext.data.JsonP.android_webkit_CookieSyncManager({"tagname":"class","name":"android.webkit.CookieSyncManager","autodetected":{},"files":[{"filename":"CookieSyncManager.js","href":"CookieSyncManager.html#android-webkit-CookieSyncManager"}],"extends":"android.webkit.WebSyncManager","deprecated":{"text":"<p>The WebView now automatically syncs cookies as necessary.\n             You no longer need to create or use the CookieSyncManager.\n             To manually force a sync you can use the CookieManager\n             method <a href=\"#!/api/android.webkit.CookieManager-method-flush\" rel=\"android.webkit.CookieManager-method-flush\" class=\"docClass\">android.webkit.CookieManager.flush</a> which is a synchronous\n             replacement for <a href=\"#!/api/android.webkit.CookieSyncManager-method-sync\" rel=\"android.webkit.CookieSyncManager-method-sync\" class=\"docClass\">sync</a>.</p>\n"},"members":[{"name":"createInstance","tagname":"method","owner":"android.webkit.CookieSyncManager","id":"method-createInstance","meta":{}},{"name":"getInstance","tagname":"method","owner":"android.webkit.CookieSyncManager","id":"method-getInstance","meta":{}},{"name":"resetSync","tagname":"method","owner":"android.webkit.CookieSyncManager","id":"method-resetSync","meta":{"deprecated":{"text":"<p>Calling resetSync is no longer necessary as the WebView automatically\n             syncs cookies.</p>\n"}}},{"name":"startSync","tagname":"method","owner":"android.webkit.CookieSyncManager","id":"method-startSync","meta":{"deprecated":{"text":"<p>Calling startSync is no longer necessary as the WebView automatically\n             syncs cookies.</p>\n"}}},{"name":"stopSync","tagname":"method","owner":"android.webkit.CookieSyncManager","id":"method-stopSync","meta":{"deprecated":{"text":"<p>Calling stopSync is no longer useful as the WebView\n             automatically syncs cookies.</p>\n"}}},{"name":"sync","tagname":"method","owner":"android.webkit.CookieSyncManager","id":"method-sync","meta":{"deprecated":{"text":"<p>Use CookieManager.flush instead.</p>\n"}}}],"alternateClassNames":[],"aliases":{},"id":"class-android.webkit.CookieSyncManager","short_doc":"The CookieSyncManager is used to synchronize the browser cookie store\n between RAM and permanent storage. ...","classIcon":"icon-class","superclasses":["android.webkit.WebSyncManager"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>android.webkit.WebSyncManager<div class='subclass '><strong>android.webkit.CookieSyncManager</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/CookieSyncManager.html#android-webkit-CookieSyncManager' target='_blank'>CookieSyncManager.js</a></div></pre><div class='doc-contents'><p>The CookieSyncManager is used to synchronize the browser cookie store\n between RAM and permanent storage. To get the best performance, browser cookies are\n saved in RAM. A separate thread saves the cookies between, driven by a timer.\n <p></p>\n\n<p> To use the CookieSyncManager, the host application has to call the following\n when the application starts:\n <p></p>\n\n<p> <pre class=\"prettyprint\">CookieSyncManager.createInstance(context)</pre><p></p>\n\n<p> To set up for sync, the host application has to call<p>\n <pre class=\"prettyprint\">CookieSyncManager.getInstance().startSync()</pre><p></p>\n\n<p> in Activity.onResume(), and call\n <p></p>\n\n<p> <pre class=\"prettyprint\">\n CookieSyncManager.getInstance().stopSync()\n </pre><p></p>\n\n<p> in Activity.onPause().<p></p>\n\n<p> To get instant sync instead of waiting for the timer to trigger, the host can\n call\n <p>\n <pre class=\"prettyprint\">CookieSyncManager.getInstance().sync()</pre><p></p>\n\n<p> The sync interval is 5 minutes, so you will want to force syncs\n manually anyway, for instance in <a href=\"#!/api/android.webkit.WebViewClient-method-onPageFinished\" rel=\"android.webkit.WebViewClient-method-onPageFinished\" class=\"docClass\">android.webkit.WebViewClient.onPageFinished</a>. Note that even sync() happens\n asynchronously, so don't do it just as your activity is shutting\n down.</p>\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This class has been <strong>deprecated</strong> </p>\n        <p>The WebView now automatically syncs cookies as necessary.\n             You no longer need to create or use the CookieSyncManager.\n             To manually force a sync you can use the CookieManager\n             method <a href=\"#!/api/android.webkit.CookieManager-method-flush\" rel=\"android.webkit.CookieManager-method-flush\" class=\"docClass\">android.webkit.CookieManager.flush</a> which is a synchronous\n             replacement for <a href=\"#!/api/android.webkit.CookieSyncManager-method-sync\" rel=\"android.webkit.CookieSyncManager-method-sync\" class=\"docClass\">sync</a>.</p>\n\n        </div>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-createInstance' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.CookieSyncManager'>android.webkit.CookieSyncManager</span><br/><a href='source/CookieSyncManager.html#android-webkit-CookieSyncManager-method-createInstance' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.CookieSyncManager-method-createInstance' class='name expandable'>createInstance</a>( <span class='pre'>context</span> ) : Object {android.webkit.CookieSyncManager}<span class=\"signature\"></span></div><div class='description'><div class='short'>Create a singleton CookieSyncManager within a context ...</div><div class='long'><p>Create a singleton CookieSyncManager within a context</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>context</span> : Object {Context}<div class='sub-desc'>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.webkit.CookieSyncManager}</span><div class='sub-desc'><p>CookieSyncManager</p>\n</div></li></ul></div></div></div><div id='method-getInstance' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.CookieSyncManager'>android.webkit.CookieSyncManager</span><br/><a href='source/CookieSyncManager.html#android-webkit-CookieSyncManager-method-getInstance' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.CookieSyncManager-method-getInstance' class='name expandable'>getInstance</a>( <span class='pre'></span> ) : Object {android.webkit.CookieSyncManager}<span class=\"signature\"></span></div><div class='description'><div class='short'>Singleton access to a android.webkit.CookieSyncManager. ...</div><div class='long'><p>Singleton access to a <a href=\"#!/api/android.webkit.CookieSyncManager\" rel=\"android.webkit.CookieSyncManager\" class=\"docClass\">android.webkit.CookieSyncManager</a>. An\n IllegalStateException will be thrown if\n createInstance(Context) is not called before.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.webkit.CookieSyncManager}</span><div class='sub-desc'><p>CookieSyncManager</p>\n</div></li></ul></div></div></div><div id='method-resetSync' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.CookieSyncManager'>android.webkit.CookieSyncManager</span><br/><a href='source/CookieSyncManager.html#android-webkit-CookieSyncManager-method-resetSync' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.CookieSyncManager-method-resetSync' class='name expandable'>resetSync</a>( <span class='pre'></span> )<span class=\"signature\"><span class='deprecated' >deprecated</span></span></div><div class='description'><div class='short'>resetSync() resets sync manager's timer. ...</div><div class='long'><p>resetSync() resets sync manager's timer.</p>\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>Calling resetSync is no longer necessary as the WebView automatically\n             syncs cookies.</p>\n\n        </div>\n</div></div></div><div id='method-startSync' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.CookieSyncManager'>android.webkit.CookieSyncManager</span><br/><a href='source/CookieSyncManager.html#android-webkit-CookieSyncManager-method-startSync' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.CookieSyncManager-method-startSync' class='name expandable'>startSync</a>( <span class='pre'></span> )<span class=\"signature\"><span class='deprecated' >deprecated</span></span></div><div class='description'><div class='short'>startSync() requests sync manager to start sync. ...</div><div class='long'><p>startSync() requests sync manager to start sync.</p>\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>Calling startSync is no longer necessary as the WebView automatically\n             syncs cookies.</p>\n\n        </div>\n</div></div></div><div id='method-stopSync' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.CookieSyncManager'>android.webkit.CookieSyncManager</span><br/><a href='source/CookieSyncManager.html#android-webkit-CookieSyncManager-method-stopSync' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.CookieSyncManager-method-stopSync' class='name expandable'>stopSync</a>( <span class='pre'></span> )<span class=\"signature\"><span class='deprecated' >deprecated</span></span></div><div class='description'><div class='short'>stopSync() requests sync manager to stop sync. ...</div><div class='long'><p>stopSync() requests sync manager to stop sync. remove any SYNC_MESSAGE in\n the queue to break the sync loop</p>\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>Calling stopSync is no longer useful as the WebView\n             automatically syncs cookies.</p>\n\n        </div>\n</div></div></div><div id='method-sync' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.CookieSyncManager'>android.webkit.CookieSyncManager</span><br/><a href='source/CookieSyncManager.html#android-webkit-CookieSyncManager-method-sync' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.CookieSyncManager-method-sync' class='name expandable'>sync</a>( <span class='pre'></span> )<span class=\"signature\"><span class='deprecated' >deprecated</span></span></div><div class='description'><div class='short'>sync() forces sync manager to sync now ...</div><div class='long'><p>sync() forces sync manager to sync now</p>\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>Use CookieManager.flush instead.</p>\n\n        </div>\n</div></div></div></div></div></div></div>","meta":{"deprecated":{"text":"<p>The WebView now automatically syncs cookies as necessary.\n             You no longer need to create or use the CookieSyncManager.\n             To manually force a sync you can use the CookieManager\n             method <a href=\"#!/api/android.webkit.CookieManager-method-flush\" rel=\"android.webkit.CookieManager-method-flush\" class=\"docClass\">android.webkit.CookieManager.flush</a> which is a synchronous\n             replacement for <a href=\"#!/api/android.webkit.CookieSyncManager-method-sync\" rel=\"android.webkit.CookieSyncManager-method-sync\" class=\"docClass\">sync</a>.</p>\n"}}});