Ext.data.JsonP.android_webkit_GeolocationPermissions({"tagname":"class","name":"android.webkit.GeolocationPermissions","autodetected":{},"files":[{"filename":"GeolocationPermissions.js","href":"GeolocationPermissions.html#android-webkit-GeolocationPermissions"}],"extends":"java.lang.Object","members":[{"name":"allow","tagname":"method","owner":"android.webkit.GeolocationPermissions","id":"method-allow","meta":{}},{"name":"clear","tagname":"method","owner":"android.webkit.GeolocationPermissions","id":"method-clear","meta":{}},{"name":"clearAll","tagname":"method","owner":"android.webkit.GeolocationPermissions","id":"method-clearAll","meta":{}},{"name":"getAllowed","tagname":"method","owner":"android.webkit.GeolocationPermissions","id":"method-getAllowed","meta":{}},{"name":"getInstance","tagname":"method","owner":"android.webkit.GeolocationPermissions","id":"method-getInstance","meta":{}},{"name":"getOrigins","tagname":"method","owner":"android.webkit.GeolocationPermissions","id":"method-getOrigins","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.webkit.GeolocationPermissions","short_doc":"This class is used to manage permissions for the WebView's Geolocation\n JavaScript API. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.webkit.GeolocationPermissions</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/GeolocationPermissions.html#android-webkit-GeolocationPermissions' target='_blank'>GeolocationPermissions.js</a></div></pre><div class='doc-contents'><p>This class is used to manage permissions for the WebView's Geolocation\n JavaScript API.</p>\n\n<p> Geolocation permissions are applied to an origin, which consists of the\n host, scheme and port of a URI. In order for web content to use the\n Geolocation API, permission must be granted for that content's origin.</p>\n\n<p> This class stores Geolocation permissions. An origin's permission state can\n be either allowed or denied. This class uses Strings to represent\n an origin.</p>\n\n<p> When an origin attempts to use the Geolocation API, but no permission state\n is currently set for that origin,\n android.webkit.WebChromeClient.onGeolocationPermissionsShowPrompt()\n is called. This allows the permission state to be set for that origin.</p>\n\n<p> The methods of this class can be used to modify and interrogate the stored\n Geolocation permissions at any time.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-allow' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.GeolocationPermissions'>android.webkit.GeolocationPermissions</span><br/><a href='source/GeolocationPermissions.html#android-webkit-GeolocationPermissions-method-allow' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.GeolocationPermissions-method-allow' class='name expandable'>allow</a>( <span class='pre'>origin</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Allows the specified origin to use the Geolocation API. ...</div><div class='long'><p>Allows the specified origin to use the Geolocation API.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>origin</span> : String<div class='sub-desc'><p>the origin for which Geolocation API use is allowed</p>\n</div></li></ul></div></div></div><div id='method-clear' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.GeolocationPermissions'>android.webkit.GeolocationPermissions</span><br/><a href='source/GeolocationPermissions.html#android-webkit-GeolocationPermissions-method-clear' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.GeolocationPermissions-method-clear' class='name expandable'>clear</a>( <span class='pre'>origin</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Clears the Geolocation permission state for the specified origin. ...</div><div class='long'><p>Clears the Geolocation permission state for the specified origin.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>origin</span> : String<div class='sub-desc'><p>the origin for which Geolocation permissions are cleared</p>\n</div></li></ul></div></div></div><div id='method-clearAll' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.GeolocationPermissions'>android.webkit.GeolocationPermissions</span><br/><a href='source/GeolocationPermissions.html#android-webkit-GeolocationPermissions-method-clearAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.GeolocationPermissions-method-clearAll' class='name expandable'>clearAll</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Clears the Geolocation permission state for all origins. ...</div><div class='long'><p>Clears the Geolocation permission state for all origins.</p>\n</div></div></div><div id='method-getAllowed' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.GeolocationPermissions'>android.webkit.GeolocationPermissions</span><br/><a href='source/GeolocationPermissions.html#android-webkit-GeolocationPermissions-method-getAllowed' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.GeolocationPermissions-method-getAllowed' class='name expandable'>getAllowed</a>( <span class='pre'>origin, callback</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets the Geolocation permission state for the specified origin. ...</div><div class='long'><p>Gets the Geolocation permission state for the specified origin.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>origin</span> : String<div class='sub-desc'><p>the origin for which Geolocation permission is requested</p>\n</div></li><li><span class='pre'>callback</span> : Object {android.webkit.ValueCallback}<div class='sub-desc'><p>a ValueCallback to receive the result of this\n                 request. This object's\n                 onReceiveValue()\n                 method will be invoked asynchronously with a boolean\n                 indicating whether or not the origin can use the\n                 Geolocation API.</p>\n</div></li></ul></div></div></div><div id='method-getInstance' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.GeolocationPermissions'>android.webkit.GeolocationPermissions</span><br/><a href='source/GeolocationPermissions.html#android-webkit-GeolocationPermissions-method-getInstance' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.GeolocationPermissions-method-getInstance' class='name expandable'>getInstance</a>( <span class='pre'></span> ) : Object {android.webkit.GeolocationPermissions}<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets the singleton instance of this class. ...</div><div class='long'><p>Gets the singleton instance of this class. This method cannot be\n called before the application instantiates a <a href=\"#!/api/android.webkit.WebView\" rel=\"android.webkit.WebView\" class=\"docClass\">android.webkit.WebView</a> instance.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.webkit.GeolocationPermissions}</span><div class='sub-desc'><p>the singleton GeolocationPermissions instance</p>\n</div></li></ul></div></div></div><div id='method-getOrigins' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.GeolocationPermissions'>android.webkit.GeolocationPermissions</span><br/><a href='source/GeolocationPermissions.html#android-webkit-GeolocationPermissions-method-getOrigins' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.GeolocationPermissions-method-getOrigins' class='name expandable'>getOrigins</a>( <span class='pre'>callback</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets the set of origins for which Geolocation permissions are stored. ...</div><div class='long'><p>Gets the set of origins for which Geolocation permissions are stored.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>callback</span> : Object {android.webkit.ValueCallback}<div class='sub-desc'><p>a ValueCallback to receive the result of this\n                 request. This object's\n                 onReceiveValue()\n                 method will be invoked asynchronously with a set of\n                 Strings containing the origins for which Geolocation\n                 permissions are stored.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});