Ext.data.JsonP.android_webkit_PermissionRequest({"tagname":"class","name":"android.webkit.PermissionRequest","autodetected":{},"files":[{"filename":"PermissionRequest.js","href":"PermissionRequest.html#android-webkit-PermissionRequest"}],"extends":"java.lang.Object","members":[{"name":"RESOURCE_AUDIO_CAPTURE","tagname":"property","owner":"android.webkit.PermissionRequest","id":"property-RESOURCE_AUDIO_CAPTURE","meta":{}},{"name":"RESOURCE_MIDI_SYSEX","tagname":"property","owner":"android.webkit.PermissionRequest","id":"property-RESOURCE_MIDI_SYSEX","meta":{}},{"name":"RESOURCE_PROTECTED_MEDIA_ID","tagname":"property","owner":"android.webkit.PermissionRequest","id":"property-RESOURCE_PROTECTED_MEDIA_ID","meta":{}},{"name":"RESOURCE_VIDEO_CAPTURE","tagname":"property","owner":"android.webkit.PermissionRequest","id":"property-RESOURCE_VIDEO_CAPTURE","meta":{}},{"name":"deny","tagname":"method","owner":"android.webkit.PermissionRequest","id":"method-deny","meta":{}},{"name":"getOrigin","tagname":"method","owner":"android.webkit.PermissionRequest","id":"method-getOrigin","meta":{}},{"name":"getResources","tagname":"method","owner":"android.webkit.PermissionRequest","id":"method-getResources","meta":{}},{"name":"grant","tagname":"method","owner":"android.webkit.PermissionRequest","id":"method-grant","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-android.webkit.PermissionRequest","short_doc":"This class defines a permission request and is used when web content\n requests access to protected resources. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.webkit.PermissionRequest</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/PermissionRequest.html#android-webkit-PermissionRequest' target='_blank'>PermissionRequest.js</a></div></pre><div class='doc-contents'><p>This class defines a permission request and is used when web content\n requests access to protected resources. The permission request related events\n are delivered via <a href=\"#!/api/android.webkit.WebChromeClient-method-onPermissionRequest\" rel=\"android.webkit.WebChromeClient-method-onPermissionRequest\" class=\"docClass\">android.webkit.WebChromeClient.onPermissionRequest</a> and\n <a href=\"#!/api/android.webkit.WebChromeClient-method-onPermissionRequestCanceled\" rel=\"android.webkit.WebChromeClient-method-onPermissionRequestCanceled\" class=\"docClass\">android.webkit.WebChromeClient.onPermissionRequestCanceled</a>.</p>\n\n<p> Either grant() or <a href=\"#!/api/android.webkit.PermissionRequest-method-deny\" rel=\"android.webkit.PermissionRequest-method-deny\" class=\"docClass\">deny</a>() must be called in UI\n thread to respond to the request.</p>\n\n<p> New protected resources whose names are not defined here may be requested in\n future versions of WebView, even when running on an older Android release. To\n avoid unintentionally granting requests for new permissions, you should pass the\n specific permissions you intend to grant to grant(),\n and avoid writing code like this example:</p>\n\n<pre> permissionRequest.grant(permissionRequest.getResources())  // This is wrong!!!\n </pre>\n\n\n<p> See the WebView's release notes for information about new protected resources.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-RESOURCE_AUDIO_CAPTURE' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.PermissionRequest'>android.webkit.PermissionRequest</span><br/><a href='source/PermissionRequest.html#android-webkit-PermissionRequest-property-RESOURCE_AUDIO_CAPTURE' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.PermissionRequest-property-RESOURCE_AUDIO_CAPTURE' class='name expandable'>RESOURCE_AUDIO_CAPTURE</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Resource belongs to audio capture device, like microphone. ...</div><div class='long'><p>Resource belongs to audio capture device, like microphone.</p>\n<p>Defaults to: <code>&quot;android.webkit.resource.AUDIO_CAPTURE&quot;</code></p></div></div></div><div id='property-RESOURCE_MIDI_SYSEX' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.PermissionRequest'>android.webkit.PermissionRequest</span><br/><a href='source/PermissionRequest.html#android-webkit-PermissionRequest-property-RESOURCE_MIDI_SYSEX' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.PermissionRequest-property-RESOURCE_MIDI_SYSEX' class='name expandable'>RESOURCE_MIDI_SYSEX</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Resource will allow sysex messages to be sent to or received from MIDI devices. ...</div><div class='long'><p>Resource will allow sysex messages to be sent to or received from MIDI devices. These\nmessages are privileged operations, e.g. modifying sound libraries and sampling data, or\neven updating the MIDI device's firmware.</p>\n\n<p>Permission may be requested for this resource in API levels 21 and above, if the Android\ndevice has been updated to WebView 45 or above.</p>\n<p>Defaults to: <code>&quot;android.webkit.resource.MIDI_SYSEX&quot;</code></p></div></div></div><div id='property-RESOURCE_PROTECTED_MEDIA_ID' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.PermissionRequest'>android.webkit.PermissionRequest</span><br/><a href='source/PermissionRequest.html#android-webkit-PermissionRequest-property-RESOURCE_PROTECTED_MEDIA_ID' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.PermissionRequest-property-RESOURCE_PROTECTED_MEDIA_ID' class='name expandable'>RESOURCE_PROTECTED_MEDIA_ID</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Resource belongs to protected media identifier. ...</div><div class='long'><p>Resource belongs to protected media identifier.\nAfter the user grants this resource, the origin can use EME APIs to generate the license\nrequests.</p>\n<p>Defaults to: <code>&quot;android.webkit.resource.PROTECTED_MEDIA_ID&quot;</code></p></div></div></div><div id='property-RESOURCE_VIDEO_CAPTURE' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.PermissionRequest'>android.webkit.PermissionRequest</span><br/><a href='source/PermissionRequest.html#android-webkit-PermissionRequest-property-RESOURCE_VIDEO_CAPTURE' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.PermissionRequest-property-RESOURCE_VIDEO_CAPTURE' class='name expandable'>RESOURCE_VIDEO_CAPTURE</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Resource belongs to video capture device, like camera. ...</div><div class='long'><p>Resource belongs to video capture device, like camera.</p>\n<p>Defaults to: <code>&quot;android.webkit.resource.VIDEO_CAPTURE&quot;</code></p></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-deny' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.PermissionRequest'>android.webkit.PermissionRequest</span><br/><a href='source/PermissionRequest.html#android-webkit-PermissionRequest-method-deny' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.PermissionRequest-method-deny' class='name expandable'>deny</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Call this method to deny the request. ...</div><div class='long'><p>Call this method to deny the request.</p>\n</div></div></div><div id='method-getOrigin' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.PermissionRequest'>android.webkit.PermissionRequest</span><br/><a href='source/PermissionRequest.html#android-webkit-PermissionRequest-method-getOrigin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.PermissionRequest-method-getOrigin' class='name expandable'>getOrigin</a>( <span class='pre'></span> ) : Object {android.net.Uri}<span class=\"signature\"></span></div><div class='description'><div class='short'>Call this method to get the origin of the web page which is trying to access\n the restricted resources. ...</div><div class='long'><p>Call this method to get the origin of the web page which is trying to access\n the restricted resources.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.net.Uri}</span><div class='sub-desc'><p>the origin of web content which attempt to access the restricted\n         resources.</p>\n</div></li></ul></div></div></div><div id='method-getResources' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.PermissionRequest'>android.webkit.PermissionRequest</span><br/><a href='source/PermissionRequest.html#android-webkit-PermissionRequest-method-getResources' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.PermissionRequest-method-getResources' class='name expandable'>getResources</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Call this method to get the resources the web page is trying to access. ...</div><div class='long'><p>Call this method to get the resources the web page is trying to access.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the array of resources the web content wants to access.</p>\n</div></li></ul></div></div></div><div id='method-grant' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.PermissionRequest'>android.webkit.PermissionRequest</span><br/><a href='source/PermissionRequest.html#android-webkit-PermissionRequest-method-grant' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.PermissionRequest-method-grant' class='name expandable'>grant</a>( <span class='pre'>resources</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Call this method to grant origin the permission to access the given resources. ...</div><div class='long'><p>Call this method to grant origin the permission to access the given resources.\n The granted permission is only valid for this WebView.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>resources</span> : Object {java.lang.String[]}<div class='sub-desc'><p>the resources granted to be accessed by origin, to grant\n        request, the requested resources returned by getResources()\n        must be equals or a subset of granted resources.\n        This parameter is designed to avoid granting permission by accident\n        especially when new resources are requested by web content.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});