Ext.data.JsonP.android_webkit_WebStorage({"tagname":"class","name":"android.webkit.WebStorage","autodetected":{},"files":[{"filename":"WebStorage.js","href":"WebStorage.html#android-webkit-WebStorage"}],"extends":"java.lang.Object","members":[{"name":"deleteAllData","tagname":"method","owner":"android.webkit.WebStorage","id":"method-deleteAllData","meta":{}},{"name":"deleteOrigin","tagname":"method","owner":"android.webkit.WebStorage","id":"method-deleteOrigin","meta":{}},{"name":"getInstance","tagname":"method","owner":"android.webkit.WebStorage","id":"method-getInstance","meta":{}},{"name":"getOrigins","tagname":"method","owner":"android.webkit.WebStorage","id":"method-getOrigins","meta":{}},{"name":"getQuotaForOrigin","tagname":"method","owner":"android.webkit.WebStorage","id":"method-getQuotaForOrigin","meta":{}},{"name":"getUsageForOrigin","tagname":"method","owner":"android.webkit.WebStorage","id":"method-getUsageForOrigin","meta":{}},{"name":"setQuotaForOrigin","tagname":"method","owner":"android.webkit.WebStorage","id":"method-setQuotaForOrigin","meta":{"deprecated":{"text":"<p>Controlling quota per-origin will not be supported in future.</p>\n"}}}],"alternateClassNames":[],"aliases":{},"id":"class-android.webkit.WebStorage","short_doc":"This class is used to manage the JavaScript storage APIs provided by the\n android.webkit.WebView. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.webkit.WebStorage</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/WebStorage.html#android-webkit-WebStorage' target='_blank'>WebStorage.js</a></div></pre><div class='doc-contents'><p>This class is used to manage the JavaScript storage APIs provided by the\n <a href=\"#!/api/android.webkit.WebView\" rel=\"android.webkit.WebView\" class=\"docClass\">android.webkit.WebView</a>. It manages the Application Cache API, the Web SQL Database\n API and the HTML5 Web Storage API.</p>\n\n<p> The Application Cache API provides a mechanism to create and maintain an\n application cache to power offline Web applications. Use of the Application\n Cache API can be attributed to an origin <a href=\"#!/api/android.webkit.WebStorage.Origin\" rel=\"android.webkit.WebStorage.Origin\" class=\"docClass\">android.webkit.WebStorage.Origin</a>, however\n it is not possible to set per-origin quotas. Note that there can be only\n one application cache per application.</p>\n\n<p> The Web SQL Database API provides storage which is private to a given origin.\n Similar to the Application Cache, use of the Web SQL Database can be attributed\n to an origin. It is also possible to set per-origin quotas.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-deleteAllData' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebStorage'>android.webkit.WebStorage</span><br/><a href='source/WebStorage.html#android-webkit-WebStorage-method-deleteAllData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebStorage-method-deleteAllData' class='name expandable'>deleteAllData</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Clears all storage currently being used by the JavaScript storage APIs. ...</div><div class='long'><p>Clears all storage currently being used by the JavaScript storage APIs.\n This includes the Application Cache, Web SQL Database and the HTML5 Web\n Storage APIs.</p>\n</div></div></div><div id='method-deleteOrigin' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebStorage'>android.webkit.WebStorage</span><br/><a href='source/WebStorage.html#android-webkit-WebStorage-method-deleteOrigin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebStorage-method-deleteOrigin' class='name expandable'>deleteOrigin</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Clears the storage currently being used by both the Application Cache and\n Web SQL Database APIs by the given origin. ...</div><div class='long'><p>Clears the storage currently being used by both the Application Cache and\n Web SQL Database APIs by the given origin. The origin is specified using\n its string representation.</p>\n</div></div></div><div id='method-getInstance' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebStorage'>android.webkit.WebStorage</span><br/><a href='source/WebStorage.html#android-webkit-WebStorage-method-getInstance' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebStorage-method-getInstance' class='name expandable'>getInstance</a>( <span class='pre'></span> ) : Object {android.webkit.WebStorage}<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets the singleton instance of this class. ...</div><div class='long'><p>Gets the singleton instance of this class.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {android.webkit.WebStorage}</span><div class='sub-desc'><p>the singleton WebStorage instance</p>\n</div></li></ul></div></div></div><div id='method-getOrigins' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebStorage'>android.webkit.WebStorage</span><br/><a href='source/WebStorage.html#android-webkit-WebStorage-method-getOrigins' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebStorage-method-getOrigins' class='name expandable'>getOrigins</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets the origins currently using either the Application Cache or Web SQL\n Database APIs. ...</div><div class='long'><p>Gets the origins currently using either the Application Cache or Web SQL\n Database APIs. This method operates asynchronously, with the result\n being provided via a <a href=\"#!/api/android.webkit.ValueCallback\" rel=\"android.webkit.ValueCallback\" class=\"docClass\">android.webkit.ValueCallback</a>. The origins are provided as\n a map, of type {@code Map&lt;String, WebStorage.Origin>}, from the string\n representation of the origin to a <a href=\"#!/api/android.webkit.WebStorage.Origin\" rel=\"android.webkit.WebStorage.Origin\" class=\"docClass\">android.webkit.WebStorage.Origin</a> object.</p>\n</div></div></div><div id='method-getQuotaForOrigin' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebStorage'>android.webkit.WebStorage</span><br/><a href='source/WebStorage.html#android-webkit-WebStorage-method-getQuotaForOrigin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebStorage-method-getQuotaForOrigin' class='name expandable'>getQuotaForOrigin</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets the storage quota for the Web SQL Database API for the given origin. ...</div><div class='long'><p>Gets the storage quota for the Web SQL Database API for the given origin.\n The quota is given in bytes and the origin is specified using its string\n representation. This method operates asynchronously, with the result\n being provided via a <a href=\"#!/api/android.webkit.ValueCallback\" rel=\"android.webkit.ValueCallback\" class=\"docClass\">android.webkit.ValueCallback</a>. Note that a quota is not\n enforced on a per-origin basis for the Application Cache API.</p>\n</div></div></div><div id='method-getUsageForOrigin' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebStorage'>android.webkit.WebStorage</span><br/><a href='source/WebStorage.html#android-webkit-WebStorage-method-getUsageForOrigin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebStorage-method-getUsageForOrigin' class='name expandable'>getUsageForOrigin</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets the amount of storage currently being used by both the Application\n Cache and Web SQL Database APIs by the given...</div><div class='long'><p>Gets the amount of storage currently being used by both the Application\n Cache and Web SQL Database APIs by the given origin. The amount is given\n in bytes and the origin is specified using its string representation.\n This method operates asynchronously, with the result being provided via\n a <a href=\"#!/api/android.webkit.ValueCallback\" rel=\"android.webkit.ValueCallback\" class=\"docClass\">android.webkit.ValueCallback</a>.</p>\n</div></div></div><div id='method-setQuotaForOrigin' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebStorage'>android.webkit.WebStorage</span><br/><a href='source/WebStorage.html#android-webkit-WebStorage-method-setQuotaForOrigin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebStorage-method-setQuotaForOrigin' class='name expandable'>setQuotaForOrigin</a>( <span class='pre'></span> )<span class=\"signature\"><span class='deprecated' >deprecated</span></span></div><div class='description'><div class='short'>Sets the storage quota for the Web SQL Database API for the given origin. ...</div><div class='long'><p>Sets the storage quota for the Web SQL Database API for the given origin.\n The quota is specified in bytes and the origin is specified using its string\n representation. Note that a quota is not enforced on a per-origin basis\n for the Application Cache API.</p>\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>Controlling quota per-origin will not be supported in future.</p>\n\n        </div>\n</div></div></div></div></div></div></div>","meta":{}});