Ext.data.JsonP.android_webkit_WebViewDatabase({"tagname":"class","name":"android.webkit.WebViewDatabase","autodetected":{},"files":[{"filename":"WebViewDatabase.js","href":"WebViewDatabase.html#android-webkit-WebViewDatabase"}],"extends":"java.lang.Object","members":[{"name":"clearFormData","tagname":"method","owner":"android.webkit.WebViewDatabase","id":"method-clearFormData","meta":{}},{"name":"clearHttpAuthUsernamePassword","tagname":"method","owner":"android.webkit.WebViewDatabase","id":"method-clearHttpAuthUsernamePassword","meta":{}},{"name":"clearUsernamePassword","tagname":"method","owner":"android.webkit.WebViewDatabase","id":"method-clearUsernamePassword","meta":{"deprecated":{"text":"<p>Saving passwords in WebView will not be supported in future versions.</p>\n"}}},{"name":"getInstance","tagname":"method","owner":"android.webkit.WebViewDatabase","id":"method-getInstance","meta":{}},{"name":"hasFormData","tagname":"method","owner":"android.webkit.WebViewDatabase","id":"method-hasFormData","meta":{}},{"name":"hasHttpAuthUsernamePassword","tagname":"method","owner":"android.webkit.WebViewDatabase","id":"method-hasHttpAuthUsernamePassword","meta":{}},{"name":"hasUsernamePassword","tagname":"method","owner":"android.webkit.WebViewDatabase","id":"method-hasUsernamePassword","meta":{"deprecated":{"text":"<p>Saving passwords in WebView will not be supported in future versions.</p>\n"}}}],"alternateClassNames":[],"aliases":{},"id":"class-android.webkit.WebViewDatabase","short_doc":"This class allows developers to determine whether any WebView used in the\n application has stored any of the followin...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.Object<div class='subclass '><strong>android.webkit.WebViewDatabase</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/WebViewDatabase.html#android-webkit-WebViewDatabase' target='_blank'>WebViewDatabase.js</a></div></pre><div class='doc-contents'><p>This class allows developers to determine whether any WebView used in the\n application has stored any of the following types of browsing data and\n to clear any such stored data for all WebViews in the application.\n <ul>\n  <li>Username/password pairs for web forms</li>\n  <li>HTTP authentication username/password pairs</li>\n  <li>Data entered into text fields (e.g. for autocomplete suggestions)</li>\n </ul></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-clearFormData' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebViewDatabase'>android.webkit.WebViewDatabase</span><br/><a href='source/WebViewDatabase.html#android-webkit-WebViewDatabase-method-clearFormData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebViewDatabase-method-clearFormData' class='name expandable'>clearFormData</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Clears any saved data for web forms. ...</div><div class='long'><p>Clears any saved data for web forms.\n@see <a href=\"#!/api/android.webkit.WebViewDatabase-method-hasFormData\" rel=\"android.webkit.WebViewDatabase-method-hasFormData\" class=\"docClass\">hasFormData</a></p>\n</div></div></div><div id='method-clearHttpAuthUsernamePassword' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebViewDatabase'>android.webkit.WebViewDatabase</span><br/><a href='source/WebViewDatabase.html#android-webkit-WebViewDatabase-method-clearHttpAuthUsernamePassword' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebViewDatabase-method-clearHttpAuthUsernamePassword' class='name expandable'>clearHttpAuthUsernamePassword</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Clears any saved credentials for HTTP authentication. ...</div><div class='long'><p>Clears any saved credentials for HTTP authentication.\n@see WebView#getHttpAuthUsernamePassword\n@see WebView#setHttpAuthUsernamePassword\n@see <a href=\"#!/api/android.webkit.WebViewDatabase-method-hasHttpAuthUsernamePassword\" rel=\"android.webkit.WebViewDatabase-method-hasHttpAuthUsernamePassword\" class=\"docClass\">hasHttpAuthUsernamePassword</a></p>\n</div></div></div><div id='method-clearUsernamePassword' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebViewDatabase'>android.webkit.WebViewDatabase</span><br/><a href='source/WebViewDatabase.html#android-webkit-WebViewDatabase-method-clearUsernamePassword' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebViewDatabase-method-clearUsernamePassword' class='name expandable'>clearUsernamePassword</a>( <span class='pre'></span> )<span class=\"signature\"><span class='deprecated' >deprecated</span></span></div><div class='description'><div class='short'>Clears any saved username/password pairs for web forms. ...</div><div class='long'><p>Clears any saved username/password pairs for web forms.\n Note that these are unrelated to HTTP authentication credentials.\n@see WebView#savePassword\n@see <a href=\"#!/api/android.webkit.WebViewDatabase-method-hasUsernamePassword\" rel=\"android.webkit.WebViewDatabase-method-hasUsernamePassword\" class=\"docClass\">hasUsernamePassword</a></p>\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>Saving passwords in WebView will not be supported in future versions.</p>\n\n        </div>\n</div></div></div><div id='method-getInstance' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebViewDatabase'>android.webkit.WebViewDatabase</span><br/><a href='source/WebViewDatabase.html#android-webkit-WebViewDatabase-method-getInstance' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebViewDatabase-method-getInstance' class='name expandable'>getInstance</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-hasFormData' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebViewDatabase'>android.webkit.WebViewDatabase</span><br/><a href='source/WebViewDatabase.html#android-webkit-WebViewDatabase-method-hasFormData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebViewDatabase-method-hasFormData' class='name expandable'>hasFormData</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets whether there is any saved data for web forms. ...</div><div class='long'><p>Gets whether there is any saved data for web forms.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>whether there is any saved data for web forms\n@see <a href=\"#!/api/android.webkit.WebViewDatabase-method-clearFormData\" rel=\"android.webkit.WebViewDatabase-method-clearFormData\" class=\"docClass\">clearFormData</a></p>\n</div></li></ul></div></div></div><div id='method-hasHttpAuthUsernamePassword' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebViewDatabase'>android.webkit.WebViewDatabase</span><br/><a href='source/WebViewDatabase.html#android-webkit-WebViewDatabase-method-hasHttpAuthUsernamePassword' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebViewDatabase-method-hasHttpAuthUsernamePassword' class='name expandable'>hasHttpAuthUsernamePassword</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Gets whether there are any saved credentials for HTTP authentication. ...</div><div class='long'><p>Gets whether there are any saved credentials for HTTP authentication.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>whether there are any saved credentials\n@see WebView#getHttpAuthUsernamePassword\n@see WebView#setHttpAuthUsernamePassword\n@see <a href=\"#!/api/android.webkit.WebViewDatabase-method-clearHttpAuthUsernamePassword\" rel=\"android.webkit.WebViewDatabase-method-clearHttpAuthUsernamePassword\" class=\"docClass\">clearHttpAuthUsernamePassword</a></p>\n</div></li></ul></div></div></div><div id='method-hasUsernamePassword' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='android.webkit.WebViewDatabase'>android.webkit.WebViewDatabase</span><br/><a href='source/WebViewDatabase.html#android-webkit-WebViewDatabase-method-hasUsernamePassword' target='_blank' class='view-source'>view source</a></div><a href='#!/api/android.webkit.WebViewDatabase-method-hasUsernamePassword' class='name expandable'>hasUsernamePassword</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"><span class='deprecated' >deprecated</span></span></div><div class='description'><div class='short'>Gets whether there are any saved username/password pairs for web forms. ...</div><div class='long'><p>Gets whether there are any saved username/password pairs for web forms.\n Note that these are unrelated to HTTP authentication credentials.</p>\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>Saving passwords in WebView will not be supported in future versions.</p>\n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>true if there are any saved username/password pairs\n@see WebView#savePassword\n@see #clearUsernamePassworda</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});