Ext.data.JsonP.java_lang_Appendable({"tagname":"class","name":"java.lang.Appendable","autodetected":{},"files":[{"filename":"Appendable.js","href":"Appendable.html#java-lang-Appendable"}],"members":[{"name":"append","tagname":"method","owner":"java.lang.Appendable","id":"method-append","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.Appendable","short_doc":"Declares methods to append characters or character sequences. ...","classIcon":"icon-class","superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Files</h4><div class='dependency'><a href='source/Appendable.html#java-lang-Appendable' target='_blank'>Appendable.js</a></div></pre><div class='doc-contents'><p>Declares methods to append characters or character sequences. Any class that\n implements this interface can receive data formatted by a\n java.util.Formatter. The appended character or character sequence\n should be valid according to the rules described in\n <a href=\"#!/api/java.lang.Character\" rel=\"java.lang.Character\" class=\"docClass\">Unicode java.lang.Character Representation</a>.\n <p>\n {@code Appendable} itself does not guarantee thread safety. This\n responsibility is up to the implementing class.\n <p>\n Implementing classes can choose different exception handling mechanism. They\n can choose to throw exceptions other than {@code IOException} or they do not\n throw any exceptions at all and use error codes instead.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-append' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Appendable'>java.lang.Appendable</span><br/><a href='source/Appendable.html#java-lang-Appendable-method-append' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Appendable-method-append' class='name expandable'>append</a>( <span class='pre'>csq, start, end</span> ) : Object {java.lang.Appendable}<span class=\"signature\"></span></div><div class='description'><div class='short'>Appends a subsequence of {@code csq}. ...</div><div class='long'><p>Appends a subsequence of {@code csq}.\n <p>\n If {@code csq} is not {@code null} then calling this method is equivalent\n to calling {@code append(csq.subSequence(start, end))}.\n <p>\n If {@code csq} is {@code null}, the characters \"null\" are appended.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>csq</span> : Object {CharSequence}<div class='sub-desc'><p>the character sequence to append.</p>\n</div></li><li><span class='pre'>start</span> : Number<div class='sub-desc'><p>the first index of the subsequence of {@code csq} that is\n            appended.</p>\n</div></li><li><span class='pre'>end</span> : Number<div class='sub-desc'><p>the last index of the subsequence of {@code csq} that is\n            appended.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Appendable}</span><div class='sub-desc'><p>this {@code Appendable}.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IndexOutOfBoundsException\n             if {@code start &lt; 0}, {@code end &lt; 0}, {@code start > end}\n             or {@code end} is greater than the length of {@code csq}.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>IOException\n             if an I/O error occurs.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});