Ext.data.JsonP.java_lang_AutoCloseable({"tagname":"class","name":"java.lang.AutoCloseable","autodetected":{},"files":[{"filename":"AutoCloseable.js","href":"AutoCloseable.html#java-lang-AutoCloseable"}],"since":"1.7","members":[{"name":"close","tagname":"method","owner":"java.lang.AutoCloseable","id":"method-close","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.AutoCloseable","short_doc":"Defines an interface for classes that can (or need to) be closed once they\n are not used any longer. ...","classIcon":"icon-class","superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Files</h4><div class='dependency'><a href='source/AutoCloseable.html#java-lang-AutoCloseable' target='_blank'>AutoCloseable.js</a></div></pre><div class='doc-contents'><p>Defines an interface for classes that can (or need to) be closed once they\n are not used any longer. Calling the {@code close} method releases resources\n that the object holds.</p>\n\n<p> <p>A common pattern for using an {@code AutoCloseable} resource: <pre>   {@code\n   Closable foo = new Foo();\n   try {\n      ...;\n   } finally {\n      foo.close();\n   }\n }</pre></p>\n        <p>Available since: <b>1.7</b></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-close' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.AutoCloseable'>java.lang.AutoCloseable</span><br/><a href='source/AutoCloseable.html#java-lang-AutoCloseable-method-close' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.AutoCloseable-method-close' class='name expandable'>close</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Closes the object and release any system resources it holds. ...</div><div class='long'><p>Closes the object and release any system resources it holds.</p>\n</div></div></div></div></div></div></div>","meta":{}});