Ext.data.JsonP.java_lang_CharSequence({"tagname":"class","name":"java.lang.CharSequence","autodetected":{},"files":[{"filename":"CharSequence.js","href":"CharSequence.html#java-lang-CharSequence"}],"members":[{"name":"charAt","tagname":"method","owner":"java.lang.CharSequence","id":"method-charAt","meta":{}},{"name":"length","tagname":"method","owner":"java.lang.CharSequence","id":"method-length","meta":{}},{"name":"subSequence","tagname":"method","owner":"java.lang.CharSequence","id":"method-subSequence","meta":{}},{"name":"toString","tagname":"method","owner":"java.lang.CharSequence","id":"method-toString","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.CharSequence","classIcon":"icon-class","superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Files</h4><div class='dependency'><a href='source/CharSequence.html#java-lang-CharSequence' target='_blank'>CharSequence.js</a></div></pre><div class='doc-contents'><p>This interface represents an ordered set of characters and defines the\n methods to probe them.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-charAt' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.CharSequence'>java.lang.CharSequence</span><br/><a href='source/CharSequence.html#java-lang-CharSequence-method-charAt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.CharSequence-method-charAt' class='name expandable'>charAt</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the character at {@code index}. ...</div><div class='long'><p>Returns the character at {@code index}.</p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IndexOutOfBoundsException if {@code index &lt; 0} or {@code index >= length()}.</p>\n</div></li></ul></div></div></div><div id='method-length' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.CharSequence'>java.lang.CharSequence</span><br/><a href='source/CharSequence.html#java-lang-CharSequence-method-length' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.CharSequence-method-length' class='name expandable'>length</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the number of characters in this sequence. ...</div><div class='long'><p>Returns the number of characters in this sequence.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>the number of characters.</p>\n</div></li></ul></div></div></div><div id='method-subSequence' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.CharSequence'>java.lang.CharSequence</span><br/><a href='source/CharSequence.html#java-lang-CharSequence-method-subSequence' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.CharSequence-method-subSequence' class='name expandable'>subSequence</a>( <span class='pre'>start, end</span> ) : Object {java.lang.CharSequence}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a {@code CharSequence} from the {@code start} index (inclusive)\n to the {@code end} index (exclusive) of this...</div><div class='long'><p>Returns a {@code CharSequence} from the {@code start} index (inclusive)\n to the {@code end} index (exclusive) of this sequence.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>start</span> : Number<div class='sub-desc'><p>the start offset of the sub-sequence. It is inclusive, that\n            is, the index of the first character that is included in the\n            sub-sequence.</p>\n</div></li><li><span class='pre'>end</span> : Number<div class='sub-desc'><p>the end offset of the sub-sequence. It is exclusive, that is,\n            the index of the first character after those that are included\n            in the sub-sequence</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.CharSequence}</span><div class='sub-desc'><p>the requested sub-sequence.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IndexOutOfBoundsException\n             if {@code start &lt; 0}, {@code end &lt; 0}, {@code start > end},\n             or if {@code start} or {@code end} are greater than the\n             length of this sequence.</p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.CharSequence'>java.lang.CharSequence</span><br/><a href='source/CharSequence.html#java-lang-CharSequence-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.CharSequence-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a string with the same characters in the same order as in this\n sequence. ...</div><div class='long'><p>Returns a string with the same characters in the same order as in this\n sequence.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>a string based on this sequence.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});