Ext.data.JsonP.java_lang_ClassLoader({"tagname":"class","name":"java.lang.ClassLoader","autodetected":{},"files":[{"filename":"ClassLoader.js","href":"ClassLoader.html#java-lang-ClassLoader"}],"extends":"java.lang.Object","members":[{"name":"clearAssertionStatus","tagname":"method","owner":"java.lang.ClassLoader","id":"method-clearAssertionStatus","meta":{}},{"name":"equals","tagname":"method","owner":"java.lang.Object","id":"method-equals","meta":{}},{"name":"getClass","tagname":"method","owner":"java.lang.Object","id":"method-getClass","meta":{}},{"name":"getParent","tagname":"method","owner":"java.lang.ClassLoader","id":"method-getParent","meta":{}},{"name":"getResource","tagname":"method","owner":"java.lang.ClassLoader","id":"method-getResource","meta":{}},{"name":"getResourceAsStream","tagname":"method","owner":"java.lang.ClassLoader","id":"method-getResourceAsStream","meta":{}},{"name":"getResources","tagname":"method","owner":"java.lang.ClassLoader","id":"method-getResources","meta":{}},{"name":"getSystemClassLoader","tagname":"method","owner":"java.lang.ClassLoader","id":"method-getSystemClassLoader","meta":{}},{"name":"getSystemResource","tagname":"method","owner":"java.lang.ClassLoader","id":"method-getSystemResource","meta":{}},{"name":"getSystemResourceAsStream","tagname":"method","owner":"java.lang.ClassLoader","id":"method-getSystemResourceAsStream","meta":{}},{"name":"getSystemResources","tagname":"method","owner":"java.lang.ClassLoader","id":"method-getSystemResources","meta":{}},{"name":"hashCode","tagname":"method","owner":"java.lang.Object","id":"method-hashCode","meta":{}},{"name":"loadClass","tagname":"method","owner":"java.lang.ClassLoader","id":"method-loadClass","meta":{}},{"name":"notify","tagname":"method","owner":"java.lang.Object","id":"method-notify","meta":{}},{"name":"notifyAll","tagname":"method","owner":"java.lang.Object","id":"method-notifyAll","meta":{}},{"name":"setClassAssertionStatus","tagname":"method","owner":"java.lang.ClassLoader","id":"method-setClassAssertionStatus","meta":{}},{"name":"setDefaultAssertionStatus","tagname":"method","owner":"java.lang.ClassLoader","id":"method-setDefaultAssertionStatus","meta":{}},{"name":"setPackageAssertionStatus","tagname":"method","owner":"java.lang.ClassLoader","id":"method-setPackageAssertionStatus","meta":{}},{"name":"toString","tagname":"method","owner":"java.lang.Object","id":"method-toString","meta":{}},{"name":"wait","tagname":"method","owner":"java.lang.Object","id":"method-wait","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.ClassLoader","short_doc":"Loads classes and resources from a repository. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='docClass'>java.lang.Object</a><div class='subclass '><strong>java.lang.ClassLoader</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/ClassLoader.html#java-lang-ClassLoader' target='_blank'>ClassLoader.js</a></div></pre><div class='doc-contents'><p>Loads classes and resources from a repository. One or more class loaders are\n installed at runtime. These are consulted whenever the runtime system needs a\n specific class that is not yet available in-memory. Typically, class loaders\n are grouped into a tree where child class loaders delegate all requests to\n parent class loaders. Only if the parent class loader cannot satisfy the\n request, the child class loader itself tries to handle it.\n <p>\n {@code ClassLoader} is an abstract class that implements the common\n infrastructure required by all class loaders. Android provides several\n concrete implementations of the class, with\n dalvik.system.PathClassLoader being the one typically used. Other\n applications may implement subclasses of {@code ClassLoader} to provide\n special ways for loading classes.\n </p>\n @see Class</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-clearAssertionStatus' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-clearAssertionStatus' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-clearAssertionStatus' class='name expandable'>clearAssertionStatus</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Sets the default assertion status for this class loader to {@code false}\n and removes any package default and class a...</div><div class='long'><p>Sets the default assertion status for this class loader to {@code false}\n and removes any package default and class assertion status settings.\n <p>\n <strong>Note:</strong> This method does nothing in the Android reference\n implementation.\n </p></p>\n</div></div></div><div id='method-equals' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-equals' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-equals' class='name expandable'>equals</a>( <span class='pre'>o</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Compares this instance with the specified object and indicates if they\n are equal. ...</div><div class='long'><p>Compares this instance with the specified object and indicates if they\n are equal. In order to be equal, {@code o} must represent the same object\n as this instance using a class-specific comparison. The general contract\n is that this comparison should be reflexive, symmetric, and transitive.\n Also, no object reference other than null is equal to null.</p>\n\n<p> <p>The default implementation returns {@code true} only if {@code this ==\n o}. See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_equals\">Writing a correct\n {@code equals} method</a>\n if you intend implementing your own {@code equals} method.</p>\n\n<p> <p>The general contract for the {@code equals} and <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a>() methods is that if {@code equals} returns {@code true} for\n any two objects, then {@code hashCode()} must return the same value for\n these objects. This means that subclasses of {@code Object} usually\n override either both methods or neither of them.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>o</span> : Object {Object}<div class='sub-desc'><p>the object to compare this instance with.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the specified object is equal to this {@code\n         Object}; {@code false} otherwise.\n@see <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a></p>\n</div></li></ul></div></div></div><div id='method-getClass' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-getClass' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-getClass' class='name expandable'>getClass</a>( <span class='pre'></span> ) : Object {java.lang.Class}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the unique instance of java.lang.Class that represents this\n object's class. ...</div><div class='long'><p>Returns the unique instance of <a href=\"#!/api/java.lang.Class\" rel=\"java.lang.Class\" class=\"docClass\">java.lang.Class</a> that represents this\n object's class. Note that {@code getClass()} is a special case in that it\n actually returns {@code Class&lt;? extends Foo>} where {@code Foo} is the\n erasure of the type of the expression {@code getClass()} was called upon.\n <p>\n As an example, the following code actually compiles, although one might\n think it shouldn't:\n <p>\n <pre>{@code\n   List<Integer> l = new ArrayList<Integer>();\n   Class&lt;? extends List> c = l.getClass();}</Integer></Integer></pre></p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Class}</span><div class='sub-desc'><p>this object's {@code Class} instance.</p>\n</div></li></ul></div></div></div><div id='method-getParent' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-getParent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-getParent' class='name expandable'>getParent</a>( <span class='pre'></span> ) : Object {java.lang.ClassLoader}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns this class loader's parent. ...</div><div class='long'><p>Returns this class loader's parent.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.ClassLoader}</span><div class='sub-desc'><p>this class loader's parent or {@code null}.</p>\n</div></li></ul></div></div></div><div id='method-getResource' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-getResource' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-getResource' class='name expandable'>getResource</a>( <span class='pre'>resName</span> ) : Object {java.net.URL}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the URL of the resource with the specified name. ...</div><div class='long'><p>Returns the URL of the resource with the specified name. This\n implementation first tries to use the parent class loader to find the\n resource; if this fails then findResource(String) is called to\n find the requested resource.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>resName</span> : String<div class='sub-desc'><p>the name of the resource to find.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.net.URL}</span><div class='sub-desc'><p>the {@code URL} object for the requested resource or {@code null}\n         if the resource can not be found\n@see Class#getResource</p>\n</div></li></ul></div></div></div><div id='method-getResourceAsStream' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-getResourceAsStream' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-getResourceAsStream' class='name expandable'>getResourceAsStream</a>( <span class='pre'>resName, resName</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a stream for the resource with the specified name. ...</div><div class='long'><p>Returns a stream for the resource with the specified name. See\n <a href=\"#!/api/java.lang.ClassLoader-method-getResource\" rel=\"java.lang.ClassLoader-method-getResource\" class=\"docClass\">getResource</a>(String) for a description of the lookup algorithm\n used to find the resource.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>resName</span> : String<div class='sub-desc'><p>the name of the resource to find.</p>\n</div></li><li><span class='pre'>resName</span> : Object<div class='sub-desc'><p>the name of the resource to find.\n@see Class#getResourceAsStream</p>\n</div></li></ul></div></div></div><div id='method-getResources' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-getResources' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-getResources' class='name expandable'>getResources</a>( <span class='pre'>resName, resName</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns an enumeration of URLs for the resource with the specified name. ...</div><div class='long'><p>Returns an enumeration of URLs for the resource with the specified name.\n This implementation first uses this class loader's parent to find the\n resource, then it calls findResources(String) to get additional\n URLs. The returned enumeration contains the {@code URL} objects of both\n find operations.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>resName</span> : String<div class='sub-desc'><p>the name of the resource to find.</p>\n</div></li><li><span class='pre'>resName</span> : Object<div class='sub-desc'><p>the name of the resource to find.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IOException\n             if an I/O error occurs.</p>\n</div></li></ul></div></div></div><div id='method-getSystemClassLoader' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-getSystemClassLoader' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-getSystemClassLoader' class='name expandable'>getSystemClassLoader</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the system class loader. ...</div><div class='long'><p>Returns the system class loader. This is the parent for new\n {@code ClassLoader} instances and is typically the class loader used to\n start the application.</p>\n</div></div></div><div id='method-getSystemResource' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-getSystemResource' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-getSystemResource' class='name expandable'>getSystemResource</a>( <span class='pre'>resName, resName</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Finds the URL of the resource with the specified name. ...</div><div class='long'><p>Finds the URL of the resource with the specified name. The system class\n loader's resource lookup algorithm is used to find the resource.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>resName</span> : String<div class='sub-desc'><p>the name of the resource to find.</p>\n</div></li><li><span class='pre'>resName</span> : Object<div class='sub-desc'><p>the name of the resource to find.\n@see Class#getResource</p>\n</div></li></ul></div></div></div><div id='method-getSystemResourceAsStream' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-getSystemResourceAsStream' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-getSystemResourceAsStream' class='name expandable'>getSystemResourceAsStream</a>( <span class='pre'>resName, resName</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a stream for the resource with the specified name. ...</div><div class='long'><p>Returns a stream for the resource with the specified name. The system\n class loader's resource lookup algorithm is used to find the resource.\n Basically, the contents of the java.class.path are searched in order,\n looking for a path which matches the specified resource.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>resName</span> : String<div class='sub-desc'><p>the name of the resource to find.</p>\n</div></li><li><span class='pre'>resName</span> : Object<div class='sub-desc'><p>the name of the resource to find.\n@see Class#getResourceAsStream</p>\n</div></li></ul></div></div></div><div id='method-getSystemResources' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-getSystemResources' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-getSystemResources' class='name expandable'>getSystemResources</a>( <span class='pre'>resName, resName</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns an enumeration of URLs for the resource with the specified name. ...</div><div class='long'><p>Returns an enumeration of URLs for the resource with the specified name.\n The system class loader's resource lookup algorithm is used to find the\n resource.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>resName</span> : String<div class='sub-desc'><p>the name of the resource to find.</p>\n</div></li><li><span class='pre'>resName</span> : Object<div class='sub-desc'><p>the name of the resource to find.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IOException\n             if an I/O error occurs.</p>\n</div></li></ul></div></div></div><div id='method-hashCode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-hashCode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-hashCode' class='name expandable'>hashCode</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns an integer hash code for this object. ...</div><div class='long'><p>Returns an integer hash code for this object. By contract, any two\n objects for which <a href=\"#!/api/java.lang.Object-method-equals\" rel=\"java.lang.Object-method-equals\" class=\"docClass\">equals</a> returns {@code true} must return\n the same hash code value. This means that subclasses of {@code Object}\n usually override both methods or neither method.</p>\n\n<p> <p>Note that hash values must not change over time unless information used in equals\n comparisons also changes.</p>\n\n<p> <p>See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_hashCode\">Writing a correct\n {@code hashCode} method</a>\n if you intend implementing your own {@code hashCode} method.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>this object's hash code.\n@see <a href=\"#!/api/java.lang.Object-method-equals\" rel=\"java.lang.Object-method-equals\" class=\"docClass\">equals</a></p>\n</div></li></ul></div></div></div><div id='method-loadClass' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-loadClass' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-loadClass' class='name expandable'>loadClass</a>( <span class='pre'>className, className</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Loads the class with the specified name. ...</div><div class='long'><p>Loads the class with the specified name. Invoking this method is\n equivalent to calling {@code loadClass(className, false)}.\n <p>\n <strong>Note:</strong> In the Android reference implementation, the\n second parameter of boolean) is ignored\n anyway.\n </p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>className</span> : String<div class='sub-desc'><p>the name of the class to look for.</p>\n</div></li><li><span class='pre'>className</span> : Object<div class='sub-desc'><p>the name of the class to look for.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>ClassNotFoundException\n             if the class can not be found.</p>\n</div></li></ul></div></div></div><div id='method-notify' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notify' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notify' class='name expandable'>notify</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to...</div><div class='long'><p>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to be woken up. If more than\n one thread is waiting, one of them is chosen at the discretion of the\n VM. The chosen thread will not run immediately. The thread\n that called {@code notify()} has to release the object's monitor first.\n Also, the chosen thread still has to compete against other threads that\n try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></div></div><div id='method-notifyAll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notifyAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notifyAll' class='name expandable'>notifyAll</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods...</div><div class='long'><p>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods) to be woken up. The threads\n will not run immediately. The thread that called {@code notify()} has to\n release the object's monitor first. Also, the threads still have to\n compete against other threads that try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul></p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div><div id='method-setClassAssertionStatus' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-setClassAssertionStatus' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-setClassAssertionStatus' class='name expandable'>setClassAssertionStatus</a>( <span class='pre'>cname, enable</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Sets the assertion status of the class with the specified name. ...</div><div class='long'><p>Sets the assertion status of the class with the specified name.\n <p>\n <strong>Note: </strong>This method does nothing in the Android reference\n implementation.\n </p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>cname</span> : String<div class='sub-desc'><p>the name of the class for which to set the assertion status.</p>\n</div></li><li><span class='pre'>enable</span> : Boolean<div class='sub-desc'><p>the new assertion status.</p>\n</div></li></ul></div></div></div><div id='method-setDefaultAssertionStatus' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-setDefaultAssertionStatus' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-setDefaultAssertionStatus' class='name expandable'>setDefaultAssertionStatus</a>( <span class='pre'>enable</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Sets the default assertion status for this class loader. ...</div><div class='long'><p>Sets the default assertion status for this class loader.\n <p>\n <strong>Note: </strong>This method does nothing in the Android reference\n implementation.\n </p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>enable</span> : Boolean<div class='sub-desc'><p>the new assertion status.</p>\n</div></li></ul></div></div></div><div id='method-setPackageAssertionStatus' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassLoader'>java.lang.ClassLoader</span><br/><a href='source/ClassLoader.html#java-lang-ClassLoader-method-setPackageAssertionStatus' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassLoader-method-setPackageAssertionStatus' class='name expandable'>setPackageAssertionStatus</a>( <span class='pre'>pname, enable</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Sets the assertion status of the package with the specified name. ...</div><div class='long'><p>Sets the assertion status of the package with the specified name.\n <p>\n <strong>Note: </strong>This method does nothing in the Android reference\n implementation.\n </p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>pname</span> : String<div class='sub-desc'><p>the name of the package for which to set the assertion status.</p>\n</div></li><li><span class='pre'>enable</span> : Boolean<div class='sub-desc'><p>the new assertion status.</p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a string containing a concise, human-readable description of this\n object. ...</div><div class='long'><p>Returns a string containing a concise, human-readable description of this\n object. Subclasses are encouraged to override this method and provide an\n implementation that takes into account the object's type and data. The\n default implementation is equivalent to the following expression:</p>\n\n<pre>   getClass().getName() + '@' + Integer.toHexString(hashCode())</pre>\n\n\n<p> <p>See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_toString\">Writing a useful\n {@code toString} method</a>\n if you intend implementing your own {@code toString} method.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>a printable representation of this object.</p>\n</div></li></ul></div></div></div><div id='method-wait' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-wait' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-wait' class='name expandable'>wait</a>( <span class='pre'>millis, nanos</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of t...</div><div class='long'><p>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of this object or until the\n specified timeout expires. This method can only be invoked by a thread\n that owns this object's monitor; see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>() on how a thread\n can become the owner of a monitor.</p>\n\n<p> <p>A waiting thread can be sent {@code interrupt()} to cause it to\n prematurely stop waiting, so {@code wait} should be called in a loop to\n check that the condition that has been waited for has been met before\n continuing.</p>\n\n<p> <p>While the thread waits, it gives up ownership of this object's\n monitor. When it is notified (or interrupted), it re-acquires the monitor\n before it starts running.</p>\n\n<p> <p>A timeout of zero means the calling thread should wait forever unless interrupted or\n notified.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>millis</span> : Number<div class='sub-desc'><p>the maximum time to wait in milliseconds.</p>\n</div></li><li><span class='pre'>nanos</span> : Number<div class='sub-desc'><p>the fraction of a millisecond to wait, specified in\n            nanoseconds.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalArgumentException\n             if {@code millis &lt; 0}, {@code nanos &lt; 0} or {@code nanos >\n             999999}.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>InterruptedException if the current thread has been interrupted.\n             The interrupted status of the current thread will be cleared before the exception\n             is thrown.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});