Ext.data.JsonP.java_lang_ClassNotFoundException({"tagname":"class","name":"java.lang.ClassNotFoundException","autodetected":{},"files":[{"filename":"ClassNotFoundException.js","href":"ClassNotFoundException.html#java-lang-ClassNotFoundException"}],"extends":"java.lang.ReflectiveOperationException","members":[{"name":"addSuppressed","tagname":"method","owner":"java.lang.Throwable","id":"method-addSuppressed","meta":{}},{"name":"equals","tagname":"method","owner":"java.lang.Object","id":"method-equals","meta":{}},{"name":"fillInStackTrace","tagname":"method","owner":"java.lang.Throwable","id":"method-fillInStackTrace","meta":{}},{"name":"getCause","tagname":"method","owner":"java.lang.ClassNotFoundException","id":"method-getCause","meta":{}},{"name":"getClass","tagname":"method","owner":"java.lang.Object","id":"method-getClass","meta":{}},{"name":"getException","tagname":"method","owner":"java.lang.ClassNotFoundException","id":"method-getException","meta":{}},{"name":"getLocalizedMessage","tagname":"method","owner":"java.lang.Throwable","id":"method-getLocalizedMessage","meta":{}},{"name":"getMessage","tagname":"method","owner":"java.lang.Throwable","id":"method-getMessage","meta":{}},{"name":"getStackTrace","tagname":"method","owner":"java.lang.Throwable","id":"method-getStackTrace","meta":{}},{"name":"getSuppressed","tagname":"method","owner":"java.lang.Throwable","id":"method-getSuppressed","meta":{}},{"name":"hashCode","tagname":"method","owner":"java.lang.Object","id":"method-hashCode","meta":{}},{"name":"initCause","tagname":"method","owner":"java.lang.Throwable","id":"method-initCause","meta":{}},{"name":"notify","tagname":"method","owner":"java.lang.Object","id":"method-notify","meta":{}},{"name":"notifyAll","tagname":"method","owner":"java.lang.Object","id":"method-notifyAll","meta":{}},{"name":"printStackTrace","tagname":"method","owner":"java.lang.Throwable","id":"method-printStackTrace","meta":{}},{"name":"setStackTrace","tagname":"method","owner":"java.lang.Throwable","id":"method-setStackTrace","meta":{}},{"name":"toString","tagname":"method","owner":"java.lang.Throwable","id":"method-toString","meta":{}},{"name":"wait","tagname":"method","owner":"java.lang.Object","id":"method-wait","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.ClassNotFoundException","classIcon":"icon-class","superclasses":["java.lang.Object","java.lang.Throwable","java.lang.Exception","java.lang.ReflectiveOperationException"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='docClass'>java.lang.Object</a><div class='subclass '><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='docClass'>java.lang.Throwable</a><div class='subclass '><a href='#!/api/java.lang.Exception' rel='java.lang.Exception' class='docClass'>java.lang.Exception</a><div class='subclass '><a href='#!/api/java.lang.ReflectiveOperationException' rel='java.lang.ReflectiveOperationException' class='docClass'>java.lang.ReflectiveOperationException</a><div class='subclass '><strong>java.lang.ClassNotFoundException</strong></div></div></div></div></div><h4>Files</h4><div class='dependency'><a href='source/ClassNotFoundException.html#java-lang-ClassNotFoundException' target='_blank'>ClassNotFoundException.js</a></div></pre><div class='doc-contents'><p>Thrown when a class loader is unable to find a class.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addSuppressed' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='defined-in docClass'>java.lang.Throwable</a><br/><a href='source/Throwable.html#java-lang-Throwable-method-addSuppressed' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Throwable-method-addSuppressed' class='name expandable'>addSuppressed</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Adds {@code throwable} to the list of throwables suppressed by this. ...</div><div class='long'><p>Adds {@code throwable} to the list of throwables suppressed by this. The\n throwable will included when this exception's stack trace is printed.</p>\n        <p>Available since: <b>1.7</b></p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalArgumentException if {@code throwable == this}.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>NullPointerException if {@code throwable == null}.</p>\n</div></li></ul></div></div></div><div id='method-equals' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-equals' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-equals' class='name expandable'>equals</a>( <span class='pre'>o</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Compares this instance with the specified object and indicates if they\n are equal. ...</div><div class='long'><p>Compares this instance with the specified object and indicates if they\n are equal. In order to be equal, {@code o} must represent the same object\n as this instance using a class-specific comparison. The general contract\n is that this comparison should be reflexive, symmetric, and transitive.\n Also, no object reference other than null is equal to null.</p>\n\n<p> <p>The default implementation returns {@code true} only if {@code this ==\n o}. See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_equals\">Writing a correct\n {@code equals} method</a>\n if you intend implementing your own {@code equals} method.</p>\n\n<p> <p>The general contract for the {@code equals} and <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a>() methods is that if {@code equals} returns {@code true} for\n any two objects, then {@code hashCode()} must return the same value for\n these objects. This means that subclasses of {@code Object} usually\n override either both methods or neither of them.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>o</span> : Object {Object}<div class='sub-desc'><p>the object to compare this instance with.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the specified object is equal to this {@code\n         Object}; {@code false} otherwise.\n@see <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a></p>\n</div></li></ul></div></div></div><div id='method-fillInStackTrace' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='defined-in docClass'>java.lang.Throwable</a><br/><a href='source/Throwable.html#java-lang-Throwable-method-fillInStackTrace' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Throwable-method-fillInStackTrace' class='name expandable'>fillInStackTrace</a>( <span class='pre'></span> ) : Object {java.lang.Throwable}<span class=\"signature\"></span></div><div class='description'><div class='short'>Records the stack trace from the point where this method has been called\n to this {@code Throwable}. ...</div><div class='long'><p>Records the stack trace from the point where this method has been called\n to this {@code Throwable}. This method is invoked by the {@code Throwable} constructors.</p>\n\n<p> <p>This method is public so that code (such as an RPC system) which catches\n a {@code Throwable} and then re-throws it can replace the construction-time stack trace\n with a stack trace from the location where the exception was re-thrown, by <i>calling</i>\n {@code fillInStackTrace}.</p>\n\n<p> <p>This method is non-final so that non-Java language implementations can disable VM stack\n traces for their language. Filling in the stack trace is relatively expensive.\n <i>Overriding</i> this method in the root of a language's exception hierarchy allows the\n language to avoid paying for something it doesn't need.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Throwable}</span><div class='sub-desc'><p>this {@code Throwable} instance.</p>\n</div></li></ul></div></div></div><div id='method-getCause' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassNotFoundException'>java.lang.ClassNotFoundException</span><br/><a href='source/ClassNotFoundException.html#java-lang-ClassNotFoundException-method-getCause' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassNotFoundException-method-getCause' class='name expandable'>getCause</a>( <span class='pre'></span> ) : Object {java.lang.Throwable}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the cause of this Throwable, or {@code null} if there is no\n cause. ...</div><div class='long'><p>Returns the cause of this Throwable, or {@code null} if there is no\n cause.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Throwable}</span><div class='sub-desc'><p>Throwable the receiver's cause.</p>\n</div></li></ul><p>Overrides: <a href=\"#!/api/java.lang.Throwable-method-getCause\" rel=\"java.lang.Throwable-method-getCause\" class=\"docClass\">java.lang.Throwable.getCause</a></p></div></div></div><div id='method-getClass' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-getClass' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-getClass' class='name expandable'>getClass</a>( <span class='pre'></span> ) : Object {java.lang.Class}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the unique instance of java.lang.Class that represents this\n object's class. ...</div><div class='long'><p>Returns the unique instance of <a href=\"#!/api/java.lang.Class\" rel=\"java.lang.Class\" class=\"docClass\">java.lang.Class</a> that represents this\n object's class. Note that {@code getClass()} is a special case in that it\n actually returns {@code Class&lt;? extends Foo>} where {@code Foo} is the\n erasure of the type of the expression {@code getClass()} was called upon.\n <p>\n As an example, the following code actually compiles, although one might\n think it shouldn't:\n <p>\n <pre>{@code\n   List<Integer> l = new ArrayList<Integer>();\n   Class&lt;? extends List> c = l.getClass();}</Integer></Integer></pre></p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Class}</span><div class='sub-desc'><p>this object's {@code Class} instance.</p>\n</div></li></ul></div></div></div><div id='method-getException' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.ClassNotFoundException'>java.lang.ClassNotFoundException</span><br/><a href='source/ClassNotFoundException.html#java-lang-ClassNotFoundException-method-getException' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.ClassNotFoundException-method-getException' class='name expandable'>getException</a>( <span class='pre'></span> ) : Object {java.lang.Throwable}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the exception which occurred when loading the class. ...</div><div class='long'><p>Returns the exception which occurred when loading the class.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Throwable}</span><div class='sub-desc'><p>Throwable the exception which occurred while loading the class.</p>\n</div></li></ul></div></div></div><div id='method-getLocalizedMessage' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='defined-in docClass'>java.lang.Throwable</a><br/><a href='source/Throwable.html#java-lang-Throwable-method-getLocalizedMessage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Throwable-method-getLocalizedMessage' class='name expandable'>getLocalizedMessage</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the detail message which was provided when this\n {@code Throwable} was created. ...</div><div class='long'><p>Returns the detail message which was provided when this\n {@code Throwable} was created. Returns {@code null} if no message was\n provided at creation time. Subclasses may override this method to return\n localized text for the message. Android returns the regular detail message.</p>\n</div></div></div><div id='method-getMessage' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='defined-in docClass'>java.lang.Throwable</a><br/><a href='source/Throwable.html#java-lang-Throwable-method-getMessage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Throwable-method-getMessage' class='name expandable'>getMessage</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the detail message which was provided when this\n {@code Throwable} was created. ...</div><div class='long'><p>Returns the detail message which was provided when this\n {@code Throwable} was created. Returns {@code null} if no message was\n provided at creation time.</p>\n</div></div></div><div id='method-getStackTrace' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='defined-in docClass'>java.lang.Throwable</a><br/><a href='source/Throwable.html#java-lang-Throwable-method-getStackTrace' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Throwable-method-getStackTrace' class='name expandable'>getStackTrace</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a clone of the array of stack trace elements of this {@code Throwable}. ...</div><div class='long'><p>Returns a clone of the array of stack trace elements of this {@code Throwable}. Each\n {@code StackTraceElement} represents an entry in the call stack. The\n element at position 0 is the top of the stack, that is, the stack frame\n where this {@code Throwable} is thrown.\n@see <a href=\"#!/api/java.lang.Throwable-method-printStackTrace\" rel=\"java.lang.Throwable-method-printStackTrace\" class=\"docClass\">printStackTrace</a>()</p>\n</div></div></div><div id='method-getSuppressed' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='defined-in docClass'>java.lang.Throwable</a><br/><a href='source/Throwable.html#java-lang-Throwable-method-getSuppressed' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Throwable-method-getSuppressed' class='name expandable'>getSuppressed</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the throwables suppressed by this. ...</div><div class='long'><p>Returns the throwables suppressed by this.</p>\n        <p>Available since: <b>1.7</b></p>\n</div></div></div><div id='method-hashCode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-hashCode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-hashCode' class='name expandable'>hashCode</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns an integer hash code for this object. ...</div><div class='long'><p>Returns an integer hash code for this object. By contract, any two\n objects for which <a href=\"#!/api/java.lang.Object-method-equals\" rel=\"java.lang.Object-method-equals\" class=\"docClass\">equals</a> returns {@code true} must return\n the same hash code value. This means that subclasses of {@code Object}\n usually override both methods or neither method.</p>\n\n<p> <p>Note that hash values must not change over time unless information used in equals\n comparisons also changes.</p>\n\n<p> <p>See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_hashCode\">Writing a correct\n {@code hashCode} method</a>\n if you intend implementing your own {@code hashCode} method.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>this object's hash code.\n@see <a href=\"#!/api/java.lang.Object-method-equals\" rel=\"java.lang.Object-method-equals\" class=\"docClass\">equals</a></p>\n</div></li></ul></div></div></div><div id='method-initCause' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='defined-in docClass'>java.lang.Throwable</a><br/><a href='source/Throwable.html#java-lang-Throwable-method-initCause' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Throwable-method-initCause' class='name expandable'>initCause</a>( <span class='pre'>throwable</span> ) : Object {java.lang.Throwable}<span class=\"signature\"></span></div><div class='description'><div class='short'>Initializes the cause of this {@code Throwable}. ...</div><div class='long'><p>Initializes the cause of this {@code Throwable}. The cause can only be\n initialized once.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>throwable</span> : Object {Throwable}<div class='sub-desc'><p>the cause of this {@code Throwable}.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Throwable}</span><div class='sub-desc'><p>this {@code Throwable} instance.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalArgumentException\n             if {@code Throwable} is this object.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalStateException\n             if the cause has already been initialized.</p>\n</div></li></ul></div></div></div><div id='method-notify' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notify' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notify' class='name expandable'>notify</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to...</div><div class='long'><p>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to be woken up. If more than\n one thread is waiting, one of them is chosen at the discretion of the\n VM. The chosen thread will not run immediately. The thread\n that called {@code notify()} has to release the object's monitor first.\n Also, the chosen thread still has to compete against other threads that\n try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></div></div><div id='method-notifyAll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notifyAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notifyAll' class='name expandable'>notifyAll</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods...</div><div class='long'><p>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods) to be woken up. The threads\n will not run immediately. The thread that called {@code notify()} has to\n release the object's monitor first. Also, the threads still have to\n compete against other threads that try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul></p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div><div id='method-printStackTrace' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='defined-in docClass'>java.lang.Throwable</a><br/><a href='source/Throwable.html#java-lang-Throwable-method-printStackTrace' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Throwable-method-printStackTrace' class='name expandable'>printStackTrace</a>( <span class='pre'>err</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Writes a printable representation of this {@code Throwable}'s stack trace\n to the specified print writer. ...</div><div class='long'><p>Writes a printable representation of this {@code Throwable}'s stack trace\n to the specified print writer. If the {@code Throwable} contains a\n cause, the method will be invoked recursively for the\n nested {@code Throwable}.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>err</span> : Object {PrintWriter}<div class='sub-desc'><p>the writer to write the stack trace on.</p>\n</div></li></ul></div></div></div><div id='method-setStackTrace' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='defined-in docClass'>java.lang.Throwable</a><br/><a href='source/Throwable.html#java-lang-Throwable-method-setStackTrace' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Throwable-method-setStackTrace' class='name expandable'>setStackTrace</a>( <span class='pre'>trace</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Sets the array of stack trace elements. ...</div><div class='long'><p>Sets the array of stack trace elements. Each {@code StackTraceElement}\n represents an entry in the call stack. A copy of the specified array is\n stored in this {@code Throwable}. will be returned by {@code\n getStackTrace()} and printed by {@code printStackTrace()}.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>trace</span> : Object {java.lang.StackTraceElement[]}<div class='sub-desc'><p>the new array of {@code StackTraceElement}s. A copy of the\n            array is stored in this {@code Throwable}, so subsequent\n            changes to {@code trace} will not change the call stack stored\n            in this {@code Throwable}.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>NullPointerException\n             if any element in {@code trace} is {@code null}.\n@see <a href=\"#!/api/java.lang.Throwable-method-printStackTrace\" rel=\"java.lang.Throwable-method-printStackTrace\" class=\"docClass\">printStackTrace</a>()</p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='defined-in docClass'>java.lang.Throwable</a><br/><a href='source/Throwable.html#java-lang-Throwable-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Throwable-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Overrides: <a href=\"#!/api/java.lang.Object-method-toString\" rel=\"java.lang.Object-method-toString\" class=\"docClass\">java.lang.Object.toString</a></p></div></div></div><div id='method-wait' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-wait' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-wait' class='name expandable'>wait</a>( <span class='pre'>millis, nanos</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of t...</div><div class='long'><p>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of this object or until the\n specified timeout expires. This method can only be invoked by a thread\n that owns this object's monitor; see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>() on how a thread\n can become the owner of a monitor.</p>\n\n<p> <p>A waiting thread can be sent {@code interrupt()} to cause it to\n prematurely stop waiting, so {@code wait} should be called in a loop to\n check that the condition that has been waited for has been met before\n continuing.</p>\n\n<p> <p>While the thread waits, it gives up ownership of this object's\n monitor. When it is notified (or interrupted), it re-acquires the monitor\n before it starts running.</p>\n\n<p> <p>A timeout of zero means the calling thread should wait forever unless interrupted or\n notified.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>millis</span> : Number<div class='sub-desc'><p>the maximum time to wait in milliseconds.</p>\n</div></li><li><span class='pre'>nanos</span> : Number<div class='sub-desc'><p>the fraction of a millisecond to wait, specified in\n            nanoseconds.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalArgumentException\n             if {@code millis &lt; 0}, {@code nanos &lt; 0} or {@code nanos >\n             999999}.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>InterruptedException if the current thread has been interrupted.\n             The interrupted status of the current thread will be cleared before the exception\n             is thrown.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});