Ext.data.JsonP.java_lang_Comparable({"tagname":"class","name":"java.lang.Comparable","autodetected":{},"files":[{"filename":"Comparable.js","href":"Comparable.html#java-lang-Comparable"}],"members":[{"name":"compareTo","tagname":"method","owner":"java.lang.Comparable","id":"method-compareTo","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.Comparable","short_doc":"This interface should be implemented by all classes that wish to define a\n natural order of their instances. ...","classIcon":"icon-class","superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Files</h4><div class='dependency'><a href='source/Comparable.html#java-lang-Comparable' target='_blank'>Comparable.js</a></div></pre><div class='doc-contents'><p>This interface should be implemented by all classes that wish to define a\n <em>natural order</em> of their instances.\n java.util.Collections.sort and {@code java.util.Arrays#sort} can then\n be used to automatically sort lists of classes that implement this interface.\n <p>\n The order rule must be both transitive (if {@code x.compareTo(y) &lt; 0} and\n {@code y.compareTo(z) &lt; 0}, then {@code x.compareTo(z) &lt; 0} must hold) and\n invertible (the sign of the result of x.compareTo(y) must be equal to the\n negation of the sign of the result of y.compareTo(x) for all combinations of\n x and y).\n <p>\n In addition, it is recommended (but not required) that if and only if the\n result of x.compareTo(y) is zero, then the result of x.equals(y) should be\n {@code true}.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-compareTo' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Comparable'>java.lang.Comparable</span><br/><a href='source/Comparable.html#java-lang-Comparable-method-compareTo' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Comparable-method-compareTo' class='name expandable'>compareTo</a>( <span class='pre'>another</span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Compares this object to the specified object to determine their relative\n order. ...</div><div class='long'><p>Compares this object to the specified object to determine their relative\n order.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>another</span> : Object {Object}<div class='sub-desc'><p>the object to compare to this instance.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>a negative integer if this instance is less than {@code another};\n         a positive integer if this instance is greater than\n         {@code another}; 0 if this instance has the same order as\n         {@code another}.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>ClassCastException\n             if {@code another} cannot be converted into something\n             comparable to {@code this} instance.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});