Ext.data.JsonP.java_lang_IntegralToString({"tagname":"class","name":"java.lang.IntegralToString","autodetected":{},"files":[{"filename":"IntegralToString.js","href":"IntegralToString.html#java-lang-IntegralToString"}],"extends":"java.lang.Object","hide":true,"members":[{"name":"appendByteAsHex","tagname":"method","owner":"java.lang.IntegralToString","id":"method-appendByteAsHex","meta":{}},{"name":"appendInt","tagname":"method","owner":"java.lang.IntegralToString","id":"method-appendInt","meta":{}},{"name":"appendLong","tagname":"method","owner":"java.lang.IntegralToString","id":"method-appendLong","meta":{}},{"name":"byteToHexString","tagname":"method","owner":"java.lang.IntegralToString","id":"method-byteToHexString","meta":{}},{"name":"bytesToHexString","tagname":"method","owner":"java.lang.IntegralToString","id":"method-bytesToHexString","meta":{}},{"name":"equals","tagname":"method","owner":"java.lang.Object","id":"method-equals","meta":{}},{"name":"getClass","tagname":"method","owner":"java.lang.Object","id":"method-getClass","meta":{}},{"name":"hashCode","tagname":"method","owner":"java.lang.Object","id":"method-hashCode","meta":{}},{"name":"intToBinaryString","tagname":"method","owner":"java.lang.IntegralToString","id":"method-intToBinaryString","meta":{}},{"name":"intToHexString","tagname":"method","owner":"java.lang.IntegralToString","id":"method-intToHexString","meta":{}},{"name":"intToOctalString","tagname":"method","owner":"java.lang.IntegralToString","id":"method-intToOctalString","meta":{}},{"name":"intToString","tagname":"method","owner":"java.lang.IntegralToString","id":"method-intToString","meta":{}},{"name":"longToBinaryString","tagname":"method","owner":"java.lang.IntegralToString","id":"method-longToBinaryString","meta":{}},{"name":"longToHexString","tagname":"method","owner":"java.lang.IntegralToString","id":"method-longToHexString","meta":{}},{"name":"longToOctalString","tagname":"method","owner":"java.lang.IntegralToString","id":"method-longToOctalString","meta":{}},{"name":"longToString","tagname":"method","owner":"java.lang.IntegralToString","id":"method-longToString","meta":{}},{"name":"notify","tagname":"method","owner":"java.lang.Object","id":"method-notify","meta":{}},{"name":"notifyAll","tagname":"method","owner":"java.lang.Object","id":"method-notifyAll","meta":{}},{"name":"toString","tagname":"method","owner":"java.lang.Object","id":"method-toString","meta":{}},{"name":"wait","tagname":"method","owner":"java.lang.Object","id":"method-wait","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.IntegralToString","short_doc":"Converts integral types to strings. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='docClass'>java.lang.Object</a><div class='subclass '><strong>java.lang.IntegralToString</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/IntegralToString.html#java-lang-IntegralToString' target='_blank'>IntegralToString.js</a></div></pre><div class='doc-contents'><p>Converts integral types to strings. This class is public but hidden so that it can also be\n used by java.util.Formatter to speed up %d. This class is in java.lang so that it can take\n advantage of the package-private String constructor.</p>\n\n<p> The most important methods are appendInt/appendLong and intToString(int)/longToString(int).\n The former are used in the implementation of StringBuilder, StringBuffer, and Formatter, while\n the latter are used by Integer.toString and Long.toString.</p>\n\n<p> The append methods take AbstractStringBuilder rather than Appendable because the latter requires\n CharSequences, while we only have raw char[]s. Since much of the savings come from not creating\n any garbage, we can't afford temporary CharSequence instances.</p>\n\n<p> One day the performance advantage of the binary/hex/octal specializations will be small enough\n that we can lose the duplication, but until then this class offers the full set.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-appendByteAsHex' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-appendByteAsHex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-appendByteAsHex' class='name expandable'>appendByteAsHex</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-appendInt' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-appendInt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-appendInt' class='name expandable'>appendInt</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Equivalent to sb.append(Integer.toString(i)). ...</div><div class='long'><p>Equivalent to sb.append(Integer.toString(i)).</p>\n</div></div></div><div id='method-appendLong' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-appendLong' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-appendLong' class='name expandable'>appendLong</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Equivalent to sb.append(Long.toString(l)). ...</div><div class='long'><p>Equivalent to sb.append(Long.toString(l)).</p>\n</div></div></div><div id='method-byteToHexString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-byteToHexString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-byteToHexString' class='name expandable'>byteToHexString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-bytesToHexString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-bytesToHexString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-bytesToHexString' class='name expandable'>bytesToHexString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-equals' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-equals' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-equals' class='name expandable'>equals</a>( <span class='pre'>o</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Compares this instance with the specified object and indicates if they\n are equal. ...</div><div class='long'><p>Compares this instance with the specified object and indicates if they\n are equal. In order to be equal, {@code o} must represent the same object\n as this instance using a class-specific comparison. The general contract\n is that this comparison should be reflexive, symmetric, and transitive.\n Also, no object reference other than null is equal to null.</p>\n\n<p> <p>The default implementation returns {@code true} only if {@code this ==\n o}. See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_equals\">Writing a correct\n {@code equals} method</a>\n if you intend implementing your own {@code equals} method.</p>\n\n<p> <p>The general contract for the {@code equals} and <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a>() methods is that if {@code equals} returns {@code true} for\n any two objects, then {@code hashCode()} must return the same value for\n these objects. This means that subclasses of {@code Object} usually\n override either both methods or neither of them.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>o</span> : Object {Object}<div class='sub-desc'><p>the object to compare this instance with.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the specified object is equal to this {@code\n         Object}; {@code false} otherwise.\n@see <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a></p>\n</div></li></ul></div></div></div><div id='method-getClass' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-getClass' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-getClass' class='name expandable'>getClass</a>( <span class='pre'></span> ) : Object {java.lang.Class}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the unique instance of java.lang.Class that represents this\n object's class. ...</div><div class='long'><p>Returns the unique instance of <a href=\"#!/api/java.lang.Class\" rel=\"java.lang.Class\" class=\"docClass\">java.lang.Class</a> that represents this\n object's class. Note that {@code getClass()} is a special case in that it\n actually returns {@code Class&lt;? extends Foo>} where {@code Foo} is the\n erasure of the type of the expression {@code getClass()} was called upon.\n <p>\n As an example, the following code actually compiles, although one might\n think it shouldn't:\n <p>\n <pre>{@code\n   List<Integer> l = new ArrayList<Integer>();\n   Class&lt;? extends List> c = l.getClass();}</Integer></Integer></pre></p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Class}</span><div class='sub-desc'><p>this object's {@code Class} instance.</p>\n</div></li></ul></div></div></div><div id='method-hashCode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-hashCode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-hashCode' class='name expandable'>hashCode</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns an integer hash code for this object. ...</div><div class='long'><p>Returns an integer hash code for this object. By contract, any two\n objects for which <a href=\"#!/api/java.lang.Object-method-equals\" rel=\"java.lang.Object-method-equals\" class=\"docClass\">equals</a> returns {@code true} must return\n the same hash code value. This means that subclasses of {@code Object}\n usually override both methods or neither method.</p>\n\n<p> <p>Note that hash values must not change over time unless information used in equals\n comparisons also changes.</p>\n\n<p> <p>See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_hashCode\">Writing a correct\n {@code hashCode} method</a>\n if you intend implementing your own {@code hashCode} method.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>this object's hash code.\n@see <a href=\"#!/api/java.lang.Object-method-equals\" rel=\"java.lang.Object-method-equals\" class=\"docClass\">equals</a></p>\n</div></li></ul></div></div></div><div id='method-intToBinaryString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-intToBinaryString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-intToBinaryString' class='name expandable'>intToBinaryString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-intToHexString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-intToHexString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-intToHexString' class='name expandable'>intToHexString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-intToOctalString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-intToOctalString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-intToOctalString' class='name expandable'>intToOctalString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-intToString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-intToString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-intToString' class='name expandable'>intToString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Equivalent to Integer.toString(i). ...</div><div class='long'><p>Equivalent to Integer.toString(i).</p>\n</div></div></div><div id='method-longToBinaryString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-longToBinaryString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-longToBinaryString' class='name expandable'>longToBinaryString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-longToHexString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-longToHexString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-longToHexString' class='name expandable'>longToHexString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-longToOctalString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-longToOctalString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-longToOctalString' class='name expandable'>longToOctalString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-longToString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.IntegralToString'>java.lang.IntegralToString</span><br/><a href='source/IntegralToString.html#java-lang-IntegralToString-method-longToString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.IntegralToString-method-longToString' class='name expandable'>longToString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Equivalent to Long.toString(l). ...</div><div class='long'><p>Equivalent to Long.toString(l).</p>\n</div></div></div><div id='method-notify' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notify' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notify' class='name expandable'>notify</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to...</div><div class='long'><p>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to be woken up. If more than\n one thread is waiting, one of them is chosen at the discretion of the\n VM. The chosen thread will not run immediately. The thread\n that called {@code notify()} has to release the object's monitor first.\n Also, the chosen thread still has to compete against other threads that\n try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></div></div><div id='method-notifyAll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notifyAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notifyAll' class='name expandable'>notifyAll</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods...</div><div class='long'><p>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods) to be woken up. The threads\n will not run immediately. The thread that called {@code notify()} has to\n release the object's monitor first. Also, the threads still have to\n compete against other threads that try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul></p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a string containing a concise, human-readable description of this\n object. ...</div><div class='long'><p>Returns a string containing a concise, human-readable description of this\n object. Subclasses are encouraged to override this method and provide an\n implementation that takes into account the object's type and data. The\n default implementation is equivalent to the following expression:</p>\n\n<pre>   getClass().getName() + '@' + Integer.toHexString(hashCode())</pre>\n\n\n<p> <p>See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_toString\">Writing a useful\n {@code toString} method</a>\n if you intend implementing your own {@code toString} method.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>a printable representation of this object.</p>\n</div></li></ul></div></div></div><div id='method-wait' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-wait' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-wait' class='name expandable'>wait</a>( <span class='pre'>millis, nanos</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of t...</div><div class='long'><p>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of this object or until the\n specified timeout expires. This method can only be invoked by a thread\n that owns this object's monitor; see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>() on how a thread\n can become the owner of a monitor.</p>\n\n<p> <p>A waiting thread can be sent {@code interrupt()} to cause it to\n prematurely stop waiting, so {@code wait} should be called in a loop to\n check that the condition that has been waited for has been met before\n continuing.</p>\n\n<p> <p>While the thread waits, it gives up ownership of this object's\n monitor. When it is notified (or interrupted), it re-acquires the monitor\n before it starts running.</p>\n\n<p> <p>A timeout of zero means the calling thread should wait forever unless interrupted or\n notified.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>millis</span> : Number<div class='sub-desc'><p>the maximum time to wait in milliseconds.</p>\n</div></li><li><span class='pre'>nanos</span> : Number<div class='sub-desc'><p>the fraction of a millisecond to wait, specified in\n            nanoseconds.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalArgumentException\n             if {@code millis &lt; 0}, {@code nanos &lt; 0} or {@code nanos >\n             999999}.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>InterruptedException if the current thread has been interrupted.\n             The interrupted status of the current thread will be cleared before the exception\n             is thrown.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});