Ext.data.JsonP.java_lang_Object({"tagname":"class","name":"java.lang.Object","autodetected":{},"files":[{"filename":"Object.js","href":"Object.html#java-lang-Object"}],"members":[{"name":"equals","tagname":"method","owner":"java.lang.Object","id":"method-equals","meta":{}},{"name":"getClass","tagname":"method","owner":"java.lang.Object","id":"method-getClass","meta":{}},{"name":"hashCode","tagname":"method","owner":"java.lang.Object","id":"method-hashCode","meta":{}},{"name":"notify","tagname":"method","owner":"java.lang.Object","id":"method-notify","meta":{}},{"name":"notifyAll","tagname":"method","owner":"java.lang.Object","id":"method-notifyAll","meta":{}},{"name":"toString","tagname":"method","owner":"java.lang.Object","id":"method-toString","meta":{}},{"name":"wait","tagname":"method","owner":"java.lang.Object","id":"method-wait","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.Object","short_doc":"The root class of the Java class hierarchy. ...","classIcon":"icon-class","superclasses":[],"subclasses":["java.lang.Boolean","java.lang.Character","java.lang.Character.Subset","java.lang.Class","java.lang.ClassLoader","java.lang.Compiler","java.lang.Daemons","java.lang.Enum","java.lang.IntegralToString","java.lang.JavaClass","java.lang.Math","java.lang.Number","java.lang.Package","java.lang.Process","java.lang.ProcessBuilder","java.lang.Runtime","java.lang.SecurityManager","java.lang.StackTraceElement","java.lang.StrictMath","java.lang.String","java.lang.StringFactory","java.lang.System","java.lang.Thread","java.lang.ThreadGroup","java.lang.ThreadLocal","java.lang.Throwable","java.lang.Void"],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Subclasses</h4><div class='dependency'><a href='#!/api/java.lang.Boolean' rel='java.lang.Boolean' class='docClass'>java.lang.Boolean</a></div><div class='dependency'><a href='#!/api/java.lang.Character' rel='java.lang.Character' class='docClass'>java.lang.Character</a></div><div class='dependency'><a href='#!/api/java.lang.Character.Subset' rel='java.lang.Character.Subset' class='docClass'>java.lang.Character.Subset</a></div><div class='dependency'><a href='#!/api/java.lang.Class' rel='java.lang.Class' class='docClass'>java.lang.Class</a></div><div class='dependency'><a href='#!/api/java.lang.ClassLoader' rel='java.lang.ClassLoader' class='docClass'>java.lang.ClassLoader</a></div><div class='dependency'><a href='#!/api/java.lang.Compiler' rel='java.lang.Compiler' class='docClass'>java.lang.Compiler</a></div><div class='dependency'><a href='#!/api/java.lang.Daemons' rel='java.lang.Daemons' class='docClass'>java.lang.Daemons</a></div><div class='dependency'><a href='#!/api/java.lang.Enum' rel='java.lang.Enum' class='docClass'>java.lang.Enum</a></div><div class='dependency'><a href='#!/api/java.lang.IntegralToString' rel='java.lang.IntegralToString' class='docClass'>java.lang.IntegralToString</a></div><div class='dependency'><a href='#!/api/java.lang.JavaClass' rel='java.lang.JavaClass' class='docClass'>java.lang.JavaClass</a></div><div class='dependency'><a href='#!/api/java.lang.Math' rel='java.lang.Math' class='docClass'>java.lang.Math</a></div><div class='dependency'><a href='#!/api/java.lang.Number' rel='java.lang.Number' class='docClass'>java.lang.Number</a></div><div class='dependency'><a href='#!/api/java.lang.Package' rel='java.lang.Package' class='docClass'>java.lang.Package</a></div><div class='dependency'><a href='#!/api/java.lang.Process' rel='java.lang.Process' class='docClass'>java.lang.Process</a></div><div class='dependency'><a href='#!/api/java.lang.ProcessBuilder' rel='java.lang.ProcessBuilder' class='docClass'>java.lang.ProcessBuilder</a></div><div class='dependency'><a href='#!/api/java.lang.Runtime' rel='java.lang.Runtime' class='docClass'>java.lang.Runtime</a></div><div class='dependency'><a href='#!/api/java.lang.SecurityManager' rel='java.lang.SecurityManager' class='docClass'>java.lang.SecurityManager</a></div><div class='dependency'><a href='#!/api/java.lang.StackTraceElement' rel='java.lang.StackTraceElement' class='docClass'>java.lang.StackTraceElement</a></div><div class='dependency'><a href='#!/api/java.lang.StrictMath' rel='java.lang.StrictMath' class='docClass'>java.lang.StrictMath</a></div><div class='dependency'><a href='#!/api/java.lang.String' rel='java.lang.String' class='docClass'>java.lang.String</a></div><div class='dependency'><a href='#!/api/java.lang.StringFactory' rel='java.lang.StringFactory' class='docClass'>java.lang.StringFactory</a></div><div class='dependency'><a href='#!/api/java.lang.System' rel='java.lang.System' class='docClass'>java.lang.System</a></div><div class='dependency'><a href='#!/api/java.lang.Thread' rel='java.lang.Thread' class='docClass'>java.lang.Thread</a></div><div class='dependency'><a href='#!/api/java.lang.ThreadGroup' rel='java.lang.ThreadGroup' class='docClass'>java.lang.ThreadGroup</a></div><div class='dependency'><a href='#!/api/java.lang.ThreadLocal' rel='java.lang.ThreadLocal' class='docClass'>java.lang.ThreadLocal</a></div><div class='dependency'><a href='#!/api/java.lang.Throwable' rel='java.lang.Throwable' class='docClass'>java.lang.Throwable</a></div><div class='dependency'><a href='#!/api/java.lang.Void' rel='java.lang.Void' class='docClass'>java.lang.Void</a></div><h4>Files</h4><div class='dependency'><a href='source/Object.html#java-lang-Object' target='_blank'>Object.js</a></div></pre><div class='doc-contents'><p>The root class of the Java class hierarchy. All non-primitive types\n (including arrays) inherit either directly or indirectly from this class.</p>\n\n<p> <a name=\"writing_equals\"><h4>Writing a correct {@code equals} method</h4></a>\n <p>Follow this style to write a canonical {@code equals} method:</p>\n\n<pre>   // Use @Override to avoid accidental overloading.\n   &#x0040;Override public boolean equals(Object o) {\n     // Return true if the objects are identical.\n     // (This is just an optimization, not required for correctness.)\n     if (this == o) {\n       return true;\n     }\n\n     // Return false if the other object has the wrong type.\n     // This type may be an interface depending on the interface's specification.\n     if (!(o instanceof MyType)) {\n       return false;\n     }\n\n     // Cast to the appropriate type.\n     // This will succeed because of the instanceof, and lets us access private fields.\n     MyType lhs = (MyType) o;\n\n     // Check each field. Primitive fields, reference fields, and nullable reference\n     // fields are all treated differently.\n     return primitiveField == lhs.primitiveField &amp;&amp;\n             referenceField.equals(lhs.referenceField) &amp;&amp;\n             (nullableField == null ? lhs.nullableField == null\n                                    : nullableField.equals(lhs.nullableField));\n   }\n </pre>\n\n\n<p> <p>If you override {@code equals}, you should also override {@code hashCode}: equal\n instances must have equal hash codes.</p>\n\n<p> <p>See <i>Effective Java</i> item 8 for much more detail and clarification.</p>\n\n<p> <a name=\"writing_hashCode\"><h4>Writing a correct {@code hashCode} method</h4></a>\n <p>Follow this style to write a canonical {@code hashCode} method:</p>\n\n<pre>   &#x0040;Override public int hashCode() {\n     // Start with a non-zero constant.\n     int result = 17;\n\n     // Include a hash for each field.\n     result = 31 * result + (booleanField ? 1 : 0);\n\n     result = 31 * result + byteField;\n     result = 31 * result + charField;\n     result = 31 * result + shortField;\n     result = 31 * result + intField;\n\n     result = 31 * result + (int) (longField ^ (longField >>> 32));\n\n     result = 31 * result + Float.floatToIntBits(floatField);\n\n     long doubleFieldBits = Double.doubleToLongBits(doubleField);\n     result = 31 * result + (int) (doubleFieldBits ^ (doubleFieldBits >>> 32));\n\n     result = 31 * result + Arrays.hashCode(arrayField);\n\n     result = 31 * result + referenceField.hashCode();\n     result = 31 * result +\n         (nullableReferenceField == null ? 0\n                                         : nullableReferenceField.hashCode());\n\n     return result;\n   }\n </pre>\n\n\n<p> <p>If you don't intend your type to be used as a hash key, don't simply rely on the default\n {@code hashCode} implementation, because that silently and non-obviously breaks any future\n code that does use your type as a hash key. You should throw instead:</p>\n\n<pre>   &#x0040;Override public int hashCode() {\n     throw new UnsupportedOperationException();\n   }\n </pre>\n\n\n<p> <p>See <i>Effective Java</i> item 9 for much more detail and clarification.</p>\n\n<p> <a name=\"writing_toString\"><h4>Writing a useful {@code toString} method</h4></a>\n <p>For debugging convenience, it's common to override {@code toString} in this style:</p>\n\n<pre>   &#x0040;Override public String toString() {\n     return getClass().getName() + \"[\" +\n         \"primitiveField=\" + primitiveField + \", \" +\n         \"referenceField=\" + referenceField + \", \" +\n         \"arrayField=\" + Arrays.toString(arrayField) + \"]\";\n   }\n </pre>\n\n\n<p> <p>The set of fields to include is generally the same as those that would be tested\n in your {@code equals} implementation.\n <p>See <i>Effective Java</i> item 10 for much more detail and clarification.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-equals' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Object'>java.lang.Object</span><br/><a href='source/Object.html#java-lang-Object-method-equals' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-equals' class='name expandable'>equals</a>( <span class='pre'>o</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Compares this instance with the specified object and indicates if they\n are equal. ...</div><div class='long'><p>Compares this instance with the specified object and indicates if they\n are equal. In order to be equal, {@code o} must represent the same object\n as this instance using a class-specific comparison. The general contract\n is that this comparison should be reflexive, symmetric, and transitive.\n Also, no object reference other than null is equal to null.</p>\n\n<p> <p>The default implementation returns {@code true} only if {@code this ==\n o}. See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_equals\">Writing a correct\n {@code equals} method</a>\n if you intend implementing your own {@code equals} method.</p>\n\n<p> <p>The general contract for the {@code equals} and <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a>() methods is that if {@code equals} returns {@code true} for\n any two objects, then {@code hashCode()} must return the same value for\n these objects. This means that subclasses of {@code Object} usually\n override either both methods or neither of them.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>o</span> : Object {Object}<div class='sub-desc'><p>the object to compare this instance with.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the specified object is equal to this {@code\n         Object}; {@code false} otherwise.\n@see <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a></p>\n</div></li></ul></div></div></div><div id='method-getClass' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Object'>java.lang.Object</span><br/><a href='source/Object.html#java-lang-Object-method-getClass' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-getClass' class='name expandable'>getClass</a>( <span class='pre'></span> ) : Object {java.lang.Class}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the unique instance of java.lang.Class that represents this\n object's class. ...</div><div class='long'><p>Returns the unique instance of <a href=\"#!/api/java.lang.Class\" rel=\"java.lang.Class\" class=\"docClass\">java.lang.Class</a> that represents this\n object's class. Note that {@code getClass()} is a special case in that it\n actually returns {@code Class&lt;? extends Foo>} where {@code Foo} is the\n erasure of the type of the expression {@code getClass()} was called upon.\n <p>\n As an example, the following code actually compiles, although one might\n think it shouldn't:\n <p>\n <pre>{@code\n   List<Integer> l = new ArrayList<Integer>();\n   Class&lt;? extends List> c = l.getClass();}</Integer></Integer></pre></p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Class}</span><div class='sub-desc'><p>this object's {@code Class} instance.</p>\n</div></li></ul></div></div></div><div id='method-hashCode' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Object'>java.lang.Object</span><br/><a href='source/Object.html#java-lang-Object-method-hashCode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-hashCode' class='name expandable'>hashCode</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns an integer hash code for this object. ...</div><div class='long'><p>Returns an integer hash code for this object. By contract, any two\n objects for which <a href=\"#!/api/java.lang.Object-method-equals\" rel=\"java.lang.Object-method-equals\" class=\"docClass\">equals</a> returns {@code true} must return\n the same hash code value. This means that subclasses of {@code Object}\n usually override both methods or neither method.</p>\n\n<p> <p>Note that hash values must not change over time unless information used in equals\n comparisons also changes.</p>\n\n<p> <p>See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_hashCode\">Writing a correct\n {@code hashCode} method</a>\n if you intend implementing your own {@code hashCode} method.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>this object's hash code.\n@see <a href=\"#!/api/java.lang.Object-method-equals\" rel=\"java.lang.Object-method-equals\" class=\"docClass\">equals</a></p>\n</div></li></ul></div></div></div><div id='method-notify' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Object'>java.lang.Object</span><br/><a href='source/Object.html#java-lang-Object-method-notify' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notify' class='name expandable'>notify</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to...</div><div class='long'><p>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to be woken up. If more than\n one thread is waiting, one of them is chosen at the discretion of the\n VM. The chosen thread will not run immediately. The thread\n that called {@code notify()} has to release the object's monitor first.\n Also, the chosen thread still has to compete against other threads that\n try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></div></div><div id='method-notifyAll' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Object'>java.lang.Object</span><br/><a href='source/Object.html#java-lang-Object-method-notifyAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notifyAll' class='name expandable'>notifyAll</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods...</div><div class='long'><p>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods) to be woken up. The threads\n will not run immediately. The thread that called {@code notify()} has to\n release the object's monitor first. Also, the threads still have to\n compete against other threads that try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul></p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Object'>java.lang.Object</span><br/><a href='source/Object.html#java-lang-Object-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a string containing a concise, human-readable description of this\n object. ...</div><div class='long'><p>Returns a string containing a concise, human-readable description of this\n object. Subclasses are encouraged to override this method and provide an\n implementation that takes into account the object's type and data. The\n default implementation is equivalent to the following expression:</p>\n\n<pre>   getClass().getName() + '@' + Integer.toHexString(hashCode())</pre>\n\n\n<p> <p>See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_toString\">Writing a useful\n {@code toString} method</a>\n if you intend implementing your own {@code toString} method.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>a printable representation of this object.</p>\n</div></li></ul></div></div></div><div id='method-wait' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Object'>java.lang.Object</span><br/><a href='source/Object.html#java-lang-Object-method-wait' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-wait' class='name expandable'>wait</a>( <span class='pre'>millis, nanos</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of t...</div><div class='long'><p>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of this object or until the\n specified timeout expires. This method can only be invoked by a thread\n that owns this object's monitor; see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>() on how a thread\n can become the owner of a monitor.</p>\n\n<p> <p>A waiting thread can be sent {@code interrupt()} to cause it to\n prematurely stop waiting, so {@code wait} should be called in a loop to\n check that the condition that has been waited for has been met before\n continuing.</p>\n\n<p> <p>While the thread waits, it gives up ownership of this object's\n monitor. When it is notified (or interrupted), it re-acquires the monitor\n before it starts running.</p>\n\n<p> <p>A timeout of zero means the calling thread should wait forever unless interrupted or\n notified.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>millis</span> : Number<div class='sub-desc'><p>the maximum time to wait in milliseconds.</p>\n</div></li><li><span class='pre'>nanos</span> : Number<div class='sub-desc'><p>the fraction of a millisecond to wait, specified in\n            nanoseconds.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalArgumentException\n             if {@code millis &lt; 0}, {@code nanos &lt; 0} or {@code nanos >\n             999999}.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>InterruptedException if the current thread has been interrupted.\n             The interrupted status of the current thread will be cleared before the exception\n             is thrown.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});