Ext.data.JsonP.java_lang_Package({"tagname":"class","name":"java.lang.Package","autodetected":{},"files":[{"filename":"Package.js","href":"Package.html#java-lang-Package"}],"extends":"java.lang.Object","members":[{"name":"equals","tagname":"method","owner":"java.lang.Object","id":"method-equals","meta":{}},{"name":"getAnnotation","tagname":"method","owner":"java.lang.Package","id":"method-getAnnotation","meta":{}},{"name":"getAnnotations","tagname":"method","owner":"java.lang.Package","id":"method-getAnnotations","meta":{}},{"name":"getClass","tagname":"method","owner":"java.lang.Object","id":"method-getClass","meta":{}},{"name":"getDeclaredAnnotations","tagname":"method","owner":"java.lang.Package","id":"method-getDeclaredAnnotations","meta":{}},{"name":"getImplementationTitle","tagname":"method","owner":"java.lang.Package","id":"method-getImplementationTitle","meta":{}},{"name":"getImplementationVendor","tagname":"method","owner":"java.lang.Package","id":"method-getImplementationVendor","meta":{}},{"name":"getImplementationVersion","tagname":"method","owner":"java.lang.Package","id":"method-getImplementationVersion","meta":{}},{"name":"getName","tagname":"method","owner":"java.lang.Package","id":"method-getName","meta":{}},{"name":"getPackage","tagname":"method","owner":"java.lang.Package","id":"method-getPackage","meta":{}},{"name":"getPackages","tagname":"method","owner":"java.lang.Package","id":"method-getPackages","meta":{}},{"name":"getSpecificationTitle","tagname":"method","owner":"java.lang.Package","id":"method-getSpecificationTitle","meta":{}},{"name":"getSpecificationVendor","tagname":"method","owner":"java.lang.Package","id":"method-getSpecificationVendor","meta":{}},{"name":"getSpecificationVersion","tagname":"method","owner":"java.lang.Package","id":"method-getSpecificationVersion","meta":{}},{"name":"hashCode","tagname":"method","owner":"java.lang.Package","id":"method-hashCode","meta":{}},{"name":"isAnnotationPresent","tagname":"method","owner":"java.lang.Package","id":"method-isAnnotationPresent","meta":{}},{"name":"isCompatibleWith","tagname":"method","owner":"java.lang.Package","id":"method-isCompatibleWith","meta":{}},{"name":"isSealed","tagname":"method","owner":"java.lang.Package","id":"method-isSealed","meta":{}},{"name":"notify","tagname":"method","owner":"java.lang.Object","id":"method-notify","meta":{}},{"name":"notifyAll","tagname":"method","owner":"java.lang.Object","id":"method-notifyAll","meta":{}},{"name":"toString","tagname":"method","owner":"java.lang.Package","id":"method-toString","meta":{}},{"name":"wait","tagname":"method","owner":"java.lang.Object","id":"method-wait","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.Package","short_doc":"implements java.lang.reflect.AnnotatedElement\n\nContains information about a Java package. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='docClass'>java.lang.Object</a><div class='subclass '><strong>java.lang.Package</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/Package.html#java-lang-Package' target='_blank'>Package.js</a></div></pre><div class='doc-contents'><p>implements java.lang.reflect.AnnotatedElement</p>\n\n<p>Contains information about a Java package. This includes implementation and\n specification versions. Typically this information is retrieved from the\n manifest.\n <p>\n Packages are managed by class loaders. All classes loaded by the same loader\n from the same package share a {@code Package} instance.\n </p></p>\n\n<p> @see <a href=\"#!/api/java.lang.ClassLoader\" rel=\"java.lang.ClassLoader\" class=\"docClass\">java.lang.ClassLoader</a></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-equals' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-equals' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-equals' class='name expandable'>equals</a>( <span class='pre'>o</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Compares this instance with the specified object and indicates if they\n are equal. ...</div><div class='long'><p>Compares this instance with the specified object and indicates if they\n are equal. In order to be equal, {@code o} must represent the same object\n as this instance using a class-specific comparison. The general contract\n is that this comparison should be reflexive, symmetric, and transitive.\n Also, no object reference other than null is equal to null.</p>\n\n<p> <p>The default implementation returns {@code true} only if {@code this ==\n o}. See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_equals\">Writing a correct\n {@code equals} method</a>\n if you intend implementing your own {@code equals} method.</p>\n\n<p> <p>The general contract for the {@code equals} and <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a>() methods is that if {@code equals} returns {@code true} for\n any two objects, then {@code hashCode()} must return the same value for\n these objects. This means that subclasses of {@code Object} usually\n override either both methods or neither of them.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>o</span> : Object {Object}<div class='sub-desc'><p>the object to compare this instance with.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the specified object is equal to this {@code\n         Object}; {@code false} otherwise.\n@see <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a></p>\n</div></li></ul></div></div></div><div id='method-getAnnotation' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getAnnotation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getAnnotation' class='name expandable'>getAnnotation</a>( <span class='pre'>annotationType</span> ) : Object {java.lang.annotation.Annotation}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the annotation associated with the specified annotation type and\n this package, if present. ...</div><div class='long'><p>Returns the annotation associated with the specified annotation type and\n this package, if present.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>annotationType</span> : Object {java.lang.Class}<div class='sub-desc'><p>the annotation type to look for.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.annotation.Annotation}</span><div class='sub-desc'><p>an instance of Annotation or {@code null}.\n@see java.lang.reflect.AnnotatedElement#getAnnotation(<a href=\"#!/api/java.lang.Class\" rel=\"java.lang.Class\" class=\"docClass\">java.lang.Class</a>)</p>\n</div></li></ul></div></div></div><div id='method-getAnnotations' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getAnnotations' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getAnnotations' class='name expandable'>getAnnotations</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns an array of this package's annotations. ...</div><div class='long'><p>Returns an array of this package's annotations.</p>\n</div></div></div><div id='method-getClass' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-getClass' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-getClass' class='name expandable'>getClass</a>( <span class='pre'></span> ) : Object {java.lang.Class}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the unique instance of java.lang.Class that represents this\n object's class. ...</div><div class='long'><p>Returns the unique instance of <a href=\"#!/api/java.lang.Class\" rel=\"java.lang.Class\" class=\"docClass\">java.lang.Class</a> that represents this\n object's class. Note that {@code getClass()} is a special case in that it\n actually returns {@code Class&lt;? extends Foo>} where {@code Foo} is the\n erasure of the type of the expression {@code getClass()} was called upon.\n <p>\n As an example, the following code actually compiles, although one might\n think it shouldn't:\n <p>\n <pre>{@code\n   List<Integer> l = new ArrayList<Integer>();\n   Class&lt;? extends List> c = l.getClass();}</Integer></Integer></pre></p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Class}</span><div class='sub-desc'><p>this object's {@code Class} instance.</p>\n</div></li></ul></div></div></div><div id='method-getDeclaredAnnotations' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getDeclaredAnnotations' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getDeclaredAnnotations' class='name expandable'>getDeclaredAnnotations</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns an array of this package's declared annotations. ...</div><div class='long'><p>Returns an array of this package's declared annotations. Package annotations aren't\n inherited, so this is equivalent to <a href=\"#!/api/java.lang.Package-method-getAnnotations\" rel=\"java.lang.Package-method-getAnnotations\" class=\"docClass\">getAnnotations</a>.</p>\n</div></div></div><div id='method-getImplementationTitle' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getImplementationTitle' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getImplementationTitle' class='name expandable'>getImplementationTitle</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the title of the implementation of this package, or {@code null}\n if this is unknown. ...</div><div class='long'><p>Returns the title of the implementation of this package, or {@code null}\n if this is unknown. The format of this string is unspecified.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the implementation title, may be {@code null}.</p>\n</div></li></ul></div></div></div><div id='method-getImplementationVendor' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getImplementationVendor' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getImplementationVendor' class='name expandable'>getImplementationVendor</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the name of the vendor or organization that provides this\n implementation of the package, or {@code null} if ...</div><div class='long'><p>Returns the name of the vendor or organization that provides this\n implementation of the package, or {@code null} if this is unknown. The\n format of this string is unspecified.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the implementation vendor name, may be {@code null}.</p>\n</div></li></ul></div></div></div><div id='method-getImplementationVersion' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getImplementationVersion' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getImplementationVersion' class='name expandable'>getImplementationVersion</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the version of the implementation of this package, or {@code\n null} if this is unknown. ...</div><div class='long'><p>Returns the version of the implementation of this package, or {@code\n null} if this is unknown. The format of this string is unspecified.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the implementation version, may be {@code null}.</p>\n</div></li></ul></div></div></div><div id='method-getName' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getName' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getName' class='name expandable'>getName</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the name of this package in the standard dot notation; for\n example: \"java.lang\". ...</div><div class='long'><p>Returns the name of this package in the standard dot notation; for\n example: \"java.lang\".</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the name of this package.</p>\n</div></li></ul></div></div></div><div id='method-getPackage' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getPackage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getPackage' class='name expandable'>getPackage</a>( <span class='pre'>packageName</span> ) : Object {java.lang.Package}<span class=\"signature\"></span></div><div class='description'><div class='short'>Attempts to locate the requested package in the caller's class loader. ...</div><div class='long'><p>Attempts to locate the requested package in the caller's class loader. If\n no package information can be located, {@code null} is returned.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>packageName</span> : String<div class='sub-desc'><p>the name of the package to find.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Package}</span><div class='sub-desc'><p>the requested package, or {@code null}.\n@see ClassLoader#getPackage(<a href=\"#!/api/java.lang.String\" rel=\"java.lang.String\" class=\"docClass\">java.lang.String</a>)</p>\n</div></li></ul></div></div></div><div id='method-getPackages' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getPackages' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getPackages' class='name expandable'>getPackages</a>( <span class='pre'></span> ) : Object {java.lang.Package}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns all the packages known to the caller's class loader. ...</div><div class='long'><p>Returns all the packages known to the caller's class loader.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Package}</span><div class='sub-desc'><p>all the packages known to the caller's class loader.\n@see ClassLoader#getPackages</p>\n</div></li></ul></div></div></div><div id='method-getSpecificationTitle' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getSpecificationTitle' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getSpecificationTitle' class='name expandable'>getSpecificationTitle</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the title of the specification this package implements, or\n {@code null} if this is unknown. ...</div><div class='long'><p>Returns the title of the specification this package implements, or\n {@code null} if this is unknown.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the specification title, may be {@code null}.</p>\n</div></li></ul></div></div></div><div id='method-getSpecificationVendor' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getSpecificationVendor' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getSpecificationVendor' class='name expandable'>getSpecificationVendor</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the name of the vendor or organization that owns and maintains\n the specification this package implements, or...</div><div class='long'><p>Returns the name of the vendor or organization that owns and maintains\n the specification this package implements, or {@code null} if this is\n unknown.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the specification vendor name, may be {@code null}.</p>\n</div></li></ul></div></div></div><div id='method-getSpecificationVersion' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-getSpecificationVersion' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-getSpecificationVersion' class='name expandable'>getSpecificationVersion</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the version of the specification this package implements, or\n {@code null} if this is unknown. ...</div><div class='long'><p>Returns the version of the specification this package implements, or\n {@code null} if this is unknown. The version string is a sequence of\n non-negative integers separated by dots; for example: \"1.2.3\".</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the specification version string, may be {@code null}.</p>\n</div></li></ul></div></div></div><div id='method-hashCode' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-hashCode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-hashCode' class='name expandable'>hashCode</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Overrides: <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">java.lang.Object.hashCode</a></p></div></div></div><div id='method-isAnnotationPresent' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-isAnnotationPresent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-isAnnotationPresent' class='name expandable'>isAnnotationPresent</a>( <span class='pre'>annotationType</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Indicates whether the specified annotation is present. ...</div><div class='long'><p>Indicates whether the specified annotation is present.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>annotationType</span> : Object {java.lang.Class}<div class='sub-desc'><p>the annotation type to look for.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the annotation is present; {@code false}\n         otherwise.\n@see java.lang.reflect.AnnotatedElement#isAnnotationPresent(<a href=\"#!/api/java.lang.Class\" rel=\"java.lang.Class\" class=\"docClass\">java.lang.Class</a>)</p>\n</div></li></ul></div></div></div><div id='method-isCompatibleWith' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-isCompatibleWith' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-isCompatibleWith' class='name expandable'>isCompatibleWith</a>( <span class='pre'>version</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Indicates whether this package's specification version is compatible with\n the specified version string. ...</div><div class='long'><p>Indicates whether this package's specification version is compatible with\n the specified version string. Version strings are compared by comparing\n each dot separated part of the version as an integer.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>version</span> : String<div class='sub-desc'><p>the version string to compare against.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the package versions are compatible; {@code\n         false} otherwise.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>NumberFormatException\n             if this package's version string or the one provided are not\n             in the correct format.</p>\n</div></li></ul></div></div></div><div id='method-isSealed' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-isSealed' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-isSealed' class='name expandable'>isSealed</a>( <span class='pre'>url</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Indicates whether this package is sealed with respect to the specified\n URL. ...</div><div class='long'><p>Indicates whether this package is sealed with respect to the specified\n URL.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>url</span> : Object {URL}<div class='sub-desc'><p>the URL to check.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if this package is sealed with {@code url}; {@code\n         false} otherwise</p>\n</div></li></ul></div></div></div><div id='method-notify' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notify' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notify' class='name expandable'>notify</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to...</div><div class='long'><p>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to be woken up. If more than\n one thread is waiting, one of them is chosen at the discretion of the\n VM. The chosen thread will not run immediately. The thread\n that called {@code notify()} has to release the object's monitor first.\n Also, the chosen thread still has to compete against other threads that\n try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></div></div><div id='method-notifyAll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notifyAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notifyAll' class='name expandable'>notifyAll</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods...</div><div class='long'><p>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods) to be woken up. The threads\n will not run immediately. The thread that called {@code notify()} has to\n release the object's monitor first. Also, the threads still have to\n compete against other threads that try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul></p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Package'>java.lang.Package</span><br/><a href='source/Package.html#java-lang-Package-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Package-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Overrides: <a href=\"#!/api/java.lang.Object-method-toString\" rel=\"java.lang.Object-method-toString\" class=\"docClass\">java.lang.Object.toString</a></p></div></div></div><div id='method-wait' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-wait' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-wait' class='name expandable'>wait</a>( <span class='pre'>millis, nanos</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of t...</div><div class='long'><p>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of this object or until the\n specified timeout expires. This method can only be invoked by a thread\n that owns this object's monitor; see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>() on how a thread\n can become the owner of a monitor.</p>\n\n<p> <p>A waiting thread can be sent {@code interrupt()} to cause it to\n prematurely stop waiting, so {@code wait} should be called in a loop to\n check that the condition that has been waited for has been met before\n continuing.</p>\n\n<p> <p>While the thread waits, it gives up ownership of this object's\n monitor. When it is notified (or interrupted), it re-acquires the monitor\n before it starts running.</p>\n\n<p> <p>A timeout of zero means the calling thread should wait forever unless interrupted or\n notified.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>millis</span> : Number<div class='sub-desc'><p>the maximum time to wait in milliseconds.</p>\n</div></li><li><span class='pre'>nanos</span> : Number<div class='sub-desc'><p>the fraction of a millisecond to wait, specified in\n            nanoseconds.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalArgumentException\n             if {@code millis &lt; 0}, {@code nanos &lt; 0} or {@code nanos >\n             999999}.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>InterruptedException if the current thread has been interrupted.\n             The interrupted status of the current thread will be cleared before the exception\n             is thrown.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});