Ext.data.JsonP.java_lang_Runtime({"tagname":"class","name":"java.lang.Runtime","autodetected":{},"files":[{"filename":"Runtime.js","href":"Runtime.html#java-lang-Runtime"}],"extends":"java.lang.Object","members":[{"name":"addShutdownHook","tagname":"method","owner":"java.lang.Runtime","id":"method-addShutdownHook","meta":{}},{"name":"availableProcessors","tagname":"method","owner":"java.lang.Runtime","id":"method-availableProcessors","meta":{}},{"name":"equals","tagname":"method","owner":"java.lang.Object","id":"method-equals","meta":{}},{"name":"exec","tagname":"method","owner":"java.lang.Runtime","id":"method-exec","meta":{}},{"name":"exit","tagname":"method","owner":"java.lang.Runtime","id":"method-exit","meta":{}},{"name":"freeMemory","tagname":"method","owner":"java.lang.Runtime","id":"method-freeMemory","meta":{}},{"name":"gc","tagname":"method","owner":"java.lang.Runtime","id":"method-gc","meta":{}},{"name":"getClass","tagname":"method","owner":"java.lang.Object","id":"method-getClass","meta":{}},{"name":"getLocalizedInputStream","tagname":"method","owner":"java.lang.Runtime","id":"method-getLocalizedInputStream","meta":{"deprecated":{"text":"<p>Use InputStreamReader instead.</p>\n"}}},{"name":"getLocalizedOutputStream","tagname":"method","owner":"java.lang.Runtime","id":"method-getLocalizedOutputStream","meta":{"deprecated":{"text":"<p>Use OutputStreamWriter instead.</p>\n"}}},{"name":"getRuntime","tagname":"method","owner":"java.lang.Runtime","id":"method-getRuntime","meta":{}},{"name":"halt","tagname":"method","owner":"java.lang.Runtime","id":"method-halt","meta":{}},{"name":"hashCode","tagname":"method","owner":"java.lang.Object","id":"method-hashCode","meta":{}},{"name":"load","tagname":"method","owner":"java.lang.Runtime","id":"method-load","meta":{}},{"name":"loadLibrary","tagname":"method","owner":"java.lang.Runtime","id":"method-loadLibrary","meta":{}},{"name":"maxMemory","tagname":"method","owner":"java.lang.Runtime","id":"method-maxMemory","meta":{}},{"name":"notify","tagname":"method","owner":"java.lang.Object","id":"method-notify","meta":{}},{"name":"notifyAll","tagname":"method","owner":"java.lang.Object","id":"method-notifyAll","meta":{}},{"name":"removeShutdownHook","tagname":"method","owner":"java.lang.Runtime","id":"method-removeShutdownHook","meta":{}},{"name":"runFinalization","tagname":"method","owner":"java.lang.Runtime","id":"method-runFinalization","meta":{}},{"name":"runFinalizersOnExit","tagname":"method","owner":"java.lang.Runtime","id":"method-runFinalizersOnExit","meta":{"deprecated":{"text":"<p>This method is unsafe.</p>\n"}}},{"name":"toString","tagname":"method","owner":"java.lang.Object","id":"method-toString","meta":{}},{"name":"totalMemory","tagname":"method","owner":"java.lang.Runtime","id":"method-totalMemory","meta":{}},{"name":"traceInstructions","tagname":"method","owner":"java.lang.Runtime","id":"method-traceInstructions","meta":{}},{"name":"traceMethodCalls","tagname":"method","owner":"java.lang.Runtime","id":"method-traceMethodCalls","meta":{}},{"name":"wait","tagname":"method","owner":"java.lang.Object","id":"method-wait","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.Runtime","short_doc":"Allows Java applications to interface with the environment in which they are\n running. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='docClass'>java.lang.Object</a><div class='subclass '><strong>java.lang.Runtime</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/Runtime.html#java-lang-Runtime' target='_blank'>Runtime.js</a></div></pre><div class='doc-contents'><p>Allows Java applications to interface with the environment in which they are\n running. Applications can not create an instance of this class, but they can\n get a singleton instance by invoking <a href=\"#!/api/java.lang.Runtime-method-getRuntime\" rel=\"java.lang.Runtime-method-getRuntime\" class=\"docClass\">getRuntime</a>().</p>\n\n<p> @see System</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addShutdownHook' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-addShutdownHook' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-addShutdownHook' class='name expandable'>addShutdownHook</a>( <span class='pre'>hook</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Registers a VM shutdown hook. ...</div><div class='long'><p>Registers a VM shutdown hook. A shutdown hook is a\n {@code Thread} that is ready to run, but has not yet been started. All\n registered shutdown hooks will be executed when the VM\n terminates normally (typically when the <a href=\"#!/api/java.lang.Runtime-method-exit\" rel=\"java.lang.Runtime-method-exit\" class=\"docClass\">exit</a>(int) method is called).</p>\n\n<p> <p><i>Note that on Android, the application lifecycle does not include VM termination,\n so calling this method will not ensure that your code is run</i>. Instead, you should\n use the most appropriate lifecycle notification ({@code Activity.onPause}, say).</p>\n\n<p> <p>Shutdown hooks are run concurrently and in an unspecified order. Hooks\n failing due to an unhandled exception are not a problem, but the stack\n trace might be printed to the console. Once initiated, the whole shutdown\n process can only be terminated by calling {@code halt()}.</p>\n\n<p> <p>If <a href=\"#!/api/java.lang.Runtime-method-runFinalizersOnExit\" rel=\"java.lang.Runtime-method-runFinalizersOnExit\" class=\"docClass\">runFinalizersOnExit</a>(boolean) has been called with a {@code\n true} argument, garbage collection and finalization will take place after\n all hooks are either finished or have failed. Then the VM\n terminates.</p>\n\n<p> <p>It is recommended that shutdown hooks do not do any time-consuming\n activities, in order to not hold up the shutdown process longer than\n necessary.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>hook</span> : Object {Thread}<div class='sub-desc'><p>the shutdown hook to register.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalArgumentException\n             if the hook has already been started or if it has already\n             been registered.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalStateException\n             if the VM is already shutting down.</p>\n</div></li></ul></div></div></div><div id='method-availableProcessors' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-availableProcessors' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-availableProcessors' class='name expandable'>availableProcessors</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the number of processor cores available to the VM, at least 1. ...</div><div class='long'><p>Returns the number of processor cores available to the VM, at least 1.\n Traditionally this returned the number currently online,\n but many mobile devices are able to take unused cores offline to\n save power, so releases newer than Android 4.2 (Jelly Bean) return the maximum number of\n cores that could be made available if there were no power or heat\n constraints.</p>\n</div></div></div><div id='method-equals' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-equals' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-equals' class='name expandable'>equals</a>( <span class='pre'>o</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Compares this instance with the specified object and indicates if they\n are equal. ...</div><div class='long'><p>Compares this instance with the specified object and indicates if they\n are equal. In order to be equal, {@code o} must represent the same object\n as this instance using a class-specific comparison. The general contract\n is that this comparison should be reflexive, symmetric, and transitive.\n Also, no object reference other than null is equal to null.</p>\n\n<p> <p>The default implementation returns {@code true} only if {@code this ==\n o}. See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_equals\">Writing a correct\n {@code equals} method</a>\n if you intend implementing your own {@code equals} method.</p>\n\n<p> <p>The general contract for the {@code equals} and <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a>() methods is that if {@code equals} returns {@code true} for\n any two objects, then {@code hashCode()} must return the same value for\n these objects. This means that subclasses of {@code Object} usually\n override either both methods or neither of them.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>o</span> : Object {Object}<div class='sub-desc'><p>the object to compare this instance with.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the specified object is equal to this {@code\n         Object}; {@code false} otherwise.\n@see <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">hashCode</a></p>\n</div></li></ul></div></div></div><div id='method-exec' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-exec' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-exec' class='name expandable'>exec</a>( <span class='pre'>prog, envp, directory</span> ) : Object {java.lang.Process}<span class=\"signature\"></span></div><div class='description'><div class='short'>Executes the specified program in a separate native process. ...</div><div class='long'><p>Executes the specified program in a separate native process. The new\n process uses the environment provided in {@code envp} and the working\n directory specified by {@code directory}.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>prog</span> : String<div class='sub-desc'><p>the name of the program to execute.</p>\n</div></li><li><span class='pre'>envp</span> : Object {java.lang.String[]}<div class='sub-desc'><p>the array containing the environment to start the new process\n            in.</p>\n</div></li><li><span class='pre'>directory</span> : Object {File}<div class='sub-desc'><p>the directory in which to execute the program. If {@code null},\n            execute if in the same directory as the parent process.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Process}</span><div class='sub-desc'><p>the new {@code Process} object that represents the native\n         process.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IOException\n             if the requested program can not be executed.</p>\n</div></li></ul></div></div></div><div id='method-exit' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-exit' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-exit' class='name expandable'>exit</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the VM to stop running and the program to exit. ...</div><div class='long'><p>Causes the VM to stop running and the program to exit.\n If <a href=\"#!/api/java.lang.Runtime-method-runFinalizersOnExit\" rel=\"java.lang.Runtime-method-runFinalizersOnExit\" class=\"docClass\">runFinalizersOnExit</a>(boolean) has been previously invoked with a\n {@code true} argument, then all objects will be properly\n garbage-collected and finalized first.\n Use 0 to signal success to the calling process and 1 to signal failure.\n This method is unlikely to be useful to an Android application.</p>\n</div></div></div><div id='method-freeMemory' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-freeMemory' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-freeMemory' class='name expandable'>freeMemory</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the number of bytes currently available on the heap without expanding the heap. ...</div><div class='long'><p>Returns the number of bytes currently available on the heap without expanding the heap. See\n <a href=\"#!/api/java.lang.Runtime-method-totalMemory\" rel=\"java.lang.Runtime-method-totalMemory\" class=\"docClass\">totalMemory</a> for the heap's current size. When these bytes are exhausted, the heap\n may expand. See <a href=\"#!/api/java.lang.Runtime-method-maxMemory\" rel=\"java.lang.Runtime-method-maxMemory\" class=\"docClass\">maxMemory</a> for that limit.</p>\n</div></div></div><div id='method-gc' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-gc' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-gc' class='name expandable'>gc</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Indicates to the VM that it would be a good time to run the\n garbage collector. ...</div><div class='long'><p>Indicates to the VM that it would be a good time to run the\n garbage collector. Note that this is a hint only. There is no guarantee\n that the garbage collector will actually be run.</p>\n</div></div></div><div id='method-getClass' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-getClass' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-getClass' class='name expandable'>getClass</a>( <span class='pre'></span> ) : Object {java.lang.Class}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the unique instance of java.lang.Class that represents this\n object's class. ...</div><div class='long'><p>Returns the unique instance of <a href=\"#!/api/java.lang.Class\" rel=\"java.lang.Class\" class=\"docClass\">java.lang.Class</a> that represents this\n object's class. Note that {@code getClass()} is a special case in that it\n actually returns {@code Class&lt;? extends Foo>} where {@code Foo} is the\n erasure of the type of the expression {@code getClass()} was called upon.\n <p>\n As an example, the following code actually compiles, although one might\n think it shouldn't:\n <p>\n <pre>{@code\n   List<Integer> l = new ArrayList<Integer>();\n   Class&lt;? extends List> c = l.getClass();}</Integer></Integer></pre></p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Class}</span><div class='sub-desc'><p>this object's {@code Class} instance.</p>\n</div></li></ul></div></div></div><div id='method-getLocalizedInputStream' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-getLocalizedInputStream' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-getLocalizedInputStream' class='name expandable'>getLocalizedInputStream</a>( <span class='pre'>stream</span> ) : Object {java.io.InputStream}<span class=\"signature\"><span class='deprecated' >deprecated</span></span></div><div class='description'><div class='short'>Returns the localized version of the specified input stream. ...</div><div class='long'><p>Returns the localized version of the specified input stream. The input\n stream that is returned automatically converts all characters from the\n local character set to Unicode after reading them from the underlying\n stream.</p>\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>Use InputStreamReader instead.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>stream</span> : Object {InputStream}<div class='sub-desc'><p>the input stream to localize.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.io.InputStream}</span><div class='sub-desc'><p>the localized input stream.</p>\n</div></li></ul></div></div></div><div id='method-getLocalizedOutputStream' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-getLocalizedOutputStream' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-getLocalizedOutputStream' class='name expandable'>getLocalizedOutputStream</a>( <span class='pre'>stream</span> ) : Object {java.io.OutputStream}<span class=\"signature\"><span class='deprecated' >deprecated</span></span></div><div class='description'><div class='short'>Returns the localized version of the specified output stream. ...</div><div class='long'><p>Returns the localized version of the specified output stream. The output\n stream that is returned automatically converts all characters from\n Unicode to the local character set before writing them to the underlying\n stream.</p>\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>Use OutputStreamWriter instead.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>stream</span> : Object {OutputStream}<div class='sub-desc'><p>the output stream to localize.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.io.OutputStream}</span><div class='sub-desc'><p>the localized output stream.</p>\n</div></li></ul></div></div></div><div id='method-getRuntime' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-getRuntime' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-getRuntime' class='name expandable'>getRuntime</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the single {@code Runtime} instance for the current application. ...</div><div class='long'><p>Returns the single {@code Runtime} instance for the current application.</p>\n</div></div></div><div id='method-halt' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-halt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-halt' class='name expandable'>halt</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the VM to stop running, and the program to exit with the given return code. ...</div><div class='long'><p>Causes the VM to stop running, and the program to exit with the given return code.\n Use 0 to signal success to the calling process and 1 to signal failure.\n Neither shutdown hooks nor finalizers are run before exiting.\n This method is unlikely to be useful to an Android application.</p>\n</div></div></div><div id='method-hashCode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-hashCode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-hashCode' class='name expandable'>hashCode</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns an integer hash code for this object. ...</div><div class='long'><p>Returns an integer hash code for this object. By contract, any two\n objects for which <a href=\"#!/api/java.lang.Object-method-equals\" rel=\"java.lang.Object-method-equals\" class=\"docClass\">equals</a> returns {@code true} must return\n the same hash code value. This means that subclasses of {@code Object}\n usually override both methods or neither method.</p>\n\n<p> <p>Note that hash values must not change over time unless information used in equals\n comparisons also changes.</p>\n\n<p> <p>See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_hashCode\">Writing a correct\n {@code hashCode} method</a>\n if you intend implementing your own {@code hashCode} method.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>this object's hash code.\n@see <a href=\"#!/api/java.lang.Object-method-equals\" rel=\"java.lang.Object-method-equals\" class=\"docClass\">equals</a></p>\n</div></li></ul></div></div></div><div id='method-load' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-load' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-load' class='name expandable'>load</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Loads the shared library found at the given absolute path. ...</div><div class='long'><p>Loads the shared library found at the given absolute path.\n This should be of the form {@code /path/to/library/libMyLibrary.so}.\n Most callers should use <a href=\"#!/api/java.lang.Runtime-method-loadLibrary\" rel=\"java.lang.Runtime-method-loadLibrary\" class=\"docClass\">loadLibrary</a>(String) instead, and\n let the system find the correct file to load.</p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>UnsatisfiedLinkError if the library can not be loaded,\n either because it's not found or because there is something wrong with it.</p>\n</div></li></ul></div></div></div><div id='method-loadLibrary' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-loadLibrary' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-loadLibrary' class='name expandable'>loadLibrary</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Loads a shared library. ...</div><div class='long'><p>Loads a shared library. Class loaders have some influence over this\n process, but for a typical Android app, it works as follows:</p>\n\n<p> <p>Given the name {@code \"MyLibrary\"}, that string will be passed to\n <a href=\"#!/api/java.lang.System-method-mapLibraryName\" rel=\"java.lang.System-method-mapLibraryName\" class=\"docClass\">java.lang.System.mapLibraryName</a>. That means it would be a mistake\n for the caller to include the usual {@code \"lib\"} prefix and {@code \".so\"}\n suffix.</p>\n\n<p> <p>That file will then be searched for on the application's native library\n search path. This consists of the application's own native library directory\n followed by the system's native library directories.</p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>UnsatisfiedLinkError if the library can not be loaded,\n either because it's not found or because there is something wrong with it.</p>\n</div></li></ul></div></div></div><div id='method-maxMemory' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-maxMemory' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-maxMemory' class='name expandable'>maxMemory</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the maximum number of bytes the heap can expand to. ...</div><div class='long'><p>Returns the maximum number of bytes the heap can expand to. See <a href=\"#!/api/java.lang.Runtime-method-totalMemory\" rel=\"java.lang.Runtime-method-totalMemory\" class=\"docClass\">totalMemory</a> for the\n current number of bytes taken by the heap, and <a href=\"#!/api/java.lang.Runtime-method-freeMemory\" rel=\"java.lang.Runtime-method-freeMemory\" class=\"docClass\">freeMemory</a> for the current number of\n those bytes actually used by live objects.</p>\n</div></div></div><div id='method-notify' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notify' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notify' class='name expandable'>notify</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to...</div><div class='long'><p>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to be woken up. If more than\n one thread is waiting, one of them is chosen at the discretion of the\n VM. The chosen thread will not run immediately. The thread\n that called {@code notify()} has to release the object's monitor first.\n Also, the chosen thread still has to compete against other threads that\n try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></div></div><div id='method-notifyAll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notifyAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notifyAll' class='name expandable'>notifyAll</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods...</div><div class='long'><p>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods) to be woken up. The threads\n will not run immediately. The thread that called {@code notify()} has to\n release the object's monitor first. Also, the threads still have to\n compete against other threads that try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul></p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div><div id='method-removeShutdownHook' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-removeShutdownHook' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-removeShutdownHook' class='name expandable'>removeShutdownHook</a>( <span class='pre'>hook</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Unregisters a previously registered VM shutdown hook. ...</div><div class='long'><p>Unregisters a previously registered VM shutdown hook.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>hook</span> : Object {Thread}<div class='sub-desc'><p>the shutdown hook to remove.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the hook has been removed successfully; {@code\n         false} otherwise.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalStateException\n             if the VM is already shutting down.</p>\n</div></li></ul></div></div></div><div id='method-runFinalization' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-runFinalization' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-runFinalization' class='name expandable'>runFinalization</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Provides a hint to the runtime that it would be useful to attempt\n to perform any outstanding object finalization. ...</div><div class='long'><p>Provides a hint to the runtime that it would be useful to attempt\n to perform any outstanding object finalization.</p>\n</div></div></div><div id='method-runFinalizersOnExit' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-runFinalizersOnExit' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-runFinalizersOnExit' class='name expandable'>runFinalizersOnExit</a>( <span class='pre'>run</span> )<span class=\"signature\"><span class='deprecated' >deprecated</span></span></div><div class='description'><div class='short'>Sets the flag that indicates whether all objects are finalized when the\n runtime is about to exit. ...</div><div class='long'><p>Sets the flag that indicates whether all objects are finalized when the\n runtime is about to exit. Note that all finalization which occurs\n when the system is exiting is performed after all running threads have\n been terminated.</p>\n        <div class='rounded-box deprecated-box deprecated-tag-box'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>This method is unsafe.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>run</span> : Boolean<div class='sub-desc'><p>{@code true} to enable finalization on exit, {@code false} to\n            disable it.</p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns a string containing a concise, human-readable description of this\n object. ...</div><div class='long'><p>Returns a string containing a concise, human-readable description of this\n object. Subclasses are encouraged to override this method and provide an\n implementation that takes into account the object's type and data. The\n default implementation is equivalent to the following expression:</p>\n\n<pre>   getClass().getName() + '@' + Integer.toHexString(hashCode())</pre>\n\n\n<p> <p>See <a href=\"{@docRoot}reference/java/lang/Object.html#writing_toString\">Writing a useful\n {@code toString} method</a>\n if you intend implementing your own {@code toString} method.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>a printable representation of this object.</p>\n</div></li></ul></div></div></div><div id='method-totalMemory' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-totalMemory' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-totalMemory' class='name expandable'>totalMemory</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the number of bytes taken by the heap at its current size. ...</div><div class='long'><p>Returns the number of bytes taken by the heap at its current size. The heap may expand or\n contract over time, as the number of live objects increases or decreases. See\n <a href=\"#!/api/java.lang.Runtime-method-maxMemory\" rel=\"java.lang.Runtime-method-maxMemory\" class=\"docClass\">maxMemory</a> for the maximum heap size, and <a href=\"#!/api/java.lang.Runtime-method-freeMemory\" rel=\"java.lang.Runtime-method-freeMemory\" class=\"docClass\">freeMemory</a> for an idea of how much\n the heap could currently contract.</p>\n</div></div></div><div id='method-traceInstructions' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-traceInstructions' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-traceInstructions' class='name expandable'>traceInstructions</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Switches the output of debug information for instructions on or off. ...</div><div class='long'><p>Switches the output of debug information for instructions on or off.\n On Android, this method does nothing.</p>\n</div></div></div><div id='method-traceMethodCalls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.Runtime'>java.lang.Runtime</span><br/><a href='source/Runtime.html#java-lang-Runtime-method-traceMethodCalls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Runtime-method-traceMethodCalls' class='name expandable'>traceMethodCalls</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Switches the output of debug information for methods on or off. ...</div><div class='long'><p>Switches the output of debug information for methods on or off.</p>\n</div></div></div><div id='method-wait' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-wait' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-wait' class='name expandable'>wait</a>( <span class='pre'>millis, nanos</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of t...</div><div class='long'><p>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of this object or until the\n specified timeout expires. This method can only be invoked by a thread\n that owns this object's monitor; see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>() on how a thread\n can become the owner of a monitor.</p>\n\n<p> <p>A waiting thread can be sent {@code interrupt()} to cause it to\n prematurely stop waiting, so {@code wait} should be called in a loop to\n check that the condition that has been waited for has been met before\n continuing.</p>\n\n<p> <p>While the thread waits, it gives up ownership of this object's\n monitor. When it is notified (or interrupted), it re-acquires the monitor\n before it starts running.</p>\n\n<p> <p>A timeout of zero means the calling thread should wait forever unless interrupted or\n notified.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>millis</span> : Number<div class='sub-desc'><p>the maximum time to wait in milliseconds.</p>\n</div></li><li><span class='pre'>nanos</span> : Number<div class='sub-desc'><p>the fraction of a millisecond to wait, specified in\n            nanoseconds.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalArgumentException\n             if {@code millis &lt; 0}, {@code nanos &lt; 0} or {@code nanos >\n             999999}.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>InterruptedException if the current thread has been interrupted.\n             The interrupted status of the current thread will be cleared before the exception\n             is thrown.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});