Ext.data.JsonP.java_lang_StackTraceElement({"tagname":"class","name":"java.lang.StackTraceElement","autodetected":{},"files":[{"filename":"StackTraceElement.js","href":"StackTraceElement.html#java-lang-StackTraceElement"}],"extends":"java.lang.Object","members":[{"name":"equals","tagname":"method","owner":"java.lang.StackTraceElement","id":"method-equals","meta":{}},{"name":"getClass","tagname":"method","owner":"java.lang.Object","id":"method-getClass","meta":{}},{"name":"getClassName","tagname":"method","owner":"java.lang.StackTraceElement","id":"method-getClassName","meta":{}},{"name":"getFileName","tagname":"method","owner":"java.lang.StackTraceElement","id":"method-getFileName","meta":{}},{"name":"getLineNumber","tagname":"method","owner":"java.lang.StackTraceElement","id":"method-getLineNumber","meta":{}},{"name":"getMethodName","tagname":"method","owner":"java.lang.StackTraceElement","id":"method-getMethodName","meta":{}},{"name":"hashCode","tagname":"method","owner":"java.lang.StackTraceElement","id":"method-hashCode","meta":{}},{"name":"isNativeMethod","tagname":"method","owner":"java.lang.StackTraceElement","id":"method-isNativeMethod","meta":{}},{"name":"notify","tagname":"method","owner":"java.lang.Object","id":"method-notify","meta":{}},{"name":"notifyAll","tagname":"method","owner":"java.lang.Object","id":"method-notifyAll","meta":{}},{"name":"toString","tagname":"method","owner":"java.lang.StackTraceElement","id":"method-toString","meta":{}},{"name":"wait","tagname":"method","owner":"java.lang.Object","id":"method-wait","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.StackTraceElement","short_doc":"implements java.io.Serializable\n\nA representation of a single stack frame. ...","classIcon":"icon-class","superclasses":["java.lang.Object"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='docClass'>java.lang.Object</a><div class='subclass '><strong>java.lang.StackTraceElement</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/StackTraceElement.html#java-lang-StackTraceElement' target='_blank'>StackTraceElement.js</a></div></pre><div class='doc-contents'><p>implements java.io.Serializable</p>\n\n<p>A representation of a single stack frame. Arrays of {@code StackTraceElement}\n are stored in <a href=\"#!/api/java.lang.Throwable\" rel=\"java.lang.Throwable\" class=\"docClass\">java.lang.Throwable</a> objects to represent the whole state of the\n call stack at the time a {@code Throwable} gets thrown.</p>\n\n<p> @see Throwable#getStackTrace()</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-equals' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StackTraceElement'>java.lang.StackTraceElement</span><br/><a href='source/StackTraceElement.html#java-lang-StackTraceElement-method-equals' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StackTraceElement-method-equals' class='name expandable'>equals</a>( <span class='pre'>obj</span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Compares this instance with the specified object and indicates if they\n are equal. ...</div><div class='long'><p>Compares this instance with the specified object and indicates if they\n are equal. In order to be equal, the following conditions must be\n fulfilled:\n <ul>\n <li>{@code obj} must be a stack trace element,</li>\n <li>the method names of this stack trace element and of {@code obj} must\n not be {@code null},</li>\n <li>the class, method and file names as well as the line number of this\n stack trace element and of {@code obj} must be equal.</li>\n </ul></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>obj</span> : Object {Object}<div class='sub-desc'><p>the object to compare this instance with.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the specified object is equal to this\n         {@code StackTraceElement}; {@code false} otherwise.\n@see <a href=\"#!/api/java.lang.StackTraceElement-method-hashCode\" rel=\"java.lang.StackTraceElement-method-hashCode\" class=\"docClass\">hashCode</a></p>\n</div></li></ul><p>Overrides: <a href=\"#!/api/java.lang.Object-method-equals\" rel=\"java.lang.Object-method-equals\" class=\"docClass\">java.lang.Object.equals</a></p></div></div></div><div id='method-getClass' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-getClass' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-getClass' class='name expandable'>getClass</a>( <span class='pre'></span> ) : Object {java.lang.Class}<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the unique instance of java.lang.Class that represents this\n object's class. ...</div><div class='long'><p>Returns the unique instance of <a href=\"#!/api/java.lang.Class\" rel=\"java.lang.Class\" class=\"docClass\">java.lang.Class</a> that represents this\n object's class. Note that {@code getClass()} is a special case in that it\n actually returns {@code Class&lt;? extends Foo>} where {@code Foo} is the\n erasure of the type of the expression {@code getClass()} was called upon.\n <p>\n As an example, the following code actually compiles, although one might\n think it shouldn't:\n <p>\n <pre>{@code\n   List<Integer> l = new ArrayList<Integer>();\n   Class&lt;? extends List> c = l.getClass();}</Integer></Integer></pre></p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.Class}</span><div class='sub-desc'><p>this object's {@code Class} instance.</p>\n</div></li></ul></div></div></div><div id='method-getClassName' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StackTraceElement'>java.lang.StackTraceElement</span><br/><a href='source/StackTraceElement.html#java-lang-StackTraceElement-method-getClassName' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StackTraceElement-method-getClassName' class='name expandable'>getClassName</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the fully qualified name of the class belonging to this\n {@code StackTraceElement}. ...</div><div class='long'><p>Returns the fully qualified name of the class belonging to this\n {@code StackTraceElement}.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the fully qualified type name of the class</p>\n</div></li></ul></div></div></div><div id='method-getFileName' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StackTraceElement'>java.lang.StackTraceElement</span><br/><a href='source/StackTraceElement.html#java-lang-StackTraceElement-method-getFileName' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StackTraceElement-method-getFileName' class='name expandable'>getFileName</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the name of the Java source file containing class belonging to\n this {@code StackTraceElement}. ...</div><div class='long'><p>Returns the name of the Java source file containing class belonging to\n this {@code StackTraceElement}.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the name of the file, or {@code null} if this information is not\n         available.</p>\n</div></li></ul></div></div></div><div id='method-getLineNumber' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StackTraceElement'>java.lang.StackTraceElement</span><br/><a href='source/StackTraceElement.html#java-lang-StackTraceElement-method-getLineNumber' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StackTraceElement-method-getLineNumber' class='name expandable'>getLineNumber</a>( <span class='pre'></span> ) : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the line number in the source for the class belonging to this\n {@code StackTraceElement}. ...</div><div class='long'><p>Returns the line number in the source for the class belonging to this\n {@code StackTraceElement}.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>the line number, or a negative number if this information is not\n         available.</p>\n</div></li></ul></div></div></div><div id='method-getMethodName' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StackTraceElement'>java.lang.StackTraceElement</span><br/><a href='source/StackTraceElement.html#java-lang-StackTraceElement-method-getMethodName' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StackTraceElement-method-getMethodName' class='name expandable'>getMethodName</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the name of the method belonging to this {@code\n StackTraceElement}. ...</div><div class='long'><p>Returns the name of the method belonging to this {@code\n StackTraceElement}.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the name of the method, or \"<unknown method>\" if this information\n         is not available.</unknown></p>\n</div></li></ul></div></div></div><div id='method-hashCode' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StackTraceElement'>java.lang.StackTraceElement</span><br/><a href='source/StackTraceElement.html#java-lang-StackTraceElement-method-hashCode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StackTraceElement-method-hashCode' class='name expandable'>hashCode</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Overrides: <a href=\"#!/api/java.lang.Object-method-hashCode\" rel=\"java.lang.Object-method-hashCode\" class=\"docClass\">java.lang.Object.hashCode</a></p></div></div></div><div id='method-isNativeMethod' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StackTraceElement'>java.lang.StackTraceElement</span><br/><a href='source/StackTraceElement.html#java-lang-StackTraceElement-method-isNativeMethod' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StackTraceElement-method-isNativeMethod' class='name expandable'>isNativeMethod</a>( <span class='pre'></span> ) : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Indicates if the method name returned by getMethodName() is\n implemented as a native method. ...</div><div class='long'><p>Indicates if the method name returned by <a href=\"#!/api/java.lang.StackTraceElement-method-getMethodName\" rel=\"java.lang.StackTraceElement-method-getMethodName\" class=\"docClass\">getMethodName</a>() is\n implemented as a native method.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>{@code true} if the method in which this stack trace element is\n         executing is a native method; {@code false} otherwise.</p>\n</div></li></ul></div></div></div><div id='method-notify' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notify' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notify' class='name expandable'>notify</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to...</div><div class='long'><p>Causes a thread which is waiting on this object's monitor (by means of\n calling one of the {@code wait()} methods) to be woken up. If more than\n one thread is waiting, one of them is chosen at the discretion of the\n VM. The chosen thread will not run immediately. The thread\n that called {@code notify()} has to release the object's monitor first.\n Also, the chosen thread still has to compete against other threads that\n try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></div></div><div id='method-notifyAll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-notifyAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-notifyAll' class='name expandable'>notifyAll</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods...</div><div class='long'><p>Causes all threads which are waiting on this object's monitor (by means\n of calling one of the {@code wait()} methods) to be woken up. The threads\n will not run immediately. The thread that called {@code notify()} has to\n release the object's monitor first. Also, the threads still have to\n compete against other threads that try to synchronize on the same object.</p>\n\n<p> <p>This method can only be invoked by a thread which owns this object's\n monitor. A thread becomes owner of an object's monitor\n <ul>\n <li>by executing a synchronized method of that object;</li>\n <li>by executing the body of a {@code synchronized} statement that\n synchronizes on the object;</li>\n <li>by executing a synchronized static method if the object is of type\n {@code Class}.</li>\n </ul></p>\n<h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long)\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StackTraceElement'>java.lang.StackTraceElement</span><br/><a href='source/StackTraceElement.html#java-lang-StackTraceElement-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StackTraceElement-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Overrides: <a href=\"#!/api/java.lang.Object-method-toString\" rel=\"java.lang.Object-method-toString\" class=\"docClass\">java.lang.Object.toString</a></p></div></div></div><div id='method-wait' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/java.lang.Object' rel='java.lang.Object' class='defined-in docClass'>java.lang.Object</a><br/><a href='source/Object.html#java-lang-Object-method-wait' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.Object-method-wait' class='name expandable'>wait</a>( <span class='pre'>millis, nanos</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of t...</div><div class='long'><p>Causes the calling thread to wait until another thread calls the {@code\n notify()} or {@code notifyAll()} method of this object or until the\n specified timeout expires. This method can only be invoked by a thread\n that owns this object's monitor; see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>() on how a thread\n can become the owner of a monitor.</p>\n\n<p> <p>A waiting thread can be sent {@code interrupt()} to cause it to\n prematurely stop waiting, so {@code wait} should be called in a loop to\n check that the condition that has been waited for has been met before\n continuing.</p>\n\n<p> <p>While the thread waits, it gives up ownership of this object's\n monitor. When it is notified (or interrupted), it re-acquires the monitor\n before it starts running.</p>\n\n<p> <p>A timeout of zero means the calling thread should wait forever unless interrupted or\n notified.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>millis</span> : Number<div class='sub-desc'><p>the maximum time to wait in milliseconds.</p>\n</div></li><li><span class='pre'>nanos</span> : Number<div class='sub-desc'><p>the fraction of a millisecond to wait, specified in\n            nanoseconds.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalArgumentException\n             if {@code millis &lt; 0}, {@code nanos &lt; 0} or {@code nanos >\n             999999}.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>IllegalMonitorStateException\n             if the thread calling this method is not the owner of this\n             object's monitor.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>InterruptedException if the current thread has been interrupted.\n             The interrupted status of the current thread will be cleared before the exception\n             is thrown.\n@see <a href=\"#!/api/java.lang.Object-method-notify\" rel=\"java.lang.Object-method-notify\" class=\"docClass\">notify</a>\n@see <a href=\"#!/api/java.lang.Object-method-notifyAll\" rel=\"java.lang.Object-method-notifyAll\" class=\"docClass\">notifyAll</a>\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>()\n@see <a href=\"#!/api/java.lang.Object-method-wait\" rel=\"java.lang.Object-method-wait\" class=\"docClass\">wait</a>(long,int)\n@see <a href=\"#!/api/java.lang.Thread\" rel=\"java.lang.Thread\" class=\"docClass\">java.lang.Thread</a></p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});