Ext.data.JsonP.java_lang_StringBuffer({"tagname":"class","name":"java.lang.StringBuffer","autodetected":{},"files":[{"filename":"StringBuffer.js","href":"StringBuffer.html#java-lang-StringBuffer"}],"extends":"java.lang.AbstractStringBuilder","since":"1.0","members":[{"name":"append","tagname":"method","owner":"java.lang.StringBuffer","id":"method-append","meta":{}},{"name":"appendCodePoint","tagname":"method","owner":"java.lang.StringBuffer","id":"method-appendCodePoint","meta":{}},{"name":"charAt","tagname":"method","owner":"java.lang.StringBuffer","id":"method-charAt","meta":{}},{"name":"codePointAt","tagname":"method","owner":"java.lang.StringBuffer","id":"method-codePointAt","meta":{}},{"name":"codePointBefore","tagname":"method","owner":"java.lang.StringBuffer","id":"method-codePointBefore","meta":{}},{"name":"codePointCount","tagname":"method","owner":"java.lang.StringBuffer","id":"method-codePointCount","meta":{}},{"name":"delete","tagname":"method","owner":"java.lang.StringBuffer","id":"method-delete","meta":{}},{"name":"deleteCharAt","tagname":"method","owner":"java.lang.StringBuffer","id":"method-deleteCharAt","meta":{}},{"name":"ensureCapacity","tagname":"method","owner":"java.lang.StringBuffer","id":"method-ensureCapacity","meta":{}},{"name":"getChars","tagname":"method","owner":"java.lang.StringBuffer","id":"method-getChars","meta":{}},{"name":"indexOf","tagname":"method","owner":"java.lang.StringBuffer","id":"method-indexOf","meta":{}},{"name":"insert","tagname":"method","owner":"java.lang.StringBuffer","id":"method-insert","meta":{}},{"name":"lastIndexOf","tagname":"method","owner":"java.lang.StringBuffer","id":"method-lastIndexOf","meta":{}},{"name":"offsetByCodePoints","tagname":"method","owner":"java.lang.StringBuffer","id":"method-offsetByCodePoints","meta":{}},{"name":"replace","tagname":"method","owner":"java.lang.StringBuffer","id":"method-replace","meta":{}},{"name":"reverse","tagname":"method","owner":"java.lang.StringBuffer","id":"method-reverse","meta":{}},{"name":"setCharAt","tagname":"method","owner":"java.lang.StringBuffer","id":"method-setCharAt","meta":{}},{"name":"setLength","tagname":"method","owner":"java.lang.StringBuffer","id":"method-setLength","meta":{}},{"name":"subSequence","tagname":"method","owner":"java.lang.StringBuffer","id":"method-subSequence","meta":{}},{"name":"substring","tagname":"method","owner":"java.lang.StringBuffer","id":"method-substring","meta":{}},{"name":"toString","tagname":"method","owner":"java.lang.StringBuffer","id":"method-toString","meta":{}},{"name":"trimToSize","tagname":"method","owner":"java.lang.StringBuffer","id":"method-trimToSize","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.StringBuffer","short_doc":"implements java.lang.Appendable\n\n implements java.io.Serializable\n\n implements java.lang.CharSequence\n\nA modifiable s...","classIcon":"icon-class","superclasses":["java.lang.AbstractStringBuilder"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.AbstractStringBuilder<div class='subclass '><strong>java.lang.StringBuffer</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/StringBuffer.html#java-lang-StringBuffer' target='_blank'>StringBuffer.js</a></div></pre><div class='doc-contents'><p>implements <a href=\"#!/api/java.lang.Appendable\" rel=\"java.lang.Appendable\" class=\"docClass\">java.lang.Appendable</a></p>\n\n<p> implements java.io.Serializable</p>\n\n<p> implements <a href=\"#!/api/java.lang.CharSequence\" rel=\"java.lang.CharSequence\" class=\"docClass\">java.lang.CharSequence</a></p>\n\n<p>A modifiable <a href=\"#!/api/java.lang.CharSequence\" rel=\"java.lang.CharSequence\" class=\"docClass\">sequence of characters</a> for use in creating\n strings, where all accesses are synchronized. This class has mostly been replaced\n by <a href=\"#!/api/java.lang.StringBuilder\" rel=\"java.lang.StringBuilder\" class=\"docClass\">java.lang.StringBuilder</a> because this synchronization is rarely useful. This\n class is mainly used to interact with legacy APIs that expose it.</p>\n\n<p> <p>For particularly complex string-building needs, consider java.util.Formatter.</p>\n\n<p> <p>The majority of the modification methods on this class return {@code\n this} so that method calls can be chained together. For example:\n {@code new StringBuffer(\"a\").append(\"b\").append(\"c\").toString()}.</p>\n\n<p> @see CharSequence\n @see Appendable\n @see StringBuilder\n @see String\n @see String#format</p>\n        <p>Available since: <b>1.0</b></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-append' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-append' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-append' class='name expandable'>append</a>( <span class='pre'>s, start, end</span> ) : Object {java.lang.StringBuffer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Appends the specified subsequence of the CharSequence to this buffer. ...</div><div class='long'><p>Appends the specified subsequence of the CharSequence to this buffer.\n <p>\n If the specified CharSequence is {@code null}, then the string {@code\n \"null\"} is used to extract a subsequence.</p>\n        <p>Available since: <b>1.5</b></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>s</span> : Object {CharSequence}<div class='sub-desc'><p>the CharSequence to append.</p>\n</div></li><li><span class='pre'>start</span> : Number<div class='sub-desc'><p>the inclusive start index.</p>\n</div></li><li><span class='pre'>end</span> : Number<div class='sub-desc'><p>the exclusive end index.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuffer}</span><div class='sub-desc'><p>this StringBuffer.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IndexOutOfBoundsException\n             if {@code start} or {@code end} are negative, {@code start}\n             is greater than {@code end} or {@code end} is greater than\n             the length of {@code s}.</p>\n</div></li></ul></div></div></div><div id='method-appendCodePoint' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-appendCodePoint' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-appendCodePoint' class='name expandable'>appendCodePoint</a>( <span class='pre'>codePoint</span> ) : Object {java.lang.StringBuffer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Appends the string representation of the specified Unicode code point to\n the end of this buffer. ...</div><div class='long'><p>Appends the string representation of the specified Unicode code point to\n the end of this buffer.\n <p>\n The code point is converted to a {@code char[]} as defined by\n java.lang.Character.toChars(int).</p>\n        <p>Available since: <b>1.5</b></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>codePoint</span> : Number<div class='sub-desc'><p>the Unicode code point to encode and append.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuffer}</span><div class='sub-desc'><p>this StringBuffer.\n@see Character#toChars(int)</p>\n</div></li></ul></div></div></div><div id='method-charAt' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-charAt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-charAt' class='name expandable'>charAt</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-codePointAt' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-codePointAt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-codePointAt' class='name expandable'>codePointAt</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-codePointBefore' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-codePointBefore' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-codePointBefore' class='name expandable'>codePointBefore</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-codePointCount' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-codePointCount' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-codePointCount' class='name expandable'>codePointCount</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-delete' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-delete' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-delete' class='name expandable'>delete</a>( <span class='pre'>start, end</span> ) : Object {java.lang.StringBuffer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Deletes a range of characters. ...</div><div class='long'><p>Deletes a range of characters.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>start</span> : Number<div class='sub-desc'><p>the offset of the first character.</p>\n</div></li><li><span class='pre'>end</span> : Number<div class='sub-desc'><p>the offset one past the last character.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuffer}</span><div class='sub-desc'><p>this StringBuffer.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>StringIndexOutOfBoundsException\n             if {@code start &lt; 0}, {@code start > end} or {@code end >\n             length()}.</p>\n</div></li></ul></div></div></div><div id='method-deleteCharAt' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-deleteCharAt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-deleteCharAt' class='name expandable'>deleteCharAt</a>( <span class='pre'>location</span> ) : Object {java.lang.StringBuffer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Deletes the character at the specified offset. ...</div><div class='long'><p>Deletes the character at the specified offset.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>location</span> : Number<div class='sub-desc'><p>the offset of the character to delete.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuffer}</span><div class='sub-desc'><p>this StringBuffer.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>StringIndexOutOfBoundsException\n             if {@code location &lt; 0} or {@code location >= length()}</p>\n</div></li></ul></div></div></div><div id='method-ensureCapacity' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-ensureCapacity' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-ensureCapacity' class='name expandable'>ensureCapacity</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-getChars' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-getChars' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-getChars' class='name expandable'>getChars</a>( <span class='pre'>start, end, buffer, idx</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Copies the requested sequence of characters to the {@code char[]} passed\n starting at {@code idx}. ...</div><div class='long'><p>Copies the requested sequence of characters to the {@code char[]} passed\n starting at {@code idx}.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>start</span> : Number<div class='sub-desc'><p>the starting offset of characters to copy.</p>\n</div></li><li><span class='pre'>end</span> : Number<div class='sub-desc'><p>the ending offset of characters to copy.</p>\n</div></li><li><span class='pre'>buffer</span> : Object {char[]}<div class='sub-desc'><p>the destination character array.</p>\n</div></li><li><span class='pre'>idx</span> : Number<div class='sub-desc'><p>the starting offset in the character array.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IndexOutOfBoundsException\n             if {@code start &lt; 0}, {@code end > length()}, {@code start >\n             end}, {@code index &lt; 0}, {@code end - start > buffer.length -\n             index}</p>\n</div></li></ul></div></div></div><div id='method-indexOf' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-indexOf' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-indexOf' class='name expandable'>indexOf</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-insert' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-insert' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-insert' class='name expandable'>insert</a>( <span class='pre'>index, s, start, end</span> ) : Object {java.lang.StringBuffer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Inserts the specified subsequence into this buffer at the specified\n index. ...</div><div class='long'><p>Inserts the specified subsequence into this buffer at the specified\n index.\n <p>\n If the specified CharSequence is {@code null}, the string {@code \"null\"}\n is inserted, otherwise the contents of the CharSequence.</p>\n        <p>Available since: <b>1.5</b></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>index</span> : Number<div class='sub-desc'><p>The index at which to insert.</p>\n</div></li><li><span class='pre'>s</span> : Object {CharSequence}<div class='sub-desc'><p>The char sequence to insert.</p>\n</div></li><li><span class='pre'>start</span> : Number<div class='sub-desc'><p>The inclusive start index in the char sequence.</p>\n</div></li><li><span class='pre'>end</span> : Number<div class='sub-desc'><p>The exclusive end index in the char sequence.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuffer}</span><div class='sub-desc'><p>this buffer.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IndexOutOfBoundsException\n             if {@code index} is negative or greater than the current\n             length, {@code start} or {@code end} are negative, {@code\n             start} is greater than {@code end} or {@code end} is greater\n             than the length of {@code s}.</p>\n</div></li></ul></div></div></div><div id='method-lastIndexOf' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-lastIndexOf' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-lastIndexOf' class='name expandable'>lastIndexOf</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-offsetByCodePoints' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-offsetByCodePoints' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-offsetByCodePoints' class='name expandable'>offsetByCodePoints</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-replace' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-replace' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-replace' class='name expandable'>replace</a>( <span class='pre'>start, end, string</span> ) : Object {java.lang.StringBuffer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Replaces the characters in the specified range with the contents of the\n specified string. ...</div><div class='long'><p>Replaces the characters in the specified range with the contents of the\n specified string.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>start</span> : Number<div class='sub-desc'><p>the inclusive begin index.</p>\n</div></li><li><span class='pre'>end</span> : Number<div class='sub-desc'><p>the exclusive end index.</p>\n</div></li><li><span class='pre'>string</span> : String<div class='sub-desc'><p>the string that will replace the contents in the range.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuffer}</span><div class='sub-desc'><p>this buffer.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>StringIndexOutOfBoundsException\n             if {@code start} or {@code end} are negative, {@code start}\n             is greater than {@code end} or {@code end} is greater than\n             the length of {@code s}.</p>\n</div></li></ul></div></div></div><div id='method-reverse' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-reverse' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-reverse' class='name expandable'>reverse</a>( <span class='pre'></span> ) : Object {java.lang.StringBuffer}<span class=\"signature\"></span></div><div class='description'><div class='short'>Reverses the order of characters in this buffer. ...</div><div class='long'><p>Reverses the order of characters in this buffer.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuffer}</span><div class='sub-desc'><p>this buffer.</p>\n</div></li></ul></div></div></div><div id='method-setCharAt' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-setCharAt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-setCharAt' class='name expandable'>setCharAt</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-setLength' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-setLength' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-setLength' class='name expandable'>setLength</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-subSequence' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-subSequence' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-subSequence' class='name expandable'>subSequence</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-substring' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-substring' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-substring' class='name expandable'>substring</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-toString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-trimToSize' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuffer'>java.lang.StringBuffer</span><br/><a href='source/StringBuffer.html#java-lang-StringBuffer-method-trimToSize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuffer-method-trimToSize' class='name expandable'>trimToSize</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div></div></div></div></div>","meta":{}});