Ext.data.JsonP.java_lang_StringBuilder({"tagname":"class","name":"java.lang.StringBuilder","autodetected":{},"files":[{"filename":"StringBuilder.js","href":"StringBuilder.html#java-lang-StringBuilder"}],"extends":"java.lang.AbstractStringBuilder","since":"1.5","members":[{"name":"append","tagname":"method","owner":"java.lang.StringBuilder","id":"method-append","meta":{}},{"name":"appendCodePoint","tagname":"method","owner":"java.lang.StringBuilder","id":"method-appendCodePoint","meta":{}},{"name":"delete","tagname":"method","owner":"java.lang.StringBuilder","id":"method-delete","meta":{}},{"name":"deleteCharAt","tagname":"method","owner":"java.lang.StringBuilder","id":"method-deleteCharAt","meta":{}},{"name":"insert","tagname":"method","owner":"java.lang.StringBuilder","id":"method-insert","meta":{}},{"name":"replace","tagname":"method","owner":"java.lang.StringBuilder","id":"method-replace","meta":{}},{"name":"reverse","tagname":"method","owner":"java.lang.StringBuilder","id":"method-reverse","meta":{}},{"name":"toString","tagname":"method","owner":"java.lang.StringBuilder","id":"method-toString","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-java.lang.StringBuilder","short_doc":"implements java.lang.Appendable\n\n implements java.lang.CharSequence\n\n implements java.io.Serializable\n\nA modifiable s...","classIcon":"icon-class","superclasses":["java.lang.AbstractStringBuilder"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>java.lang.AbstractStringBuilder<div class='subclass '><strong>java.lang.StringBuilder</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/StringBuilder.html#java-lang-StringBuilder' target='_blank'>StringBuilder.js</a></div></pre><div class='doc-contents'><p>implements <a href=\"#!/api/java.lang.Appendable\" rel=\"java.lang.Appendable\" class=\"docClass\">java.lang.Appendable</a></p>\n\n<p> implements <a href=\"#!/api/java.lang.CharSequence\" rel=\"java.lang.CharSequence\" class=\"docClass\">java.lang.CharSequence</a></p>\n\n<p> implements java.io.Serializable</p>\n\n<p>A modifiable <a href=\"#!/api/java.lang.CharSequence\" rel=\"java.lang.CharSequence\" class=\"docClass\">sequence of characters</a> for use in creating\n strings. This class is intended as a direct replacement of\n <a href=\"#!/api/java.lang.StringBuffer\" rel=\"java.lang.StringBuffer\" class=\"docClass\">java.lang.StringBuffer</a> for non-concurrent use; unlike {@code StringBuffer} this\n class is not synchronized.</p>\n\n<p> <p>For particularly complex string-building needs, consider java.util.Formatter.</p>\n\n<p> <p>The majority of the modification methods on this class return {@code\n this} so that method calls can be chained together. For example:\n {@code new StringBuilder(\"a\").append(\"b\").append(\"c\").toString()}.</p>\n\n<p> @see CharSequence\n @see Appendable\n @see StringBuffer\n @see String\n @see String#format</p>\n        <p>Available since: <b>1.5</b></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-append' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuilder'>java.lang.StringBuilder</span><br/><a href='source/StringBuilder.html#java-lang-StringBuilder-method-append' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuilder-method-append' class='name expandable'>append</a>( <span class='pre'>csq, start, end</span> ) : Object {java.lang.StringBuilder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Appends the string representation of the specified subsequence of the\n {@code CharSequence}. ...</div><div class='long'><p>Appends the string representation of the specified subsequence of the\n {@code CharSequence}. If the {@code CharSequence} is {@code null}, then\n the string {@code \"null\"} is used to extract the subsequence from.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>csq</span> : Object {CharSequence}<div class='sub-desc'><p>the {@code CharSequence} to append.</p>\n</div></li><li><span class='pre'>start</span> : Number<div class='sub-desc'><p>the beginning index.</p>\n</div></li><li><span class='pre'>end</span> : Number<div class='sub-desc'><p>the ending index.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuilder}</span><div class='sub-desc'><p>this builder.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IndexOutOfBoundsException\n             if {@code start} or {@code end} are negative, {@code start}\n             is greater than {@code end} or {@code end} is greater than\n             the length of {@code csq}.</p>\n</div></li></ul></div></div></div><div id='method-appendCodePoint' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuilder'>java.lang.StringBuilder</span><br/><a href='source/StringBuilder.html#java-lang-StringBuilder-method-appendCodePoint' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuilder-method-appendCodePoint' class='name expandable'>appendCodePoint</a>( <span class='pre'>codePoint</span> ) : Object {java.lang.StringBuilder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Appends the encoded Unicode code point. ...</div><div class='long'><p>Appends the encoded Unicode code point. The code point is converted to a\n {@code char[]} as defined by java.lang.Character.toChars(int).</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>codePoint</span> : Number<div class='sub-desc'><p>the Unicode code point to encode and append.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuilder}</span><div class='sub-desc'><p>this builder.\n@see Character#toChars(int)</p>\n</div></li></ul></div></div></div><div id='method-delete' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuilder'>java.lang.StringBuilder</span><br/><a href='source/StringBuilder.html#java-lang-StringBuilder-method-delete' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuilder-method-delete' class='name expandable'>delete</a>( <span class='pre'>start, end</span> ) : Object {java.lang.StringBuilder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Deletes a sequence of characters specified by {@code start} and {@code\n end}. ...</div><div class='long'><p>Deletes a sequence of characters specified by {@code start} and {@code\n end}. Shifts any remaining characters to the left.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>start</span> : Number<div class='sub-desc'><p>the inclusive start index.</p>\n</div></li><li><span class='pre'>end</span> : Number<div class='sub-desc'><p>the exclusive end index.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuilder}</span><div class='sub-desc'><p>this builder.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>StringIndexOutOfBoundsException\n             if {@code start} is less than zero, greater than the current\n             length or greater than {@code end}.</p>\n</div></li></ul></div></div></div><div id='method-deleteCharAt' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuilder'>java.lang.StringBuilder</span><br/><a href='source/StringBuilder.html#java-lang-StringBuilder-method-deleteCharAt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuilder-method-deleteCharAt' class='name expandable'>deleteCharAt</a>( <span class='pre'>index</span> ) : Object {java.lang.StringBuilder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Deletes the character at the specified index. ...</div><div class='long'><p>Deletes the character at the specified index. shifts any remaining\n characters to the left.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>index</span> : Number<div class='sub-desc'><p>the index of the character to delete.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuilder}</span><div class='sub-desc'><p>this builder.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>StringIndexOutOfBoundsException\n             if {@code index} is less than zero or is greater than or\n             equal to the current length.</p>\n</div></li></ul></div></div></div><div id='method-insert' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuilder'>java.lang.StringBuilder</span><br/><a href='source/StringBuilder.html#java-lang-StringBuilder-method-insert' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuilder-method-insert' class='name expandable'>insert</a>( <span class='pre'>offset, s, start, end</span> ) : Object {java.lang.StringBuilder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Inserts the string representation of the specified subsequence of the\n {@code CharSequence} at the specified {@code o...</div><div class='long'><p>Inserts the string representation of the specified subsequence of the\n {@code CharSequence} at the specified {@code offset}. The {@code\n CharSequence} is converted to a String as defined by\n int). If the {@code CharSequence}\n is {@code null}, then the string {@code \"null\"} is used to determine the\n subsequence.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>offset</span> : Number<div class='sub-desc'><p>the index to insert at.</p>\n</div></li><li><span class='pre'>s</span> : Object {CharSequence}<div class='sub-desc'><p>the {@code CharSequence} to insert.</p>\n</div></li><li><span class='pre'>start</span> : Number<div class='sub-desc'><p>the start of the subsequence of the character sequence.</p>\n</div></li><li><span class='pre'>end</span> : Number<div class='sub-desc'><p>the end of the subsequence of the character sequence.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuilder}</span><div class='sub-desc'><p>this builder.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>IndexOutOfBoundsException\n             if {@code offset} is negative or greater than the current\n             {@code length()}, or {@code start} and {@code end} do not\n             specify a valid subsequence.\n@see CharSequence#subSequence(int, int)</p>\n</div></li></ul></div></div></div><div id='method-replace' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuilder'>java.lang.StringBuilder</span><br/><a href='source/StringBuilder.html#java-lang-StringBuilder-method-replace' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuilder-method-replace' class='name expandable'>replace</a>( <span class='pre'>start, end, string</span> ) : Object {java.lang.StringBuilder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Replaces the specified subsequence in this builder with the specified\n string. ...</div><div class='long'><p>Replaces the specified subsequence in this builder with the specified\n string.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>start</span> : Number<div class='sub-desc'><p>the inclusive begin index.</p>\n</div></li><li><span class='pre'>end</span> : Number<div class='sub-desc'><p>the exclusive end index.</p>\n</div></li><li><span class='pre'>string</span> : String<div class='sub-desc'><p>the replacement string.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuilder}</span><div class='sub-desc'><p>this builder.</p>\n</div></li></ul><h3 class='pa'>Throws</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>StringIndexOutOfBoundsException\n             if {@code start} is negative, greater than the current\n             {@code length()} or greater than {@code end}.</p>\n</div></li><li><span class='pre'>Object</span><div class='sub-desc'><p>NullPointerException\n            if {@code str} is {@code null}.</p>\n</div></li></ul></div></div></div><div id='method-reverse' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuilder'>java.lang.StringBuilder</span><br/><a href='source/StringBuilder.html#java-lang-StringBuilder-method-reverse' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuilder-method-reverse' class='name expandable'>reverse</a>( <span class='pre'></span> ) : Object {java.lang.StringBuilder}<span class=\"signature\"></span></div><div class='description'><div class='short'>Reverses the order of characters in this builder. ...</div><div class='long'><p>Reverses the order of characters in this builder.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object {java.lang.StringBuilder}</span><div class='sub-desc'><p>this buffer.</p>\n</div></li></ul></div></div></div><div id='method-toString' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='java.lang.StringBuilder'>java.lang.StringBuilder</span><br/><a href='source/StringBuilder.html#java-lang-StringBuilder-method-toString' target='_blank' class='view-source'>view source</a></div><a href='#!/api/java.lang.StringBuilder-method-toString' class='name expandable'>toString</a>( <span class='pre'></span> ) : String<span class=\"signature\"></span></div><div class='description'><div class='short'>Returns the contents of this builder. ...</div><div class='long'><p>Returns the contents of this builder.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>the string representation of the data in this builder.</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});